
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)90	1.19.1.8  src/oss/kazn/kazn/kazn_kpc.c, oss.kazn.src, oss600, 040618a  5/13/03  17:33:43";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));

extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));

extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );




struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;
        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#ifdef LINUX_RHEL4
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void * kenv_pathReqHandle_t;







typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef void (*kpc_res_rele_func_t)(void *);
typedef struct kpcInfo {
    struct kpcInfo *next;
    struct kpcInfo *prev;
    char *resName;
    kpc_resFlags_t resFlags;
    uint32_t kpcFlags;
    uint32_t branchId;
    byte_t *extData;
    uint16_t resNameLen;
    uint16_t extDataLen;
    union {
        struct __f {
            pal_rawFid_t *poFid;
            pal_ftypes_t poFtype;
            int32_t kpcFileAddGen;
            pal_rawFid_t __poFid;
        } f;
        struct __nw {
            int64_t policyVersion;
            pal_ptr32_t pUserRes;
            void *pRes;
            kpc_res_rele_func_t relef;
        } nw;
    } resData;

    char __resName[48];
} kenv_kpcInfo_t;
typedef struct filetgt {
    char *trappedNameRef;
    char *baseName;
    pal_pathBuf_t *fullSrnRef;
    pal_rawFid_t *dir_rfidp;
    pal_rawFid_t *pathFids;
    pal_vnodeH_t dir_vnh;
    pal_vnodeH_t vnh;
    struct filetgt *auxFile;
    int tnLen;
    int pathFidsCount;
    int pathFidsAlloced;
    pal_rawFid_t rfid;
    pal_fattr_t fattrs;
    pal_pid_t killPid;


    void *tgt_nd;
    void *aux_tgt_nd;


    pal_rawFid_t _fids[5];
} kenv_fileTgt_t;






typedef struct pgmInfo {
    kenv_procFlags_t procFlags;
    char *pgmSRN;
    char *pgmKPON;
    pal_rawFid_t pgmFid;
    pal_rawFid_t pgmDFid;
    pal_fattr_t pgmFattrs;
    struct pgmInfo *saveArea;
    int16_t __srnLen;
    int16_t __kponLen;
    char __srn[32];
    char __kpon[32];
} pgmInfo_t;
typedef void * kenv_envHandle_t;

typedef struct kenv_env {
    int magic;
    uint32_t flags;
    pal_pid_t pid;
    int envError;



    union {



        struct {
            kenv_fileTgt_t f;
            pal_idSet_t idSet;
            pal_dev_t termDev;
            char *localTermName;
            pal_nwAddr_t nwTermAddr;
            byte_t *termExtData;
            int termExtDataLen;
        } fs;



        struct {
            pal_nwAddr_t addrRemote;
            pal_nwAddr_t addrLocal;
        } nw;
    } tgt;




    pal_idList_t idList;




    pgmInfo_t accPgm;




    int kpcInfoCount;
    kenv_kpcInfo_t *kpcInfoHead;
    kenv_kpcInfo_t *curKPCInfo;
    kenv_kpcInfo_t _kpcInfo;



    void *auxDatap1;
} kenv_env_t;
extern pal_authID_t kenv_envGetAuthID(kenv_envHandle_t);
extern pal_idList_t *kenv_envGetIdListRef(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetPathFids(kenv_envHandle_t, int *);
extern void kenv_envSetPathFids(kenv_envHandle_t, int, pal_rawFid_t *);
extern void kenv_envSetRfid(kenv_envHandle_t, pal_rawFid_t *, pal_fattr_t *);
extern void kenv_envSetFattr(kenv_envHandle_t, pal_fattr_t *);
extern pal_fattr_t *kenv_envGetFattr(kenv_envHandle_t);
extern void kenv_envSetKPCInfo(kenv_envHandle_t , kenv_kpcInfo_t *);
extern kenv_kpcInfo_t * kenv_envGetKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfo(kenv_envHandle_t);
extern void kenv_envSetNextKPCInfo(kenv_envHandle_t);
extern void kenv_envSetFirstKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfoResName(kenv_envHandle_t,
                                        kenv_kpcInfo_t *, char *, int);
extern char * kenv_envGetProgram(kenv_envHandle_t);
extern pal_rawFid_t *
        kenv_envGetPgmFidAndDirFid(kenv_envHandle_t,
                                   pal_rawFid_t **, pal_fattr_t **);
extern char *kenv_envSetPgmResource(kenv_envHandle_t, char *, int);
extern char *kenv_envGetPgmResource(kenv_envHandle_t);
extern void kenv_envSetAuxFileActive(kenv_envHandle_t, int);
extern char *kenv_envGetTrappedName(kenv_envHandle_t, int *);
extern char *kenv_envGetBaseName(kenv_envHandle_t);
extern void kenv_envSetImpProcAccId(kenv_envHandle_t, pal_authID_t);
extern void kenv_envProgramExecUpdate(kenv_envHandle_t);
extern void kenv_envSaveProgramState(kenv_envHandle_t);
extern void kenv_envRestoreProgramState(kenv_envHandle_t);
extern void kenv_envTrackOpenFd(kenv_envHandle_t, int, int);
extern int kenv_envGetFdInfo(kenv_envHandle_t, int);
extern void kenv_envGetTerminals(kenv_envHandle_t,
                                 pal_dev_t **, pal_nwAddr_t **);
extern pal_dev_t *kenv_envGetTermDev(kenv_envHandle_t);
extern char *kenv_envSetLocalTermName(kenv_envHandle_t, char *);
extern byte_t *kenv_envSetTermExtData(kenv_envHandle_t, int, byte_t *);
extern byte_t *kenv_envGetTermExtData(kenv_envHandle_t, int *);
extern pal_nwAddr_t *kenv_envGetNWTerm(kenv_envHandle_t);
extern void kenv_envResetTargetData(kenv_envHandle_t, int);
extern char *kenv_envFdToBname(kenv_envHandle_t);
extern pal_pathBuf_t *kenv_envGetFullSrnRef(kenv_envHandle_t);
extern void kenv_envSetFullSrnRef(kenv_envHandle_t, pal_pathBuf_t *);
extern pal_rawFid_t *kenv_envBuildPathFids(kenv_envHandle_t, int *);
extern pal_rawFid_t *kenv_envGetDirRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetFidsAndFattrs(kenv_envHandle_t,
                                              pal_rawFid_t **, pal_fattr_t **);

extern int kenv_envSetKPCCurrent(kenv_envHandle_t, char *);




extern void kenv_envSetTrappedNameRef(kenv_env_t *, char *, int);
extern void kenv_envInit(kenv_env_t *);
extern void kenv_envClean(kenv_env_t *);
extern int kenv_envProcessTrappedPath(kenv_env_t *, int);
extern int kenv_envProcessAuxPath(kenv_env_t *, char *, int, int);
extern void kenv_envUpdateACLInfo(kenv_env_t *);
extern void kenv_envInitialize(void);
extern void kenv_envShutdown(void);
extern kenv_env_t *kenv_envAllocEnv(void);
extern void kenv_envFreeEnv(kenv_env_t *);
typedef struct kaznStats {
    int32_t accAllowedCalls;
    int32_t checkAccessCalls;
    int32_t totalGrants;
    int32_t totalDenies;
    int32_t rcGrants;
    int32_t privGrants;
    int32_t padA;
    int32_t loginIdSets;
    int32_t secIdSets;
    int32_t noTrustDenies;
    int32_t impSetId;
    int32_t padB;
    int32_t pdosdCalls;
    int32_t pdosdActiveCalls;
    int32_t pdosdFileCalls;
    int32_t pdosdIdCalls;
    int32_t pdosdNetCalls;
    int32_t pdosdLoginCalls;
    int32_t pdosdFail;
    int32_t pdosdGrantError;
    int32_t pdosdDenyError;
    int32_t pdosdGrantAudit;
    int32_t pdosdDenyAudit;
    int32_t pdosdSlowCalls;
    int32_t pdosdTimeOuts;
    int32_t pdosdBusy;
    int32_t pdosdInWarning;
} kaznStats_t;




extern kazn_expandSRN;
typedef int kazn_aznResult_t;
extern kaznStats_t kaznStats;

extern char *kazn_grantStr;
extern char *kazn_denyStr;

extern int kazn_accessAllowed(kenv_envHandle_t, int, int, int);
extern kazn_aznResult_t kazn_checkAccess(kenv_envHandle_t, int, int, int);
extern void kazn_kpcUpdateLastNotify(void);
extern int kazn_setGrantSuserOnError(int);
extern void kazn_expandTrappedFilePath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kazn_init(void);
extern void kazn_shutdown(void);
typedef enum kpc_notifyOp {
    kpc_opAdd, kpc_opDelete
} kpc_notifyOp_t;

typedef enum kpc_objType {
    kpc_objFile,
    kpc_objNetwork,
    kpc_objIdset,
    kpc_objMyProgram

} kpc_objType_t;


typedef struct _addrType {
    int addrClassic:1;
    int addrV6:1;
    int noProto:1;
    int noServ:1;
    int noHostIP:1;
    int noHostName:1;
    int hostInline:1;
    int nwIn:1;
    int nwOut:1;
    int pad:23;
} kpc_nwAddrType_t;





typedef struct idInfo {
    int64_t idValue __attribute__ ((aligned (8)));
    int isGroupId:1;
} __attribute__ ((aligned (8))) kpc_idInfo_t;







typedef oss_nwAddr_t kpc_nwAddr_t;


typedef struct _portrange {
    uint16_t portLow;
    uint16_t portHigh;
} kpc_portrange_t;
typedef struct _nwdesc {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));



    pal_ptr32_t pHost;

    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        kpc_portrange_t *setp;
    } portRange;
    char *wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc_t;




typedef struct _resInfo {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        kpc_nwDesc_t *nwDesc;


    } resDesc;





    char *resourceName;


    byte_t *extData;


} kpc_resourceInfo_t;
typedef struct kpcRecord {
    kpc_resFlags_t flags;
    int32_t extDataLen;
    int32_t howFound;
    uint32_t branchId;
    int32_t reserved[4];
    char kpon[1024];
    byte_t extData[6144];
} kpc_record_t;
typedef struct _nwdesc32 {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));
    pal_ptr32_t pHost;
    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        pal_ptr32_t set;
    } portRange;
    pal_ptr32_t wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc32_t;





typedef struct _resInfo32 {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        pal_ptr32_t pnwDesc;


    } resDesc;





    pal_ptr32_t resourceName;


    pal_ptr32_t extData;


} kpc_resourceInfo32_t;



typedef struct kpcattr {
    int64_t kpcEpoch __attribute__ ((aligned (8)));

    int64_t lastNotify __attribute__ ((aligned (8)));
    int64_t policyVersion __attribute__ ((aligned (8)));
    int64_t policyEpoch __attribute__ ((aligned (8)));




    int32_t resourceCount;
} __attribute__ ((aligned (8))) kpc_attr_t;
typedef struct kpc_info {
    kpc_attr_t attrs;
    uint32_t resourceChecks;
    uint32_t doEvals;
    uint32_t resourceAdds;
    uint32_t resourceDeletes;
    uint32_t setVersionCalls;
    uint32_t startEpochCalls;
    uint32_t commitEpochCalls;
} kpc_info_t;

extern kpc_info_t kpcInfo;
typedef struct kpc_kptr
{
    uint32_t high;
    uint32_t low;
} kpc_kptr_t;

typedef struct kpc_fdumpRec {
    uint32_t resFlags;
    uint32_t intResFlags;
    uint32_t pointerSize;
    uint32_t branchId;
    kpc_kptr_t resPtr;
    kpc_kptr_t rfidPtr;
    kpc_kptr_t dfidPtr;
    char resName[156];
} kpc_fdumpRec_t;



typedef struct kpc_fdumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_fdumpRec_t frecs[3072];
} kpc_fdumpBlock_t;



typedef struct kpc_ndumpRec
{
    kpc_nwAddrType_t addrType;
    uint32_t pointerSize;
    uint32_t branchId;
    int64_t policyVersion __attribute__ ((aligned (8)));
    kpc_kptr_t protPtr;
    kpc_kptr_t servPtr;
    kpc_kptr_t hostPtr;
    char resName[156];
} __attribute__ ((aligned (8))) kpc_ndumpRec_t;



typedef struct kpc_ndumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_ndumpRec_t nrecs[128];
} kpc_ndumpBlock_t;




extern kpc_info_t kpcInfo;
extern void kazn_kpcNetSetActive(int);
extern int kazn_kpcNetGetActive(void);

extern void kazn_kpcInit(void);
extern int kazn_kpcCheckResource(kenv_envHandle_t, int, int, int);
extern int kazn_kpcFileCheckResource(kenv_envHandle_t, int, int);
extern int kazn_kpcNetCheckResource(kenv_envHandle_t, int, int);
extern char *kazn_kpcFileFindPgmResource(kenv_envHandle_t, kpc_resFlags_t *);
extern void kazn_kpcFileDirNotify(char *);
extern char *kazn_kpcFileFindTerminal(kenv_envHandle_t, int *, byte_t **);
extern void kazn_kpcFileInit(void);
extern void kazn_kpcFileShutdown(void);
extern void kazn_kpcFileEpochNotify(int64_t, int);
extern void kazn_kpcNetInit(void);
extern void kazn_kpcNetShutdown(void);
extern void kazn_kpcFileRefreshNotify(kenv_envHandle_t);
extern void kazn_kpcFileCreateNotify(kenv_envHandle_t);
extern int kazn_kpcfRunAsync(void);
extern void kpcf_asyncLUThread(void);
extern int kpcf_asyncStopLookup(void);




void kazn_kpcfTriggerAsyncRefresh(int);

extern void kazn_kpcfStopAsync(void);
extern int64_t kazn_kpcStartNewPolicyEpoch(void);
extern int kazn_kpcCommitPolicyEpoch(int64_t);
extern void kazn_kpcfFlushNegCache(void);


extern void kazn_kpcSetPolicyVersion(int64_t);
extern void kazn_kpcGetAttr(kpc_attr_t *);
extern int kazn_kpcAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetDelResource(kpc_resourceInfo_t *);
extern void kazn_kpcNetSetResource(int, kenv_envHandle_t, char *);
typedef struct kazn_rcfStats {
    int32_t checks;
    int32_t grants;
    int32_t inheritGrants;
    int32_t viaPgmGrants;
    int32_t wcGrants;
    int32_t adds;
    int32_t reclaimAdds;
    int32_t updates;
    int32_t flushes;
    int32_t baseCacheSize;
} kazn_rcfStats_t;





typedef struct kazn_rcIdStats {
    int32_t checks;
    int32_t grants;
    int32_t adds;
    int32_t reclaimAdds;
    int32_t updates;
    int32_t flushes;
} kazn_rcIdStats_t;



extern kazn_rcfStats_t kazn_rcfStats;
extern kazn_rcIdStats_t kazn_rcIdStats;


extern int kazn_rcCheck(kenv_envHandle_t, int, int, int);
extern int kazn_rcAddGrant(kenv_envHandle_t, int, int, int);

extern int kazn_rcfCheck(kenv_envHandle_t, int, int);
extern int kazn_rcfAddGrant(kenv_envHandle_t, int, int);

extern int kazn_rcIdCheck(kenv_envHandle_t, int, int);
extern int kazn_rcIdAddGrant(kenv_envHandle_t, int, int);

extern int kazn_rcGetActive(void);
extern void kazn_rcSetActive(int);
extern void kazn_rcInit(void);
extern void kazn_rcfInit(void);
extern void kazn_rcIdInit(void);

extern void kazn_rcfFlushAll(void);
extern void kazn_rcIdFlush(void);

extern void kazn_rcShutdown(void);
extern void kazn_rcfShutdown(void);
static pal_mutex_t kpcLock;




kpc_info_t kpcInfo;
void
kazn_kpcUpdateLastNotify()
{
    (kail_mutex_lock(&kpcLock));
    kpcInfo.attrs.lastNotify = ((pal_time_t)(kail_xtime->tv_sec));
    (kail_mutex_unlock(&kpcLock));
}
void
kazn_kpcSetPolicyVersion(int64_t pv)
{
    (kail_mutex_lock(&kpcLock));
    kpcInfo.attrs.policyVersion = pv;
    kpcInfo.setVersionCalls++;
    (kail_mutex_unlock(&kpcLock));
    kazn_rcfFlushAll();
    kazn_rcIdFlush();
}
int64_t
kazn_kpcStartNewPolicyEpoch(void)
{
    int64_t pe;

    (kail_mutex_lock(&kpcLock));
    kpcInfo.attrs.policyEpoch++;
    kpcInfo.startEpochCalls++;
    pe = kpcInfo.attrs.policyEpoch;
    (kail_mutex_unlock(&kpcLock));

    kazn_kpcFileEpochNotify(pe, 0);
    return pe;
}
int
kazn_kpcCommitPolicyEpoch(int64_t pe)
{
    int rc = 0;

    (kail_mutex_lock(&kpcLock));
    kpcInfo.commitEpochCalls++;
    if (pe != kpcInfo.attrs.policyEpoch) {
        rc = EINVAL;
    }
    (kail_mutex_unlock(&kpcLock));

    if (rc == 0) {
        kazn_kpcFileEpochNotify(pe, 1 );
    }

    return rc;
}
void
kazn_kpcGetAttr(kpc_attr_t *attrp)
{
    (kail_mutex_lock(&kpcLock));
    *attrp = kpcInfo.attrs;
    (kail_mutex_unlock(&kpcLock));
}
int
kazn_kpcDelResource(kpc_resourceInfo_t *rip)
{
    int rc;

    switch(rip->objType) {
    case kpc_objFile:
        rc = kazn_kpcFileDelResource(rip);
        break;

    case kpc_objNetwork:
        rc = kazn_kpcNetDelResource(rip);
        break;

    case kpc_objIdset:
        rc = 0;
        break;

    default:
        rc = EINVAL;
        break;
    }

    if (!rc) {
        (kail_mutex_lock(&kpcLock));
        kpcInfo.attrs.resourceCount--;
        kpcInfo.resourceDeletes++;
        (kail_mutex_unlock(&kpcLock));
    }
    return rc;
}
int
kazn_kpcAddResource(kpc_resourceInfo_t *rip)
{
    int rc;

    switch(rip->objType) {
    case kpc_objFile:
        rc = kazn_kpcFileAddResource(rip);
        break;

    case kpc_objNetwork:
        rc = kazn_kpcNetAddResource(rip);
        break;

    case kpc_objIdset:
        rc = 0;
        break;

    default:
        rc = EINVAL;
        break;
    }

    if (!rc) {
        (kail_mutex_lock(&kpcLock));
        kpcInfo.attrs.resourceCount++;
        kpcInfo.resourceAdds++;
        (kail_mutex_unlock(&kpcLock));
    }
    return rc;
}
int
kazn_kpcCheckResource(
    kenv_envHandle_t accEnv,
    int objType,
    int action,
    int extFlags)
{
    int doEval;

    kenv_envResetKPCInfo(accEnv);

    switch(objType) {
    case 1:
        doEval = kazn_kpcFileCheckResource(accEnv, action, extFlags);
        break;

    case 3:
        doEval = kazn_kpcNetCheckResource(accEnv, action, extFlags);
        break;

    case 2:

        doEval = 1;
        break;

    default:
        ;
        doEval = 1;
        break;
    }


    (kail_mutex_lock(&kpcLock));
    kpcInfo.resourceChecks++;
    if (doEval)
        kpcInfo.doEvals++;
    (kail_mutex_unlock(&kpcLock));

    return doEval;
}
static void
loadInitialLoginPrograms(void)
{

    char **nptr;
    kpc_resourceInfo_t ri;

    memset(&ri,0,sizeof(ri));
    ri.flags.isLoginPgm = 1;
    ri.flags.isTCB = 1;
    ri.objType = kpc_objFile;
    ri.op = kpc_opAdd;

    for (nptr = pal_loginPrograms; nptr && *nptr; nptr++) {
        ri.resourceName = *nptr;
        (void)kazn_kpcFileAddResource(&ri);
    }

}
void
kazn_kpcInit(void)
{
    (kail_mutex_init(&kpcLock));
    memset(&kpcInfo,0,sizeof(kpcInfo));
    kpcInfo.attrs.kpcEpoch = (uint32_t)((pal_time_t)(kail_xtime->tv_sec));
    kazn_kpcFileInit();
    loadInitialLoginPrograms();



}
