
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)98	1.81  src/oss/kazn/kenv/kenv_env.c, oss.kazn.src, oss600, 050318a  3/16/05  17:09:00";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));

extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));

extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );




struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;
        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#ifdef LINUX_RHEL4
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
enum kt_msgs {
    KT_TRACE_DUMMY = 1024,
    KT_TRACE_STR,
    KT_TRACE_INT,
    KT_TRACE_LKUPNAME,
    KT_TRACE_PROCESS_PATH,
    KT_TRACE_NOFID,
    KT_TRACE_TRACK_OPEN,
    KT_TRACE_KAZN_PATH_ACCESS,
    KT_TRACE_KAZN_PATH_ACCESS_RTN,
    KT_TRACE_KPC_NOTIFY,
    KT_TRACE_KPC_NOTIFY_RTN,
    KT_TRACE_KPC_GETATTR,
    KT_TRACE_KPC_GETATTR_RTN,
    KT_TRACE_KPC_SETVERSION,
    KT_TRACE_KPC_SETVERSION_RTN,
    KT_TRACE_KPC_SETEPOCH,
    KT_TRACE_KPC_SETEPOCH_RTN,
    KT_TRACE_KOSS_SYSCALL,
    KT_TRACE_KOSS_SYSCALL_RTN,
    KT_TRACE_KOSS_REGISTER,
    KT_TRACE_KOSS_REGISTER_RTN,
    KT_TRACE_KOSS_SET_PRIVID,
    KT_TRACE_KOSS_SET_PRIVPID,
    KT_TRACE_KOSS_ALLOC_FAIL,
    KT_TRACE_KOSS_INT_ERR,
    KT_TRACE_KAUD_SETLEVEL,
    KT_TRACE_KAUD_SETLEVEL_RTN,
    KT_TRACE_KAUD_AUD_SERVICE,
    KT_TRACE_KAUD_AUD_SERVICE_RTN,
    KT_TRACE_CSC_SETGROUPS,
    KT_TRACE_KOSS_PRIVCHECK,
    KT_TRACE_KOSS_PRIVCHECK_IDS,
    KT_TRACE_KOSS_PRIVCHECK_RTN,
    KT_TRACE_CSC_SUID,
    KT_TRACE_CSC_SUID2,
    KT_TRACE_CSC_SGID,
    KT_TRACE_CSC_SUID_BYPASS,
    KT_TRACE_CSC_SGID_BYPASS,
    KT_TRACE_KOSS_SET_ACTIVE,
    KT_TRACE_KOSS_SET_INACTIVE,
    KT_TRACE_KOSS_SET_STATE,
    KT_TRACE_NCT_OCREAT_CK_LINK_TGT,
    KT_TRACE_CSC_LOGIN_DIRECT_BP,
    KT_TRACE_KUTIL_GET_LOGIN_DATA,
    KT_TRACE_KUTIL_GET_LOGIN_DATA_EXIT,
    KT_TRACE_KAUD_LOG_USER_EVENT,
    KT_TRACE_KAUD_LOG_USER_EVENT_EXIT,
    KT_TRACE_KAUD_TRACE_EVENT,
    KT_TRACE_KAUD_TRACE_EVENT_EXIT,
    KT_TRACE_KAUD_LOGOUT_NOTERM,
    KT_TRACE_KAUD_LOGOUT_LOCTERM,
    KT_TRACE_KAUD_LOGOUT_REMTERM,
    KT_TRACE_KAUD_LOGOUT_EXIT,
    KT_TRACE_KAUD_TRACE_PID_EXEMPT,
    KT_TRACE_KAUD_TRACE_UID_EXEMPT,
    KT_TRACE_KOSS_INIT_PROC_RGY,
    KT_TRACE_KOSS_ASYNC_LU_START,
    KT_TRACE_KOSS_ASYNC_LU_STOP,
    KT_TRACE_KOSS_ASYNC_LU_TIMEOUT,
    KT_TRACE_KOSS_ASYNC_LU_STATE,
    KT_TRACE_KPCF_TRIG_REF,
    KT_TRACE_KPCF_SCAN_TIME,
    KT_TRACE_SHMEM_REINIT,
    KT_TRACE_SHMEM_REINITERR,
    KT_TRACE_SHMEM_INIT,
    KT_TRACE_SHMEM_FINI_ENT,
    KT_TRACE_SHMEM_FINI_WAITUSED,
    KT_TRACE_SHMEM_FINI_FAILUSED,
    KT_TRACE_SHMEM_FINI_FAILWAITERS,
    KT_TRACE_SHMEM_SRVT_START,
    KT_TRACE_SHMEM_SRVT_INVNODE,
    KT_TRACE_SHMEM_SRVT_ERRCOPY,
    KT_TRACE_SHMEM_SRVT_STOP,
    KT_TRACE_SHMEM_SRVT_WAIT,
    KT_TRACE_SHMEM_SRVT_WAITERR,
    KT_TRACE_SHMEM_STOP,
    KT_TRACE_GETMEM_NONE,
    KT_TRACE_SHBANG_TOOBIG,
    KT_TRACE_SHBANG_CHECK_READ,
    KT_TRACE_SHMEM_HELPER_START,
    KT_TRACE_SHMEM_HELPER_RESTART,
    KT_TRACE_SHMEM_HELPER_RETURN,
    KT_TRACE_SHMEM_CHECK_FAIL,
    KT_TRACE_SHMEM_NODE_RECLAIM,
    KT_TRACE_FDPATH_FAILURE,
    KT_TRACE_SHMEM_OLDPOOL_DEC
};
enum kt_kazn_msgs {
    KT_TRACE_KAZN_DUMMY = 2048,
    KT_TRACE_KAZN_ACC_ALLOWED_FI,
    KT_TRACE_KAZN_ACC_ALLOWED_ID,
    KT_TRACE_KAZN_ACC_ALLOWED_NW,
    KT_TRACE_KAZN_CFR,
    KT_TRACE_KAZN_CFR_HIT,
    KT_TRACE_KAZN_CFR_MISS,
    KT_TRACE_KAZN_KPCF_ADD,
    KT_TRACE_KAZN_KPCF_UPDATE,
    KT_TRACE_KAZN_KPCF_DEL,
    KT_TRACE_KPCF_DINS,
    KT_TRACE_KPCF_REFRES,
    KT_TRACE_KPCF_REFRES_RTN,
    KT_TRACE_KPCF_REF_FR,
    KT_TRACE_KPCF_NCADD,
    KT_TRACE_KPCF_NCHIT,
    KT_TRACE_KPCF_NCFLUSH,
    KT_TRACE_KPCF_DIR_NOTIFY,
    KT_TRACE_KPCF_EPOCH_DEL,
    KT_TRACE_KPCF_HIT_WC,
    KT_TRACE_KAZN_LOGIN_SUSKIP,
    KT_TRACE_KAZN_SECPGM_SUSKIP,
    KT_TRACE_KAZN_PRIVPGM_PERMIT,
    KT_TRACE_KPCF_HIT_LOCALTERM,
    KT_TRACE_KAZN_ACC_ALLOWED_EFLAGS,
    KT_TRACE_KAZN_RES_NOAZN,
    KT_TRACE_KPCF_KPCI_ADD_PO,
    KT_TRACE_KAZN_CHECKACCESS,
    KT_TRACE_KAZN_CHECKACCESS_GRANT,
    KT_TRACE_KAZN_CHECKACCESS_DENY,
    KT_TRACE_KAZN_CHECKACCESS_DENY_MORE,
    KT_TRACE_KPCF_REFRESH_NOTIFY,
    KT_TRACE_KPCF_CHECKPATH,
    KT_TRACE_KPCF_CKPATH_RTN,
    KT_TRACE_KPCF_CKPATH_FAST_RTN,
    KT_TRACE_KPCF_REF_DHASH,
    KT_TRACE_KPCF_REF_DHASH_RTN,
    KT_TRACE_RCF_ADD_GRANT,
    KT_TRACE_RCF_ADD_GRANT_RES,
    KT_TRACE_RCF_CHECK,
    KT_TRACE_RCF_CHECK_GRANT,
    KT_TRACE_RCF_CHECK_NOGRANT,
    KT_TRACE_RCF_FLUSH,
    KT_TRACE_RCF_COND_INFO,
    KT_TRACE_KAZN_DAEMON_EBUSY,
    KT_TRACE_KPCF_BKG_SLEEP,
    KT_TRACE_KPCF_BKG_RUN,
    KT_TRACE_KPCF_EPOCH_NOT,
    KT_TRACE_KPCF_EPOCH_NOT_COMMIT,
    KT_TRACE_KAZN_RES_NOTIFY,
    KT_TRACE_KPC_GET_NEWEPOCH,
    KT_TRACE_KPC_COMMIT_EPOCH,
    KT_TRACE_CSC_OPEN,
    KT_TRACE_CSC_KILL_ERR,
    KT_TRACE_KPCF_GENFID_ERR,
    KT_TRACE_KPCF_NOFID_REFRESH,
    KT_TRACE_KPCF_ADD_IMMUNE,
    KT_TRACE_KPCF_UPDATE_IMMUNE,
    KT_TRACE_KAZN_ERR_GRANT,
    KT_TRACE_KAZN_FIND_PGM_KPON,
    KT_TRACE_KAZN_FIND_PGM_KPON_FOUND,
    KT_TRACE_KAZN_FIND_PGM_KPON_NONE,
    KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG,
    KT_TRACE_KAZN_KPC_QFILE,
    KT_TRACE_KAZN_KPC_QFILE_RTN,
    KT_TRACE_KAZN_KPC_QPGM,
    KT_TRACE_KAZN_KPC_QPGM_RTN,
    KT_TRACE_KAZN_KPC_DHASHFID_EXIT,
    KT_TRACE_KAZN_KPC_DHASHNAME_EXIT,
    KT_TRACE_KAZN_KPC_CREATE_NOTIFY,
    KT_TRACE_RCID_ADD_GRANT,
    KT_TRACE_RCID_ADD_GRANT_RES,
    KT_TRACE_RCID_CHECK,
    KT_TRACE_RCID_CHECK_GRANT,
    KT_TRACE_RCID_CHECK_NOGRANT,
    KT_TRACE_RCID_FLUSH,
    KT_TRACE_KAZN_AZNCALL_REMAP_TO,
    KT_TRACE_KPCF_EXCEPTION_ADD,
    KT_TRACE_KAZN_AZND_TOUT,
    KT_TRACE_KAZN_EXPAND_PATH,
    KT_TRACE_KAZN_EXPAND_PATH_ERR,
    KT_TRACE_KAZN_EXPAND_PATH_SKIP,
    KT_TRACE_KAZN_UFILE_HIT,
    KT_TRACE_KAZN_UFILE_ADD,
    KT_TRACE_KAZN_UFILE_MISS,
    KT_TRACE_KAZN_UFILE_FLUSH,
    KT_TRACE_KPCF_REF_DH_BYFID,
    KT_TRACE_KPCF_REF_DH_BYFID_END,
    KT_TRACE_EXEC_SETUSER,
    KT_TRACE_EXEC_SETGROUP,
    KT_TRACE_KAZN_CHECK_FID_ONLY,
    KT_TRACE_KAZN_EXEMPT_PID_PERMIT,
    KT_TRACE_KAZN_PFC_HIT,
    KT_TRACE_KAZN_PFC_ADD,
    KT_TRACE_KAZN_PFC_MISS,
    KT_TRACE_KAZN_PFC_FLUSH,
    KT_TRACE_KAZN_PFC_FLUSHBYRES,
    KT_TRACE_KAZN_PFC_PROTRES_RELE,
    KT_TRACE_KAZN_ACC_ALLOWED_PERMIT,
    KT_TRACE_KAZN_ACC_ALLOWED_DENY,

    KT_TRACE_KAZN_AUTOFS_NOREF,

    KT_TRACE_KAZN_NW_ADDR_BADFAM,
    KT_TRACE_KAZN_RES_TRY_AGAIN,
    KT_TRACE_KAZN_KPC_QNW,
    KT_TRACE_KAZN_KPC_QNW_RTN,
    KT_TRACE_KAZN_IMSURPGM_SUSKIP,
    KT_TRACE_KAZN_USER_AUDIT_LOGOUT,
    KT_TRACE_KAZN_ALWAYS_SET_KPON,
    KT_TRACE_KAZN_FILTER_RES,
    KT_TRACE_KAZN_KPCFT_DELAY,
    KT_TRACE_KAZN_IPV6_ADDR,
    KT_TRACE_KAZN_DHANAL_FRL_CLR,
    KT_TRACE_KAZN_SET_ALIAS,
    KT_TRACE_KAZN_HAS_ALIAS,
    KT_TRACE_KAZN_RES_WAIT,
    KT_TRACE_KAZN_RES_REFD,
    KT_TRACE_KAZN_RES_BROADCAST,
    KT_TRACE_KAZN_DHASH_REF_LOOP,
    KT_TRACE_KAZN_USE_COPY,
    KT_TRACE_KAZN_NO_COPY,
    KT_TRACE_KAZN_DENY_SHMCTL_OP,
    KT_TRACE_KAZN_DHASH_SEARCH_STALE
};







enum kt_kmsg_msgs {
    KT_TRACE_KMSG_DUMMY = 3072,
    KT_TRACE_KMSG_INIT,
    KT_TRACE_KMSG_FINISH,
    KT_TRACE_KMSG_OPEN,
    KT_TRACE_KMSG_CLOSE,
    KT_TRACE_KMSG_IOCTL,
    KT_TRACE_KMSG_READ_ENTRY,
    KT_TRACE_KMSG_READ_EXIT,
    KT_TRACE_KMSG_READ_WAIT,
    KT_TRACE_KMSG_READ_WORK,
    KT_TRACE_KMSG_WRITE_ENTRY,
    KT_TRACE_KMSG_WRITE_EXIT,
    KT_TRACE_KMSG_WRITE_ID,
    KT_TRACE_KMSG_WRITE_LEN,
    KT_TRACE_KMSG_SEND_REQ,
    KT_TRACE_KMSG_GET_RESP,
    KT_TRACE_KMSG_RECV_RESP,
    KT_TRACE_KMSG_GET_HAND,
    KT_TRACE_KMSG_FREE_HAND,
    KT_TRACE_KMSG_WAIT_MSG,

    KT_TRACE_KMSG_BADTRANID,
    KT_TRACE_KMSG_BADSIZE,
    KT_TRACE_KMSG_TOOBIG,
    KT_TRACE_KMSG_CHANCLOSED,
    KT_TRACE_KMSG_ERR_GET_HAND,
    KT_TRACE_KMSG_GET_RESP_ERR,
    KT_TRACE_KMSG_CHAN_DOWN,
    KT_TRACE_KMSG_CHAN_RETRY,
    KT_TRACE_KMSG_WAIT_TO,
    KT_TRACE_KMSG_HARD_TO,
    KT_TRACE_KMSG_TO_RETRY,
    KT_TRACE_KMSG_DOWN_TO_TOUT
};







enum kt_kenv_msgs {
    KT_TRACE_KENV_DUMMY = 4096,
    KT_TRACE_KENV_NEW_PROC_INFO,
    KT_TRACE_KENV_PR_ADD_FD,
    KT_TRACE_KENV_PR_CLOSE_FD,
    KT_TRACE_KENV_PR_RET_FDINFO,
    KT_TRACE_KENV_PR_GROW_FDTABLE,
    KT_TRACE_KENV_PR_ADD_FLAGS,
    KT_TRACE_KENV_PR_DEL_FLAGS,
    KT_TRACE_KENV_PR_SET_IMP_ID,
    KT_TRACE_KENV_E_NW_TERM,
    KT_TRACE_KENV_E_DEV_TERM,
    KT_TRACE_KENV_E_NO_TERM,
    KT_TRACE_KENV_PR_ADD_FLAGS_BNAME,
    KT_TRACE_KENV_PTP_E2BIG,
    KT_TRACE_KENV_PTP_E2BIG_RETRY,
    KT_TRACE_KENV_PR_GET_TRUE_ACCID,
    KT_TRACE_KENV_PR_SET_ACC_ID,
    KT_TRACE_KENV_PR_ADD_NO_FORK,
    KT_TRACE_KENV_PR_ADD_REMT_TERM,
    KT_TRACE_KENV_PR_GET_REMT_TERM,
    KT_TRACE_KENV_BUMP_STREAM_COUNT,
    KT_TRACE_KENV_DELAY_PROC_DEL,
    KT_TRACE_KENV_PROC_INFO_NOTPAR,
    KT_TRACE_KENV_E_NW_TERM_IPV6,
    KT_TRACE_KENV_IPV6_ADDR,
    KT_TRACE_KENV_PR_NOSET_REMT,
    KT_TRACE_KENV_SHMEM_TOOBIG,
    KT_TRACE_KENV_SHMEM_WAIT,
    KT_TRACE_KENV_SHMEM_STOPPED,
    KT_TRACE_KENV_SHMEM_NOFREE,
    KT_TRACE_KENV_SHMEM_INVNODE,
    KT_TRACE_KENV_SHMEM_RQWAIT,
    KT_TRACE_KENV_SHMEM_RQDONE,
    KT_TRACE_KENV_SHMEM_PUTERR,
    KT_TRACE_KENV_SHMEM_PUT,
    KT_TRACE_KENV_GETMEM_REL,
    KT_TRACE_KENV_GETMEM_NEVER,
    KT_TRACE_KENV_GETMEM_OK,
    KT_TRACE_KENV_GETMEM_OFF,
    KT_TRACE_KENV_GETMEM_ERR,
    KT_TRACE_KENV_PUTMEM,
    KT_TRACE_KENV_SHMAT_RESET,
    KT_TRACE_KENV_SHMREQ_SCAN_DELAY,
    KT_TRACE_KENV_SHMREQ_SCAN_NOW,
    KT_TRACE_KENV_SHMREQ_REC_NOPID,
    KT_TRACE_KENV_SHMREQ_REC_EXP,
    KT_TRACE_KENV_SHMREQ_SCAN_RET,
    KT_TRACE_KENV_SHMEM_RESET_EXEC,
    KT_TRACE_KENV_PROC_FORK_CHILD,
    KT_TRACE_KENV_PROC_FORK_PAR,
    KT_TRACE_KENV_PROC_ALREADY,
    KT_TRACE_KENV_PROC_CONDADD,
    KT_TRACE_KENV_PROC_EXISTS,
    KT_TRACE_KENV_PR_ADD_NO_PAR,
    KT_TRACE_KENV_PROC_ADD,
    KT_TRACE_KENV_PROC_ADD_PPID,
    KT_TRACE_KENV_PROC_TERM,
    KT_TRACE_KENV_PROC_USE_DEAD
};







enum kt_dbg_msgs {
    KT_TRACE_DBG_DUMMY = 8192,
    KT_TRACE_DBG_NCT_Q_AREQ,
    KT_TRACE_DBG_NCT_START_AREQ,
    KT_TRACE_DBG_NCT_END_AREQ,
    KT_TRACE_DBG_PAL_NO_FID,
    KT_TRACE_DBG_PAL_LKUP_ERR,
    KT_TRACE_DBG_PAL_DCOMP_ERR,
    KT_TRACE_DBG_PAL_LU_FID_DIR,
    KT_TRACE_DBG_TLI_SVC_PRIM_PEND,
    KT_TRACE_DBG_TLI_SVC_PRIM_NOPEND,
    KT_TRACE_DBG_NCT_PATH_OP_RESULT,
    KT_TRACE_DBG_NCT_FD_OP_RESULT,
    KT_TRACE_DBG_NCT_KILL_COMMON,
    KT_TRACE_DBG_NCT_KILL_TRAP,
    KT_TRACE_DBG_NCT_KILL_FILTER_PGRP,
    KT_TRACE_DBG_NCT_KILL_FILTER_USER,

    KT_TRACE_DBG_PAL_FILE_COUNT,
    KT_TRACE_DBG_PAL_FILE_LOOKUP22,
    KT_TRACE_DBG_PAL_FILE_LOOKUP24,

    KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP,
    KT_TRACE_DBG_RFID_FL_VFSP,
    KT_TRACE_DBG_AUTO_FS_MOUNTED,
    KT_TRACE_DBG_DEFER_UMOUNT,
    KT_TRACE_DBG_CHECK_VFS_MOUNTED,
    KT_TRACE_DBG_MOUNTED_YES,
    KT_TRACE_DBG_MOUNTED_NO,
    KT_TRACE_DBG_VFS_DATA_SET,
    KT_TRACE_DBG_FURTHER_LKUP_REQ,
    KT_TRACE_DBG_NEXT_LOOKUP,
    KT_TRACE_DBG_GEN_RES_FIDS,
    KT_TRACE_DBG_CHECK_FID_PATH,

    KT_TRACE_DBG_RESET_VFS_DATA,
    KT_TRACE_DBG_FAILED_VFS_SEARCH,
    KT_TRACE_DBG_ASYNC_LU_START,
    KT_TRACE_DBG_DEFER_UNAVAIL,
    KT_TRACE_DBG_REFRESH_FSID_EQ,
    KT_TRACE_DBG_REFRESH_FSID_NOFID,
    KT_TRACE_DBG_REFRESH_EPOCH,

    KT_TRACE_DBG_KPCF_ADD_RES,
    KT_TRACE_DBG_KPCF_AZN_FLAGS,
    KT_TRACE_DBG_NCT_FORK_TRAP,
    KT_TRACE_DBG_EXIT_CHECK_LEAF,

    KT_TRACE_DBG_SHMEM_SRVT_WAIT,
    KT_TRACE_DBG_SHMEM_SRVT_PROC,
    KT_TRACE_DBG_SHMEM_SRVT_RECLAIM,
    KT_TRACE_DBG_SHBANG_EXEC,
    KT_TRACE_DBG_SHMEM_HELPER_CHECK,
    KT_TRACE_DBG_FDPATH_BUILT,
    KT_TRACE_DBG_BYPASS_ENTRY1,
    KT_TRACE_DBG_BYPASS_ENTRY2,
    KT_TRACE_DBG_BYPASS_EXIT
};
enum kt_ffdc_msgs {
    KT_TRACE_FFDC_DUMMY = 5120,
    KT_TRACE_FFDC_STR,
    KT_TRACE_FFDC_AZNCALL_FILE,
    KT_TRACE_FFDC_AZNCALL_IDSET,
    KT_TRACE_FFDC_AZNCALL_NWOUT,
    KT_TRACE_FFDC_AZNCALL_NWIN,
    KT_TRACE_FFDC_AZNCALL_RACC_ADDR,
    KT_TRACE_FFDC_AZNCALL_CONT,
    KT_TRACE_FFDC_AZNCALL_RES_PERMIT,
    KT_TRACE_FFDC_AZNCALL_RES_DENY,
    KT_TRACE_FFDC_ERR_GRANT,
    KT_TRACE_FFDC_AZNCALL_SLOW,
    KT_TRACE_FFDC_CSC_LOGIN,
    KT_TRACE_FFDC_CKLOGIN,
    KT_TRACE_FFDC_CKLOGIN_EXIT,
    KT_TRACE_FFDC_CKLOGIN_DOAZN,
    KT_TRACE_FFDC_EXEC_PGM,
    KT_TRACE_FFDC_EXEC_PGM_LINK,
    KT_TRACE_FFDC_EXEC_SUPGM,
    KT_TRACE_FFDC_EXEC_SGPGM,
    KT_TRACE_FFDC_EXEC_SUGPGM,
    KT_TRACE_FFDC_EXEC_DENIED,
    KT_TRACE_FFDC_EXEC_ALLOWED,
    KT_TRACE_FFDC_LOGOUT_LOC,
    KT_TRACE_FFDC_LOGOUT_REM,
    KT_TRACE_FFDC_PROC_ADD,
    KT_TRACE_FFDC_PROC_ADD_PPID,
    KT_TRACE_FFDC_PROC_TERM,
    KT_TRACE_FFDC_NPC_FREE,
    KT_TRACE_FFDC_HOST_RULE_BAD,
    KT_TRACE_FFDC_CSC_V6TERM,
    KT_TRACE_FFDC_IPV6_ADDR
};




enum kt_knpc_msgs {
    KT_TRACE_KNPC_DUMMY = 6144,
    KT_TRACE_KNPC_STR,
    KT_TRACE_KNPC_SEARCH_SERVICE,
    KT_TRACE_KNPC_SEARCH_HOSTIP,
    KT_TRACE_KNPC_SEARCH_HOSTNAME,
    KT_TRACE_KNPC_SEARCH_PROTOCOL,
    KT_TRACE_KNPC_NET_UPD_ENTRY,
    KT_TRACE_KNPC_NET_UPD_ENTRY2,
    KT_TRACE_KNPC_KPCRES_ATTACH,
    KT_TRACE_KNPC_NET_ALREADY,
    KT_TRACE_KNPC_NETIN_ADD_NODE,
    KT_TRACE_KNPC_NETIN_DEL_ERR,
    KT_TRACE_KNPC_NETIN_DEL,
    KT_TRACE_KNPC_NETOUT_ADD_NODE,
    KT_TRACE_KNPC_NETOUT_DEL_ERR,
    KT_TRACE_KNPC_NETOUT_DEL,
    KT_TRACE_KNPC_NETIN_MATCH,
    KT_TRACE_KNPC_NETOUT_MATCH,
    KT_TRACE_KNPC_DUMP_HEADER,
    KT_TRACE_KNPC_DUMP_ELEM,
    KT_TRACE_KNPC_CUR_INIT,
    KT_TRACE_KNPC_CUR_FINI,
    KT_TRACE_KNPC_CHECK_RES,

    KT_TRACE_KNPCD_SERV_NODE_ALLOC,
    KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_SERV_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_HOSTIP_NODE_FREE,
    KT_TRACE_KNPCD_HOST_NODE_FREE,
    KT_TRACE_KNPCD_PROT_NODE_ALLOC,
    KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_PROT_NODE_FREE,
    KT_TRACE_KNPCD_MATCH_SERVICE,
    KT_TRACE_KNPCD_MATCH_HOSTIP,
    KT_TRACE_KNPCD_MATCH_PROTOCOL,
    KT_TRACE_KNPCD_KPON_FREE,
    KT_TRACE_KNPCD_WAIT_LOCK,
    KT_TRACE_KNPCD_SEARCH_SERV_ENTRY,
    KT_TRACE_KNPCD_SEARCH_NODE_CMP,
    KT_TRACE_KNPCD_FREE_NODE_REF,
    KT_TRACE_KNPCD_MATCH_HOSTNAME,
    KT_TRACE_KNPC_NETIN_SETRES,
    KT_TRACE_KNPC_NETOUT_SETRES,
    KT_TRACE_KNPC_ENV_SETRES,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC,
    KT_TRACE_KNPCD_HOSTIPV6_ADDR,
    KT_TRACE_KNPCD_HOSTIPV6_MASK,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIPV6_HIT_V4,
    KT_TRACE_KNPCD_HOSTIPV6_CMP,
    KT_TRACE_KNPC_SEARCH_HOSTIPV6,
    KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM,
    KT_TRACE_KNPCD_MATCH_HOSTIPV6,
    KT_TRACE_KNPC_BRANCH_CHANGE
};



enum kt_knrc_msgs {
    KT_TRACE_KNRC_DUMMY = 7168,
    KT_TRACE_KNRC_STR,
    KT_TRACE_KNRC_INIT_ERR,
    KT_TRACE_KNRC_INIT_CACHE,
    KT_TRACE_KNRC_FINI_FREE,
    KT_TRACE_KNRC_CHECK_GROW,
    KT_TRACE_KNRC_RECYCLE_ELEM,
    KT_TRACE_KNRC_NEW_POOL_ALLOC,
    KT_TRACE_KNRC_FLUSH,
    KT_TRACE_KNRC_ADD_EXACT,
    KT_TRACE_KNRC_ADD_GRANT_EXACT,
    KT_TRACE_KNRC_ADD_AMBIG,
    KT_TRACE_KNRC_AMBIG_HASH,
    KT_TRACE_KNRC_ADD_GRANT_AMBIG,
    KT_TRACE_KNRC_HAS_VIA,
    KT_TRACE_KNRC_ADD_STATS,
    KT_TRACE_KNRC_CHECK_EXACT,
    KT_TRACE_KNRC_RECLAIM_EXACT,
    KT_TRACE_KNRC_FID_NOMATCH,
    KT_TRACE_KNRC_HIT_EXACT,
    KT_TRACE_KNRC_NOMATCH_EXACT,
    KT_TRACE_KNRC_CHECK_STATS,
    KT_TRACE_KNRC_CHECK_AMBIG,
    KT_TRACE_KNRC_CHECK_HASHQ,
    KT_TRACE_KNRC_RECLAIM_AMBIG,
    KT_TRACE_KNRC_HIT_AMBIG,
    KT_TRACE_KNRC_NOMATCH_AMBIG,
    KT_TRACE_KNRC_RECLAIM,
    KT_TRACE_KNRC_RECLAIM_ELEM
};
struct sockaddr {
        unsigned short sa_family;
        char sa_data[14];
} ;
struct in_addr {
        uint s_addr;
};

struct sockaddr_in {
  unsigned short sin_family;
  unsigned short int sin_port;
  struct in_addr sin_addr;


  unsigned char __pad[16 - sizeof(short int) -
                        sizeof(unsigned short int) - sizeof(struct in_addr)];
};
struct in6_addr
{
        union
        {
                unsigned char u6_addr8[16];
                unsigned short u6_addr16[8];
                unsigned int u6_addr32[4];
        } in6_u;



};
struct sockaddr_in6 {
        unsigned short int sin6_family;
        unsigned short sin6_port;
        unsigned int sin6_flowinfo;
        struct in6_addr sin6_addr;
        unsigned int sin6_scope_id;
};


typedef struct sockaddr pal_sockaddr_t;
extern int pal_netSockFdToAddrInfo(int, int *, pal_nwAddr_t *, pal_nwAddr_t *);
extern int pal_netSaddrToNwAddr(pal_sockaddr_t *, pal_nwAddr_t *);
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void * kenv_pathReqHandle_t;







typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
typedef void (*kpc_res_rele_func_t)(void *);
typedef struct kpcInfo {
    struct kpcInfo *next;
    struct kpcInfo *prev;
    char *resName;
    kpc_resFlags_t resFlags;
    uint32_t kpcFlags;
    uint32_t branchId;
    byte_t *extData;
    uint16_t resNameLen;
    uint16_t extDataLen;
    union {
        struct __f {
            pal_rawFid_t *poFid;
            pal_ftypes_t poFtype;
            int32_t kpcFileAddGen;
            pal_rawFid_t __poFid;
        } f;
        struct __nw {
            int64_t policyVersion;
            pal_ptr32_t pUserRes;
            void *pRes;
            kpc_res_rele_func_t relef;
        } nw;
    } resData;

    char __resName[48];
} kenv_kpcInfo_t;
typedef struct filetgt {
    char *trappedNameRef;
    char *baseName;
    pal_pathBuf_t *fullSrnRef;
    pal_rawFid_t *dir_rfidp;
    pal_rawFid_t *pathFids;
    pal_vnodeH_t dir_vnh;
    pal_vnodeH_t vnh;
    struct filetgt *auxFile;
    int tnLen;
    int pathFidsCount;
    int pathFidsAlloced;
    pal_rawFid_t rfid;
    pal_fattr_t fattrs;
    pal_pid_t killPid;


    void *tgt_nd;
    void *aux_tgt_nd;


    pal_rawFid_t _fids[5];
} kenv_fileTgt_t;






typedef struct pgmInfo {
    kenv_procFlags_t procFlags;
    char *pgmSRN;
    char *pgmKPON;
    pal_rawFid_t pgmFid;
    pal_rawFid_t pgmDFid;
    pal_fattr_t pgmFattrs;
    struct pgmInfo *saveArea;
    int16_t __srnLen;
    int16_t __kponLen;
    char __srn[32];
    char __kpon[32];
} pgmInfo_t;
typedef void * kenv_envHandle_t;

typedef struct kenv_env {
    int magic;
    uint32_t flags;
    pal_pid_t pid;
    int envError;



    union {



        struct {
            kenv_fileTgt_t f;
            pal_idSet_t idSet;
            pal_dev_t termDev;
            char *localTermName;
            pal_nwAddr_t nwTermAddr;
            byte_t *termExtData;
            int termExtDataLen;
        } fs;



        struct {
            pal_nwAddr_t addrRemote;
            pal_nwAddr_t addrLocal;
        } nw;
    } tgt;




    pal_idList_t idList;




    pgmInfo_t accPgm;




    int kpcInfoCount;
    kenv_kpcInfo_t *kpcInfoHead;
    kenv_kpcInfo_t *curKPCInfo;
    kenv_kpcInfo_t _kpcInfo;



    void *auxDatap1;
} kenv_env_t;
extern pal_authID_t kenv_envGetAuthID(kenv_envHandle_t);
extern pal_idList_t *kenv_envGetIdListRef(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetPathFids(kenv_envHandle_t, int *);
extern void kenv_envSetPathFids(kenv_envHandle_t, int, pal_rawFid_t *);
extern void kenv_envSetRfid(kenv_envHandle_t, pal_rawFid_t *, pal_fattr_t *);
extern void kenv_envSetFattr(kenv_envHandle_t, pal_fattr_t *);
extern pal_fattr_t *kenv_envGetFattr(kenv_envHandle_t);
extern void kenv_envSetKPCInfo(kenv_envHandle_t , kenv_kpcInfo_t *);
extern kenv_kpcInfo_t * kenv_envGetKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfo(kenv_envHandle_t);
extern void kenv_envSetNextKPCInfo(kenv_envHandle_t);
extern void kenv_envSetFirstKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfoResName(kenv_envHandle_t,
                                        kenv_kpcInfo_t *, char *, int);
extern char * kenv_envGetProgram(kenv_envHandle_t);
extern pal_rawFid_t *
        kenv_envGetPgmFidAndDirFid(kenv_envHandle_t,
                                   pal_rawFid_t **, pal_fattr_t **);
extern char *kenv_envSetPgmResource(kenv_envHandle_t, char *, int);
extern char *kenv_envGetPgmResource(kenv_envHandle_t);
extern void kenv_envSetAuxFileActive(kenv_envHandle_t, int);
extern char *kenv_envGetTrappedName(kenv_envHandle_t, int *);
extern char *kenv_envGetBaseName(kenv_envHandle_t);
extern void kenv_envSetImpProcAccId(kenv_envHandle_t, pal_authID_t);
extern void kenv_envProgramExecUpdate(kenv_envHandle_t);
extern void kenv_envSaveProgramState(kenv_envHandle_t);
extern void kenv_envRestoreProgramState(kenv_envHandle_t);
extern void kenv_envTrackOpenFd(kenv_envHandle_t, int, int);
extern int kenv_envGetFdInfo(kenv_envHandle_t, int);
extern void kenv_envGetTerminals(kenv_envHandle_t,
                                 pal_dev_t **, pal_nwAddr_t **);
extern pal_dev_t *kenv_envGetTermDev(kenv_envHandle_t);
extern char *kenv_envSetLocalTermName(kenv_envHandle_t, char *);
extern byte_t *kenv_envSetTermExtData(kenv_envHandle_t, int, byte_t *);
extern byte_t *kenv_envGetTermExtData(kenv_envHandle_t, int *);
extern pal_nwAddr_t *kenv_envGetNWTerm(kenv_envHandle_t);
extern void kenv_envResetTargetData(kenv_envHandle_t, int);
extern char *kenv_envFdToBname(kenv_envHandle_t);
extern pal_pathBuf_t *kenv_envGetFullSrnRef(kenv_envHandle_t);
extern void kenv_envSetFullSrnRef(kenv_envHandle_t, pal_pathBuf_t *);
extern pal_rawFid_t *kenv_envBuildPathFids(kenv_envHandle_t, int *);
extern pal_rawFid_t *kenv_envGetDirRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetFidsAndFattrs(kenv_envHandle_t,
                                              pal_rawFid_t **, pal_fattr_t **);

extern int kenv_envSetKPCCurrent(kenv_envHandle_t, char *);




extern void kenv_envSetTrappedNameRef(kenv_env_t *, char *, int);
extern void kenv_envInit(kenv_env_t *);
extern void kenv_envClean(kenv_env_t *);
extern int kenv_envProcessTrappedPath(kenv_env_t *, int);
extern int kenv_envProcessAuxPath(kenv_env_t *, char *, int, int);
extern void kenv_envUpdateACLInfo(kenv_env_t *);
extern void kenv_envInitialize(void);
extern void kenv_envShutdown(void);
extern kenv_env_t *kenv_envAllocEnv(void);
extern void kenv_envFreeEnv(kenv_env_t *);



typedef struct envHandle {
    struct envHandle *next;
    uint32_t hMagic;
    int allocList;
    kenv_env_t envObj;
} envHandle_t;





typedef struct envHandleQ {

    pal_icLock_t qLock;



    envHandle_t *handles;
    uint32_t count;
    uint32_t checks;
    uint32_t cacheLinePad[32];
} envHandleQ_t;
int kenv_envHandlesAlloced = 0;
int kenv_envHandlesMax = 40;
envHandleQ_t kenv_envHandleQ[13];
kenv_env_t *
kenv_envAllocEnv(void)
{
    int qIndex;
    envHandleQ_t *qp;
    envHandle_t *hp;
    kenv_env_t *envp;

    qIndex = (((uint32_t)(kail_current_tid())) % 13);
    qp = &kenv_envHandleQ[qIndex];

    (kail_iclock_lock(&(qp)->qLock));;
    qp->checks++;
    hp = qp->handles;
    if (hp) {
        qp->handles = hp->next;
        qp->count--;
    }
    (kail_iclock_unlock(&(qp)->qLock));;

    if (hp) {
        hp->next = NULL;
        envp = &hp->envObj;
    } else {
        envp = NULL;
        hp = (envHandle_t *)pal_alloc(sizeof(*hp));
        if (hp) {
            kail_atomic_add((int)(1),(void *)(&kenv_envHandlesAlloced));
            hp->allocList = qIndex;
            hp->hMagic = 0x4545eabf;
            hp->next = NULL;
            envp = &hp->envObj;
        }
    }

    if (envp) {
        kenv_envInit(&hp->envObj);
    }
    return(envp);
}
void
kenv_envFreeEnv(kenv_env_t *envp)
{
    int qIndex;
    envHandleQ_t *qp;
    envHandle_t *hp;

    hp = (envHandle_t *)((char *)((envp)) - (offsetof(envHandle_t, envObj)));
    ;

    qIndex = hp->allocList;
    ;

    kenv_envClean((envp));

    qp = &kenv_envHandleQ[qIndex];
    if ((kenv_envHandlesAlloced <= kenv_envHandlesMax) ||
        (qp->handles == NULL)) {
        (kail_iclock_lock(&(qp)->qLock));;
        hp->next = qp->handles;
        qp->handles = hp;
        qp->count++;
        (kail_iclock_unlock(&(qp)->qLock));;
    } else {
        pal_free(hp, sizeof(*hp));
        kail_atomic_add((int)(-1),(void *)(&kenv_envHandlesAlloced));
    }
}
void
kenv_envInit(kenv_env_t *ep)
{
    ep->magic = 0x4869dcba;
    ep->envError = 0;
    ep->flags = 0;
    ep->accPgm.procFlags = 0;
    ep->accPgm.pgmSRN = NULL;
    ep->accPgm.__srnLen = 0;
    ep->kpcInfoCount = 0;
    ep->tgt.fs.f.trappedNameRef = NULL;
    ep->tgt.fs.f.fullSrnRef = NULL;
    ep->tgt.fs.f.baseName = NULL;
    ep->tgt.fs.f.pathFids = NULL;
    ep->tgt.fs.f.dir_rfidp = NULL;
    ep->tgt.fs.f.dir_vnh = NULL;
    ep->tgt.fs.f.vnh = NULL;

    ep->tgt.fs.f.tgt_nd = NULL;
    ep->tgt.fs.f.aux_tgt_nd = NULL;

}
pal_authID_t
kenv_envGetAuthID(kenv_envHandle_t envH)
{
    return (((kenv_env_t *)envH)->idList.accId);
}
pal_idList_t *
kenv_envGetIdListRef(kenv_envHandle_t envH)
{
    kenv_env_t *ep = (kenv_env_t *)envH;

    return &ep->idList;
}
char *
kenv_envGetProgram(kenv_envHandle_t envH)
{
    int rc, len, allocLen;
    kenv_env_t *ep = (kenv_env_t *)envH;
    char *np;

    allocLen = 0;
    if (!ep->accPgm.pgmSRN) {
        np = ep->accPgm.__srn;
        len = sizeof(ep->accPgm.__srn);

        for (;;) {
            rc = kenv_procGetProgramInfo(ep->pid, np, &len,
                                         NULL, NULL, NULL, NULL);
            if (rc == E2BIG) {
                (ep)->flags |= 0x01000000;
                if (allocLen) {
                    break;
                }

                if (np = pal_alloc(len + 1)) {
                    allocLen = len + 1;
                    len = allocLen;
                    continue;
                }
            }
            break;
        }

        if (rc == 0) {
            if (np == ep->accPgm.__srn) {
                ep->accPgm.pgmSRN = np;
                ep->accPgm.__srnLen = len;
            } else {
                (ep)->flags |= 0x01000000;
                (void)kutil_setStringWithLocal(np, &len, ep->accPgm.__srn,
                                               sizeof(ep->accPgm.__srn),
                                               &ep->accPgm.pgmSRN);
                if (ep->accPgm.pgmSRN) {
                    ep->accPgm.__srnLen = len;
                }
            }
        } else {
            ep->accPgm.pgmSRN = ep->accPgm.__srn;
            ep->accPgm.pgmSRN[0] = '\0';
            ep->accPgm.__srnLen = 0;
        }

        if (allocLen) {
            pal_free(np, allocLen);
        }
    }

    return (ep->accPgm.pgmSRN);
}
pal_rawFid_t *
kenv_envGetPgmFidAndDirFid(
    kenv_envHandle_t envH,
    pal_rawFid_t **dfidpp,
    pal_fattr_t **fap)
{
    kenv_env_t *ep = (kenv_env_t *)envH;
    pal_rawFid_t *fidp = NULL;

    if ((ep->flags & 0x00000008) ||
        kenv_procGetProgramFid(ep->pid, &ep->accPgm.pgmFid,
                               &ep->accPgm.pgmDFid, &ep->accPgm.pgmFattrs)) {

        ep->flags |= 0x00000008;
        fidp = &ep->accPgm.pgmFid;
        if (dfidpp) {
            *dfidpp = &ep->accPgm.pgmDFid;
        }
        if (fap) {
            *fap = &ep->accPgm.pgmFattrs;
        }
    }
    return fidp;
}
char *
kenv_envGetPgmResource(kenv_envHandle_t envH)
{
    kenv_env_t *ep = (kenv_env_t *)envH;

    if (ep->flags & 0x00000080) {
        return ep->accPgm.pgmKPON;
    } else {
        return NULL;
    }
}
char *
kenv_envSetPgmResource(kenv_envHandle_t envH, char *resName, int nameLen)
{
    int len;
    kenv_env_t *ep = (kenv_env_t *)envH;

    if (ep->flags & 0x00000080) {
        kutil_freeStringWithLocal(ep->accPgm.pgmKPON,
                                  ep->accPgm.__kpon, ep->accPgm.__kponLen);
    }

    len = nameLen;
    (void)kutil_setStringWithLocal(resName, &len, ep->accPgm.__kpon,
                                   sizeof(ep->accPgm.__kpon),
                                   &ep->accPgm.pgmKPON);
    if (ep->accPgm.pgmKPON) {
        ep->flags |= 0x00000080;
        ep->accPgm.__kponLen = len;
        if (ep->accPgm.pgmKPON != ep->accPgm.__kpon) {
            (ep)->flags |= 0x01000000;
        }
    }

    return ep->accPgm.pgmKPON;
}
pal_rawFid_t *
kenv_envGetRawFid(kenv_envHandle_t envH)
{


    kenv_env_t *ep = envH;
    uint32_t ef = ep->flags;
    pal_rawFid_t *fp;


    if ((ef & (0x00000400 | 0x00000002)) == 0x00000002) {
        fp = &ep->tgt.fs.f.rfid;
    } else if ((ef & (0x00000400 | 0x00000200)) == (0x00000400 | 0x00000200)) {
        fp = &ep->tgt.fs.f.auxFile->rfid;
    } else {
        fp = NULL;
    }
    return fp;
}
pal_rawFid_t *
kenv_envGetPathFids(kenv_envHandle_t envH, int *count)
{
    kenv_env_t *ep = envH;
    kenv_fileTgt_t *ftp = &ep->tgt.fs.f;
    pal_rawFid_t *pfids;


    if ((ep->flags & 0x00000400)) {
        ftp = ep->tgt.fs.f.auxFile;
    }

    if (ftp->pathFids) {
        pfids = ftp->pathFids;
        *count = ftp->pathFidsCount;
    } else {
        pfids = NULL;
    }
    return pfids;
}
static
cleanPathFids(kenv_fileTgt_t *ftp)
{
    pal_rawFid_t *fids = ftp->pathFids;


    if (fids && (fids != ftp->_fids)) {
        pal_free(fids, ftp->pathFidsAlloced * sizeof(pal_rawFid_t));
    }
    ftp->pathFids = NULL;
    ftp->pathFidsAlloced = ftp->pathFidsCount = 0;
    ftp->dir_rfidp = NULL;
}
static int
setPathFids(kenv_env_t *ep, kenv_fileTgt_t *ftp, int nFids, pal_rawFid_t *pFids)
{
    int i, setCount;
    pal_rawFid_t *rfp;


    if (ftp->pathFids) {
        cleanPathFids(ftp);
    }

    setCount = 0;
    if (nFids <= 5) {
        ftp->pathFids = ftp->_fids;
    } else {
        ftp->pathFids = (pal_rawFid_t *)
                        pal_alloc(nFids * sizeof(pal_rawFid_t));
        if (ftp->pathFids) {
            (ep)->flags |= 0x01000000;
            ftp->pathFidsAlloced = nFids;
        }
    }

    if (ftp->pathFids) {
        memcpy((char *)ftp->pathFids,(char *)pFids,nFids * sizeof(*rfp));
        ftp->pathFidsCount = setCount = nFids;
        if (ftp->dir_rfidp != ftp->pathFids) {
            ftp->dir_rfidp = ftp->pathFids;
        }
    }
    return setCount;
}
pal_rawFid_t *
kenv_envBuildPathFids(kenv_envHandle_t envH, int *count)
{


    kenv_env_t *ep = envH;
    int rc, allocCount, numFids, retry;
    kenv_fileTgt_t *ftp = &ep->tgt.fs.f;
    pal_rawFid_t *pfids, *retFids;
    pal_vnodeH_t dvnh;


    if ((ep->flags & 0x00000400)) {
        ftp = ep->tgt.fs.f.auxFile;
    }
    dvnh = ftp->dir_vnh;
    pfids = ftp->pathFids;
    retFids = NULL;


    if (!pfids && dvnh) {
        (ep)->flags |= 0x01000000;
        numFids = 20;
        do {
            rc = ENOMEM;
            retry = 0;
            pfids = (pal_rawFid_t *)pal_alloc(numFids * sizeof(*pfids));
            if (pfids) {
                allocCount = numFids;
                rc = pal_pathFidsFromDirVnh(dvnh, pfids, &numFids);
                if ((rc == E2BIG) && (numFids > 0)) {
                    retry = 1;
                }

                if (retry || rc) {
                    if (retry) {
                        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PTP_E2BIG_RETRY, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(numFids), (long)allocCount, (long)rc),0) : 0);




                    }
                    pal_free(pfids, allocCount * sizeof(*pfids));
                    allocCount = 0;
                    pfids = NULL;
                }
            }
        } while (retry);

        if ((rc == 0) && numFids) {
            ftp->pathFids = pfids;
            ftp->pathFidsCount = numFids;
            ftp->pathFidsAlloced = allocCount;
        }
    }


    if (pfids) {

        ;
        *count = ftp->pathFidsCount;
        retFids = ftp->pathFids;
        if (ftp->dir_rfidp != retFids) {
            ftp->dir_rfidp = retFids;
        }
    } else {
        *count = 0;
    }
    return retFids;
}
pal_rawFid_t *
kenv_envGetDirRawFid(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    kenv_fileTgt_t *ftp = &ep->tgt.fs.f;


    if ((ep->flags & 0x00000400)) {
        ftp = ep->tgt.fs.f.auxFile;
    }
    return ftp->dir_rfidp;
}
void
kenv_envSetRfid(kenv_envHandle_t envH, pal_rawFid_t *rfp, pal_fattr_t *fap)
{
    kenv_env_t *ep = envH;


    ep->tgt.fs.f.rfid = *rfp;
    ep->flags |= (0x00000002 | 0x00100000);
    if (fap) {
        ep->tgt.fs.f.fattrs = *fap;
        ep->flags |= 0x00000004;
    }
}
pal_fattr_t *
kenv_envGetFattr(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    int flags = ep->flags;
    pal_fattr_t *fap = NULL;


    if (!(flags & 0x00000400)) {
        if (flags & 0x00000004)
            fap = &ep->tgt.fs.f.fattrs;
    } else {
        if (flags & 0x00000800)
            fap = &ep->tgt.fs.f.auxFile->fattrs;
    }

    return fap;
}
pal_rawFid_t *
kenv_envGetFidsAndFattrs(
    kenv_envHandle_t envH,
    pal_rawFid_t **dfOutpp,
    pal_fattr_t **faOutpp)
{
    kenv_env_t *ep = envH;
    kenv_fileTgt_t *ftp;
    uint32_t flags = ep->flags;
    pal_rawFid_t *drfp;
    pal_rawFid_t *rfp = NULL;
    pal_fattr_t *fap = NULL;


    if (!(flags & 0x00000400)) {
        ftp = &ep->tgt.fs.f;
        if (flags & 0x00000002) {
            rfp = &ftp->rfid;
        }
        if (flags & 0x00000004) {
            fap = &ftp->fattrs;
        }
    } else {
        ftp = ep->tgt.fs.f.auxFile;
        if (flags & 0x00000200) {
            rfp = &ftp->rfid;
        }
        if (flags & 0x00000800) {
            fap = &ftp->fattrs;
        }
    }
    drfp = ftp->dir_rfidp;

    *dfOutpp = drfp;
    *faOutpp = fap;
    return rfp;
}
void
kenv_envSetFattr(kenv_envHandle_t envH, pal_fattr_t *fap)
{
    kenv_env_t *ep = envH;
    int flags = ep->flags;


    if (!(flags & 0x00000400)) {
        ep->tgt.fs.f.fattrs = *fap;
        ep->flags |= (0x00000004 | 0x00100000);
    } else {
        ep->tgt.fs.f.auxFile->fattrs = *fap;
        ep->flags |= 0x00000800;
    }
}
void
kenv_envSetTrappedNameRef(kenv_env_t *ep, char *np, int nlen)
{
    kenv_fileTgt_t *ftp = &ep->tgt.fs.f;


    if (ep->flags & 0x00000400) {
        ftp = ep->tgt.fs.f.auxFile;
    }

    ep->flags |= 0x00100000;
    ftp->trappedNameRef = np;
    if (nlen) {
        ftp->tnLen = nlen;
    } else if (np) {
        ftp->tnLen = strlen(np);
    }
}
char *
kenv_envGetTrappedName(kenv_envHandle_t envH, int *len)
{
    kenv_env_t *ep = envH;
    kenv_fileTgt_t *ftp = &ep->tgt.fs.f;
    char *tn;
    int l = 0;


    if (ep->flags & 0x00000400) {
        ftp = ep->tgt.fs.f.auxFile;
    }

    if (tn = ftp->trappedNameRef) {
        l = ftp->tnLen;
    }

    *len = l;
    return tn;
}
void
kenv_envSetFullSrnRef(kenv_envHandle_t envH, pal_pathBuf_t *pbuf)
{
    kenv_env_t *ep = envH;
    kenv_fileTgt_t *ftp = &ep->tgt.fs.f;


    if (ep->flags & 0x00000400) {
        ftp = ep->tgt.fs.f.auxFile;
    }
    ftp->fullSrnRef = pbuf;
}
pal_pathBuf_t *
kenv_envGetFullSrnRef(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    kenv_fileTgt_t *ftp = &ep->tgt.fs.f;


    if (ep->flags & 0x00000400) {
        ftp = ep->tgt.fs.f.auxFile;
    }
    return ftp->fullSrnRef;
}
char *
kenv_envGetBaseName(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    kenv_fileTgt_t *ftp;
    char *tmpName, *bn;
    int len;

    ftp = &ep->tgt.fs.f;
    if ((ep->flags & 0x00000400)) {
        ftp = ep->tgt.fs.f.auxFile;
    }

    tmpName = ftp->trappedNameRef;
    if (!ftp->baseName && tmpName) {
        len = ftp->tnLen;
        bn = pal_alloc(len + 1);
        if (bn) {
            strcpy(bn, tmpName);
            kutil_pathBaseName(bn);
            ftp->baseName = pal_alloc(strlen(bn) + 1);
            if (ftp->baseName) {
                ep->flags |= 0x00100000;
                (ep)->flags |= 0x01000000;
                strcpy(ftp->baseName, bn);
            }
            pal_free(bn, len + 1);
        }
    }

    return ftp->baseName;
}
void
kenv_envSetPathFids(kenv_envHandle_t envH, int nFids, pal_rawFid_t *pFids)
{
    kenv_env_t *ep = envH;
    (void)setPathFids(ep, &ep->tgt.fs.f, nFids, pFids);
}
static void
freeKPCInfo(kenv_kpcInfo_t *kip)
{
    if (kip->resName) {
        kutil_freeStringWithLocal(kip->resName,
                                  kip->__resName, kip->resNameLen);
    }

    if (kip->extDataLen) {
        pal_free(kip->extData, kip->extDataLen);
    }


    if ((kip->kpcFlags & 0x02000000) && (kip->resData.nw.relef)) {
        kip->resData.nw.relef(kip->resData.nw.pRes);
    }






    if (kip->next == kip->prev) {
        if (kip->next) {

          kip->next->next = NULL;
          kip->next->prev = NULL;
        }
    } else {

        kip->prev->next = kip->next;

        kip->next->prev = kip->prev;
    }
}
void
kenv_envResetKPCInfo(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    kenv_kpcInfo_t *kip, *nextKip;
    int freeKip = 0;

    if (!ep->kpcInfoCount)
        return;

    kip = ep->kpcInfoHead;
    while (kip) {
        nextKip = kip->next;
        freeKPCInfo(kip);
        if (kip != &ep->_kpcInfo) {
            pal_free(kip, sizeof(*kip));
        }
        kip = nextKip;
    }
    ep->kpcInfoCount = 0;
}
void
kenv_envClean(kenv_env_t *ep)
{
    kenv_fileTgt_t *ftp;
    pgmInfo_t *pi;
    int pfidCount, eflags;
    pal_vnodeH_t dvh, vh;


    eflags = ep->flags;
    dvh = ep->tgt.fs.f.dir_vnh;
    if (dvh && (eflags & 0x00100000)) {
        pal_releVnode(dvh);
    }
    vh = ep->tgt.fs.f.vnh;
    if (vh && (eflags & 0x00100000)) {
        pal_releVnode(vh);
    }


    if (!(eflags & 0x01000000)) {
        return;
    }

    if (eflags & 0x00100000) {
        ftp = &ep->tgt.fs.f;
        if (ftp->baseName) {
            pal_free(ep->tgt.fs.f.baseName,
                     strlen(ep->tgt.fs.f.baseName) + 1);
        }
        if (ftp->pathFids) {
            cleanPathFids(ftp);
        }




        (!(ftp->fullSrnRef == NULL)? (*((char *)0) = 0) : 0);
    }

    if (ep->accPgm.pgmSRN) {
        kutil_freeStringWithLocal(ep->accPgm.pgmSRN,
                                  ep->accPgm.__srn, ep->accPgm.__srnLen);
    }

    if (eflags & 0x00000080) {
        ;
        kutil_freeStringWithLocal(ep->accPgm.pgmKPON,
                                  ep->accPgm.__kpon, ep->accPgm.__kponLen);
    }

    if (ep->kpcInfoCount) {
        kenv_envResetKPCInfo(ep);
    }

    if (eflags & 0x00000100) {
        ftp = ep->tgt.fs.f.auxFile;
        ;
        if (ftp->pathFids) {
            cleanPathFids(ftp);
        }
        if (ftp->baseName) {
            pal_free(ftp->baseName, strlen(ftp->baseName) + 1);
        }

        (!(ftp->fullSrnRef == NULL)? (*((char *)0) = 0) : 0);
        if (ftp->dir_vnh) {
            pal_releVnode(ftp->dir_vnh);
        }
        if (ftp->vnh) {
            pal_releVnode(ftp->vnh);
        }
        pal_free(ftp, sizeof(*ftp));
    }

    if (eflags & (0x00000020 | 0x00000040)) {
        if (ep->tgt.fs.localTermName) {
            pal_free(ep->tgt.fs.localTermName,
                     strlen(ep->tgt.fs.localTermName) + 1);
        }

        if (ep->tgt.fs.termExtDataLen) {
            pal_free(ep->tgt.fs.termExtData, ep->tgt.fs.termExtDataLen);
        }
    }

    if (eflags & 0x00010000) {
        ;
        pi = ep->accPgm.saveArea;
        ;
        if (pi->pgmSRN) {
            kutil_freeStringWithLocal(pi->pgmSRN, pi->__srn, pi->__srnLen);
        }
        pal_free(pi, sizeof(*pi));
        ep->accPgm.saveArea = NULL;
        eflags &= ~0x00010000;
    }
}
void
kenv_envSetKPCInfo(kenv_envHandle_t envH, kenv_kpcInfo_t *ip)
{
    kenv_env_t *ep = envH;
    kenv_kpcInfo_t *kip;
    int len, hitErr, skipRes=0;

    if (!ip->resName)
        return;

    if (ep->kpcInfoCount == 0) {
        ep->kpcInfoHead = &ep->_kpcInfo;
        kip = ep->curKPCInfo = ep->kpcInfoHead;
    } else {
        kip = (kenv_kpcInfo_t *)pal_alloc(sizeof(*kip));
        if (!kip) {
            return;
        }
    }

    kip->resName = NULL;
    kip->next = NULL;

    kip->prev = NULL;

    kip->extDataLen = 0;
    hitErr = 0;

    len = ip->resNameLen;
    (void)kutil_setStringWithLocal(ip->resName, &len, kip->__resName,
                                   sizeof(kip->__resName), &kip->resName);
    if (kip->resName) {
        kip->resNameLen = len;
    } else {
        hitErr = 1;
    }

    if (ip->extDataLen) {
        kip->extData = (byte_t *)pal_alloc(ip->extDataLen);
        if (kip->extData) {
            memcpy(kip->extData,ip->extData,ip->extDataLen);
            kip->extDataLen = ip->extDataLen;
        } else {
            hitErr = 1;
        }
    }

    if (hitErr == 0) {
        kip->branchId = ip->branchId;
        kip->resFlags = ip->resFlags;
        kip->kpcFlags = ip->kpcFlags;
        if (ip->kpcFlags & 0x02000000) {
            kip->resData.nw.policyVersion = ip->resData.nw.policyVersion;
            kip->resData.nw.pRes = ip->resData.nw.pRes;
            kip->resData.nw.relef = ip->resData.nw.relef;
        } else {

            kip->resData.f.kpcFileAddGen = ip->resData.f.kpcFileAddGen;
            kip->resData.f.poFtype = ip->resData.f.poFtype;
            if (ip->resData.f.poFid) {
                kip->resData.f.__poFid = *(ip->resData.f.poFid);
                kip->resData.f.poFid = &(kip->resData.f.__poFid);
            } else {
                kip->resData.f.poFid = NULL;
            }
        }
        if (kip->extDataLen || (ep->kpcInfoCount) ||
            (kip->resName && (kip->resName != kip->__resName))) {
            (ep)->flags |= 0x01000000;
        }
        if (ep->kpcInfoCount >= 1) {



            if ((ep->kpcInfoHead->resFlags.hasPop ||
                 ep->kpcInfoHead->resFlags.hasAuthz) &&
                !ep->kpcInfoHead->resFlags.hasAcl) {
                if (strncmp(kip->resName,ep->kpcInfoHead->resName,
                            kip->resNameLen) == 0) {
                    skipRes = 1;



                    if (kip->resFlags.hasViaPgm) {

                        ep->kpcInfoHead->resFlags.hasViaPgm = 1;
                        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_ALWAYS_SET_KPON, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(ep->kpcInfoHead), (long)ep, (long)(((kenv_env_t *)(ep))->flags)),0) : 0);




                    }
                    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 3) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_FILTER_RES, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((1)<<20) + ((1)<<16)), (long)(kip), (long)*((int *)&(ep->kpcInfoHead->resFlags)), (long)kip->resName, (long)ep->kpcInfoHead->resName),0) : 0);





                }
            }
            if (!skipRes) {
                ep->kpcInfoCount++;
                kip->next = ep->kpcInfoHead;
                if (ep->kpcInfoHead->prev) {
                    kip->prev = ep->kpcInfoHead->prev;
                    ep->kpcInfoHead->prev->next = kip;
                } else {
                    kip->prev = ep->kpcInfoHead;
                    ep->kpcInfoHead->next = kip;
                }
                ep->kpcInfoHead->prev = kip;
            } else {

                freeKPCInfo(kip);
                pal_free(kip, sizeof(*kip));
            }
        } else {

            ep->kpcInfoCount++;
        }
    } else {
        freeKPCInfo(kip);
        if (kip != &ep->_kpcInfo) {
            pal_free(kip, sizeof(*kip));
        }
    }
}
void
kenv_envResetKPCInfoResName(
    kenv_envHandle_t envH,
    kenv_kpcInfo_t *kip,
    char *newName,
    int nameLen)
{
    int oldLen, len, rc;
    char nameSave[48], *oldName;


    (!(kip->resName)? (*((char *)0) = 0) : 0);

    oldLen = len = kip->resNameLen;
    rc = kutil_setStringWithLocal(kip->resName, &len, nameSave,
                                   48, &oldName);
    if (rc == 0) {
        len = nameLen;
        rc = kutil_setStringWithLocal(newName, &len, kip->__resName,
                                      48, &kip->resName);
        if (rc == 0) {
            kip->resNameLen = len;
            if (kip->resName != kip->__resName) {
                ((kenv_env_t *)envH)->flags |= 0x01000000;
            }

            kutil_freeStringWithLocal(oldName, nameSave, oldLen);
        } else {
            if (oldLen < 48) {
                kip->resName = kip->__resName;
                strcpy(kip->resName, oldName);
                kutil_freeStringWithLocal(oldName, nameSave, oldLen);
            } else {

                kip->resName = oldName;
            }
            kip->resNameLen = oldLen;
        }
    }
}
kenv_kpcInfo_t *
kenv_envGetKPCInfo(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    kenv_kpcInfo_t *kip = NULL;

    if (ep->kpcInfoCount) {
        kip = ep->curKPCInfo;
    }

    return kip;
}
void
kenv_envSetNextKPCInfo(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;

    if (ep->kpcInfoCount) {



        if (ep->curKPCInfo && ep->curKPCInfo->next &&
            (ep->curKPCInfo->next != ep->kpcInfoHead)) {
            ep->curKPCInfo = ep->curKPCInfo->next;
        } else {
            ep->curKPCInfo = NULL;
        }
    }
}
void
kenv_envSetFirstKPCInfo(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;

    if (ep->kpcInfoCount) {
        ep->curKPCInfo = ep->kpcInfoHead;
    }
}
int
kenv_envSetKPCCurrent(kenv_envHandle_t envH, char *pcName)
{
    kenv_kpcInfo_t *pIter;
    kenv_env_t *envp = (kenv_env_t *)envH;
    int rc = -1;

    for (pIter = envp->kpcInfoHead; pIter != NULL; pIter = pIter->next) {
        if (strcmp(pIter->resName,pcName) == 0) {
            envp->curKPCInfo = pIter;
            (((kenv_env_t *)(envp))->flags |= 0x00080000);
            rc = 0;
            break;
        }


        if (pIter->next && (pIter->next == envp->kpcInfoHead)) break;
    }

    return(rc);
}
int
kenv_envGetFdInfo(kenv_envHandle_t envH, int fd)
{
    kenv_env_t *ep = envH;
    pal_rawFid_t *pFids, *rfp;
    pal_vnodeH_t dirVh, vnh;
    kenv_fileTgt_t *ftp;
    int rc, fidCount, found = 0, rel_dirVh = 1;


    ftp = &ep->tgt.fs.f;
    ep->flags |= 0x00100000;
    dirVh = kenv_procGetFdDirVnode(ep->pid, fd);
    if (dirVh) {
        vnh = pal_unixDescToVnode(fd);
    }

    if (dirVh && vnh) {
        rc = pal_vnodesToFids(dirVh, vnh, &ftp->rfid, NULL,
                              &pFids, &fidCount, &ftp->fattrs);
        if (rc == 0) {
            if (fidCount && pFids) {
                if (setPathFids(ep, ftp, fidCount, pFids) == 0) {

                    rc = ENOMEM;
                }
                pal_free(pFids, sizeof(*pFids) * fidCount);
            }

            if (rc == 0) {
                found = 1;
                (!(ftp->dir_vnh == NULL)? (*((char *)0) = 0) : 0);
                ftp->dir_vnh = dirVh;
                rel_dirVh = 0;
                (((kenv_env_t *)(ep))->tgt.fs.f.killPid = (fd));
                ep->flags |= (0x00000002 |
                    0x00000004 | 0x00020000);
            }
        }
        pal_releVnode(vnh);
    }

    if (dirVh && rel_dirVh) {
        pal_releVnode(dirVh);
    }

    return found;
}
char *
kenv_envFdToBname(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    int rc, fd, len;
    pal_pathBuf_t pb;
    pal_vnodeH_t dirVh;
    char *bName = NULL;
    kenv_fileTgt_t *ftp;


    ftp = &ep->tgt.fs.f;
    bName = ftp->baseName;


    dirVh = ftp->dir_vnh;
    if (!bName && dirVh && (ep->flags & 0x00020000)) {
        fd = (((kenv_env_t *)(ep))->tgt.fs.f.killPid);
        if (fd >= 0) {
            ((&pb)->pbuf = NULL);
            rc = pal_unixDescToBaseName(fd, dirVh, &pb);
            if ((rc == 0) && pb.pathLen) {
                if (bName = pal_alloc(pb.pathLen + 1)) {
                    strcpy(bName, pb.pbuf);
                    ftp->baseName = bName;
                    ep->flags |= 0x00100000;
                    (ep)->flags |= 0x01000000;
                }
            }
            if ((&pb)->pbuf) pal_free((&pb)->pbuf, (&pb)->pbLen);
        }
    }


    return bName;
}
void
kenv_envTrackOpenFd(kenv_envHandle_t envH, int fd, int oflags)
{
    kenv_env_t *ep = envH;
    pal_vnodeH_t dirVh;
    char *tn;
    int didAdd;


    if (dirVh = ep->tgt.fs.f.dir_vnh) {
        didAdd = kenv_procAddFd(ep->pid, fd, dirVh);
        if ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) && didAdd) {
            if ((tn = ep->tgt.fs.f.trappedNameRef) == NULL) {
                tn = "?";
            }
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[1], KT_TRACE_TRACK_OPEN, (((1)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(tn), (long)fd),0) : 0);

        }
    }
}
int
kenv_envProcessTrappedPath(kenv_env_t *ep, int pflags)
{
    int rc, oflags;
    kenv_fileTgt_t *ftp;
    char *tn;


    ftp = &ep->tgt.fs.f;
    tn = ftp->trappedNameRef;
    ;
    ;


    if ((((kenv_env_t *)(ep))->tgt.fs.f.tgt_nd)) {
        char *l_tn = (char *)((((kenv_env_t *)(ep))->tgt.fs.f.tgt_nd));
        rc = pal_lookupFidsAndInfo(l_tn, pflags, &ftp->rfid, ftp->_fids,
                               &ftp->fattrs, &ftp->vnh, &ftp->dir_vnh, &oflags);
    }
    else
    rc = pal_lookupFidsAndInfo(tn, pflags, &ftp->rfid, ftp->_fids,
                               &ftp->fattrs, &ftp->vnh, &ftp->dir_vnh, &oflags);




    if (rc == 0) {
        if (pflags & 0x8) {
            ep->flags |= 0x00001000;
        }
        if (oflags & 0x1) {
            ep->flags |= (0x00000002 | 0x00000004);
        }
        if ((oflags & 0x2)) {
            ftp->dir_rfidp = ftp->_fids;
        }
    } else {
        ftp->dir_vnh = NULL;
        ftp->vnh = NULL;
    }
    return rc;
}
void
kenv_envSetAuxFileActive(kenv_envHandle_t envH, int on)
{
    kenv_env_t *ep = envH;

    if (on) {
        ep->flags |= 0x00000400;
    } else {
        ep->flags &= ~0x00000400;
    }
}
int
kenv_envProcessAuxPath(kenv_env_t *ep, char *path, int pflags, int aflags)
{
    int rc, oflags;
    kenv_fileTgt_t *ftp;
    pal_vnodeH_t dvh;


    ;
    if (!(ftp = (kenv_fileTgt_t *)pal_alloc(sizeof(*ftp)))) {
        return ENOMEM;
    }

    (ep)->flags |= 0x01000000;
    memset((char *)ftp,0,sizeof(*ftp));
    ftp->trappedNameRef = path;
    ftp->tnLen = strlen(path);


    ftp->dir_rfidp = ftp->_fids;

    if ((((kenv_env_t *)(ep))->tgt.fs.f.aux_tgt_nd)) {
        char *l_path = (char *)((((kenv_env_t *)(ep))->tgt.fs.f.aux_tgt_nd));
        rc = pal_lookupFidsAndInfo(l_path, pflags, &ftp->rfid, ftp->_fids,
                               &ftp->fattrs, NULL, &ftp->dir_vnh, &oflags);
    }
    else
    rc = pal_lookupFidsAndInfo(path, pflags, &ftp->rfid, ftp->_fids,
                               &ftp->fattrs, NULL, &ftp->dir_vnh, &oflags);




    if (rc == 0) {
        if (pflags & 0x8) {
            ep->flags |= 0x00001000;
        }
        if (oflags & 0x1) {
            ep->flags |= (0x00000200 | 0x00000800);
        }
        if ((oflags & 0x2)) {
            ftp->dir_rfidp = ftp->_fids;
        }
        ep->flags |= 0x00000100;
        ep->tgt.fs.f.auxFile = ftp;
    } else {
        pal_free(ftp, sizeof(*ftp));
    }

    return rc;
}
void
kenv_envSetImpProcAccId(kenv_envHandle_t envH, pal_authID_t accId)
{
    kenv_env_t *ep = envH;

    if (kenv_procSetImpId(ep->pid, accId)) {
        ep->idList.accId = accId;
    }
}
void
kenv_envProgramExecUpdate(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    kenv_kpcInfo_t *kpcInfo;
    kenv_procFlags_t pf = 0;
    pal_rawFid_t *rfid, *dir_rfid;
    pal_fattr_t *fap;
    char *tn;
    int c, i, kpcInfoCount;
    int addFlags = (0x1 | 0x4);


    if (ep->flags & 0x00000080) {
        ;
        ep->flags &= ~0x00000080;
        kutil_freeStringWithLocal(ep->accPgm.pgmKPON,
                                  ep->accPgm.__kpon, ep->accPgm.__kponLen);
        ep->accPgm.pgmKPON = NULL;
    }

    if (ep->accPgm.pgmSRN) {
        kutil_freeStringWithLocal(ep->accPgm.pgmSRN,
                                  ep->accPgm.__srn, ep->accPgm.__srnLen);
        ep->accPgm.pgmSRN = NULL;
    }

    kpcInfoCount = (((kenv_env_t *)(envH))->kpcInfoCount);
    if (kpcInfoCount > 0) {
        kenv_envSetFirstKPCInfo(envH);
        for (i = 0; i < kpcInfoCount; i++, kenv_envSetNextKPCInfo(envH)) {

            kpcInfo = kenv_envGetKPCInfo(envH);
            ;

            if (kpcInfo->kpcFlags & 0x2) {

                continue;
            }

            if (kpcInfo->resFlags.isLoginPgm) {
                pf |= 0x4;
                addFlags |= 0x2;
            }

            if (kpcInfo->resFlags.isImpersonator) {
                pf |= 0x8;
            }
            if (kpcInfo->resFlags.isImSurPgm) {
                pf |= 0x00100000;
            }

            if (kpcInfo->resFlags.isPrivPgm) {
                pf |= 0x2;
                if (pal_isImmunePath(kpcInfo->resName)) {
                    pf |= 0x1;
                }
            } else {
                if (kpcInfo->resFlags.isSecPgm) {
                    pf |= 0x10;
                }
            }
        }
        kenv_envSetFirstKPCInfo(envH);
    }

    tn = kenv_envGetTrappedName(envH, &c);
    dir_rfid = kenv_envGetDirRawFid(envH);
    if (dir_rfid) {
        rfid = kenv_envGetRawFid(envH);
        fap = kenv_envGetFattr(envH);
    } else {
        rfid = NULL;
        fap = NULL;
    }





    if (tn && !(pf & 0x1) && pal_isImmunePath(tn)) {
        pf |= (0x1 | 0x2);
    }

    if (kenv_procSetProgramData(ep->pid, rfid, dir_rfid,
                                fap, tn, &pf, addFlags)) {
        ep->accPgm.procFlags = pf;
    }
}
void
kenv_envSaveProgramState(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    pgmInfo_t *pi;
    char *pn;
    pal_idList_t idl;
    int len = 0;

    pi = (pgmInfo_t *)pal_alloc(sizeof(*pi));
    if (!pi)
        return;

    (ep)->flags |= 0x01000000;
    pi->__srnLen = pi->__kponLen = 0;
    pi->pgmKPON = NULL;

    kenv_procGetProgramFid(ep->pid, &pi->pgmFid,
                           &pi->pgmDFid, &pi->pgmFattrs);

    kenv_procGetInfo(ep->pid, &pi->procFlags, &idl, NULL);

    pn = kenv_envGetProgram(envH);
    (void)kutil_setStringWithLocal(pn, &len, pi->__srn,
                                   sizeof(pi->__srn), &pi->pgmSRN);
    pi->__srnLen = len;

    if (ep->flags & 0x00000080) {
        ;
        ep->flags &= ~0x00000080;
        kutil_freeStringWithLocal(ep->accPgm.pgmKPON,
                                  ep->accPgm.__kpon, ep->accPgm.__kponLen);
        ep->accPgm.pgmKPON = NULL;
    }

    ep->accPgm.saveArea = pi;
    ep->flags |= 0x00010000;
}
void
kenv_envRestoreProgramState(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    pgmInfo_t *pi;

    if (!(ep->flags & 0x00010000))
        return;

    pi = ep->accPgm.saveArea;
    ;

    (void)kenv_procSetProgramData(ep->pid, &pi->pgmFid,
                                  &pi->pgmDFid, &pi->pgmFattrs,
                                  pi->pgmSRN, &pi->procFlags,
                                  0x1);



    ep->accPgm.procFlags = pi->procFlags;
    if (ep->flags & 0x00000080) {
        ;
        ep->flags &= ~0x00000080;
        kutil_freeStringWithLocal(ep->accPgm.pgmKPON,
                                  ep->accPgm.__kpon, ep->accPgm.__kponLen);
        ep->accPgm.pgmKPON = NULL;
    }

    if (ep->accPgm.pgmSRN) {
        kutil_freeStringWithLocal(ep->accPgm.pgmSRN,
                                  ep->accPgm.__srn, ep->accPgm.__srnLen);
        ep->accPgm.pgmSRN = NULL;
    }
    ep->flags &= ~(0x00010000 | 0x00000008);




    if (pi->pgmSRN) {
        kutil_freeStringWithLocal(pi->pgmSRN, pi->__srn, pi->__srnLen);
    }
    pal_free(pi, sizeof(*pi));
    ep->accPgm.saveArea = NULL;
}
void
kenv_envGetTerminals(
    kenv_envHandle_t envH,
    pal_dev_t **localTermDevice,
    pal_nwAddr_t **nwTermAddr)
{
    kenv_env_t *ep = envH;
    pal_dev_t ttyDev;
    int rc, flags;

    ;
    ep->tgt.fs.termExtDataLen = 0;
    ep->tgt.fs.localTermName = NULL;
    *localTermDevice = NULL;
    *nwTermAddr = NULL;


    if (ep->flags & 0x00000040) {
        *nwTermAddr = &ep->tgt.fs.nwTermAddr;
    } else if (ep->accPgm.procFlags & 0x8000) {
        if(kenv_procGetRterm(ep->pid, &ep->tgt.fs.nwTermAddr)) {
            ep->flags |= 0x00000040;
            *nwTermAddr = &ep->tgt.fs.nwTermAddr;
        }
    } else if (ep->flags & 0x00000020) {
        *localTermDevice = &ep->tgt.fs.termDev;
    } else {
        if ((((kenv_env_t *)(envH))->accPgm.procFlags) & 0x4) {
            flags = 0x1;
        } else {
            flags = 0;
        }
        rc = pal_getLocalTermDevice(kenv_envGetProgram(envH), flags, &ttyDev);
        if (rc == 0) {
            ep->tgt.fs.termDev = ttyDev;
            *localTermDevice = &ep->tgt.fs.termDev;
            ep->flags |= 0x00000020;
        }
    }

    if (*nwTermAddr) {
        if (ep->tgt.fs.nwTermAddr.ip.ipV6) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_E_NW_TERM_IPV6, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl((*nwTermAddr)->ip.addr.a32[0])), (long)ntohl((*nwTermAddr)->ip.addr.a32[1]), (long)ntohl((*nwTermAddr)->ip.addr.a32[2]), (long)ntohl((*nwTermAddr)->ip.addr.a32[3])),0) : 0);




        } else {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_E_NW_TERM, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)((int) (ntohl(ep->tgt.fs.nwTermAddr.ip.addr.addrClassic.addr)))),0) : 0);


        }
    } else if (*localTermDevice) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_E_DEV_TERM, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(pal_devToInt32(ep->tgt.fs.termDev))),0) : 0);

    } else {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event0((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_E_NO_TERM, (((0)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16))),0) : 0);
    }
}
pal_dev_t *
kenv_envGetTermDev(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    pal_dev_t *termDev = NULL;

    if (ep->flags & 0x00000020) {
        termDev = &ep->tgt.fs.termDev;
    }
    return termDev;
}
pal_nwAddr_t *
kenv_envGetNWTerm(kenv_envHandle_t envH)
{
    kenv_env_t *ep = envH;
    pal_nwAddr_t *nwa = NULL;

    if (ep->flags & 0x00000040) {
        nwa = &ep->tgt.fs.nwTermAddr;
    }
    return nwa;
}
char *
kenv_envSetLocalTermName(kenv_envHandle_t envH, char *name)
{
    kenv_env_t *ep = envH;
    char *termName = NULL;

    ;
    if (ep->flags & 0x00000020) {
        termName = pal_alloc(strlen(name) + 1);
        if (termName) {
            strcpy(termName, name);
            ep->tgt.fs.localTermName = termName;
            (ep)->flags |= 0x01000000;
        }
    }
    return termName;
}
byte_t *
kenv_envSetTermExtData(kenv_envHandle_t envH, int len, byte_t *eData)
{
    kenv_env_t *ep = envH;
    byte_t *extData = NULL;


    ;
    if ((ep->flags & 0x00000020) ||
        (ep->flags & 0x00000040)) {
        extData = (byte_t *)pal_alloc(len);
        if (extData) {
            memcpy(extData,eData,len);
            ep->tgt.fs.termExtData = extData;
            ep->tgt.fs.termExtDataLen = len;
            (ep)->flags |= 0x01000000;
        }
    }
    return extData;
}
byte_t *
kenv_envGetTermExtData(kenv_envHandle_t envH, int *len)
{
    kenv_env_t *ep = envH;
    byte_t *extData = NULL;

    *len = 0;
    if ((ep->flags & 0x00000020) ||
        (ep->flags & 0x00000040)) {
        if (ep->tgt.fs.termExtDataLen) {
            extData = ep->tgt.fs.termExtData;
            *len = ep->tgt.fs.termExtDataLen;
        }
    }
    return extData;
}
void
kenv_envResetTargetData(kenv_envHandle_t envH, int which)
{
    kenv_env_t *ep = (kenv_env_t *)envH;
    kenv_fileTgt_t *ftp;
    pal_rawFid_t *rfp;
    int pfidCount;

    ftp = &ep->tgt.fs.f;

    ftp->trappedNameRef = NULL;
    ftp->tnLen = 0;

    if (ftp->baseName) {
        pal_free(ftp->baseName, strlen(ftp->baseName) + 1);
        ftp->baseName = NULL;
    }

    if (ftp->dir_vnh) {
        pal_releVnode(ftp->dir_vnh);
        ftp->dir_vnh = NULL;
    }

    if (ftp->vnh) {
        pal_releVnode(ftp->vnh);
        ftp->vnh = NULL;
    }

    if (ftp->pathFids) {
        cleanPathFids(ftp);
    }


    ftp->tgt_nd = NULL;
    ftp->aux_tgt_nd = NULL;


    if (ep->flags & 0x00000100) {
        ftp = ep->tgt.fs.f.auxFile;
        ;
        if (ftp->pathFids) {
            cleanPathFids(ftp);
        }
        if (ftp->baseName) {
            pal_free(ftp->baseName, strlen(ftp->baseName) + 1);
        }
        pal_free(ftp, sizeof(*ftp));
    }

    if ((ep->flags & 0x00000020) ||
        (ep->flags & 0x00000040)) {
        if (ep->tgt.fs.localTermName) {
            pal_free(ep->tgt.fs.localTermName,
                     strlen(ep->tgt.fs.localTermName) + 1);
        }

        if (ep->tgt.fs.termExtDataLen) {
            pal_free(ep->tgt.fs.termExtData, ep->tgt.fs.termExtDataLen);
        }
        ep->tgt.fs.termExtDataLen = 0;
    }

    ep->tgt.fs.idSet.idVal = 0;
    ep->tgt.fs.idSet.setMask = 0;
    ep->flags &= ~(0x00000002 | 0x00000100 | 0x00000200 | 0x00000400 | 0x00000004 | 0x00000800 | 0x00001000 | 0x00000020 | 0x00000040);
}
void
kenv_envInitialize(void)
{
    int i, j;
    envHandleQ_t *qp;
    envHandle_t *hp;

    if (pal_sysMemMB >= 128) {

        kenv_envHandlesMax *= 5;
    }

    memset((char *)kenv_envHandleQ,0,sizeof(kenv_envHandleQ));
    for (i=0; i < 13; i++) {
        qp = &kenv_envHandleQ[i];
        (kail_iclock_init(&(qp)->qLock));;
        qp->checks = qp->count = 0;
        qp->handles = NULL;
        qp->cacheLinePad[0] = 999999;
        qp->cacheLinePad[1] = 999999;
    }
}
void
kenv_envShutdown(void)
{
    int i;
    envHandleQ_t *qp;
    envHandle_t *hp;

    for (i=0; i < 13; i++) {
        qp = &kenv_envHandleQ[i];
        (kail_iclock_lock(&(qp)->qLock));;
        while(qp->handles) {
            hp = qp->handles;
            qp->handles = hp->next;
            pal_free(hp, sizeof(*hp));
        }
        (kail_iclock_unlock(&(qp)->qLock));;
        qp->checks = qp->count = 0;
    }

    kenv_envHandlesAlloced = 0;
}
