
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[] = "@(#)78       1.22  src/oss/kazn/kail/kail_lsm.c, oss.kazn.src, oss600, 070720c 8/9/07 13:33:59";
#include <linux/version.h>






#include <linux/module.h>

#include <linux/kernel.h>


#include <linux/types.h>

#include <linux/slab.h>

#include <linux/vmalloc.h>

#include <linux/smp_lock.h>

#include <linux/sched.h>

#include <linux/file.h>

#include <linux/fs.h>

#include <linux/wait.h>

#include <linux/namei.h>

#include <linux/list.h>

#include <linux/mount.h>

#include <linux/ptrace.h>

#include <linux/pid.h>

#include <linux/fs_struct.h>

#include <net/sock.h>

#include <asm/atomic.h>

#include <asm/semaphore.h>

#include <asm/current.h>

#include <asm/uaccess.h>


#include <linux/nfs_fs.h>

#include <linux/namespace.h>


#include <linux/security.h>
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );

extern asmlinkage int kail_copy_exec_argv(void *, char *, int);


struct group_info;
extern gid_t * FASTCALL(kail_groups_blocks(struct group_info *,int));
extern int FASTCALL(kail_groups_ngroups(struct group_info *));
extern int FASTCALL(kail_groups_nblocks(struct group_info *));







struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

extern int change_KailPerm2ro(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
struct syscall_glue_table {
        long syscall_index;
        sys_call_fn syscall_glue_pre;
        sys_call_fn syscall_glue_post;
        sys_call_fn syscall_glue_pre_post;

        sys_call_fn sys32call_glue_pre;
        sys_call_fn sys32call_glue_post;
        sys_call_fn sys32call_glue_pre_post;

};
extern struct syscall_glue_table kail_syscall_glue_list[];

struct syscall_table {
        sys_call_fn orig_syscall;
        sys_call_fn syscall_pre;
        sys_call_fn syscall_post;

        sys_call_fn orig_sys32call;

};
extern struct syscall_table kail_syscall_list[];
typedef unsigned int uid32_t;
typedef unsigned int gid32_t;
struct kail_lsmhooks_table {
        sys_call_fn lsmhooks_pre;
        sys_call_fn lsmhooks_post;
};
extern struct kail_lsmhooks_table kail_lsmhooks_list[];
static struct vfsmount *find_vfsmount(struct dentry * const dentry)
{
        struct dentry *l_d = dentry;
        struct vfsmount *mnt = NULL;
        struct vfsmount * const pwdmnt = current->fs->pwdmnt;
        struct vfsmount * const rootmnt = current->fs->rootmnt;

        ;


        if (l_d == pwdmnt->mnt_root) {
                mnt = pwdmnt;
        } else if (l_d == rootmnt->mnt_root) {
                mnt = rootmnt;
        } else while (l_d != l_d->d_parent) {
                l_d = l_d->d_parent;
                if (l_d == pwdmnt->mnt_root) {
                        mnt = pwdmnt;
                        break;
                } else if (l_d == rootmnt->mnt_root) {
                        mnt = rootmnt;
                        break;
                }
        }

        if (!mnt) {


                struct vfsmount *m;
                struct vfsmount *n;


                list_for_each_entry_safe(m,n,&current->namespace->list,mnt_list) {
                        if ((m == pwdmnt)
                                || (m == rootmnt)) {
                                continue;
                        }

                        l_d = dentry;
                        if (l_d == m->mnt_root) {
                                mnt = m;
                                break;
                        } else while (l_d != l_d->d_parent) {

                                l_d = l_d->d_parent;
                                if (l_d == m->mnt_root) {
                                        mnt = m;
                                        break;
                                }
                        }
                        if (mnt) {
                                break;
                        }
                }
        }

        ;

        (unlikely(!(mnt)) ? (printk("kail_assert: %s:%d\n","/project/oss600/build/oss600/src/oss/kazn/kail/kail_lsm.c",141), *((char *)0) = 0,0) : 0);
        return(mnt);
}
int kail_sec_task_create (unsigned long clone_flags)
{

        ;



        current->security = (void *)clone_flags;

        return 0;
}
int kail_sec_task_alloc_security (struct task_struct *p)
{

        const long clone_flags = (long)current->security;

        ;
        if (clone_flags & (CLONE_FS|CLONE_FILES|CLONE_SIGHAND|CLONE_THREAD|CLONE_SYSVSEM)) {
                ;
                (*(kail_lsmhooks_list[1]).lsmhooks_post)(p->pid);
        } else {
                ;
                (*(kail_lsmhooks_list[0]).lsmhooks_post)(p->pid);
        }

        current->security = NULL;

        return 0;
}
void kail_sec_task_free_security (struct task_struct *p)
{
        ;



        (*(kail_lsmhooks_list[2]).lsmhooks_pre)(p->pid);

        p->security = NULL;
}
#if defined(LINUX_RHEL5)







#endif 

#if !defined(LINUX_RHEL5)


int kail_sec_task_kill (struct task_struct *p, struct siginfo *info, int sig)
{
        return 0;

}

#endif 
int kail_sec_inode_create (struct inode *dir, struct dentry *dentry, int mode)
{

        int rc = 0;

        char create_name[60 +1]; char *create_namep, *create_namep_alloc = NULL; struct dentry *create_dentry = (dentry); struct vfsmount *create_mnt = (NULL) ? (NULL) : find_vfsmount(create_dentry); struct nameidata create_nd; struct kail_datanameidata create_dnd; int create_error; create_namep = d_path(dentry,create_mnt,create_name,60); create_error = PTR_ERR(create_namep); if (unlikely((IS_ERR(create_namep)) && ((create_error == -E2BIG) || (create_error == -ENAMETOOLONG)))) { create_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (create_namep_alloc) { create_namep = d_path(dentry,create_mnt, create_namep_alloc,PATH_MAX); } } if (!IS_ERR(create_namep)) { memset(&create_nd,0,sizeof(create_nd)); create_nd.dentry = create_dentry; create_nd.mnt = create_mnt; memset(&create_dnd,0,sizeof(create_dnd)); create_dnd.nd = &create_nd; create_dnd.path = create_namep; } else { rc = PTR_ERR(create_namep); };

        ;



        if (!rc)
                rc = ((*(kail_lsmhooks_list[3]).lsmhooks_pre)(&create_dnd,mode));

        if (unlikely(create_namep_alloc != NULL)) kfree(create_namep_alloc);;

        ;

        return rc;
}

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 
void kail_sec_inode_post_create (struct inode *dir, struct dentry *dentry, int mode)
{
        int rc = 0;

        char create_name[60 +1]; char *create_namep, *create_namep_alloc = NULL; struct dentry *create_dentry = (dentry); struct vfsmount *create_mnt = (NULL) ? (NULL) : find_vfsmount(create_dentry); struct nameidata create_nd; struct kail_datanameidata create_dnd; int create_error; create_namep = d_path(dentry,create_mnt,create_name,60); create_error = PTR_ERR(create_namep); if (unlikely((IS_ERR(create_namep)) && ((create_error == -E2BIG) || (create_error == -ENAMETOOLONG)))) { create_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (create_namep_alloc) { create_namep = d_path(dentry,create_mnt, create_namep_alloc,PATH_MAX); } } if (!IS_ERR(create_namep)) { memset(&create_nd,0,sizeof(create_nd)); create_nd.dentry = create_dentry; create_nd.mnt = create_mnt; memset(&create_dnd,0,sizeof(create_dnd)); create_dnd.nd = &create_nd; create_dnd.path = create_namep; } else { rc = PTR_ERR(create_namep); };

        ;



        if (!rc)
                (*(kail_lsmhooks_list[3]).lsmhooks_post)(&create_dnd,mode);

        if (unlikely(create_namep_alloc != NULL)) kfree(create_namep_alloc);;
}

#endif 
int kail_sec_inode_mkdir (struct inode *dir, struct dentry *dentry, int mode)
{
        int rc = 0;

        char mkdir_name[60 +1]; char *mkdir_namep, *mkdir_namep_alloc = NULL; struct dentry *mkdir_dentry = (dentry); struct vfsmount *mkdir_mnt = (NULL) ? (NULL) : find_vfsmount(mkdir_dentry); struct nameidata mkdir_nd; struct kail_datanameidata mkdir_dnd; int mkdir_error; mkdir_namep = d_path(dentry,mkdir_mnt,mkdir_name,60); mkdir_error = PTR_ERR(mkdir_namep); if (unlikely((IS_ERR(mkdir_namep)) && ((mkdir_error == -E2BIG) || (mkdir_error == -ENAMETOOLONG)))) { mkdir_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (mkdir_namep_alloc) { mkdir_namep = d_path(dentry,mkdir_mnt, mkdir_namep_alloc,PATH_MAX); } } if (!IS_ERR(mkdir_namep)) { memset(&mkdir_nd,0,sizeof(mkdir_nd)); mkdir_nd.dentry = mkdir_dentry; mkdir_nd.mnt = mkdir_mnt; memset(&mkdir_dnd,0,sizeof(mkdir_dnd)); mkdir_dnd.nd = &mkdir_nd; mkdir_dnd.path = mkdir_namep; } else { rc = PTR_ERR(mkdir_namep); };

        ;



        if (!rc)
                rc = ((*(kail_lsmhooks_list[4]).lsmhooks_pre)(&mkdir_dnd,mode));

        if (unlikely(mkdir_namep_alloc != NULL)) kfree(mkdir_namep_alloc);;

        ;

        return rc;
}

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 
void kail_sec_inode_post_mkdir (struct inode *dir, struct dentry *dentry, int mode)
{
        int rc = 0;

        char mkdir_name[60 +1]; char *mkdir_namep, *mkdir_namep_alloc = NULL; struct dentry *mkdir_dentry = (dentry); struct vfsmount *mkdir_mnt = (NULL) ? (NULL) : find_vfsmount(mkdir_dentry); struct nameidata mkdir_nd; struct kail_datanameidata mkdir_dnd; int mkdir_error; mkdir_namep = d_path(dentry,mkdir_mnt,mkdir_name,60); mkdir_error = PTR_ERR(mkdir_namep); if (unlikely((IS_ERR(mkdir_namep)) && ((mkdir_error == -E2BIG) || (mkdir_error == -ENAMETOOLONG)))) { mkdir_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (mkdir_namep_alloc) { mkdir_namep = d_path(dentry,mkdir_mnt, mkdir_namep_alloc,PATH_MAX); } } if (!IS_ERR(mkdir_namep)) { memset(&mkdir_nd,0,sizeof(mkdir_nd)); mkdir_nd.dentry = mkdir_dentry; mkdir_nd.mnt = mkdir_mnt; memset(&mkdir_dnd,0,sizeof(mkdir_dnd)); mkdir_dnd.nd = &mkdir_nd; mkdir_dnd.path = mkdir_namep; } else { rc = PTR_ERR(mkdir_namep); };

        ;



        if (!rc)
                (*(kail_lsmhooks_list[4]).lsmhooks_post)(&mkdir_dnd,mode);

        if (unlikely(mkdir_namep_alloc != NULL)) kfree(mkdir_namep_alloc);;
}

#endif 
int kail_sec_inode_rmdir (struct inode *dir, struct dentry *dentry)
{
        int rc = 0;

        char rmdir_name[60 +1]; char *rmdir_namep, *rmdir_namep_alloc = NULL; struct dentry *rmdir_dentry = (dentry); struct vfsmount *rmdir_mnt = (NULL) ? (NULL) : find_vfsmount(rmdir_dentry); struct nameidata rmdir_nd; struct kail_datanameidata rmdir_dnd; int rmdir_error; rmdir_namep = d_path(dentry,rmdir_mnt,rmdir_name,60); rmdir_error = PTR_ERR(rmdir_namep); if (unlikely((IS_ERR(rmdir_namep)) && ((rmdir_error == -E2BIG) || (rmdir_error == -ENAMETOOLONG)))) { rmdir_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (rmdir_namep_alloc) { rmdir_namep = d_path(dentry,rmdir_mnt, rmdir_namep_alloc,PATH_MAX); } } if (!IS_ERR(rmdir_namep)) { memset(&rmdir_nd,0,sizeof(rmdir_nd)); rmdir_nd.dentry = rmdir_dentry; rmdir_nd.mnt = rmdir_mnt; memset(&rmdir_dnd,0,sizeof(rmdir_dnd)); rmdir_dnd.nd = &rmdir_nd; rmdir_dnd.path = rmdir_namep; } else { rc = PTR_ERR(rmdir_namep); };
        { char *ld = rmdir_namep,*d = ld;
          while (ld) {
                d = ld;

                ld=strchr(d+1,'/');
          }







          strcpy(d+1,(const char *)dentry->d_name.name);
        }

        ;



        if (!rc)
                rc = ((*(kail_lsmhooks_list[5]).lsmhooks_pre)(&rmdir_dnd));

        if (unlikely(rmdir_namep_alloc != NULL)) kfree(rmdir_namep_alloc);;

        ;

        return rc;
}
int kail_sec_inode_mknod (struct inode *dir, struct dentry *dentry, int mode, dev_t dev)
{
        int rc = 0;

        char mknod_name[60 +1]; char *mknod_namep, *mknod_namep_alloc = NULL; struct dentry *mknod_dentry = (dentry); struct vfsmount *mknod_mnt = (NULL) ? (NULL) : find_vfsmount(mknod_dentry); struct nameidata mknod_nd; struct kail_datanameidata mknod_dnd; int mknod_error; mknod_namep = d_path(dentry,mknod_mnt,mknod_name,60); mknod_error = PTR_ERR(mknod_namep); if (unlikely((IS_ERR(mknod_namep)) && ((mknod_error == -E2BIG) || (mknod_error == -ENAMETOOLONG)))) { mknod_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (mknod_namep_alloc) { mknod_namep = d_path(dentry,mknod_mnt, mknod_namep_alloc,PATH_MAX); } } if (!IS_ERR(mknod_namep)) { memset(&mknod_nd,0,sizeof(mknod_nd)); mknod_nd.dentry = mknod_dentry; mknod_nd.mnt = mknod_mnt; memset(&mknod_dnd,0,sizeof(mknod_dnd)); mknod_dnd.nd = &mknod_nd; mknod_dnd.path = mknod_namep; } else { rc = PTR_ERR(mknod_namep); };

        ;



        if (!rc)
                rc = ((*(kail_lsmhooks_list[6]).lsmhooks_pre)(&mknod_dnd,mode,dev));

        if (unlikely(mknod_namep_alloc != NULL)) kfree(mknod_namep_alloc);;

        ;

        return rc;
}

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 
void kail_sec_inode_post_mknod (struct inode *dir, struct dentry *dentry, int mode, dev_t dev)
{
        int rc = 0;

        char mknod_name[60 +1]; char *mknod_namep, *mknod_namep_alloc = NULL; struct dentry *mknod_dentry = (dentry); struct vfsmount *mknod_mnt = (NULL) ? (NULL) : find_vfsmount(mknod_dentry); struct nameidata mknod_nd; struct kail_datanameidata mknod_dnd; int mknod_error; mknod_namep = d_path(dentry,mknod_mnt,mknod_name,60); mknod_error = PTR_ERR(mknod_namep); if (unlikely((IS_ERR(mknod_namep)) && ((mknod_error == -E2BIG) || (mknod_error == -ENAMETOOLONG)))) { mknod_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (mknod_namep_alloc) { mknod_namep = d_path(dentry,mknod_mnt, mknod_namep_alloc,PATH_MAX); } } if (!IS_ERR(mknod_namep)) { memset(&mknod_nd,0,sizeof(mknod_nd)); mknod_nd.dentry = mknod_dentry; mknod_nd.mnt = mknod_mnt; memset(&mknod_dnd,0,sizeof(mknod_dnd)); mknod_dnd.nd = &mknod_nd; mknod_dnd.path = mknod_namep; } else { rc = PTR_ERR(mknod_namep); };

        ;



        if (!rc)
                (*(kail_lsmhooks_list[6]).lsmhooks_post)(&mknod_dnd,mode,dev);

        if (unlikely(mknod_namep_alloc != NULL)) kfree(mknod_namep_alloc);;
}

#endif 
int kail_sec_inode_rename (struct inode *old_dir, struct dentry *old_dentry,
                                struct inode *new_dir, struct dentry *new_dentry)
{
        int rc = 0;

        char rename_old_name[60 +1]; char *rename_old_namep, *rename_old_namep_alloc = NULL; struct dentry *rename_old_dentry = (old_dentry); struct vfsmount *rename_old_mnt = (NULL) ? (NULL) : find_vfsmount(rename_old_dentry); struct nameidata rename_old_nd; struct kail_datanameidata rename_old_dnd; int rename_old_error; rename_old_namep = d_path(old_dentry,rename_old_mnt,rename_old_name,60); rename_old_error = PTR_ERR(rename_old_namep); if (unlikely((IS_ERR(rename_old_namep)) && ((rename_old_error == -E2BIG) || (rename_old_error == -ENAMETOOLONG)))) { rename_old_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (rename_old_namep_alloc) { rename_old_namep = d_path(old_dentry,rename_old_mnt, rename_old_namep_alloc,PATH_MAX); } } if (!IS_ERR(rename_old_namep)) { memset(&rename_old_nd,0,sizeof(rename_old_nd)); rename_old_nd.dentry = rename_old_dentry; rename_old_nd.mnt = rename_old_mnt; memset(&rename_old_dnd,0,sizeof(rename_old_dnd)); rename_old_dnd.nd = &rename_old_nd; rename_old_dnd.path = rename_old_namep; } else { rc = PTR_ERR(rename_old_namep); };

        if (unlikely(rc)) {
                ;

        }


        char rename_new_name[60 +1]; char *rename_new_namep, *rename_new_namep_alloc = NULL; struct dentry *rename_new_dentry = (new_dentry); struct vfsmount *rename_new_mnt = (rename_old_mnt) ? (rename_old_mnt) : find_vfsmount(rename_new_dentry); struct nameidata rename_new_nd; struct kail_datanameidata rename_new_dnd; int rename_new_error; rename_new_namep = d_path(new_dentry,rename_new_mnt,rename_new_name,60); rename_new_error = PTR_ERR(rename_new_namep); if (unlikely((IS_ERR(rename_new_namep)) && ((rename_new_error == -E2BIG) || (rename_new_error == -ENAMETOOLONG)))) { rename_new_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (rename_new_namep_alloc) { rename_new_namep = d_path(new_dentry,rename_new_mnt, rename_new_namep_alloc,PATH_MAX); } } if (!IS_ERR(rename_new_namep)) { memset(&rename_new_nd,0,sizeof(rename_new_nd)); rename_new_nd.dentry = rename_new_dentry; rename_new_nd.mnt = rename_new_mnt; memset(&rename_new_dnd,0,sizeof(rename_new_dnd)); rename_new_dnd.nd = &rename_new_nd; rename_new_dnd.path = rename_new_namep; } else { rc = PTR_ERR(rename_new_namep); };

        ;




        if (!rc)
                rc = ((*(kail_lsmhooks_list[7]).lsmhooks_pre)(&rename_old_dnd,&rename_new_dnd));

        if (unlikely(rename_old_namep_alloc != NULL)) kfree(rename_old_namep_alloc);;
        if (unlikely(rename_new_namep_alloc != NULL)) kfree(rename_new_namep_alloc);;

        ;

        return rc;
}

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 
void kail_sec_inode_post_rename (struct inode *old_dir, struct dentry *old_dentry,
                                        struct inode *new_dir, struct dentry *new_dentry)
{
        int rc = 0;

        char rename_old_name[60 +1]; char *rename_old_namep, *rename_old_namep_alloc = NULL; struct dentry *rename_old_dentry = (old_dentry); struct vfsmount *rename_old_mnt = (NULL) ? (NULL) : find_vfsmount(rename_old_dentry); struct nameidata rename_old_nd; struct kail_datanameidata rename_old_dnd; int rename_old_error; rename_old_namep = d_path(old_dentry,rename_old_mnt,rename_old_name,60); rename_old_error = PTR_ERR(rename_old_namep); if (unlikely((IS_ERR(rename_old_namep)) && ((rename_old_error == -E2BIG) || (rename_old_error == -ENAMETOOLONG)))) { rename_old_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (rename_old_namep_alloc) { rename_old_namep = d_path(old_dentry,rename_old_mnt, rename_old_namep_alloc,PATH_MAX); } } if (!IS_ERR(rename_old_namep)) { memset(&rename_old_nd,0,sizeof(rename_old_nd)); rename_old_nd.dentry = rename_old_dentry; rename_old_nd.mnt = rename_old_mnt; memset(&rename_old_dnd,0,sizeof(rename_old_dnd)); rename_old_dnd.nd = &rename_old_nd; rename_old_dnd.path = rename_old_namep; } else { rc = PTR_ERR(rename_old_namep); };

        if (unlikely(rc)) {
                ;

        }


        char rename_new_name[60 +1]; char *rename_new_namep, *rename_new_namep_alloc = NULL; struct dentry *rename_new_dentry = (new_dentry); struct vfsmount *rename_new_mnt = (rename_old_mnt) ? (rename_old_mnt) : find_vfsmount(rename_new_dentry); struct nameidata rename_new_nd; struct kail_datanameidata rename_new_dnd; int rename_new_error; rename_new_namep = d_path(new_dentry,rename_new_mnt,rename_new_name,60); rename_new_error = PTR_ERR(rename_new_namep); if (unlikely((IS_ERR(rename_new_namep)) && ((rename_new_error == -E2BIG) || (rename_new_error == -ENAMETOOLONG)))) { rename_new_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (rename_new_namep_alloc) { rename_new_namep = d_path(new_dentry,rename_new_mnt, rename_new_namep_alloc,PATH_MAX); } } if (!IS_ERR(rename_new_namep)) { memset(&rename_new_nd,0,sizeof(rename_new_nd)); rename_new_nd.dentry = rename_new_dentry; rename_new_nd.mnt = rename_new_mnt; memset(&rename_new_dnd,0,sizeof(rename_new_dnd)); rename_new_dnd.nd = &rename_new_nd; rename_new_dnd.path = rename_new_namep; } else { rc = PTR_ERR(rename_new_namep); };

        ;




        if (!rc)
                (*(kail_lsmhooks_list[7]).lsmhooks_post)(&rename_old_dnd,&rename_new_dnd);

        if (unlikely(rename_old_namep_alloc != NULL)) kfree(rename_old_namep_alloc);;
        if (unlikely(rename_new_namep_alloc != NULL)) kfree(rename_new_namep_alloc);;
}

#endif 
int kail_sec_inode_unlink (struct inode *dir, struct dentry *dentry)
{
        int rc = 0;

        char unlink_name[60 +1]; char *unlink_namep, *unlink_namep_alloc = NULL; struct dentry *unlink_dentry = (dentry); struct vfsmount *unlink_mnt = (NULL) ? (NULL) : find_vfsmount(unlink_dentry); struct nameidata unlink_nd; struct kail_datanameidata unlink_dnd; int unlink_error; unlink_namep = d_path(dentry,unlink_mnt,unlink_name,60); unlink_error = PTR_ERR(unlink_namep); if (unlikely((IS_ERR(unlink_namep)) && ((unlink_error == -E2BIG) || (unlink_error == -ENAMETOOLONG)))) { unlink_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (unlink_namep_alloc) { unlink_namep = d_path(dentry,unlink_mnt, unlink_namep_alloc,PATH_MAX); } } if (!IS_ERR(unlink_namep)) { memset(&unlink_nd,0,sizeof(unlink_nd)); unlink_nd.dentry = unlink_dentry; unlink_nd.mnt = unlink_mnt; memset(&unlink_dnd,0,sizeof(unlink_dnd)); unlink_dnd.nd = &unlink_nd; unlink_dnd.path = unlink_namep; } else { rc = PTR_ERR(unlink_namep); };

        ;



        if (!rc)
                rc = ((*(kail_lsmhooks_list[8]).lsmhooks_pre)(&unlink_dnd));

        if (unlikely(unlink_namep_alloc != NULL)) kfree(unlink_namep_alloc);;

        ;

        return rc;
}
int kail_sec_inode_symlink (struct inode *dir, struct dentry *dentry, const char *old_name)
{
        int rc = 0;

        char symlink_name[60 +1]; char *symlink_namep, *symlink_namep_alloc = NULL; struct dentry *symlink_dentry = (dentry); struct vfsmount *symlink_mnt = (NULL) ? (NULL) : find_vfsmount(symlink_dentry); struct nameidata symlink_nd; struct kail_datanameidata symlink_dnd; int symlink_error; symlink_namep = d_path(dentry,symlink_mnt,symlink_name,60); symlink_error = PTR_ERR(symlink_namep); if (unlikely((IS_ERR(symlink_namep)) && ((symlink_error == -E2BIG) || (symlink_error == -ENAMETOOLONG)))) { symlink_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (symlink_namep_alloc) { symlink_namep = d_path(dentry,symlink_mnt, symlink_namep_alloc,PATH_MAX); } } if (!IS_ERR(symlink_namep)) { memset(&symlink_nd,0,sizeof(symlink_nd)); symlink_nd.dentry = symlink_dentry; symlink_nd.mnt = symlink_mnt; memset(&symlink_dnd,0,sizeof(symlink_dnd)); symlink_dnd.nd = &symlink_nd; symlink_dnd.path = symlink_namep; } else { rc = PTR_ERR(symlink_namep); };

        ;



        if (!rc)
                rc = ((*(kail_lsmhooks_list[9]).lsmhooks_pre)(old_name,&symlink_dnd));

        if (unlikely(symlink_namep_alloc != NULL)) kfree(symlink_namep_alloc);;

        ;

        return rc;
}

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 
void kail_sec_inode_post_symlink (struct inode *dir, struct dentry *dentry, const char *old_name)
{
        int rc = 0;

        char symlink_name[60 +1]; char *symlink_namep, *symlink_namep_alloc = NULL; struct dentry *symlink_dentry = (dentry); struct vfsmount *symlink_mnt = (NULL) ? (NULL) : find_vfsmount(symlink_dentry); struct nameidata symlink_nd; struct kail_datanameidata symlink_dnd; int symlink_error; symlink_namep = d_path(dentry,symlink_mnt,symlink_name,60); symlink_error = PTR_ERR(symlink_namep); if (unlikely((IS_ERR(symlink_namep)) && ((symlink_error == -E2BIG) || (symlink_error == -ENAMETOOLONG)))) { symlink_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (symlink_namep_alloc) { symlink_namep = d_path(dentry,symlink_mnt, symlink_namep_alloc,PATH_MAX); } } if (!IS_ERR(symlink_namep)) { memset(&symlink_nd,0,sizeof(symlink_nd)); symlink_nd.dentry = symlink_dentry; symlink_nd.mnt = symlink_mnt; memset(&symlink_dnd,0,sizeof(symlink_dnd)); symlink_dnd.nd = &symlink_nd; symlink_dnd.path = symlink_namep; } else { rc = PTR_ERR(symlink_namep); };

        ;



        if (!rc)
                (*(kail_lsmhooks_list[9]).lsmhooks_post)(old_name,&symlink_dnd);

        if (unlikely(symlink_namep_alloc != NULL)) kfree(symlink_namep_alloc);;
}

#endif 
int kail_sec_inode_readlink (struct dentry *dentry)
{
        int rc = 0;

        char readlink_name[60 +1]; char *readlink_namep, *readlink_namep_alloc = NULL; struct dentry *readlink_dentry = (dentry); struct vfsmount *readlink_mnt = (NULL) ? (NULL) : find_vfsmount(readlink_dentry); struct nameidata readlink_nd; struct kail_datanameidata readlink_dnd; int readlink_error; readlink_namep = d_path(dentry,readlink_mnt,readlink_name,60); readlink_error = PTR_ERR(readlink_namep); if (unlikely((IS_ERR(readlink_namep)) && ((readlink_error == -E2BIG) || (readlink_error == -ENAMETOOLONG)))) { readlink_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (readlink_namep_alloc) { readlink_namep = d_path(dentry,readlink_mnt, readlink_namep_alloc,PATH_MAX); } } if (!IS_ERR(readlink_namep)) { memset(&readlink_nd,0,sizeof(readlink_nd)); readlink_nd.dentry = readlink_dentry; readlink_nd.mnt = readlink_mnt; memset(&readlink_dnd,0,sizeof(readlink_dnd)); readlink_dnd.nd = &readlink_nd; readlink_dnd.path = readlink_namep; } else { rc = PTR_ERR(readlink_namep); };

        ;



        if (!rc)
                rc = ((*(kail_lsmhooks_list[10]).lsmhooks_pre)(&readlink_dnd));

        if (unlikely(readlink_namep_alloc != NULL)) kfree(readlink_namep_alloc);;

        ;

        return rc;
}
int kail_sec_inode_follow_link (struct dentry *dentry, struct nameidata *nd)
{
        int rc = 0;

#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)
        if (CHECK_LOOKUP_FLAG(nd)) {

                ;


                return 0;
        }


#endif 
#ifdef LINUX_SLES9
        if (nd->intent.it_op == IT_LOOKUP) {

                ;


                return 0;
        }

#endif 

        char follow_link_name[60 +1]; char *follow_link_namep, *follow_link_namep_alloc = NULL; struct dentry *follow_link_dentry = (dentry); struct vfsmount *follow_link_mnt = (nd->mnt) ? (nd->mnt) : find_vfsmount(follow_link_dentry); struct nameidata follow_link_nd; struct kail_datanameidata follow_link_dnd; int follow_link_error; follow_link_namep = d_path(dentry,follow_link_mnt,follow_link_name,60); follow_link_error = PTR_ERR(follow_link_namep); if (unlikely((IS_ERR(follow_link_namep)) && ((follow_link_error == -E2BIG) || (follow_link_error == -ENAMETOOLONG)))) { follow_link_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (follow_link_namep_alloc) { follow_link_namep = d_path(dentry,follow_link_mnt, follow_link_namep_alloc,PATH_MAX); } } if (!IS_ERR(follow_link_namep)) { memset(&follow_link_nd,0,sizeof(follow_link_nd)); follow_link_nd.dentry = follow_link_dentry; follow_link_nd.mnt = follow_link_mnt; memset(&follow_link_dnd,0,sizeof(follow_link_dnd)); follow_link_dnd.nd = &follow_link_nd; follow_link_dnd.path = follow_link_namep; } else { rc = PTR_ERR(follow_link_namep); };

        ;


#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)

        ;




#endif 
#ifdef LINUX_SLES9

        ;





#endif 

        if (!rc)
                rc = ((*(kail_lsmhooks_list[10]).lsmhooks_pre)(&follow_link_dnd));

        if (unlikely(follow_link_namep_alloc != NULL)) kfree(follow_link_namep_alloc);;

        ;

        return rc;
}
int kail_sec_task_setuid (uid_t id0, uid_t id1, uid_t id2, int flags)
{
        int rc = 0;

        ;
        if (flags == LSM_SETID_ID) {
                rc = ((*(kail_lsmhooks_list[11]).lsmhooks_pre)(id0));
        } else if (flags == LSM_SETID_RE) {
                rc = ((*(kail_lsmhooks_list[12]).lsmhooks_pre)(id0,id1));
        } else if (flags == LSM_SETID_RES) {
                rc = ((*(kail_lsmhooks_list[13]).lsmhooks_pre)(id0,id1,id2));
        } else if (flags == LSM_SETID_FS) {
                rc = ((*(kail_lsmhooks_list[14]).lsmhooks_pre)(id0));
        }

        ;

        return rc;
}
int kail_sec_task_setgid (gid_t id0, gid_t id1, gid_t id2, int flags)
{
        int rc = 0;

        ;
        if (flags == LSM_SETID_ID) {
                rc = ((*(kail_lsmhooks_list[15]).lsmhooks_pre)(id0));
        } else if (flags == LSM_SETID_RE) {
                rc = ((*(kail_lsmhooks_list[16]).lsmhooks_pre)(id0,id1));
        } else if (flags == LSM_SETID_RES) {
                rc = ((*(kail_lsmhooks_list[17]).lsmhooks_pre)(id0,id1,id2));
        } else if (flags == LSM_SETID_FS) {
                rc = ((*(kail_lsmhooks_list[18]).lsmhooks_pre)(id0));
        }

        ;

        return rc;
}
int kail_sec_task_setgroups (struct group_info *group_info)
{
        int rc;

        ;


        rc = ((*(kail_lsmhooks_list[19]).lsmhooks_pre)(group_info));

        ;

        return rc;
}
int kail_sec_register_security (const char *name, struct security_operations *ops)
{
        ;



        return -EINVAL;
}
int kail_sec_unregister_security (const char *name, struct security_operations *ops)
{
        ;



        return -EINVAL;
}
int kail_sec_inode_setattr (struct dentry *dentry, struct iattr *attr)
{
        int rc = 0;

        char setattr_name[60 +1]; char *setattr_namep, *setattr_namep_alloc = NULL; struct dentry *setattr_dentry = (dentry); struct vfsmount *setattr_mnt = (NULL) ? (NULL) : find_vfsmount(setattr_dentry); struct nameidata setattr_nd; struct kail_datanameidata setattr_dnd; int setattr_error; setattr_namep = d_path(dentry,setattr_mnt,setattr_name,60); setattr_error = PTR_ERR(setattr_namep); if (unlikely((IS_ERR(setattr_namep)) && ((setattr_error == -E2BIG) || (setattr_error == -ENAMETOOLONG)))) { setattr_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (setattr_namep_alloc) { setattr_namep = d_path(dentry,setattr_mnt, setattr_namep_alloc,PATH_MAX); } } if (!IS_ERR(setattr_namep)) { memset(&setattr_nd,0,sizeof(setattr_nd)); setattr_nd.dentry = setattr_dentry; setattr_nd.mnt = setattr_mnt; memset(&setattr_dnd,0,sizeof(setattr_dnd)); setattr_dnd.nd = &setattr_nd; setattr_dnd.path = setattr_namep; } else { rc = PTR_ERR(setattr_namep); };

        if (attr->ia_valid & (ATTR_MODE)) {
                ;


                if (!rc)
                        rc = ((*(kail_lsmhooks_list[20]).lsmhooks_pre)(&setattr_dnd,attr->ia_mode));
                ;
        } else
        if (attr->ia_valid & (ATTR_UID | ATTR_GID)) {
                ;


                if (!rc)
                        rc = ((*(kail_lsmhooks_list[21]).lsmhooks_pre)(&setattr_dnd,attr->ia_uid,attr->ia_gid));
                ;
        } else
        if (attr->ia_valid & (ATTR_SIZE)) {
                ;


                if (!rc)
                        rc = ((*(kail_lsmhooks_list[22]).lsmhooks_pre)(&setattr_dnd,attr->ia_size));
                ;
        } else
        if (attr->ia_valid & (ATTR_CTIME | ATTR_MTIME | ATTR_ATIME)) {
                ;


                if (!rc)
                        rc = ((*(kail_lsmhooks_list[23]).lsmhooks_pre)(&setattr_dnd,&(attr->ia_atime)));
                ;
        }

        if (unlikely(setattr_namep_alloc != NULL)) kfree(setattr_namep_alloc);;

        return rc;
}
int kail_sec_inode_link (struct dentry *old_dentry, struct inode *dir, struct dentry *new_dentry)
{
        int rc = 0;

        char link_old_name[60 +1]; char *link_old_namep, *link_old_namep_alloc = NULL; struct dentry *link_old_dentry = (old_dentry); struct vfsmount *link_old_mnt = (NULL) ? (NULL) : find_vfsmount(link_old_dentry); struct nameidata link_old_nd; struct kail_datanameidata link_old_dnd; int link_old_error; link_old_namep = d_path(old_dentry,link_old_mnt,link_old_name,60); link_old_error = PTR_ERR(link_old_namep); if (unlikely((IS_ERR(link_old_namep)) && ((link_old_error == -E2BIG) || (link_old_error == -ENAMETOOLONG)))) { link_old_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (link_old_namep_alloc) { link_old_namep = d_path(old_dentry,link_old_mnt, link_old_namep_alloc,PATH_MAX); } } if (!IS_ERR(link_old_namep)) { memset(&link_old_nd,0,sizeof(link_old_nd)); link_old_nd.dentry = link_old_dentry; link_old_nd.mnt = link_old_mnt; memset(&link_old_dnd,0,sizeof(link_old_dnd)); link_old_dnd.nd = &link_old_nd; link_old_dnd.path = link_old_namep; } else { rc = PTR_ERR(link_old_namep); };

        if (unlikely(rc)) {
                ;

        }


        char link_new_name[60 +1]; char *link_new_namep, *link_new_namep_alloc = NULL; struct dentry *link_new_dentry = (new_dentry); struct vfsmount *link_new_mnt = (link_old_mnt) ? (link_old_mnt) : find_vfsmount(link_new_dentry); struct nameidata link_new_nd; struct kail_datanameidata link_new_dnd; int link_new_error; link_new_namep = d_path(new_dentry,link_new_mnt,link_new_name,60); link_new_error = PTR_ERR(link_new_namep); if (unlikely((IS_ERR(link_new_namep)) && ((link_new_error == -E2BIG) || (link_new_error == -ENAMETOOLONG)))) { link_new_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (link_new_namep_alloc) { link_new_namep = d_path(new_dentry,link_new_mnt, link_new_namep_alloc,PATH_MAX); } } if (!IS_ERR(link_new_namep)) { memset(&link_new_nd,0,sizeof(link_new_nd)); link_new_nd.dentry = link_new_dentry; link_new_nd.mnt = link_new_mnt; memset(&link_new_dnd,0,sizeof(link_new_dnd)); link_new_dnd.nd = &link_new_nd; link_new_dnd.path = link_new_namep; } else { rc = PTR_ERR(link_new_namep); };

        ;




        if (!rc)
                rc = ((*(kail_lsmhooks_list[24]).lsmhooks_pre)(&link_old_dnd,&link_new_dnd));

        if (unlikely(link_old_namep_alloc != NULL)) kfree(link_old_namep_alloc);;
        if (unlikely(link_new_namep_alloc != NULL)) kfree(link_new_namep_alloc);;

        ;

        return rc;
}

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 
void kail_sec_inode_post_link (struct dentry *old_dentry, struct inode *dir, struct dentry *new_dentry)
{
        int rc = 0;

        char link_old_name[60 +1]; char *link_old_namep, *link_old_namep_alloc = NULL; struct dentry *link_old_dentry = (old_dentry); struct vfsmount *link_old_mnt = (NULL) ? (NULL) : find_vfsmount(link_old_dentry); struct nameidata link_old_nd; struct kail_datanameidata link_old_dnd; int link_old_error; link_old_namep = d_path(old_dentry,link_old_mnt,link_old_name,60); link_old_error = PTR_ERR(link_old_namep); if (unlikely((IS_ERR(link_old_namep)) && ((link_old_error == -E2BIG) || (link_old_error == -ENAMETOOLONG)))) { link_old_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (link_old_namep_alloc) { link_old_namep = d_path(old_dentry,link_old_mnt, link_old_namep_alloc,PATH_MAX); } } if (!IS_ERR(link_old_namep)) { memset(&link_old_nd,0,sizeof(link_old_nd)); link_old_nd.dentry = link_old_dentry; link_old_nd.mnt = link_old_mnt; memset(&link_old_dnd,0,sizeof(link_old_dnd)); link_old_dnd.nd = &link_old_nd; link_old_dnd.path = link_old_namep; } else { rc = PTR_ERR(link_old_namep); };

        if (unlikely(rc)) {
                ;

        }


        char link_new_name[60 +1]; char *link_new_namep, *link_new_namep_alloc = NULL; struct dentry *link_new_dentry = (new_dentry); struct vfsmount *link_new_mnt = (link_old_mnt) ? (link_old_mnt) : find_vfsmount(link_new_dentry); struct nameidata link_new_nd; struct kail_datanameidata link_new_dnd; int link_new_error; link_new_namep = d_path(new_dentry,link_new_mnt,link_new_name,60); link_new_error = PTR_ERR(link_new_namep); if (unlikely((IS_ERR(link_new_namep)) && ((link_new_error == -E2BIG) || (link_new_error == -ENAMETOOLONG)))) { link_new_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (link_new_namep_alloc) { link_new_namep = d_path(new_dentry,link_new_mnt, link_new_namep_alloc,PATH_MAX); } } if (!IS_ERR(link_new_namep)) { memset(&link_new_nd,0,sizeof(link_new_nd)); link_new_nd.dentry = link_new_dentry; link_new_nd.mnt = link_new_mnt; memset(&link_new_dnd,0,sizeof(link_new_dnd)); link_new_dnd.nd = &link_new_nd; link_new_dnd.path = link_new_namep; } else { rc = PTR_ERR(link_new_namep); };

        ;




        if (!rc)
                ((*(kail_lsmhooks_list[24]).lsmhooks_post)(&link_old_dnd,&link_new_dnd));

        if (unlikely(link_old_namep_alloc != NULL)) kfree(link_old_namep_alloc);;
        if (unlikely(link_new_namep_alloc != NULL)) kfree(link_new_namep_alloc);;
}

#endif 
int kail_sec_bprm_check_security (struct linux_binprm *bprm)
{
        int rc;

        ;



        {
          struct nameidata exec_nd;
          struct kail_datanameidata exec_dnd;

#ifdef LINUX_SLES9

                intent_init(&exec_nd.intent, IT_LOOKUP);

#endif 
                SET_LOOKUP_FLAG(&exec_nd);
                rc = path_lookup(bprm->filename,0,&exec_nd);
                CLEAR_LOOKUP_FLAG(&exec_nd);
                if (!rc) {
                        memset(&exec_dnd,0,sizeof(exec_dnd));
                        exec_dnd.nd = &exec_nd;
                        exec_dnd.path = bprm->filename;
                } else {
                        ;
                }

                if (!rc)
                        rc = ((*(kail_lsmhooks_list[25]).lsmhooks_pre)(&exec_dnd,bprm));

                ;

        }

        return rc;
}
int kail_sec_inode_permission (struct inode *inode, int mask, struct nameidata *nd)
{
        if (!nd
            || (mask == MAY_EXEC)
           ) {
                ;

                return 0;
        }
        if (
                inode && S_ISDIR(inode->i_mode)
                && (mask & MAY_WRITE)
           ) {
                ;

                return 0;
        }

        ;




#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)

        ;




        if ( (nd->flags == LOOKUP_FOLLOW)
            || (nd->flags == (LOOKUP_ACCESS | LOOKUP_FOLLOW))

            || ((nd->flags == (LOOKUP_OPEN | LOOKUP_CREATE)) && (mask == 0))
           ) {
                ;

                ;




                return 0;
        }

#endif 
#ifdef LINUX_SLES9
        ;





        if ((nd->intent.it_op == IT_LOOKUP)
            || (nd->intent.it_op == IT_GETATTR)

            || ((nd->intent.it_op == (IT_CREAT | IT_OPEN)) && (mask == 0))
           ) {
                ;

                return 0;
        }

#endif 
        {
                int open_mask = 0;
                int rc = 0;

                char permission_name[60 +1]; char *permission_namep, *permission_namep_alloc = NULL; struct dentry *permission_dentry = (nd->dentry); struct vfsmount *permission_mnt = (nd->mnt) ? (nd->mnt) : find_vfsmount(permission_dentry); struct nameidata permission_nd; struct kail_datanameidata permission_dnd; int permission_error; permission_namep = d_path(nd->dentry,permission_mnt,permission_name,60); permission_error = PTR_ERR(permission_namep); if (unlikely((IS_ERR(permission_namep)) && ((permission_error == -E2BIG) || (permission_error == -ENAMETOOLONG)))) { permission_namep_alloc = kmalloc(PATH_MAX,GFP_KERNEL); if (permission_namep_alloc) { permission_namep = d_path(nd->dentry,permission_mnt, permission_namep_alloc,PATH_MAX); } } if (!IS_ERR(permission_namep)) { memset(&permission_nd,0,sizeof(permission_nd)); permission_nd.dentry = permission_dentry; permission_nd.mnt = permission_mnt; memset(&permission_dnd,0,sizeof(permission_dnd)); permission_dnd.nd = &permission_nd; permission_dnd.path = permission_namep; } else { rc = PTR_ERR(permission_namep); };

#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)

                ;



                ;





#endif 
#ifdef LINUX_SLES9

                ;





#endif 

                if ((mask & (MAY_WRITE | MAY_READ)) == MAY_READ)
                        open_mask |= O_RDONLY;
                if ((mask & (MAY_WRITE | MAY_READ)) == MAY_WRITE)
                        open_mask |= O_WRONLY;
                if ((mask & (MAY_WRITE | MAY_READ)) == (MAY_WRITE | MAY_READ))
                        open_mask |= O_RDWR;
                if (mask & MAY_APPEND)
                        open_mask |= O_APPEND;


                if (!rc)
                        rc = ((*(kail_lsmhooks_list[26]).lsmhooks_pre)(&permission_dnd,open_mask,0));

                if (unlikely(permission_namep_alloc != NULL)) kfree(permission_namep_alloc);;

                ;

                return rc;
        }
}
int kail_sec_capable (struct task_struct *tsk, int cap)
{
        int rc;

        ;


        if (cap == CAP_SYS_BOOT) {
                ;

                rc = (*(kail_lsmhooks_list[27]).lsmhooks_pre)();
                if (rc) {
                        ;
                        return rc;
                }
                else ;

        }

        rc = cap_capable(tsk,cap);

        ;

        return rc;
}

#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#endif 





void kail_sec_sb_post_remount (struct vfsmount *mnt, unsigned long flags, void *data)
{
}

void kail_sec_sb_post_addmount (struct vfsmount *mnt, struct nameidata *mountpoint_nd)
{
}

int kail_sec_sb_mount (char *dev_name, struct nameidata *nd, char *type, unsigned long flags, void *data)
{
        return 0;
}

int kail_sec_socket_accept(struct socket * sock, struct socket * newsock)
{

        return 0;
}

int kail_sec_sb_umount (struct vfsmount *mnt, int flags)
{
        return 0;
}

void kail_sec_sb_umount_close (struct vfsmount *mnt)
{
}

int kail_sec_ptrace (struct task_struct *parent, struct task_struct * child)
{
        return cap_ptrace (parent, child);
}

int kail_sec_capget (struct task_struct *target, kernel_cap_t *effective,
                           kernel_cap_t *inheritable, kernel_cap_t *permitted)
{
        return cap_capget (target, effective, inheritable, permitted);
}

int kail_sec_capset_check (struct task_struct *target, kernel_cap_t *effective,
                                 kernel_cap_t *inheritable, kernel_cap_t *permitted)
{
        return cap_capset_check (target, effective, inheritable, permitted);
}

void kail_sec_capset_set (struct task_struct *target, kernel_cap_t *effective,
                                kernel_cap_t *inheritable, kernel_cap_t *permitted)
{
        cap_capset_set (target, effective, inheritable, permitted);
}

int kail_sec_acct (struct file *file)
{
        return 0;
}

int kail_sec_quotactl (int cmds, int type, int id, struct super_block * sb)
{
        return 0;
}

#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)






#endif 
#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

int kail_sec_quota_on (struct file * file)
{
        return 0;
}

#endif 

int kail_sec_syslog(int type)
{
        return cap_syslog(type);
}

#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)






#endif 

int kail_sec_vm_enough_memory(long pages)
{
        return cap_vm_enough_memory(pages);
}

void kail_sec_sb_umount_busy (struct vfsmount *mnt)
{
}

int kail_sec_task_getpgid (struct task_struct *p)
{
        return 0;
}

int kail_sec_task_getsid (struct task_struct *p)
{
        return 0;
}

int kail_sec_task_setrlimit (unsigned int resource, struct rlimit *new_rlim)
{
        return 0;
}

int kail_sec_task_setnice (struct task_struct *p, int nice)
{
        return 0;
}

int kail_sec_task_setscheduler (struct task_struct *p, int policy, struct sched_param *lp)
{
        return 0;
}

int kail_sec_task_getscheduler (struct task_struct *p)
{
        return 0;
}

#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)






#endif 
#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

int kail_sec_sysctl(ctl_table * table, int op)
{
        return 0;
}

#endif 

int kail_sec_bprm_alloc_security (struct linux_binprm *bprm)
{
        return 0;
}

void kail_sec_bprm_free_security (struct linux_binprm *bprm)
{
}

#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)

void kail_sec_bprm_apply_creds (struct linux_binprm *bprm, int unsafe)
{
        cap_bprm_apply_creds (bprm,unsafe);
}

#endif 

#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)






#endif 

#ifdef LINUX_SLES9

void kail_sec_bprm_compute_creds (struct linux_binprm *bprm)
{
        cap_bprm_compute_creds (bprm);
}

#endif 

int kail_sec_bprm_set_security (struct linux_binprm *bprm)
{
        return cap_bprm_set_security (bprm);
}

int kail_sec_bprm_secureexec (struct linux_binprm *bprm)
{
        return cap_bprm_secureexec(bprm);
}

int kail_sec_sb_alloc_security (struct super_block *sb)
{
        return 0;
}

void kail_sec_sb_free_security (struct super_block *sb)
{
}

int kail_sec_sb_kern_mount (struct super_block *sb, void *data)
{
        return 0;
}

#if defined(LINUX_RHEL5)







#endif 

#if !defined(LINUX_RHEL5)


int kail_sec_sb_statfs (struct super_block *sb)
{
        return 0;
}

#endif 

int kail_sec_sb_check_sb (struct vfsmount *mnt, struct nameidata *nd)
{
        return 0;
}

void kail_sec_sb_post_mountroot (void)
{
}

int kail_sec_sb_pivotroot (struct nameidata *old_nd, struct nameidata *new_nd)
{
        return 0;
}

void kail_sec_sb_post_pivotroot (struct nameidata *old_nd, struct nameidata *new_nd)
{
}

int kail_sec_inode_alloc_security (struct inode *inode)
{
        return 0;
}

void kail_sec_inode_free_security (struct inode *inode)
{
}

int kail_sec_inode_getattr (struct vfsmount *mnt, struct dentry *dentry)
{
        return 0;
}

void kail_sec_inode_delete (struct inode *inode)
{
}

int kail_sec_inode_setxattr (struct dentry *dentry, char *name, void *value, size_t size, int flags)
{
        return cap_inode_setxattr(dentry, name, value, size, flags);
}

void kail_sec_inode_post_setxattr (struct dentry *dentry, char *name, void *value, size_t size, int flags)
{
}

int kail_sec_inode_getxattr (struct dentry *dentry, char *name)
{
        return 0;
}

int kail_sec_inode_listxattr (struct dentry *dentry)
{
        return 0;
}

int kail_sec_inode_removexattr (struct dentry *dentry, char *name)
{
        return cap_inode_removexattr(dentry, name);
}


#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#endif 

#if defined(LINUX_RHEL4) 

int kail_sec_inode_getsecurity(struct inode *inode, const char *name, void *buffer, size_t size)
{
        return -EOPNOTSUPP;
}

int kail_sec_inode_setsecurity(struct inode *inode, const char *name, const void *value, size_t size, int flags)
{
        return -EOPNOTSUPP;
}

int kail_sec_inode_listsecurity(struct inode *inode, char *buffer,size_t buffer_size)
{
        return 0;
}

#endif 

#ifdef LINUX_SLES9

int kail_sec_inode_getsecurity(struct dentry *dentry, const char *name, void *buffer, size_t size)
{
        return -EOPNOTSUPP;
}

int kail_sec_inode_setsecurity(struct dentry *dentry, const char *name, const void *value, size_t size, int flags)
{
        return -EOPNOTSUPP;
}

int kail_sec_inode_listsecurity(struct dentry *dentry, char *buffer)
{
        return 0;
}

#endif 

int kail_sec_file_permission (struct file *file, int mask)
{
        return 0;
}

int kail_sec_file_alloc_security (struct file *file)
{
        return 0;
}

void kail_sec_file_free_security (struct file *file)
{
}

int kail_sec_file_ioctl (struct file *file, unsigned int cmd, unsigned long arg)
{
        return 0;
}

#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#endif 

#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

int kail_sec_file_mmap (struct file *file, unsigned long prot, unsigned long flags)
{
        return 0;
}

int kail_sec_file_mprotect (struct vm_area_struct *vma, unsigned long prot)
{
        return 0;
}

#endif 

int kail_sec_file_lock (struct file *file, unsigned int cmd)
{
        return 0;
}

int kail_sec_file_fcntl (struct file *file, unsigned int cmd, unsigned long arg)
{
        return 0;
}

int kail_sec_file_set_fowner (struct file *file)
{
        return 0;
}

#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)

int kail_sec_file_send_sigiotask (struct task_struct *tsk, struct fown_struct *fown, int sig)
{
        return 0;
}

#endif 

#ifdef LINUX_SLES9

int kail_sec_file_send_sigiotask (struct task_struct *tsk, struct fown_struct *fown, int fd, int reason)
{
        return 0;
}

#endif 

int kail_sec_file_receive (struct file *file)
{
        return 0;
}

int kail_sec_task_post_setuid (uid_t old_ruid, uid_t old_euid, uid_t old_suid, int flags)
{
        return cap_task_post_setuid (old_ruid, old_euid, old_suid, flags);
}

int kail_sec_task_setpgid (struct task_struct *p, pid_t pgid)
{
        return 0;
}

int kail_sec_task_wait (struct task_struct *p)
{
        return 0;
}

int kail_sec_task_prctl (int option, unsigned long arg2, unsigned long arg3,
                                unsigned long arg4, unsigned long arg5)
{
        return 0;
}

void kail_sec_task_reparent_to_init (struct task_struct *p)
{
        cap_task_reparent_to_init (p);
}

void kail_sec_task_to_inode(struct task_struct *p, struct inode *inode)
{
}

int kail_sec_ipc_permission (struct kern_ipc_perm *ipcp, short flag)
{
        return 0;
}

int kail_sec_msg_msg_alloc_security (struct msg_msg * msg)
{
        return 0;
}

void kail_sec_msg_msg_free_security (struct msg_msg * msg)
{
}

int kail_sec_msg_queue_alloc_security (struct msg_queue *msq)
{
        return 0;
}

void kail_sec_msg_queue_free_security (struct msg_queue *msq)
{
}

int kail_sec_msg_queue_associate (struct msg_queue * msq, int msqflg)
{
        return 0;
}

int kail_sec_msg_queue_msgctl (struct msg_queue * msq, int cmd)
{
        return 0;
}

int kail_sec_msg_queue_msgsnd (struct msg_queue * msq, struct msg_msg * msg, int msqflg)
{
        return 0;
}

int kail_sec_msg_queue_msgrcv (struct msg_queue * msq, struct msg_msg * msg,
                                struct task_struct * target, long type, int mode)
{
        return 0;
}

int kail_sec_shm_alloc_security (struct shmid_kernel *shp)
{
        return 0;
}

void kail_sec_shm_free_security (struct shmid_kernel *shp)
{
}

int kail_sec_shm_associate (struct shmid_kernel * shp, int shmflg)
{
        return 0;
}

int kail_sec_shm_shmctl (struct shmid_kernel * shp, int cmd)
{
        return 0;
}

int kail_sec_shm_shmat (struct shmid_kernel * shp, char __user *shmaddr, int shmflg)
{
        return 0;
}

int kail_sec_sem_alloc_security (struct sem_array *sma)
{
        return 0;
}

void kail_sec_sem_free_security (struct sem_array *sma)
{
}

int kail_sec_sem_associate (struct sem_array * sma, int semflg)
{
        return 0;
}

int kail_sec_sem_semctl (struct sem_array * sma, int cmd)
{
        return 0;
}

int kail_sec_sem_semop (struct sem_array * sma, struct sembuf * sops, unsigned nsops, int alter)
{
        return 0;
}

void kail_sec_d_instantiate (struct dentry *dentry, struct inode *inode)
{
}

int kail_sec_getprocattr(struct task_struct *p, char *name, void *value, size_t size)
{
        return -EINVAL;
}

int kail_sec_setprocattr(struct task_struct *p, char *name, void *value, size_t size)
{
        return -EINVAL;
}

#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)

int kail_sec_netlink_send (struct sock *sk,struct sk_buff *skb)
{
        return cap_netlink_send (sk,skb);
}

#endif 

#ifdef LINUX_SLES9

int kail_sec_netlink_send (struct sk_buff *skb)
{
        return cap_netlink_send (skb);
}

#endif 

#if defined(LINUX_RHEL5)







#endif 

#if !defined(LINUX_RHEL5)


int kail_sec_netlink_recv (struct sk_buff *skb)
{
        return cap_netlink_recv (skb);
}

#endif 
#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#endif 

struct security_operations kail_sec_ops = {
        .ptrace = kail_sec_ptrace,
        .capget = kail_sec_capget,
        .capset_check = kail_sec_capset_check,
        .capset_set = kail_sec_capset_set,
        .acct = kail_sec_acct,
        .sysctl = kail_sec_sysctl,
        .capable = kail_sec_capable,
        .quotactl = kail_sec_quotactl,
        .quota_on = kail_sec_quota_on,
        .syslog = kail_sec_syslog,
#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)



#endif 
        .vm_enough_memory = kail_sec_vm_enough_memory,

        .bprm_alloc_security = kail_sec_bprm_alloc_security,
        .bprm_free_security = kail_sec_bprm_free_security,
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)

        .bprm_apply_creds = kail_sec_bprm_apply_creds,

#endif 
#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)



#endif 
#ifdef LINUX_SLES9

        .bprm_compute_creds = kail_sec_bprm_compute_creds,

#endif 
        .bprm_set_security = kail_sec_bprm_set_security,
        .bprm_check_security = kail_sec_bprm_check_security,
        .bprm_secureexec = kail_sec_bprm_secureexec,

        .sb_alloc_security = kail_sec_sb_alloc_security,
        .sb_free_security = kail_sec_sb_free_security,
        .sb_kern_mount = kail_sec_sb_kern_mount,
        .sb_statfs = kail_sec_sb_statfs,
        .sb_mount = kail_sec_sb_mount,
        .sb_check_sb = kail_sec_sb_check_sb,
        .sb_umount = kail_sec_sb_umount,
        .sb_umount_close = kail_sec_sb_umount_close,
        .sb_umount_busy = kail_sec_sb_umount_busy,
        .sb_post_remount = kail_sec_sb_post_remount,
        .sb_post_mountroot = kail_sec_sb_post_mountroot,
        .sb_post_addmount = kail_sec_sb_post_addmount,
        .sb_pivotroot = kail_sec_sb_pivotroot,
        .sb_post_pivotroot = kail_sec_sb_post_pivotroot,

        .inode_alloc_security = kail_sec_inode_alloc_security,
        .inode_free_security = kail_sec_inode_free_security,
#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)



#endif 
        .inode_create = kail_sec_inode_create,
#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

        .inode_post_create = kail_sec_inode_post_create,

#endif 
        .inode_link = kail_sec_inode_link,
#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

        .inode_post_link = kail_sec_inode_post_link,

#endif 
        .inode_unlink = kail_sec_inode_unlink,
        .inode_symlink = kail_sec_inode_symlink,
#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

        .inode_post_symlink = kail_sec_inode_post_symlink,

#endif 
        .inode_mkdir = kail_sec_inode_mkdir,
#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

        .inode_post_mkdir = kail_sec_inode_post_mkdir,

#endif 
        .inode_rmdir = kail_sec_inode_rmdir,
        .inode_mknod = kail_sec_inode_mknod,
#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

        .inode_post_mknod = kail_sec_inode_post_mknod,

#endif 
        .inode_rename = kail_sec_inode_rename,
#if defined(LINUX_SLES9) || defined(LINUX_RHEL4) 

        .inode_post_rename = kail_sec_inode_post_rename,

#endif 
        .inode_readlink = kail_sec_inode_readlink,
        .inode_follow_link = kail_sec_inode_follow_link,
        .inode_permission = kail_sec_inode_permission,
        .inode_setattr = kail_sec_inode_setattr,
        .inode_getattr = kail_sec_inode_getattr,
        .inode_delete = kail_sec_inode_delete,
        .inode_setxattr = kail_sec_inode_setxattr,
        .inode_post_setxattr = kail_sec_inode_post_setxattr,
        .inode_getxattr = kail_sec_inode_getxattr,
        .inode_listxattr = kail_sec_inode_listxattr,
        .inode_removexattr = kail_sec_inode_removexattr,
        .inode_getsecurity = kail_sec_inode_getsecurity,
        .inode_setsecurity = kail_sec_inode_setsecurity,
        .inode_listsecurity = kail_sec_inode_listsecurity,

        .file_permission = kail_sec_file_permission,
        .file_alloc_security = kail_sec_file_alloc_security,
        .file_free_security = kail_sec_file_free_security,
        .file_ioctl = kail_sec_file_ioctl,
        .file_mmap = kail_sec_file_mmap,
        .file_mprotect = kail_sec_file_mprotect,
        .file_lock = kail_sec_file_lock,
        .file_fcntl = kail_sec_file_fcntl,
        .file_set_fowner = kail_sec_file_set_fowner,
        .file_send_sigiotask = kail_sec_file_send_sigiotask,
        .file_receive = kail_sec_file_receive,
        .task_create = kail_sec_task_create,
        .task_alloc_security = kail_sec_task_alloc_security,
        .task_free_security = kail_sec_task_free_security,
        .task_setuid = kail_sec_task_setuid,
        .task_post_setuid = kail_sec_task_post_setuid,
        .task_setgid = kail_sec_task_setgid,
        .task_setpgid = kail_sec_task_setpgid,
        .task_getpgid = kail_sec_task_getpgid,
        .task_getsid = kail_sec_task_getsid,
        .task_setgroups = kail_sec_task_setgroups,
        .task_setnice = kail_sec_task_setnice,
        .task_setrlimit = kail_sec_task_setrlimit,
        .task_setscheduler = kail_sec_task_setscheduler,
        .task_getscheduler = kail_sec_task_getscheduler,
        .task_kill = kail_sec_task_kill,
        .task_wait = kail_sec_task_wait,
        .task_prctl = kail_sec_task_prctl,
        .task_reparent_to_init = kail_sec_task_reparent_to_init,
        .task_to_inode = kail_sec_task_to_inode,
        .ipc_permission = kail_sec_ipc_permission,
        .msg_msg_alloc_security = kail_sec_msg_msg_alloc_security,
        .msg_msg_free_security = kail_sec_msg_msg_free_security,
        .msg_queue_alloc_security = kail_sec_msg_queue_alloc_security,
        .msg_queue_free_security = kail_sec_msg_queue_free_security,
        .msg_queue_associate = kail_sec_msg_queue_associate,
        .msg_queue_msgctl = kail_sec_msg_queue_msgctl,
        .msg_queue_msgsnd = kail_sec_msg_queue_msgsnd,
        .msg_queue_msgrcv = kail_sec_msg_queue_msgrcv,
        .shm_alloc_security = kail_sec_shm_alloc_security,
        .shm_free_security = kail_sec_shm_free_security,
        .shm_associate = kail_sec_shm_associate,
        .shm_shmctl = kail_sec_shm_shmctl,
        .shm_shmat = kail_sec_shm_shmat,
        .sem_alloc_security = kail_sec_sem_alloc_security,
        .sem_free_security = kail_sec_sem_free_security,
        .sem_associate = kail_sec_sem_associate,
        .sem_semctl = kail_sec_sem_semctl,
        .sem_semop = kail_sec_sem_semop,
        .netlink_send = kail_sec_netlink_send,
        .netlink_recv = kail_sec_netlink_recv,
        .register_security = kail_sec_register_security,
        .unregister_security = kail_sec_unregister_security,
        .d_instantiate = kail_sec_d_instantiate,
        .getprocattr = kail_sec_getprocattr,
        .setprocattr = kail_sec_setprocattr,
#if defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#endif 
} ;
