
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)53	1.167  src/oss/kazn/kazn/kazn_kpcfile.c, oss.kazn.src, oss600, 080219e  4/3/08  17:21:52";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );

extern asmlinkage int kail_copy_exec_argv(void *, char *, int);


struct group_info;
extern gid_t * FASTCALL(kail_groups_blocks(struct group_info *,int));
extern int FASTCALL(kail_groups_ngroups(struct group_info *));
extern int FASTCALL(kail_groups_nblocks(struct group_info *));







struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

extern int change_KailPerm2ro(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
enum kt_msgs {
    KT_TRACE_DUMMY = 1024,
    KT_TRACE_STR,
    KT_TRACE_INT,
    KT_TRACE_LKUPNAME,
    KT_TRACE_PROCESS_PATH,
    KT_TRACE_NOFID,
    KT_TRACE_TRACK_OPEN,
    KT_TRACE_KAZN_PATH_ACCESS,
    KT_TRACE_KAZN_PATH_ACCESS_RTN,
    KT_TRACE_KPC_NOTIFY,
    KT_TRACE_KPC_NOTIFY_RTN,
    KT_TRACE_KPC_GETATTR,
    KT_TRACE_KPC_GETATTR_RTN,
    KT_TRACE_KPC_SETVERSION,
    KT_TRACE_KPC_SETVERSION_RTN,
    KT_TRACE_KPC_SETEPOCH,
    KT_TRACE_KPC_SETEPOCH_RTN,
    KT_TRACE_KOSS_SYSCALL,
    KT_TRACE_KOSS_SYSCALL_RTN,
    KT_TRACE_KOSS_REGISTER,
    KT_TRACE_KOSS_REGISTER_RTN,
    KT_TRACE_KOSS_SET_PRIVID,
    KT_TRACE_KOSS_SET_PRIVPID,
    KT_TRACE_KOSS_ALLOC_FAIL,
    KT_TRACE_KOSS_INT_ERR,
    KT_TRACE_KAUD_SETLEVEL,
    KT_TRACE_KAUD_SETLEVEL_RTN,
    KT_TRACE_KAUD_AUD_SERVICE,
    KT_TRACE_KAUD_AUD_SERVICE_RTN,
    KT_TRACE_CSC_SETGROUPS,
    KT_TRACE_KOSS_PRIVCHECK,
    KT_TRACE_KOSS_PRIVCHECK_IDS,
    KT_TRACE_KOSS_PRIVCHECK_RTN,
    KT_TRACE_CSC_SUID,
    KT_TRACE_CSC_SUID2,
    KT_TRACE_CSC_SGID,
    KT_TRACE_CSC_SUID_BYPASS,
    KT_TRACE_CSC_SGID_BYPASS,
    KT_TRACE_KOSS_SET_ACTIVE,
    KT_TRACE_KOSS_SET_INACTIVE,
    KT_TRACE_KOSS_SET_STATE,
    KT_TRACE_NCT_OCREAT_CK_LINK_TGT,
    KT_TRACE_CSC_LOGIN_DIRECT_BP,
    KT_TRACE_KUTIL_GET_LOGIN_DATA,
    KT_TRACE_KUTIL_GET_LOGIN_DATA_EXIT,
    KT_TRACE_KAUD_LOG_USER_EVENT,
    KT_TRACE_KAUD_LOG_USER_EVENT_EXIT,
    KT_TRACE_KAUD_TRACE_EVENT,
    KT_TRACE_KAUD_TRACE_EVENT_EXIT,
    KT_TRACE_KAUD_LOGOUT_NOTERM,
    KT_TRACE_KAUD_LOGOUT_LOCTERM,
    KT_TRACE_KAUD_LOGOUT_REMTERM,
    KT_TRACE_KAUD_LOGOUT_EXIT,
    KT_TRACE_KAUD_TRACE_PID_EXEMPT,
    KT_TRACE_KAUD_TRACE_UID_EXEMPT,
    KT_TRACE_KOSS_INIT_PROC_RGY,
    KT_TRACE_KOSS_ASYNC_LU_START,
    KT_TRACE_KOSS_ASYNC_LU_STOP,
    KT_TRACE_KOSS_ASYNC_LU_TIMEOUT,
    KT_TRACE_KOSS_ASYNC_LU_STATE,
    KT_TRACE_KPCF_TRIG_REF,
    KT_TRACE_KPCF_SCAN_TIME,
    KT_TRACE_SHMEM_REINIT,
    KT_TRACE_SHMEM_REINITERR,
    KT_TRACE_SHMEM_INIT,
    KT_TRACE_SHMEM_FINI_ENT,
    KT_TRACE_SHMEM_FINI_WAITUSED,
    KT_TRACE_SHMEM_FINI_FAILUSED,
    KT_TRACE_SHMEM_FINI_FAILWAITERS,
    KT_TRACE_SHMEM_SRVT_START,
    KT_TRACE_SHMEM_SRVT_INVNODE,
    KT_TRACE_SHMEM_SRVT_ERRCOPY,
    KT_TRACE_SHMEM_SRVT_STOP,
    KT_TRACE_SHMEM_SRVT_WAIT,
    KT_TRACE_SHMEM_SRVT_WAITERR,
    KT_TRACE_SHMEM_STOP,
    KT_TRACE_GETMEM_NONE,
    KT_TRACE_SHBANG_TOOBIG,
    KT_TRACE_SHBANG_CHECK_READ,
    KT_TRACE_SHMEM_HELPER_START,
    KT_TRACE_SHMEM_HELPER_RESTART,
    KT_TRACE_SHMEM_HELPER_RETURN,
    KT_TRACE_SHMEM_CHECK_FAIL,
    KT_TRACE_SHMEM_NODE_RECLAIM,
    KT_TRACE_FDPATH_FAILURE,
    KT_TRACE_SHMEM_OLDPOOL_DEC
};
enum kt_kazn_msgs {
    KT_TRACE_KAZN_DUMMY = 2048,
    KT_TRACE_KAZN_ACC_ALLOWED_FI,
    KT_TRACE_KAZN_ACC_ALLOWED_ID,
    KT_TRACE_KAZN_ACC_ALLOWED_NW,
    KT_TRACE_KAZN_CFR,
    KT_TRACE_KAZN_CFR_HIT,
    KT_TRACE_KAZN_CFR_MISS,
    KT_TRACE_KAZN_KPCF_ADD,
    KT_TRACE_KAZN_KPCF_UPDATE,
    KT_TRACE_KAZN_KPCF_DEL,
    KT_TRACE_KPCF_DINS,
    KT_TRACE_KPCF_REFRES,
    KT_TRACE_KPCF_REFRES_RTN,
    KT_TRACE_KPCF_REF_FR,
    KT_TRACE_KPCF_NCADD,
    KT_TRACE_KPCF_NCHIT,
    KT_TRACE_KPCF_NCFLUSH,
    KT_TRACE_KPCF_DIR_NOTIFY,
    KT_TRACE_KPCF_EPOCH_DEL,
    KT_TRACE_KPCF_HIT_WC,
    KT_TRACE_KAZN_LOGIN_SUSKIP,
    KT_TRACE_KAZN_SECPGM_SUSKIP,
    KT_TRACE_KAZN_PRIVPGM_PERMIT,
    KT_TRACE_KPCF_HIT_LOCALTERM,
    KT_TRACE_KAZN_ACC_ALLOWED_EFLAGS,
    KT_TRACE_KAZN_RES_NOAZN,
    KT_TRACE_KPCF_KPCI_ADD_PO,
    KT_TRACE_KAZN_CHECKACCESS,
    KT_TRACE_KAZN_CHECKACCESS_GRANT,
    KT_TRACE_KAZN_CHECKACCESS_DENY,
    KT_TRACE_KAZN_CHECKACCESS_DENY_MORE,
    KT_TRACE_KPCF_REFRESH_NOTIFY,
    KT_TRACE_KPCF_CHECKPATH,
    KT_TRACE_KPCF_CKPATH_RTN,
    KT_TRACE_KPCF_CKPATH_FAST_RTN,
    KT_TRACE_KPCF_REF_DHASH,
    KT_TRACE_KPCF_REF_DHASH_RTN,
    KT_TRACE_RCF_ADD_GRANT,
    KT_TRACE_RCF_ADD_GRANT_RES,
    KT_TRACE_RCF_CHECK,
    KT_TRACE_RCF_CHECK_GRANT,
    KT_TRACE_RCF_CHECK_NOGRANT,
    KT_TRACE_RCF_FLUSH,
    KT_TRACE_RCF_COND_INFO,
    KT_TRACE_KAZN_DAEMON_EBUSY,
    KT_TRACE_KPCF_BKG_SLEEP,
    KT_TRACE_KPCF_BKG_RUN,
    KT_TRACE_KPCF_EPOCH_NOT,
    KT_TRACE_KPCF_EPOCH_NOT_COMMIT,
    KT_TRACE_KAZN_RES_NOTIFY,
    KT_TRACE_KPC_GET_NEWEPOCH,
    KT_TRACE_KPC_COMMIT_EPOCH,
    KT_TRACE_CSC_OPEN,
    KT_TRACE_CSC_KILL_ERR,
    KT_TRACE_KPCF_GENFID_ERR,
    KT_TRACE_KPCF_NOFID_REFRESH,
    KT_TRACE_KPCF_ADD_IMMUNE,
    KT_TRACE_KPCF_UPDATE_IMMUNE,
    KT_TRACE_KAZN_ERR_GRANT,
    KT_TRACE_KAZN_FIND_PGM_KPON,
    KT_TRACE_KAZN_FIND_PGM_KPON_FOUND,
    KT_TRACE_KAZN_FIND_PGM_KPON_NONE,
    KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG,
    KT_TRACE_KAZN_KPC_QFILE,
    KT_TRACE_KAZN_KPC_QFILE_RTN,
    KT_TRACE_KAZN_KPC_QPGM,
    KT_TRACE_KAZN_KPC_QPGM_RTN,
    KT_TRACE_KAZN_KPC_DHASHFID_EXIT,
    KT_TRACE_KAZN_KPC_DHASHNAME_EXIT,
    KT_TRACE_KAZN_KPC_CREATE_NOTIFY,
    KT_TRACE_RCID_ADD_GRANT,
    KT_TRACE_RCID_ADD_GRANT_RES,
    KT_TRACE_RCID_CHECK,
    KT_TRACE_RCID_CHECK_GRANT,
    KT_TRACE_RCID_CHECK_NOGRANT,
    KT_TRACE_RCID_FLUSH,
    KT_TRACE_KAZN_AZNCALL_REMAP_TO,
    KT_TRACE_KPCF_EXCEPTION_ADD,
    KT_TRACE_KAZN_AZND_TOUT,
    KT_TRACE_KAZN_EXPAND_PATH,
    KT_TRACE_KAZN_EXPAND_PATH_ERR,
    KT_TRACE_KAZN_EXPAND_PATH_SKIP,
    KT_TRACE_KAZN_UFILE_HIT,
    KT_TRACE_KAZN_UFILE_ADD,
    KT_TRACE_KAZN_UFILE_MISS,
    KT_TRACE_KAZN_UFILE_FLUSH,
    KT_TRACE_KPCF_REF_DH_BYFID,
    KT_TRACE_KPCF_REF_DH_BYFID_END,
    KT_TRACE_EXEC_SETUSER,
    KT_TRACE_EXEC_SETGROUP,
    KT_TRACE_KAZN_CHECK_FID_ONLY,
    KT_TRACE_KAZN_EXEMPT_PID_PERMIT,
    KT_TRACE_KAZN_PFC_HIT,
    KT_TRACE_KAZN_PFC_ADD,
    KT_TRACE_KAZN_PFC_MISS,
    KT_TRACE_KAZN_PFC_FLUSH,
    KT_TRACE_KAZN_PFC_FLUSHBYRES,
    KT_TRACE_KAZN_PFC_PROTRES_RELE,
    KT_TRACE_KAZN_ACC_ALLOWED_PERMIT,
    KT_TRACE_KAZN_ACC_ALLOWED_DENY,

    KT_TRACE_KAZN_AUTOFS_NOREF,

    KT_TRACE_KAZN_NW_ADDR_BADFAM,
    KT_TRACE_KAZN_RES_TRY_AGAIN,
    KT_TRACE_KAZN_KPC_QNW,
    KT_TRACE_KAZN_KPC_QNW_RTN,
    KT_TRACE_KAZN_IMSURPGM_SUSKIP,
    KT_TRACE_KAZN_USER_AUDIT_LOGOUT,
    KT_TRACE_KAZN_ALWAYS_SET_KPON,
    KT_TRACE_KAZN_FILTER_RES,
    KT_TRACE_KAZN_KPCFT_DELAY,
    KT_TRACE_KAZN_IPV6_ADDR,
    KT_TRACE_KAZN_DHANAL_FRL_CLR,
    KT_TRACE_KAZN_SET_ALIAS,
    KT_TRACE_KAZN_HAS_ALIAS,
    KT_TRACE_KAZN_RES_WAIT,
    KT_TRACE_KAZN_RES_REFD,
    KT_TRACE_KAZN_RES_BROADCAST,
    KT_TRACE_KAZN_DHASH_REF_LOOP,
    KT_TRACE_KAZN_USE_COPY,
    KT_TRACE_KAZN_NO_COPY,
    KT_TRACE_KAZN_DENY_SHMCTL_OP,
    KT_TRACE_KAZN_DHASH_SEARCH_STALE
};







enum kt_kmsg_msgs {
    KT_TRACE_KMSG_DUMMY = 3072,
    KT_TRACE_KMSG_INIT,
    KT_TRACE_KMSG_FINISH,
    KT_TRACE_KMSG_OPEN,
    KT_TRACE_KMSG_CLOSE,
    KT_TRACE_KMSG_IOCTL,
    KT_TRACE_KMSG_READ_ENTRY,
    KT_TRACE_KMSG_READ_EXIT,
    KT_TRACE_KMSG_READ_WAIT,
    KT_TRACE_KMSG_READ_WORK,
    KT_TRACE_KMSG_WRITE_ENTRY,
    KT_TRACE_KMSG_WRITE_EXIT,
    KT_TRACE_KMSG_WRITE_ID,
    KT_TRACE_KMSG_WRITE_LEN,
    KT_TRACE_KMSG_SEND_REQ,
    KT_TRACE_KMSG_GET_RESP,
    KT_TRACE_KMSG_RECV_RESP,
    KT_TRACE_KMSG_GET_HAND,
    KT_TRACE_KMSG_FREE_HAND,
    KT_TRACE_KMSG_WAIT_MSG,

    KT_TRACE_KMSG_BADTRANID,
    KT_TRACE_KMSG_BADSIZE,
    KT_TRACE_KMSG_TOOBIG,
    KT_TRACE_KMSG_CHANCLOSED,
    KT_TRACE_KMSG_ERR_GET_HAND,
    KT_TRACE_KMSG_GET_RESP_ERR,
    KT_TRACE_KMSG_CHAN_DOWN,
    KT_TRACE_KMSG_CHAN_RETRY,
    KT_TRACE_KMSG_WAIT_TO,
    KT_TRACE_KMSG_HARD_TO,
    KT_TRACE_KMSG_TO_RETRY,
    KT_TRACE_KMSG_DOWN_TO_TOUT
};







enum kt_kenv_msgs {
    KT_TRACE_KENV_DUMMY = 4096,
    KT_TRACE_KENV_NEW_PROC_INFO,
    KT_TRACE_KENV_PR_ADD_FD,
    KT_TRACE_KENV_PR_CLOSE_FD,
    KT_TRACE_KENV_PR_RET_FDINFO,
    KT_TRACE_KENV_PR_GROW_FDTABLE,
    KT_TRACE_KENV_PR_ADD_FLAGS,
    KT_TRACE_KENV_PR_DEL_FLAGS,
    KT_TRACE_KENV_PR_SET_IMP_ID,
    KT_TRACE_KENV_E_NW_TERM,
    KT_TRACE_KENV_E_DEV_TERM,
    KT_TRACE_KENV_E_NO_TERM,
    KT_TRACE_KENV_PR_ADD_FLAGS_BNAME,
    KT_TRACE_KENV_PTP_E2BIG,
    KT_TRACE_KENV_PTP_E2BIG_RETRY,
    KT_TRACE_KENV_PR_GET_TRUE_ACCID,
    KT_TRACE_KENV_PR_SET_ACC_ID,
    KT_TRACE_KENV_PR_ADD_NO_FORK,
    KT_TRACE_KENV_PR_ADD_REMT_TERM,
    KT_TRACE_KENV_PR_GET_REMT_TERM,
    KT_TRACE_KENV_BUMP_STREAM_COUNT,
    KT_TRACE_KENV_DELAY_PROC_DEL,
    KT_TRACE_KENV_PROC_INFO_NOTPAR,
    KT_TRACE_KENV_E_NW_TERM_IPV6,
    KT_TRACE_KENV_IPV6_ADDR,
    KT_TRACE_KENV_PR_NOSET_REMT,
    KT_TRACE_KENV_SHMEM_TOOBIG,
    KT_TRACE_KENV_SHMEM_WAIT,
    KT_TRACE_KENV_SHMEM_STOPPED,
    KT_TRACE_KENV_SHMEM_NOFREE,
    KT_TRACE_KENV_SHMEM_INVNODE,
    KT_TRACE_KENV_SHMEM_RQWAIT,
    KT_TRACE_KENV_SHMEM_RQDONE,
    KT_TRACE_KENV_SHMEM_PUTERR,
    KT_TRACE_KENV_SHMEM_PUT,
    KT_TRACE_KENV_GETMEM_REL,
    KT_TRACE_KENV_GETMEM_NEVER,
    KT_TRACE_KENV_GETMEM_OK,
    KT_TRACE_KENV_GETMEM_OFF,
    KT_TRACE_KENV_GETMEM_ERR,
    KT_TRACE_KENV_PUTMEM,
    KT_TRACE_KENV_SHMAT_RESET,
    KT_TRACE_KENV_SHMREQ_SCAN_DELAY,
    KT_TRACE_KENV_SHMREQ_SCAN_NOW,
    KT_TRACE_KENV_SHMREQ_REC_NOPID,
    KT_TRACE_KENV_SHMREQ_REC_EXP,
    KT_TRACE_KENV_SHMREQ_SCAN_RET,
    KT_TRACE_KENV_SHMEM_RESET_EXEC,
    KT_TRACE_KENV_PROC_FORK_CHILD,
    KT_TRACE_KENV_PROC_FORK_PAR,
    KT_TRACE_KENV_PROC_ALREADY,
    KT_TRACE_KENV_PROC_CONDADD,
    KT_TRACE_KENV_PROC_EXISTS,
    KT_TRACE_KENV_PR_ADD_NO_PAR,
    KT_TRACE_KENV_PROC_ADD,
    KT_TRACE_KENV_PROC_ADD_PPID,
    KT_TRACE_KENV_PROC_TERM,
    KT_TRACE_KENV_PROC_USE_DEAD,
    KT_TRACE_KENV_SHMEM_WAIT_2ND,
    KT_TRACE_KENV_SHMEM_WAIT_2ND_DONE,
    KT_TRACE_KENV_SHMEM_WAIT_DONE
};







enum kt_dbg_msgs {
    KT_TRACE_DBG_DUMMY = 8192,
    KT_TRACE_DBG_NCT_Q_AREQ,
    KT_TRACE_DBG_NCT_START_AREQ,
    KT_TRACE_DBG_NCT_END_AREQ,
    KT_TRACE_DBG_PAL_NO_FID,
    KT_TRACE_DBG_PAL_LKUP_ERR,
    KT_TRACE_DBG_PAL_DCOMP_ERR,
    KT_TRACE_DBG_PAL_LU_FID_DIR,
    KT_TRACE_DBG_TLI_SVC_PRIM_PEND,
    KT_TRACE_DBG_TLI_SVC_PRIM_NOPEND,
    KT_TRACE_DBG_NCT_PATH_OP_RESULT,
    KT_TRACE_DBG_NCT_FD_OP_RESULT,
    KT_TRACE_DBG_NCT_KILL_COMMON,
    KT_TRACE_DBG_NCT_KILL_TRAP,
    KT_TRACE_DBG_NCT_KILL_FILTER_PGRP,
    KT_TRACE_DBG_NCT_KILL_FILTER_USER,

    KT_TRACE_DBG_PAL_FILE_COUNT,
    KT_TRACE_DBG_PAL_FILE_LOOKUP22,
    KT_TRACE_DBG_PAL_FILE_LOOKUP24,

    KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP,
    KT_TRACE_DBG_RFID_FL_VFSP,
    KT_TRACE_DBG_AUTO_FS_MOUNTED,
    KT_TRACE_DBG_DEFER_UMOUNT,
    KT_TRACE_DBG_CHECK_VFS_MOUNTED,
    KT_TRACE_DBG_MOUNTED_YES,
    KT_TRACE_DBG_MOUNTED_NO,
    KT_TRACE_DBG_VFS_DATA_SET,
    KT_TRACE_DBG_FURTHER_LKUP_REQ,
    KT_TRACE_DBG_NEXT_LOOKUP,
    KT_TRACE_DBG_GEN_RES_FIDS,
    KT_TRACE_DBG_CHECK_FID_PATH,

    KT_TRACE_DBG_RESET_VFS_DATA,
    KT_TRACE_DBG_FAILED_VFS_SEARCH,
    KT_TRACE_DBG_ASYNC_LU_START,
    KT_TRACE_DBG_DEFER_UNAVAIL,
    KT_TRACE_DBG_REFRESH_FSID_EQ,
    KT_TRACE_DBG_REFRESH_FSID_NOFID,
    KT_TRACE_DBG_REFRESH_EPOCH,

    KT_TRACE_DBG_KPCF_ADD_RES,
    KT_TRACE_DBG_KPCF_AZN_FLAGS,
    KT_TRACE_DBG_NCT_FORK_TRAP,
    KT_TRACE_DBG_EXIT_CHECK_LEAF,

    KT_TRACE_DBG_SHMEM_SRVT_WAIT,
    KT_TRACE_DBG_SHMEM_SRVT_PROC,
    KT_TRACE_DBG_SHMEM_SRVT_RECLAIM,
    KT_TRACE_DBG_SHBANG_EXEC,
    KT_TRACE_DBG_SHMEM_HELPER_CHECK,
    KT_TRACE_DBG_FDPATH_BUILT,
    KT_TRACE_DBG_BYPASS_ENTRY1,
    KT_TRACE_DBG_BYPASS_ENTRY2,
    KT_TRACE_DBG_BYPASS_EXIT
};
enum kt_ffdc_msgs {
    KT_TRACE_FFDC_DUMMY = 5120,
    KT_TRACE_FFDC_STR,
    KT_TRACE_FFDC_AZNCALL_FILE,
    KT_TRACE_FFDC_AZNCALL_IDSET,
    KT_TRACE_FFDC_AZNCALL_NWOUT,
    KT_TRACE_FFDC_AZNCALL_NWIN,
    KT_TRACE_FFDC_AZNCALL_RACC_ADDR,
    KT_TRACE_FFDC_AZNCALL_CONT,
    KT_TRACE_FFDC_AZNCALL_RES_PERMIT,
    KT_TRACE_FFDC_AZNCALL_RES_DENY,
    KT_TRACE_FFDC_ERR_GRANT,
    KT_TRACE_FFDC_AZNCALL_SLOW,
    KT_TRACE_FFDC_CSC_LOGIN,
    KT_TRACE_FFDC_CKLOGIN,
    KT_TRACE_FFDC_CKLOGIN_EXIT,
    KT_TRACE_FFDC_CKLOGIN_DOAZN,
    KT_TRACE_FFDC_EXEC_PGM,
    KT_TRACE_FFDC_EXEC_PGM_LINK,
    KT_TRACE_FFDC_EXEC_SUPGM,
    KT_TRACE_FFDC_EXEC_SGPGM,
    KT_TRACE_FFDC_EXEC_SUGPGM,
    KT_TRACE_FFDC_EXEC_DENIED,
    KT_TRACE_FFDC_EXEC_ALLOWED,
    KT_TRACE_FFDC_LOGOUT_LOC,
    KT_TRACE_FFDC_LOGOUT_REM,
    KT_TRACE_FFDC_PROC_ADD,
    KT_TRACE_FFDC_PROC_ADD_PPID,
    KT_TRACE_FFDC_PROC_TERM,
    KT_TRACE_FFDC_NPC_FREE,
    KT_TRACE_FFDC_HOST_RULE_BAD,
    KT_TRACE_FFDC_CSC_V6TERM,
    KT_TRACE_FFDC_IPV6_ADDR
};




enum kt_knpc_msgs {
    KT_TRACE_KNPC_DUMMY = 6144,
    KT_TRACE_KNPC_STR,
    KT_TRACE_KNPC_SEARCH_SERVICE,
    KT_TRACE_KNPC_SEARCH_HOSTIP,
    KT_TRACE_KNPC_SEARCH_HOSTNAME,
    KT_TRACE_KNPC_SEARCH_PROTOCOL,
    KT_TRACE_KNPC_NET_UPD_ENTRY,
    KT_TRACE_KNPC_NET_UPD_ENTRY2,
    KT_TRACE_KNPC_KPCRES_ATTACH,
    KT_TRACE_KNPC_NET_ALREADY,
    KT_TRACE_KNPC_NETIN_ADD_NODE,
    KT_TRACE_KNPC_NETIN_DEL_ERR,
    KT_TRACE_KNPC_NETIN_DEL,
    KT_TRACE_KNPC_NETOUT_ADD_NODE,
    KT_TRACE_KNPC_NETOUT_DEL_ERR,
    KT_TRACE_KNPC_NETOUT_DEL,
    KT_TRACE_KNPC_NETIN_MATCH,
    KT_TRACE_KNPC_NETOUT_MATCH,
    KT_TRACE_KNPC_DUMP_HEADER,
    KT_TRACE_KNPC_DUMP_ELEM,
    KT_TRACE_KNPC_CUR_INIT,
    KT_TRACE_KNPC_CUR_FINI,
    KT_TRACE_KNPC_CHECK_RES,

    KT_TRACE_KNPCD_SERV_NODE_ALLOC,
    KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_SERV_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_HOSTIP_NODE_FREE,
    KT_TRACE_KNPCD_HOST_NODE_FREE,
    KT_TRACE_KNPCD_PROT_NODE_ALLOC,
    KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_PROT_NODE_FREE,
    KT_TRACE_KNPCD_MATCH_SERVICE,
    KT_TRACE_KNPCD_MATCH_HOSTIP,
    KT_TRACE_KNPCD_MATCH_PROTOCOL,
    KT_TRACE_KNPCD_KPON_FREE,
    KT_TRACE_KNPCD_WAIT_LOCK,
    KT_TRACE_KNPCD_SEARCH_SERV_ENTRY,
    KT_TRACE_KNPCD_SEARCH_NODE_CMP,
    KT_TRACE_KNPCD_FREE_NODE_REF,
    KT_TRACE_KNPCD_MATCH_HOSTNAME,
    KT_TRACE_KNPC_NETIN_SETRES,
    KT_TRACE_KNPC_NETOUT_SETRES,
    KT_TRACE_KNPC_ENV_SETRES,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC,
    KT_TRACE_KNPCD_HOSTIPV6_ADDR,
    KT_TRACE_KNPCD_HOSTIPV6_MASK,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIPV6_HIT_V4,
    KT_TRACE_KNPCD_HOSTIPV6_CMP,
    KT_TRACE_KNPC_SEARCH_HOSTIPV6,
    KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM,
    KT_TRACE_KNPCD_MATCH_HOSTIPV6,
    KT_TRACE_KNPC_BRANCH_CHANGE
};



enum kt_knrc_msgs {
    KT_TRACE_KNRC_DUMMY = 7168,
    KT_TRACE_KNRC_STR,
    KT_TRACE_KNRC_INIT_ERR,
    KT_TRACE_KNRC_INIT_CACHE,
    KT_TRACE_KNRC_FINI_FREE,
    KT_TRACE_KNRC_CHECK_GROW,
    KT_TRACE_KNRC_RECYCLE_ELEM,
    KT_TRACE_KNRC_NEW_POOL_ALLOC,
    KT_TRACE_KNRC_FLUSH,
    KT_TRACE_KNRC_ADD_EXACT,
    KT_TRACE_KNRC_ADD_GRANT_EXACT,
    KT_TRACE_KNRC_ADD_AMBIG,
    KT_TRACE_KNRC_AMBIG_HASH,
    KT_TRACE_KNRC_ADD_GRANT_AMBIG,
    KT_TRACE_KNRC_HAS_VIA,
    KT_TRACE_KNRC_ADD_STATS,
    KT_TRACE_KNRC_CHECK_EXACT,
    KT_TRACE_KNRC_RECLAIM_EXACT,
    KT_TRACE_KNRC_FID_NOMATCH,
    KT_TRACE_KNRC_HIT_EXACT,
    KT_TRACE_KNRC_NOMATCH_EXACT,
    KT_TRACE_KNRC_CHECK_STATS,
    KT_TRACE_KNRC_CHECK_AMBIG,
    KT_TRACE_KNRC_CHECK_HASHQ,
    KT_TRACE_KNRC_RECLAIM_AMBIG,
    KT_TRACE_KNRC_HIT_AMBIG,
    KT_TRACE_KNRC_NOMATCH_AMBIG,
    KT_TRACE_KNRC_RECLAIM,
    KT_TRACE_KNRC_RECLAIM_ELEM
};
struct sockaddr {
        unsigned short sa_family;
        char sa_data[14];
} ;
struct in_addr {
        uint s_addr;
};

struct sockaddr_in {
  unsigned short sin_family;
  unsigned short int sin_port;
  struct in_addr sin_addr;


  unsigned char __pad[16 - sizeof(short int) -
                        sizeof(unsigned short int) - sizeof(struct in_addr)];
};
struct in6_addr
{
        union
        {
                unsigned char u6_addr8[16];
                unsigned short u6_addr16[8];
                unsigned int u6_addr32[4];
        } in6_u;



};
struct sockaddr_in6 {
        unsigned short int sin6_family;
        unsigned short sin6_port;
        unsigned int sin6_flowinfo;
        struct in6_addr sin6_addr;
        unsigned int sin6_scope_id;
};


typedef struct sockaddr pal_sockaddr_t;
extern int pal_netSockFdToAddrInfo(int, int *, pal_nwAddr_t *, pal_nwAddr_t *);
extern int pal_netSaddrToNwAddr(pal_sockaddr_t *, pal_nwAddr_t *);
typedef void * kenv_pathReqHandle_t;
typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
extern void kenv_procAixChkShmdt( void );
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
typedef void (*kpc_res_rele_func_t)(void *);
typedef struct kpcInfo {
    struct kpcInfo *next;
    struct kpcInfo *prev;
    char *resName;
    kpc_resFlags_t resFlags;
    uint32_t kpcFlags;
    uint32_t branchId;
    byte_t *extData;
    uint16_t resNameLen;
    uint16_t extDataLen;
    union {
        struct __f {
            pal_rawFid_t *poFid;
            pal_ftypes_t poFtype;
            int32_t kpcFileAddGen;
            pal_rawFid_t __poFid;
        } f;
        struct __nw {
            int64_t policyVersion;
            pal_ptr32_t pUserRes;
            void *pRes;
            kpc_res_rele_func_t relef;
        } nw;
    } resData;

    char __resName[48];
} kenv_kpcInfo_t;
typedef struct filetgt {
    char *trappedNameRef;
    char *baseName;
    pal_pathBuf_t *fullSrnRef;
    pal_rawFid_t *dir_rfidp;
    pal_rawFid_t *pathFids;
    pal_vnodeH_t dir_vnh;
    pal_vnodeH_t vnh;
    struct filetgt *auxFile;
    int tnLen;
    int pathFidsCount;
    int pathFidsAlloced;
    pal_rawFid_t rfid;
    pal_fattr_t fattrs;
    pal_pid_t killPid;


    void *tgt_nd;
    void *aux_tgt_nd;


    pal_rawFid_t _fids[5];
} kenv_fileTgt_t;






typedef struct pgmInfo {
    kenv_procFlags_t procFlags;
    char *pgmSRN;
    char *pgmKPON;
    pal_rawFid_t pgmFid;
    pal_rawFid_t pgmDFid;
    pal_fattr_t pgmFattrs;
    struct pgmInfo *saveArea;
    int16_t __srnLen;
    int16_t __kponLen;
    char __srn[32];
    char __kpon[32];
} pgmInfo_t;
typedef void * kenv_envHandle_t;

typedef struct kenv_env {
    int magic;
    uint32_t flags;
    pal_pid_t pid;
    int envError;



    union {



        struct {
            kenv_fileTgt_t f;
            pal_idSet_t idSet;
            pal_dev_t termDev;
            char *localTermName;
            pal_nwAddr_t nwTermAddr;
            byte_t *termExtData;
            int termExtDataLen;
        } fs;



        struct {
            pal_nwAddr_t addrRemote;
            pal_nwAddr_t addrLocal;
        } nw;
    } tgt;




    pal_idList_t idList;




    pgmInfo_t accPgm;




    int kpcInfoCount;
    kenv_kpcInfo_t *kpcInfoHead;
    kenv_kpcInfo_t *curKPCInfo;
    kenv_kpcInfo_t _kpcInfo;



    void *auxDatap1;
} kenv_env_t;
extern pal_authID_t kenv_envGetAuthID(kenv_envHandle_t);
extern pal_idList_t *kenv_envGetIdListRef(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetPathFids(kenv_envHandle_t, int *);
extern void kenv_envSetPathFids(kenv_envHandle_t, int, pal_rawFid_t *);
extern void kenv_envSetRfid(kenv_envHandle_t, pal_rawFid_t *, pal_fattr_t *);
extern void kenv_envSetFattr(kenv_envHandle_t, pal_fattr_t *);
extern pal_fattr_t *kenv_envGetFattr(kenv_envHandle_t);
extern void kenv_envSetKPCInfo(kenv_envHandle_t , kenv_kpcInfo_t *);
extern kenv_kpcInfo_t * kenv_envGetKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfo(kenv_envHandle_t);
extern void kenv_envSetNextKPCInfo(kenv_envHandle_t);
extern void kenv_envSetFirstKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfoResName(kenv_envHandle_t,
                                        kenv_kpcInfo_t *, char *, int);
extern char * kenv_envGetProgram(kenv_envHandle_t);
extern pal_rawFid_t *
        kenv_envGetPgmFidAndDirFid(kenv_envHandle_t,
                                   pal_rawFid_t **, pal_fattr_t **);
extern char *kenv_envSetPgmResource(kenv_envHandle_t, char *, int);
extern char *kenv_envGetPgmResource(kenv_envHandle_t);
extern void kenv_envSetAuxFileActive(kenv_envHandle_t, int);
extern char *kenv_envGetTrappedName(kenv_envHandle_t, int *);
extern char *kenv_envGetBaseName(kenv_envHandle_t);
extern void kenv_envSetImpProcAccId(kenv_envHandle_t, pal_authID_t);
extern void kenv_envProgramExecUpdate(kenv_envHandle_t);
extern void kenv_envSaveProgramState(kenv_envHandle_t);
extern void kenv_envRestoreProgramState(kenv_envHandle_t);
extern void kenv_envTrackOpenFd(kenv_envHandle_t, int, int);
extern int kenv_envGetFdInfo(kenv_envHandle_t, int);
extern void kenv_envGetTerminals(kenv_envHandle_t,
                                 pal_dev_t **, pal_nwAddr_t **);
extern pal_dev_t *kenv_envGetTermDev(kenv_envHandle_t);
extern char *kenv_envSetLocalTermName(kenv_envHandle_t, char *);
extern byte_t *kenv_envSetTermExtData(kenv_envHandle_t, int, byte_t *);
extern byte_t *kenv_envGetTermExtData(kenv_envHandle_t, int *);
extern pal_nwAddr_t *kenv_envGetNWTerm(kenv_envHandle_t);
extern void kenv_envResetTargetData(kenv_envHandle_t, int);
extern char *kenv_envFdToBname(kenv_envHandle_t);
extern pal_pathBuf_t *kenv_envGetFullSrnRef(kenv_envHandle_t);
extern void kenv_envSetFullSrnRef(kenv_envHandle_t, pal_pathBuf_t *);
extern pal_rawFid_t *kenv_envBuildPathFids(kenv_envHandle_t, int *);
extern pal_rawFid_t *kenv_envGetDirRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetFidsAndFattrs(kenv_envHandle_t,
                                              pal_rawFid_t **, pal_fattr_t **);

extern int kenv_envSetKPCCurrent(kenv_envHandle_t, char *);




extern void kenv_envSetTrappedNameRef(kenv_env_t *, char *, int);
extern void kenv_envInit(kenv_env_t *);
extern void kenv_envClean(kenv_env_t *);
extern int kenv_envProcessTrappedPath(kenv_env_t *, int);
extern int kenv_envProcessAuxPath(kenv_env_t *, char *, int, int);
extern void kenv_envUpdateACLInfo(kenv_env_t *);
extern void kenv_envInitialize(void);
extern void kenv_envShutdown(void);
extern kenv_env_t *kenv_envAllocEnv(void);
extern void kenv_envFreeEnv(kenv_env_t *);
extern int csc_open(kenv_envHandle_t, int);
extern int csc_chdir(kenv_envHandle_t);



extern int csc_exec(kenv_envHandle_t,int);
extern int csc_chdir(kenv_envHandle_t);
extern int csc_mkdir(kenv_envHandle_t);
extern int csc_kill(kenv_envHandle_t, pal_pid_t);
extern int csc_delete(kenv_envHandle_t);
extern int csc_chmod(kenv_envHandle_t);
extern int csc_chown(kenv_envHandle_t);
extern int csc_truncate(kenv_envHandle_t);
extern int csc_settime(kenv_envHandle_t);
extern int csc_reboot(kenv_envHandle_t);
extern int csc_mknod(kenv_envHandle_t);
extern int csc_hardLink(kenv_envHandle_t);
extern int csc_symLink(kenv_envHandle_t);
extern int csc_readSlink(kenv_envHandle_t);
extern int csc_rename(kenv_envHandle_t);
extern int csc_readattr(kenv_envHandle_t);

extern int csc_setUserIds(kenv_envHandle_t, pal_idSet_t *, int);
extern int csc_setGroupIds(kenv_envHandle_t, pal_idSet_t *, int);
extern int csc_setGroupSet(kenv_envHandle_t, int, pal_idSet_t *, int);

extern int csc_connect(kenv_envHandle_t);
extern int csc_accept(kenv_envHandle_t);
extern int csc_bind(kenv_envHandle_t);
typedef struct loginData {
    int32_t callerFlags;
    int32_t global_audit;
    int32_t loginLocType;
    int32_t activeLogins;



    int32_t activeLoginsOnTerm;




    char loginPgmKPON[256];
    union {
        char localTermKPON[128];
        oss_nwAddr_t nwTermAddr;
    } termInfo;
} kosseal_loginData_t;
extern int kutil_kossDebugFlag;
extern int kutil_kossActive;
extern int32_t kutil_optionalTraps;







extern int kutil_kossChecksum;




extern kutil_kconfig(pal_scall_parm_t, pal_scall_parm_t,
                       pal_scall_parm_t, pal_scall_parm_t, pal_scall_parm_t,
                       int *);
typedef struct nct_asyncNode {
    kutil_q_t q;
    int op;
    int aflags;
    int returnCode;
    pal_pid_t accPid;
    void *uniquifier;

    int reqSeqNum;
    pal_idList_t idList;
    void (*notify_func)(void *);
    void *notify_arg;
    int nwProto;
    char remAddrBuf[48];
    char locAddrBuf[48];
} nct_asyncNode_t;
typedef struct _cpath {
    char *path;
    int allocLen;




    char lclStr[80];
} cpPath_t;
extern int nct_asyncRequest(nct_asyncNode_t *);
extern void nct_asyncInit(void);
extern void nct_asyncShutdown(void);

extern int nct_addAuxPath(char *, cpPath_t *, int, int, kenv_env_t *);
extern int nct_processPath(char *, cpPath_t *, int, int, kenv_env_t *);
extern int nct_callCsc(kenv_env_t *, int);
extern int nct_checkPathOp(kenv_env_t *, char *, cpPath_t *, int, int);
extern int nct_checkFdOp(kenv_env_t *, int, int);
extern int nct_openCommon(char *, cpPath_t *, int, kenv_env_t *, int *);
extern int nct_killCommon(pal_pid_t, int, int *);
extern int nct_mkdirCommon(char *, cpPath_t *, kenv_env_t *, int *);
extern int nct_linkCommon(char *, char *,
                          cpPath_t *, cpPath_t *, kenv_env_t *, int *);
extern int nct_renameCommon(char *, char *,
                            cpPath_t *, cpPath_t *, kenv_env_t *, int *);
extern int nct_symlinkCommon(char *, char *, cpPath_t *, kenv_env_t *, int *);
extern int nct_mknodCommon(char *, pal_dev_t *,
                           pal_ftypes_t, cpPath_t *, kenv_env_t *, int *);
extern int nct_execCommon(char *, cpPath_t *, void *, kenv_env_t *, int *);
extern int nct_runAsync(void);
extern void nct_stopAsync(void);
extern void nct_postRenameCommon(kenv_env_t *);
extern void nct_postLinkCommon(kenv_env_t *);
extern void nct_postSymlinkCommon(kenv_env_t *);
extern void nct_postMknodCommon(kenv_env_t *);
extern void nct_postOpenCommon(kenv_env_t *, int, int);
extern void nct_postMkdirCommon(kenv_env_t *);
extern int nct_setuidCommon(kenv_env_t *, pal_idSet_t *,
                            pal_authID_t, int, int *);
extern int nct_setgidCommon(kenv_env_t *, pal_idSet_t *, int, int *);
typedef struct kaznStats {
    int32_t accAllowedCalls;
    int32_t checkAccessCalls;
    int32_t totalGrants;
    int32_t totalDenies;
    int32_t rcGrants;
    int32_t privGrants;
    int32_t padA;
    int32_t loginIdSets;
    int32_t secIdSets;
    int32_t noTrustDenies;
    int32_t impSetId;
    int32_t padB;
    int32_t pdosdCalls;
    int32_t pdosdActiveCalls;
    int32_t pdosdFileCalls;
    int32_t pdosdIdCalls;
    int32_t pdosdNetCalls;
    int32_t pdosdLoginCalls;
    int32_t pdosdFail;
    int32_t pdosdGrantError;
    int32_t pdosdDenyError;
    int32_t pdosdGrantAudit;
    int32_t pdosdDenyAudit;
    int32_t pdosdSlowCalls;
    int32_t pdosdTimeOuts;
    int32_t pdosdBusy;
    int32_t pdosdInWarning;
} kaznStats_t;




extern kazn_expandSRN;
typedef int kazn_aznResult_t;
extern kaznStats_t kaznStats;
extern pal_mutex_t kazn_pathMutex;

extern char *kazn_grantStr;
extern char *kazn_denyStr;

extern int kazn_accessAllowed(kenv_envHandle_t, int, int, int);
extern kazn_aznResult_t kazn_checkAccess(kenv_envHandle_t, int, int, int);
extern void kazn_kpcUpdateLastNotify(void);
extern int kazn_setGrantSuserOnError(int);
extern void kazn_expandTrappedFilePath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kazn_init(void);
extern void kazn_shutdown(void);
typedef enum kpc_notifyOp {
    kpc_opAdd, kpc_opDelete
} kpc_notifyOp_t;

typedef enum kpc_objType {
    kpc_objFile,
    kpc_objNetwork,
    kpc_objIdset,
    kpc_objMyProgram

} kpc_objType_t;


typedef struct _addrType {
    int addrClassic:1;
    int addrV6:1;
    int noProto:1;
    int noServ:1;
    int noHostIP:1;
    int noHostName:1;
    int hostInline:1;
    int nwIn:1;
    int nwOut:1;
    int pad:23;
} kpc_nwAddrType_t;





typedef struct idInfo {
    int64_t idValue __attribute__ ((aligned (8)));
    int isGroupId:1;
} __attribute__ ((aligned (8))) kpc_idInfo_t;







typedef oss_nwAddr_t kpc_nwAddr_t;


typedef struct _portrange {
    uint16_t portLow;
    uint16_t portHigh;
} kpc_portrange_t;
typedef struct _nwdesc {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));



    pal_ptr32_t pHost;

    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        kpc_portrange_t *setp;
    } portRange;
    char *wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc_t;




typedef struct _resInfo {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        kpc_nwDesc_t *nwDesc;


    } resDesc;





    char *resourceName;


    byte_t *extData;


} kpc_resourceInfo_t;
typedef struct kpcRecord {
    kpc_resFlags_t flags;
    int32_t extDataLen;
    int32_t howFound;
    uint32_t branchId;
    int32_t reserved[4];
    char kpon[1024];
    byte_t extData[6144];
} kpc_record_t;
typedef struct _nwdesc32 {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));
    pal_ptr32_t pHost;
    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        pal_ptr32_t set;
    } portRange;
    pal_ptr32_t wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc32_t;





typedef struct _resInfo32 {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        pal_ptr32_t pnwDesc;


    } resDesc;





    pal_ptr32_t resourceName;


    pal_ptr32_t extData;


} kpc_resourceInfo32_t;



typedef struct kpcattr {
    int64_t kpcEpoch __attribute__ ((aligned (8)));

    int64_t lastNotify __attribute__ ((aligned (8)));
    int64_t policyVersion __attribute__ ((aligned (8)));
    int64_t policyEpoch __attribute__ ((aligned (8)));




    int32_t resourceCount;
} __attribute__ ((aligned (8))) kpc_attr_t;
typedef struct kpc_info {
    kpc_attr_t attrs;
    uint32_t resourceChecks;
    uint32_t doEvals;
    uint32_t resourceAdds;
    uint32_t resourceDeletes;
    uint32_t setVersionCalls;
    uint32_t startEpochCalls;
    uint32_t commitEpochCalls;
} kpc_info_t;

extern kpc_info_t kpcInfo;
typedef struct kpc_kptr
{
    uint32_t high;
    uint32_t low;
} kpc_kptr_t;

typedef struct kpc_fdumpRec {
    uint32_t resFlags;
    uint32_t intResFlags;
    uint32_t pointerSize;
    uint32_t branchId;
    kpc_kptr_t resPtr;
    kpc_kptr_t rfidPtr;
    kpc_kptr_t dfidPtr;
    char resName[156];
} kpc_fdumpRec_t;



typedef struct kpc_fdumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_fdumpRec_t frecs[3072];
} kpc_fdumpBlock_t;



typedef struct kpc_ndumpRec
{
    kpc_nwAddrType_t addrType;
    uint32_t pointerSize;
    uint32_t branchId;
    int64_t policyVersion __attribute__ ((aligned (8)));
    kpc_kptr_t protPtr;
    kpc_kptr_t servPtr;
    kpc_kptr_t hostPtr;
    char resName[156];
} __attribute__ ((aligned (8))) kpc_ndumpRec_t;



typedef struct kpc_ndumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_ndumpRec_t nrecs[128];
} kpc_ndumpBlock_t;




extern kpc_info_t kpcInfo;
extern void kazn_kpcNetSetActive(int);
extern int kazn_kpcNetGetActive(void);

extern void kazn_kpcInit(void);
extern int kazn_kpcCheckResource(kenv_envHandle_t, int, int, int);
extern int kazn_kpcFileCheckResource(kenv_envHandle_t, int, int);
extern int kazn_kpcNetCheckResource(kenv_envHandle_t, int, int);
extern char *kazn_kpcFileFindPgmResource(kenv_envHandle_t, kpc_resFlags_t *);
extern void kazn_kpcFileDirNotify(char *);
extern char *kazn_kpcFileFindTerminal(kenv_envHandle_t, int *, byte_t **);
extern void kazn_kpcFileInit(void);
extern void kazn_kpcFileShutdown(void);
extern void kazn_kpcFileEpochNotify(int64_t, int);
extern void kazn_kpcNetInit(void);
extern void kazn_kpcNetShutdown(void);
extern void kazn_kpcFileRefreshNotify(kenv_envHandle_t);
extern void kazn_kpcFileCreateNotify(kenv_envHandle_t);
extern int kazn_kpcfRunAsync(void);
extern void kpcf_asyncLUThread(void);
extern int kpcf_asyncStopLookup(void);




void kazn_kpcfTriggerAsyncRefresh(int);

extern void kazn_kpcfStopAsync(void);
extern int64_t kazn_kpcStartNewPolicyEpoch(void);
extern int kazn_kpcCommitPolicyEpoch(int64_t);
extern void kazn_kpcfFlushNegCache(void);


extern void kazn_kpcSetPolicyVersion(int64_t);
extern void kazn_kpcGetAttr(kpc_attr_t *);
extern int kazn_kpcAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetDelResource(kpc_resourceInfo_t *);
extern void kazn_kpcNetSetResource(int, kenv_envHandle_t, char *);
typedef struct kpcfStats {
    int32_t resChecks;
    int32_t resCheckHits;
    int32_t directHits;
    int32_t inheritHits;
    int32_t exceptionHits;
    int32_t wildCardHits;
    int32_t multiHits;
    int32_t exceptionSearches;
    int32_t pfcHits;
    int32_t ncAdds;
    int32_t ncSize;
    int32_t ncChecks;
    int32_t ncHits;
    int32_t ncFlushes;
    int32_t padB;
    int32_t resAdds;
    int32_t resDeletes;
    int32_t resUpdates;
    int32_t excResources;
    int32_t allocedResources;
    int32_t padC;
    int32_t fileRefreshes;
    int32_t refreshAllCalls;
    int32_t refreshSkippedLock;
    int32_t refreshFastExit;
    int32_t dhashRefreshes;
    int32_t refreshGenWrapped;
    int32_t padD;
    int32_t mkdirNotifies;
    int32_t rmdirNotifies;
    int32_t epochRemoves;

    int32_t dhashRefRestarts;


    int32_t tooManyClinks;

    int32_t errorResources;



} kpcFileStats_t;
typedef struct dhashInfo {
    int32_t maxChainLen;
    int32_t avgChainLen;
    int32_t totEntries;
    int32_t numEmptyChains;
    int32_t dirs;
    int32_t nonDirs;
    int32_t oneDir;
} kpcFileDhashInfo_t;






typedef struct pfcStats {
    uint32_t cacheSize;
    uint32_t finds;
    uint32_t hits;
    uint32_t compares;
    uint32_t hashBoosts;
    uint32_t adds;
    uint32_t flushes;
    uint32_t hashPurges;
    uint32_t lruBoost;
} kpcf_pfcStats_t;
typedef struct fileRes {
    kutil_q_t refreshQ;
    kutil_q_t dirFidHashQ;
    kutil_q_t nameHashQ;
    kutil_q_t excQ;


    char *resName;
    void *extData;

    pal_time_t lastRefresh;
    pal_time_t firstDirTime;

    uint32_t branchId;
    uint32_t intFlags;
    uint32_t epoch;
    uint32_t refreshGen;



    int32_t hits;
    uint16_t refCount;
    uint16_t resNameLen;
    uint16_t extDataLen;
    uint16_t nlinks;
    pal_ftypes_t ftype;
    pal_dev_t dev;
    pal_mutex_t rLock;
    pal_cond_t rCond;
    pal_rawFid_t rfid;
    pal_rawFid_t dir_rfid;
    kpc_resFlags_t rflags;
    char *bName;


    pal_vfs_val_t check_vfsp;
    struct fileRes *clink;
    struct fileRes *plink;




    char _lclSpace[27 + 1];
} fileRes_t;
typedef struct fresNode {
    fileRes_t *resp;
    struct fresNode *next;
} fresNode_t;


typedef struct fresList {
    pal_rawFid_t *rFidp;
    pal_rawFid_t *parFidp;
    pal_fattr_t *fap;
    char *nameHint;
    char *bName;
    int16_t frlFlags;
    int16_t bNameLen;
    int count;
    int frlError;
    fresNode_t node;
} fresList_t;
typedef struct _fhq {
    pal_mutex_t hlock;

    uint32_t genNo;

    uint32_t resCount;
    fileRes_t *lastHitDir;

    pal_time_t leastRefreshTime;

    kutil_q_t dfQ[8];
} dirfidHash_t;
extern kpcFileStats_t kpcFileStats;
extern pal_mutex_t fileDbLock;
extern kutil_q_t kpcf_refreshQ;
extern pal_time_t kpcf_refreshQOldest;
extern kpcf_pfcStats_t kpcf_pfcStatInfo;
extern int32_t kpcf_changeGen;
extern int32_t kpcf_adminGen;






extern char *getBaseName(fileRes_t *);
extern fileRes_t *getFileResource(void);
extern void freeFileResource(fileRes_t *);
extern void releFileResource(fileRes_t *);
extern fileRes_t * releaseFileResource(fileRes_t *frp);
extern void holdFileResource(fileRes_t *);
extern void fresListAdd(fresList_t *, fileRes_t *);
extern void fresListClean(fresList_t *);
extern fileRes_t *kpcGetUnixRes(void);
extern void kpcInitUnixRes(void);
extern void kpcSetUnixRes(kpc_resFlags_t);
extern void kpcClearUnixRes(void);
extern int kpcfNameHash(char *);
extern int kpcfDirFidHash(pal_rawFid_t *);
extern int kpcfDirFidQueueHash(pal_rawFid_t *);
extern void kpcfSetFidInfo(fileRes_t *, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *);
extern int kpcfCheckFidInfo(fileRes_t *, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *);
extern int kpcfGenResFids(fileRes_t *, pal_rawFid_t *,
                          pal_rawFid_t *, pal_fattr_t *, int, int *);
extern void kpcfMarkResourceStale(fileRes_t *);
extern void kpcfSetupKpcInfo(kenv_envHandle_t, fileRes_t *, int, char *);
extern void kpcfMarkDhashStale(int);
extern void kazn_kpcfExpandTrappedPath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kpcf_ufileSetActive(int);
extern void kpcf_ufileInit(void);
extern void kpcf_ufileShutdown(void);
extern void kpcf_ufileStats(int);

extern uint32_t kpcf_getFileEpoch(void);

extern void kpcf_pfcAdd(pal_rawFid_t *, fileRes_t *, uint32_t);
extern int kpcf_pfcCheck(pal_rawFid_t *, fileRes_t **);
extern int kpcf_pfcCheckNoAcl(pal_rawFid_t *);
extern int kpcf_pfcFlush(pal_rawFid_t *);
extern void kpcf_pfcFlushProtResp(fileRes_t *);
extern void kpcf_pfcSetActive(int);
extern int kpcf_pfcGetActive(void);
extern void kpcf_pfcStats(int);

extern void kpcf_pfcInit(void);
extern void kpcf_pfcShutdown(void);

extern int kpcf_addResourcesToKPCInfo(fresList_t *,
                                      kenv_envHandle_t, int, int, int);
extern uint32_t kpcf_getNextRefreshGen(void);
extern uint32_t kpcf_getCurRefreshGen(void);
extern int kpcf_checkRefreshGenWrap(uint32_t, uint32_t);
extern void kpcf_refreshQInsertResource(fileRes_t *, int);
extern void kpcf_refreshQRemoveResource(fileRes_t *);
extern int kpcf_findResByResName(char *, fileRes_t **, int *);
extern void kpcf_nameHashInsert(fileRes_t *, int);
extern void kpcf_nameHashRemove(fileRes_t *);
extern fileRes_t *kpcf_nameHashSearch(char *, int);
extern int kpcf_findFidByFidOnly(fresList_t *);
extern int kpcf_dumpResources(kpc_fdumpRec_t *, int *, int *);
extern int kpcf_getResInfoByResName(kpc_record_t *);
extern void kpcf_checkForFidAliases(kutil_q_t *, fileRes_t *);
extern int kpcf_negCacheCheck(pal_rawFid_t *);
extern void kpcf_negCacheAdd(pal_rawFid_t *);
extern pal_time_t kpcf_negCacheFlush(pal_rawFid_t *);
extern void kpcf_negCacheFlushAll(void);
extern void kazn_kpcfSuspendFileLkups(int);
extern void kazn_kpcfResumeFileLkups(void);

extern void kpcf_subrInit(void);
extern void kpcf_subrShutdown(void);
typedef struct kpcf_asyncLU_datum {
    fileRes_t *fresp;
    char *path;
    int inFlags, rc;
    pal_rawFid_t *rfid, *dir_rfid;
    pal_fattr_t *fap;
    int *retFlags;
    pal_pid_t pid;
} kpcf_asyncLU_datum_t;

typedef struct kpcf_asyncLU {
    kutil_q_t q;
    pal_cond_t cvReq, cvSvc;
    pal_mutex_t mutex;
    int32_t flags;
    int32_t serial;
    kpcf_asyncLU_datum_t datum;
} kpcf_asyncLU_t;
typedef struct kpcf_asyncState
{
    kutil_q_t q;
    uint32_t state;
    int32_t count,serial;
    pal_cond_t cv;
    pal_mutex_t mutex;
} kpcf_asyncState_t;




int
kpcf_asyncLUReq(fileRes_t *fresp,pal_rawFid_t *rfid,pal_rawFid_t *dir_rfid,
                pal_fattr_t *fap,int lkupFlags,int *lkupRetFlags);
void kpcf_asyncLUInit(void);
void kpcf_asyncLUFini(void);
int kpcf_asyncRunLookup(void);


extern int kpcf_asyncDebug;
extern kpcf_asyncState_t kpcf_asyncLU;
typedef struct kaud_auditEventInfo {
    uint32_t flags;



    uint32_t kaud_magic;
    uint32_t event_id;
    uint32_t aud_fail_status;
    uint32_t aud_report_flags;
    uint32_t aud_qualifier;
    uint32_t aud_permissions;
    uint16_t aud_view;
    uint16_t aud_action;
    uint16_t aud_reason;
    uint16_t aud_outcome;
    uint16_t aud_resource_type;
    int64_t aud_accessor_uid __attribute__ ((aligned (8)));
    int64_t aud_target_id __attribute__ ((aligned (8)));
    int64_t aud_accessor_pid __attribute__ ((aligned (8)));
    int64_t aud_accessor_eff_id __attribute__ ((aligned (8)));
    int64_t aud_accessor_real_id __attribute__ ((aligned (8)));




    uint32_t aud_nw_flags;
    oss_nwAddr_t aud_local_conn;
    oss_nwAddr_t aud_remote_conn;
    oss_nwAddr_t aud_remote_login_term;



    char aud_target_pon[256];
    char aud_target_srn[256];
    char aud_branch_name[80];
    char aud_local_term[80];
    char aud_accessor_name[24];
    char aud_program_name[256];




} __attribute__ ((aligned (8))) kaud_auditEventInfo_t;
extern int kaud_syscall(pal_scall_parm_t, pal_scall_parm_t,
                        pal_scall_parm_t, pal_scall_parm_t,
                        pal_scall_parm_t, int *);


extern int kaud_setAuditLevel(int32_t);




extern int kaud_intTraceFlags;
extern int kaud_checkTrace;
extern int kaud_doLogoutAudit;
extern int kaud_eucTraceUsers;
typedef struct kaud_auditServInfo {
   uint32_t event_id;
   uint32_t aud_view;
   uint64_t aud_action;
   uint32_t aud_reason;
   uint32_t aud_outcome;
   uint32_t aud_fail_status;
   uint32_t aud_resr_type;
   uint32_t pol_flags;
   uint64_t pol_epoch;
   uint64_t pol_version;
} kaud_auditServInfo_t;
extern int kaud_expandSRN;
extern int32_t kaud_audit_level;
extern int32_t kaud_warning_mode;

extern int kaud_auditService(kaud_auditServInfo_t*);
extern int kaud_logUserAuditEvent(kaud_auditEventInfo_t *);
extern int kaud_auditTraceEvent(kenv_envHandle_t, int, int, int);
extern int kaud_eucAdd(pal_authID_t uid, uint32_t states);
extern int kaud_eucDel(pal_authID_t uid);
extern int kaud_eucDump(pal_authID_t *, uint32_t *, int);
extern void kaud_auditLogout(pal_authID_t,pal_pid_t,int,char *,pal_nwAddr_t *);

extern void kaud_init(void);
extern void kaud_shutdown(void);





extern void eucReset(void);





extern fileRes_t * releaseFileResource2(fileRes_t *frp, int andFree);
extern pal_mutex_t fileResDbLock;
int debugFileResLockCount = 0;
fileRes_t * currentFileRes = NULL;
static uint32_t _kpcFileEpoch = 0;
static uint32_t _kpcFilePendingEpoch = 0;

static int kpcShuttingDown = 0;







int kpc_ftTryAgainLater = 0;
int kpc_fileThreadActive = 0;
int kpc_ftTryAgainLaterCount = 0;
int kpc_ftTotalTryAgainLaterCount = 0;
int refreshFileResCount = 0;
int refreshFileResCountOwner = 0;


uint32_t kpcf_getFileEpoch(void)
{
    return(_kpcFileEpoch);
}





int kpcFileInheritRoot = 0;




int kpcRootDirResource = 0;

kpcFileDhashInfo_t kpcFileDhashInfo = { 0 };
static int refreshFileRes(fileRes_t *, int, int);
static int refreshFileRes2(fileRes_t *, int, int);
static int refreshFileResX(fileRes_t *, int, int, int);
static void dhashRefresh(pal_rawFid_t *, pal_time_t, int *, pal_time_t *);
static int explicitRefreshOnly(fileRes_t *frp,int flags);




static kutil_q_t exceptionQ;
static kutil_q_t excNoFidQ;





static dirfidHash_t dirFidHashQ[907];
static pal_rawFid_t dh_nameMissDirFid;
static pal_rawFid_t dh_createMissFid;
static char dh_nameMiss[128];
static void
dhashInsert(int idx, fileRes_t *fresp)
{
   dirfidHash_t *hp = &dirFidHashQ[idx];
   int qIndex;
   kutil_q_t *qp;
   ;

   qIndex = kpcfDirFidQueueHash((((fresp)->intFlags & 0x1)? &fresp->rfid: NULL));
   qp = &hp->dfQ[qIndex];

   ;
   if (((fresp)->intFlags & 0x200)) {
         ;






        ((&fresp->dirFidHashQ)->next = (qp), (&fresp->dirFidHashQ)->prev = (((kutil_q_t *)qp)->prev), (((kutil_q_t *)qp)->prev)->next = (&fresp->dirFidHashQ), (qp)->prev = (&fresp->dirFidHashQ));
   } else {
        if (((fresp)->intFlags & 0x1)) {
             ;


            kpcf_checkForFidAliases(qp, fresp);
            ;
        }

        ((&fresp->dirFidHashQ)->next = (((kutil_q_t *)qp)->next), (&fresp->dirFidHashQ)->prev = (qp), (((kutil_q_t *)qp)->next)->prev = (&fresp->dirFidHashQ), (qp)->next = (&fresp->dirFidHashQ));
   }

    hp->resCount++;
    hp->genNo++;
    if (!hp->genNo) {
        hp->genNo = 1;
    }

    hp->lastHitDir = NULL;

    if (!hp->leastRefreshTime ||
        (fresp->lastRefresh < hp->leastRefreshTime)) {
        hp->leastRefreshTime = fresp->lastRefresh;
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KPCF_DINS, (((1)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(fresp->resName), (long)idx, (long)qIndex, (long)fresp->intFlags),0) : 0);
}
static void
dfidHashRemove(int idx, fileRes_t *fresp)
{

    dirfidHash_t *hp = &dirFidHashQ[idx];

    if (((((kutil_q_t *)&fresp->dirFidHashQ)->next) == (kutil_q_t *)&fresp->dirFidHashQ)) {
        return;
    }

    ;
    (((&fresp->dirFidHashQ)->next)->prev = ((&fresp->dirFidHashQ)->prev), ((&fresp->dirFidHashQ)->prev)->next = ((&fresp->dirFidHashQ)->next));

    hp->resCount--;

    hp->genNo++;
    if (!hp->genNo) {
        hp->genNo = 1;
    }

    hp->lastHitDir = NULL;
}
static void
lockFidBuckets(dirfidHash_t *hash, int idx1, int idx2)
{
    if (idx1 == idx2) {
       (kail_mutex_lock(&((&hash[idx1])->hlock)));
    } else if (idx2 > idx1) {
       (kail_mutex_lock(&((&hash[idx1])->hlock)));
       (kail_mutex_lock(&((&hash[idx2])->hlock)));
    } else {
        (kail_mutex_lock(&((&hash[idx2])->hlock)));
        (kail_mutex_lock(&((&hash[idx1])->hlock)));
    }
}
static void
unlockFidBuckets(dirfidHash_t *hash, int idx1, int idx2)
{
    (kail_mutex_unlock(&hash[idx1].hlock));
    if (idx1 != idx2)
        (kail_mutex_unlock(&hash[idx2].hlock));
}
static int
dhashHashDirExists(pal_rawFid_t *hFid, uint genNo)
{
    dirfidHash_t *hp;
    fileRes_t *rp;
    kutil_q_t *qp, *hashQ;
    int i, found = 0;

    hp = &dirFidHashQ[kpcfDirFidHash(hFid)];
    if (genNo && (genNo == hp->genNo)) {
        return 0;
    }

    for (i = 0; !found && (i < 8); i++) {
        hashQ = &hp->dfQ[i];
        for (qp = (((kutil_q_t *)hashQ)->next);
            !found && (qp != hashQ); qp = ((qp)->next)) {
            rp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, dirFidHashQ)));
            if(((rp)->intFlags & 0x2) && (((((!memcmp((&(((hFid)))->fid),(&(((&rp->dir_rfid)))->fid),((&(((hFid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((hFid)))->fsid)->val[0] == (&(((&rp->dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {
                found = 1;
            }
        }
    }

    return found;
}
void
kpcfMarkDhashStale(int index)
{
    (!((index >= 0) && (index < 907))? (*((char *)0) = 0) : 0);

    lockFidBuckets(dirFidHashQ, index, index);
    dirFidHashQ[index].leastRefreshTime = 100;;
    unlockFidBuckets(dirFidHashQ, index, index);
}
static int
dhashSearchName(
    char *name,
    fresList_t *frl,
    pal_time_t checkTime,
    uint *genNo,
    pal_time_t *firstDirTime)
{
    int i, dh, retFlags, nLen, tLen, resCount, strcmpCount;
    pal_rawFid_t *hFid = frl->parFidp;
    dirfidHash_t *hp;
    fileRes_t *resp;
    kutil_q_t *qp, *hashQ;
    pal_time_t dirTime = 0;
    char cA, cB;





    retFlags = resCount = strcmpCount = 0;
    (!(hFid)? (*((char *)0) = 0) : 0);
    dh = kpcfDirFidHash(hFid);
    hp = &dirFidHashQ[dh];
    lockFidBuckets(dirFidHashQ, dh, dh);

    if (*genNo && (*genNo == hp->genNo)) {
        retFlags = 0x00002;
        goto out;
    }

    if (hp->lastHitDir && ((hp->lastHitDir)->intFlags & 0x2) &&
        hFid && (((((!memcmp((&(((hFid)))->fid),(&(((&hp->lastHitDir->dir_rfid)))->fid),((&(((hFid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((hFid)))->fsid)->val[0] == (&(((&hp->lastHitDir->dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x100)) {
        retFlags |= (0x00004 | 0x01000);
        dirTime = hp->lastHitDir->firstDirTime;
    }

    nLen = strlen(name);




    cA = name[nLen - 1];
    if (nLen > 2) {
        cB = name[nLen - 3];
    } else {
        cB = 0;
    }

    for (i = 0; i < 8; i++) {




        hashQ = &hp->dfQ[i];
        for (qp = (((kutil_q_t *)hashQ)->next); qp != hashQ; qp = ((qp)->next)) {
            resp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, dirFidHashQ)));
            resCount++;
            if(((resp)->intFlags & 0x2) && (((((!memcmp((&(((hFid)))->fid),(&(((&resp->dir_rfid)))->fid),((&(((hFid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((hFid)))->fsid)->val[0] == (&(((&resp->dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {

                retFlags |= 0x00004;
                if (!dirTime || (dirTime > resp->firstDirTime)) {
                    dirTime = resp->firstDirTime;
                }





                if (!((resp)->intFlags & 0x1) || ((resp)->intFlags & 0x20) ||
                    ((pal_time_t)((hFid)->ctime) > resp->lastRefresh)) {

                    if (((resp)->intFlags & 0x20)) {
                        retFlags |= 0x00040;
                    }





                    tLen = resp->resNameLen;
                    if ((nLen > tLen) ||
                        (cA != resp->resName[tLen -1]) ||
                        (cB && (cB != resp->resName[tLen - 3]))) {
                        continue;
                    }

                    strcmpCount++;
                    (kail_mutex_lock(&(resp)->rLock));
                    if (strcmp(name, getBaseName(resp)) == 0) {
                        if (!((resp)->intFlags & 0x200)) {
                            if (frl->count && !(retFlags & 0x00020)) {
                                fresListClean(frl);
                            }
                            if (frl->count) {
                                retFlags |= 0x00080;
                            }
                            (kail_mutex_unlock(&(resp)->rLock));
                            fresListAdd(frl, resp);
                            (kail_mutex_lock(&(resp)->rLock));
                            retFlags |= 0x00020;
                        } else {
                             if (resp->plink) {
                                fresListAdd(frl, resp->plink);
                                retFlags |= 0x00008;
                                if (((resp->plink)->intFlags & 0x20)) {
                                    retFlags |= 0x00040;
                                }
                             }
                        }
                    }
                    (kail_mutex_unlock(&(resp)->rLock));
                }
            }
        }

        if (i == 0) {
            if (checkTime < hp->leastRefreshTime) {




                if (frl->count) {
                    retFlags |= 0x00100;
                    break;
                } else if (retFlags & 0x00004) {
                    retFlags |= 0x02000;
                    break;
                }
            }
        } else {
            retFlags |= 0x00200;
        }
    }

 out:
    if (!(retFlags & 0x00040)) {
        *genNo = hp->genNo;
    } else {
        *genNo = 0;
    }
    unlockFidBuckets(dirFidHashQ, dh, dh);

    if (retFlags & 0x00004) {
        *firstDirTime = dirTime;
        if (!frl->count && frl->nameHint &&
            (strlen(frl->nameHint) < 128)) {





            (kail_mutex_lock(&fileDbLock));
            dh_nameMissDirFid = *hFid;
            strcpy(dh_nameMiss, frl->nameHint);
            (kail_mutex_unlock(&fileDbLock));
            retFlags |= 0x10000;
        }
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_KPC_DHASHNAME_EXIT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(dh), (long)resCount, (long)strcmpCount, (long)retFlags),0) : 0);





    return retFlags;
}
static void
dhashAnalyzeFidMatch(fileRes_t *resp, fresList_t *frl, int *dhFlags)
{
    int retFlags = *dhFlags, nlinks;
    int cleanList = 0, add_resp = 0;


    (kail_mutex_lock(&(resp)->rLock));
    nlinks = (frl->fap)? frl->fap->links: resp->nlinks;
    if (!((resp)->intFlags & 0x200)) {
        if ((nlinks == 1) || !((resp->ftype) == PAL_FTYPE_FILE)) {





            if (! (((resp->ftype) == PAL_FTYPE_FILE) && ((resp)->intFlags & 0x800)) ) {
                cleanList = 1;
                retFlags |= (!((resp)->intFlags & 0x800))?
                  0x00020: 0x00080;
            } else {
                retFlags |= 0x00080;
                if (frl->nameHint) {
                    if (((resp)->intFlags & 0x1000) &&
                        (strcmp(frl->nameHint,resp->resName)==0)) {
                        cleanList = 1;
                        retFlags &= ~0x00080;
                        retFlags |= 0x00020;
                    }
                }
            }
            add_resp = 1;
        } else if ((nlinks > 1) && ((resp->ftype) == PAL_FTYPE_FILE)) {
            if (!(retFlags & 0x00010)) {
                cleanList = 1;
            }
            retFlags |= 0x00010;
            if (!frl->bName && frl->nameHint) {
                frl->bName = kutil_pathExtractBaseName(frl->nameHint);
                if (frl->bName) {
                    frl->bNameLen = strlen(frl->bName);
                } else {
                    frl->frlFlags |= 0x4;
                    frl->frlError = ENOMEM;
                }
            }
            if (frl->bName) {



                if ((frl->bName[frl->bNameLen - 1] ==
                    resp->resName[resp->resNameLen - 1]) &&
                    (strcmp(frl->bName, getBaseName(resp)) == 0)) {
                    add_resp = 1;

                    retFlags |= (!((resp)->intFlags & 0x800))?
                      0x00020: 0x00080;
                }
            }
        }
    } else {
        if (!(retFlags & (0x00010 |
            0x00040 | 0x00080 | 0x00020))) {




            retFlags |= 0x00008;
            if (resp->plink) {
                if (!((resp->plink)->intFlags & 0x20)) {

                    fresListAdd(frl, resp->plink);
                } else {
                    retFlags |= 0x00040;
                    cleanList = 1;
                }
            }
        }
    }
    (kail_mutex_unlock(&(resp)->rLock));

    if (cleanList && frl->count) {


        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_DHANAL_FRL_CLR, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(nlinks), (long)resp, (long)retFlags),0) : 0);



        fresListClean(frl);
    }
    if (add_resp) {
        fresListAdd(frl, resp);







        if (resp->rflags.isVia &&
            !(resp->rflags.hasAcl || resp->rflags.isTCB || resp->rflags.hasCond
              || resp->rflags.hasViaPgm || resp->rflags.hasTod ||
              resp->rflags.condOther || resp->rflags.hasPop ||
              resp->rflags.hasAuthz)) {
            retFlags |= 0x20000;
        }
    }
    *dhFlags = retFlags;
}
static int
dhashSearchFids(
    fresList_t *frl,
    pal_time_t checkTime,
    uint *genNo,
    pal_time_t *firstDirTime)
{
    int dh, dirMatch, retFlags, maybeRemote;
    int firstLoop, qIndex, bestIndex, resCount;
    int fidMatch;
    pal_rawFid_t *fid = frl->rFidp;
    pal_rawFid_t *hFid = frl->parFidp;
    dirfidHash_t *hp;
    fileRes_t *resp;
    kutil_q_t *hashQ, *qp, *qpNext;
    pal_time_t timeVal = 0;
    pal_time_t leastRefresh = 0;
    fresNode_t *rn;


    ;
    retFlags = resCount = 0;
    bestIndex = kpcfDirFidQueueHash(fid);
    dh = kpcfDirFidHash(hFid);
    hp = &dirFidHashQ[dh];
    maybeRemote = ((fid)->fid.fid_flags & (0x1));
    lockFidBuckets(dirFidHashQ, dh, dh);

    if (*genNo && (*genNo == hp->genNo)) {
        retFlags = 0x00002;
        goto out;
    }

    if (hp->resCount == 0) {
        retFlags = 0x00800;
        goto out;
    }

    if (hp->lastHitDir && ((hp->lastHitDir)->intFlags & 0x2) && hFid &&
        (((((!memcmp((&(((hFid)))->fid),(&(((&hp->lastHitDir->dir_rfid)))->fid),((&(((hFid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((hFid)))->fsid)->val[0] == (&(((&hp->lastHitDir->dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x100) && !maybeRemote) {
        retFlags |= (0x00004 | 0x01000);
        timeVal = hp->lastHitDir->firstDirTime;
    }
    firstLoop = 1;
    for (qIndex = bestIndex; qIndex < 8; qIndex++) {
        if (!firstLoop && (qIndex == bestIndex)) {
            continue;
        }

        hashQ = &hp->dfQ[qIndex];
        for (qp = (((kutil_q_t *)hashQ)->next); qp != hashQ; qp = qpNext) {
            qpNext = ((qp)->next);
            resp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, dirFidHashQ)));
            resCount++;
            if (!leastRefresh || (resp->lastRefresh < leastRefresh)) {
                leastRefresh = resp->lastRefresh;
            }

            if (((resp)->intFlags & 0x20)) {





                if (!(explicitRefreshOnly(resp,0))) {
                    retFlags |= (0x00040 | 0x00001);
                    fresListClean(frl);
                    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_DHASH_SEARCH_STALE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(((frl->nameHint)?frl->nameHint:"???")), (long)resp, (long)(resp->resName?resp->resName:"NULL"), (long)qIndex ,(long)1),0) : 0);







                    break;
                }
            }

            dirMatch = (((resp)->intFlags & 0x2) &&
                        hFid && (((((!memcmp((&(((hFid)))->fid),(&(((&resp->dir_rfid)))->fid),((&(((hFid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((hFid)))->fsid)->val[0] == (&(((&resp->dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1));

            if(dirMatch || !hFid) {
                if (dirMatch) {
                    if (((resp)->intFlags & 0x20)) {


                        retFlags |= (0x00040 | 0x00001);
                        fresListClean(frl);
                        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_DHASH_SEARCH_STALE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(((frl->nameHint)?frl->nameHint:"???")), (long)resp, (long)(resp->resName?resp->resName:"NULL"), (long)qIndex ,(long)2),0) : 0);







                        break;
                    }
                    retFlags |= 0x00004;
                    if (!timeVal || (timeVal > resp->firstDirTime)) {
                        timeVal = resp->firstDirTime;
                        hp->lastHitDir = resp;
                    }







                    if (maybeRemote && (((&resp->rfid)->fid.fid_flags & (0x1)))) {
                        pal_time_t hfidCT = (pal_time_t)((hFid)->ctime);
                        pal_time_t respCT = (pal_time_t)((&resp->dir_rfid)->ctime);
                        if (respCT < hfidCT) {
                            do { (resp)->intFlags |= 0x20; (resp)->intFlags &= ~0x1; } while ( 0);
                            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_DHASH_SEARCH_STALE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(((frl->nameHint)?frl->nameHint:"???")), (long)resp, (long)(resp->resName?resp->resName:"NULL"), (long)qIndex ,(long)3),0) : 0);







                            retFlags |= (0x00040 | 0x00001);
                            if ((hfidCT - respCT) > 30) {
                                break;
                            }
                        }
                    }
                }

                fidMatch = 0;
                if (((resp)->intFlags & 0x1)) {
                    fidMatch = (((((!memcmp((&(((fid)))->fid),(&(((&resp->rfid)))->fid),((&(((fid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((fid)))->fsid)->val[0] == (&(((&resp->rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x100);

                }
                if(fidMatch) {
                    if (((resp)->intFlags & 0x20)) {


                        retFlags |= (0x00040 | 0x00001);
                        fresListClean(frl);
                        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_DHASH_SEARCH_STALE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(((frl->nameHint)?frl->nameHint:"???")), (long)resp, (long)(resp->resName?resp->resName:"NULL"), (long)qIndex ,(long)4),0) : 0);







                        break;
                    }



                    dhashAnalyzeFidMatch(resp, frl, &retFlags);
                    if (retFlags & 0x00020) {
                        if (resCount > 1) {

                            (((&resp->dirFidHashQ)->next)->prev = ((&resp->dirFidHashQ)->prev), ((&resp->dirFidHashQ)->prev)->next = ((&resp->dirFidHashQ)->next));
                            ((&resp->dirFidHashQ)->next = (((kutil_q_t *)hashQ)->next), (&resp->dirFidHashQ)->prev = (hashQ), (((kutil_q_t *)hashQ)->next)->prev = (&resp->dirFidHashQ), (hashQ)->next = (&resp->dirFidHashQ));
                        }
                        if (checkTime < hp->leastRefreshTime) {

                            break;
                        }
                    }
                }

                if (checkTime > resp->lastRefresh) {

                    retFlags |= 0x00001;
                }
            }
        }

        if (firstLoop) {
            firstLoop = 0;
            if ((frl->count && !maybeRemote &&
                (checkTime < hp->leastRefreshTime)) || !firstDirTime) {

                retFlags |= 0x00100;
                break;
            } else if ((retFlags & 0x01000) &&
                        (checkTime < hp->leastRefreshTime)) {

                retFlags |= 0x02000;
                break;
            } else {



                retFlags |= 0x00200;
                qIndex = -1;
            }
        }
        if (retFlags & 0x00040) {
            break;
        }
    }

 out:
    if (!(retFlags & 0x00040)) {
        *genNo = hp->genNo;
    } else {
        *genNo = 0;
    }

    if ((retFlags &
        (0x00200 | 0x00040)) == 0x00200) {






        retFlags |= 0x00400;
        hp->leastRefreshTime = leastRefresh;
        if (maybeRemote)
            checkTime = ((pal_time_t)(kail_xtime->tv_sec));
    }

    unlockFidBuckets(dirFidHashQ, dh, dh);

    if ((retFlags & 0x00004) && firstDirTime) {
        *firstDirTime = timeVal;
    }

    if ((retFlags & 0x00080) && (frl->count == 1)) {





        rn = &((frl)->node);
        (kail_mutex_lock(&(rn->resp)->rLock));
        ((rn->resp)->intFlags &= ~0x800);
        (kail_mutex_unlock(&(rn->resp)->rLock));
        retFlags &= ~0x00080;
        retFlags |= 0x00020;
    }

    if ((retFlags & 0x00400) &&
        (checkTime > leastRefresh) && hFid) {
        timeVal = ((pal_time_t)(kail_xtime->tv_sec));
        qIndex = 0;
        if (maybeRemote || (timeVal > checkTime)) {
            if (frl->count) {
                qIndex = maybeRemote? 360: 180;
            } else if (retFlags & 0x00004) {
                qIndex = 600;
            }
        }

        if (qIndex && ((timeVal - leastRefresh) > qIndex)) {
            dhashRefresh(hFid, checkTime, &dirMatch, NULL );
            retFlags |= 0x04000;
            retFlags &= ~0x00001;
        } else if ((retFlags & 0x00001) &&
            !frl->count && (((((!memcmp((&(((fid)))->fid),(&(((&dh_createMissFid)))->fid),((&(((fid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((fid)))->fsid)->val[0] == (&(((&dh_createMissFid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x100)) {


            retFlags |= 0x08000;
            retFlags &= ~0x00001;
        }
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_KPC_DHASHFID_EXIT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(dh), (long)bestIndex, (long)resCount, (long)retFlags),0) : 0);





    return retFlags;
}
static int
exceptionFind(fresList_t *frl, int flags)
{
    fileRes_t *fresp, *trp;
    pal_rawFid_t *fidp;
    int searchDev, found, retFlags;
    kutil_q_t *qp, *excQp, *qNext;
    pal_dev_t dev;





    kail_atomic_add((int)(1),(void *)(&kpcFileStats.exceptionSearches));
    excQp = &exceptionQ;
    retFlags = 0;
    searchDev = (flags & 0x2);

    if (searchDev) {
        ;
        dev = frl->fap->dev;
    } else {
        fidp = frl->rFidp;
        ;
    }
    (kail_mutex_lock(&fileDbLock));
    { (kail_mutex_unlock(&fileDbLock)); (kail_mutex_lock(&fileResDbLock)); (kail_mutex_lock(&fileDbLock)); };

    for (qp = ((excQp)->next); qp != excQp; qp = qNext) {
        qNext = ((qp)->next);
        fresp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, excQ)));
        found = 0;
        if (searchDev) {
            if ((((fresp->ftype) == PAL_FTYPE_BLKDEV) || ((fresp->ftype) == PAL_FTYPE_CHARDEV) || ((fresp->ftype) == PAL_FTYPE_MPC)) &&
                ((fresp->dev) == (dev))) {
                if ((flags & 0x4) &&
                    (fresp->rflags.isTerminal)) {
                    found = 1;
                } else if (fresp->ftype == frl->fap->ftype) {
                    found = 1;
                }
            }
        } else if (fresp->nlinks > 1) {
            int res = ((((!memcmp((&((&fresp->rfid))->fid),(&((fidp))->fid),((&((&fresp->rfid))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&((&fresp->rfid))->fsid)->val[0] == (&((fidp))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000);
            if (res & 0x1) {
                found = 1;



            }
        }

        if (found) {
            if (((fresp)->intFlags & 0x200)) {




                (kail_mutex_lock(&(fresp)->rLock));
                trp = fresp->plink;
                (kail_mutex_unlock(&(fresp)->rLock));
                if (trp) {
                    fresp = trp;
                }
            }

            if (((fresp)->intFlags & 0x20)) {
                fresListClean(frl);
                retFlags = 0x10;
                ;
                (void)refreshFileRes2(fresp, 0x1, 0);

                qNext = ((excQp)->next);
                continue;
            }

            kail_atomic_add((int)(1),(void *)(&kpcFileStats.exceptionHits));
            (((&fresp->excQ)->next)->prev = ((&fresp->excQ)->prev), ((&fresp->excQ)->prev)->next = ((&fresp->excQ)->next));
            ((&fresp->excQ)->next = (((kutil_q_t *)excQp)->next), (&fresp->excQ)->prev = (excQp), (((kutil_q_t *)excQp)->next)->prev = (&fresp->excQ), (excQp)->next = (&fresp->excQ));
            fresListAdd(frl, fresp);
            retFlags |= 0x8;
            if (flags & 0x4) {
                break;
            }
        }
    }
    (kail_mutex_unlock(&fileDbLock));
    (kail_mutex_unlock(&fileResDbLock));
    return retFlags;
}
static int
exceptionCheck(fileRes_t *frp)
{
    int isDev = 0, isLinked = 0, isNoFid = 0;
    int didAdd = 0;
    kutil_q_t *excQp;


    ;




    if (!((((kutil_q_t *)&frp->excQ)->next) == (kutil_q_t *)&frp->excQ)) {
        (((&frp->excQ)->next)->prev = ((&frp->excQ)->prev), ((&frp->excQ)->prev)->next = ((&frp->excQ)->next));
        ((&frp->excQ)->next = (&frp->excQ)->prev = (&frp->excQ));
        kail_atomic_add((int)(-1),(void *)(&kpcFileStats.excResources));
    }

    excQp = &exceptionQ;
    if (((frp)->intFlags & 0x1)) {
        if ((((frp->ftype) == PAL_FTYPE_BLKDEV) || ((frp->ftype) == PAL_FTYPE_CHARDEV) || ((frp->ftype) == PAL_FTYPE_MPC))) {
            isDev = 1;
        } else if (((frp->ftype) == PAL_FTYPE_FILE) && (frp->nlinks > 1)) {
            isLinked = 1;
        }
    } else if (!((frp)->intFlags & 0x2)) {
        excQp = &excNoFidQ;
        isNoFid = 1;
    }

    if (isDev || isLinked || isNoFid) {
        ;
        didAdd = 1;
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.excResources));
        ((&frp->excQ)->next = (((kutil_q_t *)excQp)->next), (&frp->excQ)->prev = (excQp), (((kutil_q_t *)excQp)->next)->prev = (&frp->excQ), (excQp)->next = (&frp->excQ));
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_EXCEPTION_ADD, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(isDev), (long)isLinked, (long)isNoFid, (long)kpcFileStats.excResources),0) : 0);




    }

    return didAdd;
}
static void
addDirFidToNegativeCache(
    pal_rawFid_t *negFid,
    pal_rawFid_t *parent,
    uint dirGen)
{
    int dhash;
    uint fgen;


    if (kpcShuttingDown)
        return;

    fgen = dirGen;
    dhash = kpcfDirFidHash(negFid);
    lockFidBuckets(dirFidHashQ, dhash, dhash);
    if (!dhashHashDirExists(negFid, fgen)) {
        kpcf_negCacheAdd(negFid);
    }
    unlockFidBuckets(dirFidHashQ, dhash, dhash);
}
static int
explicitRefreshOnly(fileRes_t *frp,int flags)
{
    int rc=0;




    if (((frp)->intFlags & 0x8000)) {


        if ( (*((void **)&(frp->check_vfsp))) ) {



            if (flags & 0x8) {
                rc = 1;
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_DEFER_UMOUNT, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(frp), (long)flags),0) : 0);

            } else if ( !(kail_vfs_mounted(&(frp->check_vfsp))) ) {

                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_AUTOFS_NOREF, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16)), (long)(frp), (long)frp->intFlags, (long)(*((void **)&(frp->check_vfsp))), (long)kail_vfs_check(&(frp->check_vfsp))),0) : 0);



                rc = 1;
            } else {
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_AUTO_FS_MOUNTED, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16)), (long)(frp), (long)frp->intFlags, (long)(*((void **)&(frp->check_vfsp))), (long)kail_vfs_check(&(frp->check_vfsp))),0) : 0);



            }
        } else {



            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(frp), (long)frp->intFlags),0) : 0);

        }
    }

    return(rc);
}
static fileRes_t *
removeFileResource(fileRes_t *frp)
{
    int dh, doFree = 1;
    pal_rawFid_t *dfidp = NULL;
    fileRes_t *plink = NULL, *clink = NULL;
    fileRes_t *rc = frp;
    ;
    ;

    if (((frp)->intFlags & 0x100)) {
        return frp;
    }




    if (!((((kutil_q_t *)&frp->dirFidHashQ)->next) == (kutil_q_t *)&frp->dirFidHashQ)) {
        dfidp = (((frp)->intFlags & 0x2))? &frp->dir_rfid: NULL;
        dh = kpcfDirFidHash(dfidp);
        lockFidBuckets(dirFidHashQ, dh, dh);
        dfidHashRemove(dh, frp);
        unlockFidBuckets(dirFidHashQ, dh, dh);
    }

    kpcf_refreshQRemoveResource((frp));
    kpcf_nameHashRemove(frp);

    if (!((((kutil_q_t *)&frp->excQ)->next) == (kutil_q_t *)&frp->excQ)) {
        kail_atomic_add((int)(-1),(void *)(&kpcFileStats.excResources));
        (((&frp->excQ)->next)->prev = ((&frp->excQ)->prev), ((&frp->excQ)->prev)->next = ((&frp->excQ)->next));
        ((&frp->excQ)->next = (&frp->excQ)->prev = (&frp->excQ));
    }

    if (strcmp(frp->resName, "/unix") == 0) {
        kpcClearUnixRes();
    }

    kpcf_pfcFlushProtResp(frp);

    (kail_mutex_lock(&(frp)->rLock));
    if (frp->clink) {
        clink = frp->clink;
        frp->clink = NULL;
    }

    if (frp->plink) {
        plink = frp->plink;
        frp->plink = NULL;
    }

    if (frp->refCount) {
        frp->intFlags |= 0x100;
        doFree = 0;
    }
    (kail_mutex_unlock(&(frp)->rLock));

    if (clink) {



        if (removeFileResource(clink)) {

            releFileResource(clink);
        }
    }

    if (plink) {




        releFileResource(plink);
    }

    if (doFree) {

       rc = (fileRes_t *)NULL;
       ;


       freeFileResource(frp);
    }
    return rc;
}
static void
doSymLinkX(fileRes_t *resp, int alreadyLocked)
{


    fileRes_t *chRes, *link, *parRes, *trp;
    char *tname, *path;
    int tlen, xlen, rc, depth;
    ;
    ;


    if (!((resp)->intFlags & 0x200)) {
        parRes = resp;
    } else {
        (!(resp->plink)? (*((char *)0) = 0) : 0);
        parRes = resp->plink;



        for (trp = parRes, depth = 0;
            (trp != resp) && (depth < 6); trp = trp->clink) {
            depth++;
        }
        if (depth >= 6) {
            kail_atomic_add((int)(1),(void *)(&kpcFileStats.tooManyClinks));
            return;
        }
    }

    tname = pal_readSymLink(resp->resName, &tlen);
    if (!tname) return;
    if (*tname != '/') {



        xlen = tlen + strlen(resp->resName);
        path = pal_alloc(xlen + 1);
        if (path) {
            strcpy(path, resp->resName);
            kutil_pathToDotPath(path, resp->resNameLen);
            strcat(path, tname);
            pal_free(tname, tlen + 1);
            tname = path;
            tlen = xlen;
        } else {
            goto out;
        }
    }

    chRes = NULL;




    if (resp->clink) {
        if (!((resp->clink)->intFlags & 0x100) &&
            strcmp(tname, resp->clink->resName) == 0) {
            chRes = resp->clink;
        } else {
            link = resp->clink;
            resp->clink = NULL;
            (kail_mutex_unlock(&(resp)->rLock));
            if (removeFileResource(link)) {

                if (! releaseFileResource(link)) {
                   ;


                }
            } else {
               ;

            }
            (kail_mutex_lock(&(resp)->rLock));
        }
    }

    if (!chRes && (chRes = getFileResource())) {
        ((chRes)->intFlags |= 0x200);
        xlen = 0;
        rc = kutil_setStringWithLocal(tname, &xlen, chRes->_lclSpace,
                                      sizeof(chRes->_lclSpace),
                                      &chRes->resName);
        if (rc) {
            removeFileResource(chRes);
            goto out;
        }

        chRes->resNameLen = xlen;




        holdFileResource(chRes);
        if (resp == parRes) {
            resp->refCount++;
        } else {
            holdFileResource(parRes);
        }
        resp->clink = chRes;
        chRes->plink = parRes;





    }

    if (chRes) {
        chRes->epoch = parRes->epoch;
        chRes->rflags = resp->rflags;
        (kail_mutex_unlock(&(resp)->rLock));
        ( kail_mutex_trylock(&fileDbLock) ? 1 : (kail_mutex_unlock(&fileDbLock),0) );
           ;

        if (! alreadyLocked) {

           (int)refreshFileRes(chRes, 0x1, 0);
        } else {

           (int)refreshFileRes2(chRes, 0x1, 0);
        }
        (kail_mutex_lock(&(resp)->rLock));
    }

  out:
    if (tname) {
        pal_free(tname, tlen + 1);
    }
}

static void
doSymLink(fileRes_t *resp)
{
  doSymLinkX(resp, 0);
}
static void
doSymLink2(fileRes_t *resp)
{
  doSymLinkX(resp, 1);
}
static int
refreshFileResX(fileRes_t *fresp, int genFid, int refGen, int alreadyLocked)
{

    int oldDhash, newDhash, isExcFile, checkFlags;
    int oldDhQ, newDhQ;
    int gFlags, gInFlags=0, doInsert = 0, tlen, rc;
    fileRes_t *clink = NULL;
    struct p_fdata {
        pal_rawFid_t *dirFidp, *fidp;
        pal_rawFid_t rfid, dir_rfid;
        pal_fattr_t fa;
    };

    struct p_fdata *fip = NULL;






    int alreadyOwned = 0;
    int fileResLocked = 0;
    int ignoreDoInsert = 0;
    if (kpc_ftTryAgainLater) {
        ;

        ++kpc_ftTryAgainLater;
    } else {
        kpc_ftTryAgainLater = 1;
    }
    if (kpc_fileThreadActive) {
       ;

    }
    ;
    ;
    if (refreshFileResCount != 0) {

      ;
      alreadyOwned = refreshFileResCountOwner;
    }



    refreshFileResCountOwner = kail_current_tid();


    ++refreshFileResCount;

    kail_atomic_add((int)(1),(void *)(&kpcFileStats.fileRefreshes));
    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_REF_FR, (((1)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(fresp->resName), (long)(int)fresp->lastRefresh, (long)fresp->intFlags, (long)fresp->refreshGen),0) : 0);
    if (! alreadyLocked) {
       { (kail_mutex_unlock(&fileDbLock)); (kail_mutex_lock(&fileResDbLock)); (kail_mutex_lock(&fileDbLock)); };
       fileResLocked = 1;
    }

    if (fresp && (currentFileRes == fresp)
         && memcmp(currentFileRes->resName, fresp->resName, strlen(fresp->resName)) == 0) {
       ;


       currentFileRes = NULL;
       goto quickout;
    }





    fip = (struct p_fdata *)pal_alloc(sizeof(*fip));
    if (!fip) {
        kt_intError(6, 4, 2132, ENOMEM);
        return ENOMEM;
    }




    currentFileRes = fresp;
    ++debugFileResLockCount;
    rc = 0;
    isExcFile = 0;
    fip->dirFidp = (((fresp)->intFlags & 0x2))? &fresp->dir_rfid: NULL;
    fip->fidp = (((fresp)->intFlags & 0x1))? &fresp->rfid: NULL;


    if (genFid & 0x4) {
        if (explicitRefreshOnly(fresp,genFid)) {

            do { (fresp)->intFlags |= 0x20; (fresp)->intFlags &= ~0x1; } while ( 0);
            goto quickout;
        }
    }

    if (genFid & 0x1) {
        if (((fresp)->intFlags & 0x10000)) {


            (kail_mutex_unlock(&fileDbLock));
            (kail_mutex_lock(&(fresp)->rLock));
            while (((fresp)->intFlags & 0x10000)) {
                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_RES_WAIT, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((1)<<16)), (long)((int)kail_pid_get_epid(kail_current_tid())), (long)fresp, (long)fresp->intFlags, (long)fresp->resName),0) : 0);



                ;

                (kail_cond_wait(&(fresp)->rCond,&(fresp)->rLock));;
                ;

                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_RES_REFD, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((1)<<16)), (long)((int)kail_pid_get_epid(kail_current_tid())), (long)fresp, (long)fresp->intFlags, (long)fresp->resName),0) : 0);



            }
            (kail_mutex_unlock(&(fresp)->rLock));
            (kail_mutex_lock(&fileDbLock));
            if (!((fresp)->intFlags & 0x20)) {
                goto quickout;
            }
        }

        if (((fresp)->intFlags & 0x20000)) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_DBG_DEFER_UNAVAIL, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((1)<<20) + ((0)<<16)), (long)(fresp), (long)fresp->intFlags, (long)fresp->resName),0) : 0);


            rc = ETIMEDOUT;
            goto quickout;
        }

        oldDhash = newDhash = kpcfDirFidHash(fip->dirFidp);
        oldDhQ = newDhQ = kpcfDirFidQueueHash(fip->fidp);
        (kail_mutex_lock(&(fresp)->rLock));
        ((fresp)->intFlags |= 0x10000);
        ;

        (kail_mutex_unlock(&(fresp)->rLock));


        memset(&(fip->fa),0,sizeof(pal_fattr_t));


        if (genFid & 0x2) {
            gInFlags |= 0x2;
        }







        holdFileResource(fresp);

        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_GEN_RES_FIDS, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((2)<<16)), (long)(fresp->resName), (long)fresp, (long)genFid, (long)gInFlags),0) : 0);


        ;

        (kail_mutex_unlock(&fileDbLock));
        rc = kpcfGenResFids(fresp, &fip->rfid,
                            &fip->dir_rfid, &fip->fa, gInFlags, &gFlags);
        ;



        if (rc) {
           ;

        }

        (kail_mutex_lock(&fileDbLock));

        if (rc == ETIMEDOUT) {
           ignoreDoInsert = 1;
              ;




        }
        if (rc == ETIMEDOUT) {
           ignoreDoInsert = 1;
            ;


           if (! releaseFileResource(fresp)) {


              ;

              goto quickout;
           }
        }
        if (fresp->intFlags & 0x100) {

           ;


          goto quickout;
        }


        (kail_mutex_lock(&(fresp)->rLock));
        if ( ((fresp)->intFlags & 0x10000) ) {
           if (rc) {
           ;


           }
            ((fresp)->intFlags &= ~0x10000);
            ;


            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_RES_REFD, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((1)<<16)), (long)((int)kail_pid_get_epid(kail_current_tid())), (long)fresp, (long)fresp->intFlags, (long)fresp->resName),0) : 0);





        } else {
           ;



            (kail_mutex_unlock(&(fresp)->rLock));
            goto quickout;
        }




        if ((gFlags & 0x4) && !((fresp)->intFlags & 0x400)) {
              if (rc) {
                ;

              }
            ((fresp)->intFlags |= 0x400);
            kail_atomic_add((int)(1),(void *)(&kpcFileStats.errorResources));
        } else if (((fresp)->intFlags & 0x400) && !(gFlags & 0x4)) {
              if (rc) {
                ;

              }

            ((fresp)->intFlags &= ~0x400);
            kail_atomic_add((int)(-1),(void *)(&kpcFileStats.errorResources));
        }

        if (gFlags & 0x4) {
           ;






            (kail_mutex_unlock(&(fresp)->rLock));
            goto quickout;
        }

        if (rc) {
           ;


        }



        if (fip->fa.attrFlags & 0x4) {
            fresp->check_vfsp = fip->fa.check_vfsp;
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_RFID_FL_VFSP, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((0)<<16)), (long)(fresp), (long)fip->fa.attrFlags, (long)(*((void **)&(fresp->check_vfsp)))),0) : 0);


        }

        if (gFlags & 0x1) {
            if (((fip->fa.ftype) == PAL_FTYPE_LNK)) {

               ;


               ;



                doSymLink2(fresp);
            }
        }



        fip->fidp = (gFlags & 0x1)? &fip->rfid: NULL;
        fip->dirFidp = (gFlags & 0x2)? &fip->dir_rfid: NULL;
        checkFlags = kpcfCheckFidInfo(fresp, fip->fidp,
                                      fip->dirFidp, &fip->fa);

        (kail_mutex_unlock(&(fresp)->rLock));

        newDhash = kpcfDirFidHash(fip->dirFidp);
        newDhQ = kpcfDirFidQueueHash(fip->fidp);
        if (((((kutil_q_t *)&fresp->dirFidHashQ)->next) == (kutil_q_t *)&fresp->dirFidHashQ) || checkFlags ||
            (newDhash != oldDhash) || (newDhQ != oldDhQ)) {
            doInsert = 1;
        }
        if (doInsert && ignoreDoInsert) {
          doInsert = 0;
            ;



        }
        if (doInsert) {
            int hashRemoved = 0;
            kail_atomic_add((int)(1),(void *)(&kpcf_changeGen));
            lockFidBuckets(dirFidHashQ, oldDhash, newDhash);
            if (!((((kutil_q_t *)&fresp->dirFidHashQ)->next) == (kutil_q_t *)&fresp->dirFidHashQ)) {
                hashRemoved = 1;
                dfidHashRemove(oldDhash, fresp);
            }





            (kail_mutex_lock(&(fresp)->rLock));
            kpcfSetFidInfo(fresp, fip->fidp, fip->dirFidp, &fip->fa);
            ((fresp)->intFlags &= ~0x20);

            (kail_mutex_unlock(&(fresp)->rLock));
            dhashInsert(newDhash, fresp);
                 ;




            unlockFidBuckets(dirFidHashQ, oldDhash, newDhash);

        }
        ;


        (kail_wake_up(&(fresp)->rCond));;

        isExcFile = exceptionCheck(fresp);
    }


    (kail_mutex_lock(&(fresp)->rLock));
    fresp->lastRefresh = ((pal_time_t)(kail_xtime->tv_sec));
    fresp->refreshGen = ((refGen)? refGen: kpcf_getNextRefreshGen());
    if (((fresp)->intFlags & 0x1) && fresp->bName) {
        pal_free(fresp->bName, strlen(fresp->bName) + 1);
        fresp->bName = NULL;
    }

    if (fresp->clink && !((fresp)->intFlags & 0x1)) {
        clink = fresp->clink;
        fresp->clink = 0;
    }

    if (isExcFile) {
        ((fresp)->intFlags |= 0x4);
    } else {
        ;
        ((fresp)->intFlags &= ~0x4);
    }

    if (doInsert && ((fresp)->intFlags & 0x2)) {

        pal_time_t ncCmpTime = kpcf_negCacheFlush(&fresp->dir_rfid);
        if ((ncCmpTime != 0) && (ncCmpTime < fresp->firstDirTime)) {
            fresp->firstDirTime = ncCmpTime;
        }
    }
        ;
    (kail_mutex_unlock(&(fresp)->rLock));

    if (clink) {
        if (removeFileResource(clink)) {

            releFileResource(clink);
        }
    }




    kpcf_refreshQRemoveResource((fresp));
    kpcf_refreshQInsertResource((fresp), 1);
    ;
    goto normalout;

 quickout:
    ;

 normalout:

    --refreshFileResCount;
    ;

    if (kpc_ftTryAgainLater > 1) {
        ;

        --kpc_ftTryAgainLater;
    } else {
    kpc_ftTryAgainLater = 0;
    }


    if (fip) {
       pal_free(fip, sizeof(*fip));
    }


    if (fileResLocked) {

        fileResLocked = 0;
        --debugFileResLockCount;
        (kail_mutex_unlock(&fileResDbLock));
    } else {
      if (! alreadyLocked) {
         ;


      }
    }

    return rc;
}


static int
refreshFileRes(fileRes_t *fresp, int genFid, int refGen)
{
 return refreshFileResX(fresp, genFid, refGen, 0);
}

static int
refreshFileRes2(fileRes_t *fresp, int genFid, int refGen)
{
 return refreshFileResX(fresp, genFid, refGen, 1);
}
static void
dhashRefresh(
    pal_rawFid_t *drfp,
    pal_time_t checkTime,
    int *hitDir,
    pal_time_t *firstDirTime)
{
    int checkAll, i, dhash, sameDir, refreshCount, resCount;
    uint genNo;
    uint32_t rGen;
    dirfidHash_t *hp;
    kutil_q_t *hashQ, *qp, *qpNext;
    fileRes_t *fresp;
    pal_time_t dirTime = 0;
    pal_time_t leastRefresh;





    ;
    dhash = kpcfDirFidHash(drfp);
    hp = &dirFidHashQ[dhash];
    *hitDir = 0;
    refreshCount = 0;
    checkAll = (firstDirTime)? 0: 1;
    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_REF_DHASH, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(dhash), (long)checkAll, (long)(int)checkTime, (long)(int)hp->leastRefreshTime),0) : 0);





    (kail_mutex_lock(&fileDbLock));
    lockFidBuckets(dirFidHashQ, dhash, dhash);
    genNo = hp->genNo;
    leastRefresh = 0;
    rGen = kpcf_getCurRefreshGen();

    for (i = 0; i < 8; i++) {
        hashQ = &hp->dfQ[i];
        for (qp = (((kutil_q_t *)hashQ)->next); qp != hashQ; qp = qpNext) {
            qpNext = ((qp)->next);
            fresp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, dirFidHashQ)));
            sameDir = (((fresp)->intFlags & 0x2) &&
                       (((((!memcmp((&(((drfp)))->fid),(&(((&fresp->dir_rfid)))->fid),((&(((drfp)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((drfp)))->fsid)->val[0] == (&(((&fresp->dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1));
            if(sameDir || ((fresp)->intFlags & 0x20) || checkAll) {
                if (sameDir) {
                    *hitDir = 1;
                    if (!dirTime || (dirTime > fresp->firstDirTime)) {
                        dirTime = fresp->firstDirTime;
                    }
                }






                if (((checkTime > fresp->lastRefresh) ||
                    ((fresp)->intFlags & 0x20)) &&
                    ((rGen > fresp->refreshGen) ||
                    kpcf_checkRefreshGenWrap(fresp->refreshGen, rGen))) {

                    unlockFidBuckets(dirFidHashQ, dhash, dhash);
                    kail_atomic_add((int)(1),(void *)(&kpcFileStats.dhashRefreshes));
                    refreshCount++;




                    ;

                    (void)refreshFileRes(fresp, 0x1, 0);
                    lockFidBuckets(dirFidHashQ, dhash, dhash);

                    if (genNo != hp->genNo) {






                        kail_atomic_add((int)(1),(void *)(&kpcFileStats.dhashRefRestarts));
                        genNo = hp->genNo;
                        leastRefresh = 0;
                        i = -1;
                        break;
                    }
                }
            }

            if (!leastRefresh || (fresp->lastRefresh < leastRefresh)) {
                leastRefresh = fresp->lastRefresh;
            }

        }
    }

    if (leastRefresh) {
        hp->leastRefreshTime = leastRefresh;
    }
    resCount = hp->resCount;
    unlockFidBuckets(dirFidHashQ, dhash, dhash);

    (kail_mutex_unlock(&fileDbLock));

    if (*hitDir && firstDirTime) {
        *firstDirTime = dirTime;
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_REF_DHASH_RTN, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(resCount), (long)refreshCount, (long)*hitDir, (long)(int)leastRefresh),0) : 0);




}
static int
dhashRefreshByFid(pal_rawFid_t *drfp, pal_rawFid_t *rfp)
{
    int dirhash, fidhash, refreshCount;
    dirfidHash_t *hp;
    kutil_q_t *hashQ, *qp;
    fileRes_t *fresp;
    fresList_t frl;
    fresNode_t *rn;





    ;
    dirhash = kpcfDirFidHash(drfp);
    fidhash = kpcfDirFidQueueHash(rfp);

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_REF_DH_BYFID, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(dirhash), (long)fidhash, (long)*((int *)(&(&(rfp)->fid)->fid_ino))),0) : 0);




    hp = &dirFidHashQ[dirhash];
    refreshCount = 0;
    do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (NULL); (&frl)->rFidp = (rfp); (&frl)->parFidp = (drfp) ; } while ( 0);

    lockFidBuckets(dirFidHashQ, dirhash, dirhash);
    hashQ = &hp->dfQ[fidhash];
    for (qp = (((kutil_q_t *)hashQ)->next); qp != hashQ; qp = ((qp)->next)) {
        fresp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, dirFidHashQ)));
        if (((fresp)->intFlags & 0x1) && (((((!memcmp((&(((rfp)))->fid),(&(((&fresp->rfid)))->fid),((&(((rfp)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((rfp)))->fsid)->val[0] == (&(((&fresp->rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {
            if (!((fresp)->intFlags & 0x200)) {
                fresListAdd(&frl, fresp);
            } else if (fresp->plink) {
                fresListAdd(&frl, fresp->plink);
            }
        }
    }
    unlockFidBuckets(dirFidHashQ, dirhash, dirhash);

    if (refreshCount = frl.count) {
        for (rn = &((&frl)->node); rn; rn = rn->next) {
            kail_atomic_add((int)(1),(void *)(&kpcFileStats.dhashRefreshes));
            (kail_mutex_lock(&fileDbLock));
            (void)refreshFileRes(rn->resp, 0x1, 0);
            (kail_mutex_unlock(&fileDbLock));
        }
    }
    fresListClean(&frl);

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_REF_DH_BYFID_END, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(refreshCount)),0) : 0);

}
static int
refreshNoFidResources(int errOnly)
{
    int refreshed = 0, doRefresh, flags, rc;
    uint32_t saveGen, resGen;
    pal_rawFid_t rfid, dir_rfid;
    pal_fattr_t fa;
    kutil_q_t *qp, *qpNext;
    fileRes_t *frp;
    pal_time_t startTime;





    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_NOFID_REFRESH, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(errOnly)),0) : 0);






    if (!(kutil_kossActive == 1)) {
        return( 0 );
    }

    saveGen = kpcf_getCurRefreshGen();
    startTime = ((pal_time_t)(kail_xtime->tv_sec));

    (kail_mutex_lock(&fileDbLock));
    for (qp = (((kutil_q_t *)&excNoFidQ)->prev); qp != &excNoFidQ; qp = qpNext) {
        qpNext = ((qp)->prev);
        frp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, excQ)));
        if (!errOnly || ((frp)->intFlags & 0x400) && (frp->lastRefresh < startTime)) {

            if ((frp->refreshGen > saveGen) &&
                !kpcf_checkRefreshGenWrap(frp->refreshGen, saveGen)) {

                continue;
            }

            if (((frp)->intFlags & 0x20000)) {
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_DBG_DEFER_UNAVAIL, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((1)<<20) + ((0)<<16)), (long)(frp), (long)frp->intFlags, (long)frp->resName),0) : 0);


                continue;
            }



            if (explicitRefreshOnly(frp,0)) {
                continue;
            }

            holdFileResource(frp);
            (((&frp->excQ)->next)->prev = ((&frp->excQ)->prev), ((&frp->excQ)->prev)->next = ((&frp->excQ)->next));
            ((&frp->excQ)->next = (&frp->excQ)->prev = (&frp->excQ));
            resGen = frp->refreshGen;

            (kail_mutex_unlock(&fileDbLock));
            doRefresh = 0;
            rc = kpcfGenResFids(frp, &rfid, &dir_rfid, &fa, 0, &flags);
            if ((rc == 0) && (flags & 0x2)) {
                doRefresh = 1;
            }
            (kail_mutex_lock(&fileDbLock));

            if (!((frp)->intFlags & 0x100)) {
                if (doRefresh) {
                    (void)refreshFileRes(frp, 0x1, 0);
                    refreshed++;
                } else if (frp->refreshGen == resGen) {




                    (kail_mutex_lock(&(frp)->rLock));
                    frp->refreshGen = kpcf_getNextRefreshGen();
                    frp->lastRefresh = ((pal_time_t)(kail_xtime->tv_sec));
                    (kail_mutex_unlock(&(frp)->rLock));
                    ;
                    ((&frp->excQ)->next = (((kutil_q_t *)&excNoFidQ)->next), (&frp->excQ)->prev = (&excNoFidQ), (((kutil_q_t *)&excNoFidQ)->next)->prev = (&frp->excQ), (&excNoFidQ)->next = (&frp->excQ));
                }
            }

            releFileResource(frp);

            qpNext = (((kutil_q_t *)&excNoFidQ)->prev);
        }
    }
    (kail_mutex_unlock(&fileDbLock));

    return refreshed;
}
static int
refreshResources(pal_time_t cmpTime, int flags, pal_rawFid_t *rfp)
{
    fileRes_t *fresp;
    kutil_q_t *qp, *next;
    int refreshed, loops, byfsid, skipRefresh, doRefresh, isbkg, fastLoops,
        refflags=0x1;
    uint32_t startGen;
    pal_time_t tsave;
    if (!(kutil_kossActive == 1)) {
        return( 0 );
    }

    kail_atomic_add((int)(1),(void *)(&kpcFileStats.refreshAllCalls));
    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_REFRES, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)((int)cmpTime), (long)flags, (long)kpcf_getCurRefreshGen() + 1),0) : 0);




    refreshed = 0;
    do { pal_time_t ro_; int cks_ = 0; do { (skipRefresh) = 1; ro_ = kpcf_refreshQOldest; if ((cmpTime) >= ro_) (skipRefresh) = 0; } while ((skipRefresh) && (++cks_ < 8) && (ro_ != kpcf_refreshQOldest)); } while ( 0);
    if (skipRefresh) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.refreshSkippedLock));
        goto skipRefreshExit;
    }




    fastLoops = kpcFileStats.allocedResources >> 2;
    loops = byfsid = 0;
    isbkg = (flags & 0x1);
    if (flags & (0x2 | 0x8)) {
        ;
        byfsid = 1;
    } else {
        refflags |= 0x4;
    }
    if ((flags & 0x1) && (flags & 0x10)) {
        refflags |= 0x8;
    }

    tsave = ((pal_time_t)(kail_xtime->tv_sec));
    startGen = kpcf_getNextRefreshGen();

    (kail_mutex_lock(&fileDbLock));
    { (kail_mutex_unlock(&fileDbLock)); (kail_mutex_lock(&fileResDbLock)); (kail_mutex_lock(&fileDbLock)); };
    for (qp = (((kutil_q_t *)&kpcf_refreshQ)->prev); ((qp) != &kpcf_refreshQ); qp = next) {
        loops++;
        next = ((qp)->prev);
        fresp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, refreshQ)));





        if ((cmpTime > fresp->lastRefresh) &&
            (startGen != fresp->refreshGen)) {






            if ((fresp->refreshGen > startGen) &&
                !kpcf_checkRefreshGenWrap(fresp->refreshGen, startGen)) {
                break;
            }

            doRefresh = 0;
            if (byfsid) {
                if (((fresp)->intFlags & 0x2)) {
                    if (((&rfp->fsid)->val[0] == (&fresp->dir_rfid.fsid)->val[0])) {
                        doRefresh = 1;
                    }
                } else if (flags & 0x8) {







                    doRefresh = 1;
                }
            } else if ((fresp->epoch >= _kpcFileEpoch) || ((fresp)->intFlags & 0x200)) {
                doRefresh = 1;






            } else {
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_EPOCH_DEL, (((1)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(fresp->resName), (long)(int)_kpcFileEpoch, (long)(int)fresp->epoch),0) : 0);



                if (!removeFileResource(fresp) ) {
                   doRefresh = 0;
                   ;


                }
                kail_atomic_add((int)(1),(void *)(&kpcFileStats.epochRemoves));
            }

            if (doRefresh) {
                ;

                (void)refreshFileRes2(fresp, refflags, 0);
                refreshed++;
            }

            if (isbkg) {
                if (!(loops & 2047) || ((int)(((pal_time_t)(kail_xtime->tv_sec)) - tsave) > 1)) {
                    (kail_mutex_unlock(&fileDbLock));
                    pal_delay(100 );
                    tsave = ((pal_time_t)(kail_xtime->tv_sec));
                    (kail_mutex_lock(&fileDbLock));
                    next = (((kutil_q_t *)&kpcf_refreshQ)->prev);
                    startGen = kpcf_getCurRefreshGen();
                    if (loops > (2 * kpcFileStats.allocedResources)) {

                        break;
                    }
                }
            }
        } else {
            break;
        }
    }
    (kail_mutex_unlock(&fileDbLock));
    (kail_mutex_unlock(&fileResDbLock));
    if (loops < fastLoops) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.refreshFastExit));
    }

skipRefreshExit:
    if ((flags & 0x4) && kpcFileStats.errorResources) {
        refreshed += refreshNoFidResources(1 );
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_REFRES_RTN, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(refreshed), (long)skipRefresh),0) : 0);


    return refreshed;
}
static void
freeAllResources(void)
{
    fileRes_t *fresp;
    kutil_q_t *qp, *next;
    int freed = 0;




    for (qp = (((kutil_q_t *)&kpcf_refreshQ)->prev); ((qp) != &kpcf_refreshQ); qp = next) {
        next = ((qp)->prev);
        fresp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, refreshQ)));
        removeFileResource(fresp);
        freed++;
    }



}
static void
updateDhashStats(void)
{
    int i, j, cnt, empty = 0, max = 0, avg = 0, total = 0;
    int dirs = 0, nonDirs = 0, oneDir = 0, justOne;
    dirfidHash_t *hp;
    kutil_q_t *hashQ, *qp;
    fileRes_t *rp;
    pal_rawFid_t dfid;
    kpcFileDhashInfo_t *sp = &kpcFileDhashInfo;




    for (i = 0; i < 907; i++) {
        lockFidBuckets(dirFidHashQ, i, i);
        hp = &dirFidHashQ[i];
        for (j = 0; j < 8; j++) {
            hashQ = &hp->dfQ[j];
            if (((((kutil_q_t *)hashQ)->next) == (kutil_q_t *)hashQ)) {
                empty++;
                continue;
            }

            cnt = 0;
            justOne = 1;
            for (qp = (((kutil_q_t *)hashQ)->next);
                qp != hashQ; qp = ((qp)->next)) {
                rp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, dirFidHashQ)));

                if (((rp->ftype) == PAL_FTYPE_DIR)) {
                    dirs++;
                } else {
                    nonDirs++;
                }
                if (cnt == 0) {
                    dfid = rp->dir_rfid;
                } else if (justOne) {
                    if (!(((((!memcmp((&(((&dfid)))->fid),(&(((&rp->dir_rfid)))->fid),((&(((&dfid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((&dfid)))->fsid)->val[0] == (&(((&rp->dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {
                        justOne = 0;
                    }
                }
                    cnt++;
            }

            total += cnt;
            if (cnt > max) {
                max = cnt;
            }
            if (justOne) {
                oneDir++;
            }
        }
        unlockFidBuckets(dirFidHashQ, i, i);
    }

    if (total && (907 - empty)) {
        avg = total / (907 - empty);
    }





    (kail_mutex_lock(&fileDbLock));
    sp->maxChainLen = max;
    sp->avgChainLen = avg;
    sp->totEntries = total;
    sp->numEmptyChains = empty;
    sp->dirs = dirs;
    sp->nonDirs = nonDirs;
    sp->oneDir = oneDir;
    (kail_mutex_unlock(&fileDbLock));
}





static int kpc_ftRunning = 0;
static int kpc_ftShutdown = 0;
static int kpc_ftSleeping = 0;
static int kpc_ftTrigger = 0;
static int kpc_ftNoWindow = 0;
pal_time_t kpcf_startScan=0;


static pal_cond_t kpcf_ftCV;
pal_mutex_t kpcf_ftLock;
static void
kpcFileThread(void *a)
{



    int resCount, rc, rf, refFlags;
    pal_time_t save, now, lastStatUpdate, window;
    int64_t wait;
    pal_rawFid_t rfid;







    kpc_ftRunning = 1;
    wait = 30;
    save = ((pal_time_t)(kail_xtime->tv_sec));
    lastStatUpdate = 0;

    (kail_mutex_lock(&kpcf_ftLock));

    for (;;) {

        if (kpc_ftShutdown) {
            break;
        }
        now = ((pal_time_t)(kail_xtime->tv_sec));
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_BKG_SLEEP, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)now), (long)(int)(now - save)),0) : 0);



        save = now;
        if ((kpc_ftTrigger == 0) || (kpc_ftTrigger & 0x2) ) {
            kpc_ftSleeping = 1;
            (void)(kail_condTimedWait(&kpcf_ftCV,&kpcf_ftLock,wait,0));
            kpc_ftSleeping = 0;
        }





        if (!(kutil_kossActive == 1) ) {
            if (kpc_ftTrigger & 0x1) {
                pal_delay(1000);
                kpc_ftTrigger &= (~0x1);
                kpc_ftTrigger |= 0x2;
            }
            continue;
        }



        (kail_mutex_lock(&fileDbLock));
            if (kpc_ftTryAgainLater) {

                ++kpc_ftTryAgainLaterCount;
                ++kpc_ftTotalTryAgainLaterCount;
                ;


                if (kpc_ftTryAgainLater > 2) {

                  kpc_ftTryAgainLater = 0;
                }
                kpc_fileThreadActive = 0;
                (kail_mutex_unlock(&fileDbLock));
                continue;
            }
        ;



        kpc_ftTryAgainLaterCount = 0;

        kpc_fileThreadActive = 1;
        (kail_mutex_unlock(&fileDbLock));


        refFlags = 0x1;
        if (kpc_ftTrigger & 0x8) {
            refFlags |= 0x10;
        }

        now = ((pal_time_t)(kail_xtime->tv_sec));
        window = (24 * 3600);
        if (kpc_ftNoWindow) {
            window = 0;
            kpc_ftNoWindow = 0;
        }
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_BKG_RUN, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)now), (long)(int)window, (long)kpc_ftTrigger, (long)kpcFileStats.allocedResources),0) : 0);



        kpc_ftTrigger = 0;

        if (refFlags & 0x10) {





            while (now < kpcf_startScan) {
                (kail_mutex_unlock(&kpcf_ftLock));
                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_KPCFT_DELAY, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)kpcf_startScan), (long)(int)now),0) : 0);



                pal_delay(2 * 1000);
                (kail_mutex_lock(&kpcf_ftLock));
                now = ((pal_time_t)(kail_xtime->tv_sec));
            }
            kpcf_startScan = 0;
        }
        (kail_mutex_unlock(&kpcf_ftLock));
        save = now;



        if (kpc_ftTryAgainLater) {
            ;


        } else {
            ;



        }
        (void)refreshResources(now - window, refFlags, NULL);
         kpc_fileThreadActive = 0;
        ;







        if ((lastStatUpdate + (1200)) < now) {
            lastStatUpdate = now;
            updateDhashStats();
            kpcf_pfcStats(0);
        }
        (kail_mutex_lock(&kpcf_ftLock));

        if (kpc_ftTrigger & 0x1) {
            pal_delay(1000);
        }
    }

    kpc_ftRunning = 0;
    (kail_wake_up(&kpcf_ftCV));
    (kail_mutex_unlock(&kpcf_ftLock));
}
void
kazn_kpcFileDirNotify(char *dirPath)
{
    int rc, retFlags = 0;
    pal_rawFid_t dirFid;
    kutil_q_t *qp, *qNext;
    fileRes_t *frp;
    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_DIR_NOTIFY, (((1)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(dirPath)),0) : 0);


    kail_atomic_add((int)(1),(void *)(&kpcFileStats.mkdirNotifies));
    rc = pal_LookupFidAndDir(dirPath, 0, &dirFid, NULL, NULL, &retFlags);
    if ((rc == 0) && (retFlags & 0x1)) {




        ;
        refreshResources(((pal_time_t)(kail_xtime->tv_sec)), 0x2, &dirFid);




        refreshNoFidResources(0);






        addDirFidToNegativeCache(&dirFid, NULL, 0);
    }
}
void
kazn_kpcFileRefreshNotify(kenv_envHandle_t accEnv)
{
    int c;
    uint g;
    char *bName, *tn;
    pal_rawFid_t *dir_rfp, *rfp;
    pal_fattr_t *fap;
    pal_time_t dt;
    fresList_t frl;
    fresNode_t *rn;






    tn = kenv_envGetTrappedName(accEnv, &c);
    rfp = kenv_envGetFidsAndFattrs(accEnv, &dir_rfp, &fap);

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_REFRESH_NOTIFY, (((1)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(((tn)? tn: "<?>"))),0) : 0);


    if (fap &&
        (((fap->ftype) == PAL_FTYPE_DIR) || (((fap->ftype) == PAL_FTYPE_LNK)))) {






        ;
        refreshNoFidResources(0);
        (kail_mutex_lock(&kpcf_ftLock));
        kpc_ftNoWindow = 1;
        (kail_mutex_unlock(&kpcf_ftLock));
        ;
    }

    if ((dir_rfp && kpcf_negCacheCheck(dir_rfp))) {

        return;
    }

    ;

    g = 0;
    if (rfp) {
        (void)dhashRefreshByFid(dir_rfp, rfp);
    } else if (dir_rfp && (bName = kenv_envGetBaseName(accEnv))) {
        do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (NULL); (&frl)->rFidp = (rfp); (&frl)->parFidp = (dir_rfp) ; } while ( 0);
        (void)dhashSearchName(bName, &frl, 0, &g, &dt);
        if (frl.count) {

            (kail_mutex_lock(&fileDbLock));
            for (rn = &((&frl)->node); rn; rn = rn->next) {







                (void)refreshFileRes(rn->resp, 0x1, 0);
            }
            (kail_mutex_unlock(&fileDbLock));
        }
        fresListClean(&frl);
    }
}
void
kazn_kpcFileCreateNotify(kenv_envHandle_t accEnv)
{
    int h, rc;
    pal_rawFid_t rfid, dir_rfid, *rfp, *dir_rfp;
    kenv_kpcInfo_t *kip;
    fileRes_t *resp;
    char *tn;





    ;
    tn = kenv_envGetTrappedName(accEnv, &h);
    rfp = kenv_envGetRawFid(accEnv);
    if (!tn || rfp) {
        return;
    }

    kip = kenv_envGetKPCInfo(accEnv);
    dir_rfp = kenv_envGetDirRawFid(accEnv);

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_KPC_CREATE_NOTIFY, (((1)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(tn)),0) : 0);


    if (kip && !(kip->kpcFlags & 0x2)) {

        (kail_mutex_lock(&fileDbLock));
        rc = kpcf_findResByResName(kip->resName, &resp, &h);
        if ((rc == 0) && resp) {
            (void)refreshFileRes(resp, 0x1|0x2, 0);
        }
        (kail_mutex_unlock(&fileDbLock));

    } else if (!kip && tn &&
        dir_rfp && (((((!memcmp((&(((dir_rfp)))->fid),(&(((&dh_nameMissDirFid)))->fid),((&(((dir_rfp)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((dir_rfp)))->fsid)->val[0] == (&(((&dh_nameMissDirFid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x100)) {

        if ((((kenv_env_t *)(accEnv))->tgt.fs.f.tgt_nd)) {
           ;
                rc = pal_LookupFidAndDir((char *)((((kenv_env_t *)(accEnv))->tgt.fs.f.tgt_nd)),
                                                0, &rfid, &dir_rfid, NULL, &h);
        }
        else {
           ;
        rc = pal_LookupFidAndDir(tn, 0, &rfid, &dir_rfid, NULL, &h);
        }
        ;



        ;
        (kail_mutex_lock(&fileDbLock));
        if ((rc == 0) && !strcmp(tn, dh_nameMiss) &&
            (((((!memcmp((&(((dir_rfp)))->fid),(&(((&dh_nameMissDirFid)))->fid),((&(((dir_rfp)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((dir_rfp)))->fsid)->val[0] == (&(((&dh_nameMissDirFid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x100)) {




            dh_createMissFid = rfid;
        }
        (kail_mutex_unlock(&fileDbLock));
        ;
    }
     ;
}
static int
findFidResources(fresList_t *frl)
{
    int sFlags, tFlags, refFlags, refreshed, maybeRemote, refreshes;
    uint gen;
    pal_time_t dirTime, checkTime;
    pal_rawFid_t *rFid, *parFid;
    parFid = frl->parFidp;
    if (parFid && kpcf_negCacheCheck(parFid)) {
        return 0;
    }

    rFid = frl->rFidp;
    maybeRemote = ((rFid)->fid.fid_flags & (0x1));







    checkTime = (parFid)? (pal_time_t)((parFid)->ctime): (pal_time_t)((rFid)->ctime);
    if ((checkTime > (pal_time_t)((rFid)->ctime)) && !maybeRemote) {
        checkTime = (pal_time_t)((rFid)->ctime);
    }

    gen = 0;
    dirTime = 0;
    sFlags = dhashSearchFids(frl, checkTime, &gen, &dirTime);

    if (!frl->count) {
        int hitDirs = (sFlags & 0x00004);
        if (parFid) {
            if ((sFlags & 0x00001)) {
                if (maybeRemote) {




                    checkTime = ((pal_time_t)(kail_xtime->tv_sec));
                }
                dhashRefresh(parFid, checkTime, &hitDirs, &dirTime);
            }
            checkTime = (pal_time_t)((parFid)->ctime);
            if (hitDirs && dirTime) {
                checkTime = dirTime;
            }
        }

        refFlags = 0x8;
        if (maybeRemote) {




            refFlags |= 0x4;
            if (!hitDirs) {





                checkTime = ((pal_time_t)(kail_xtime->tv_sec));
            }
        }

        refreshed = refreshResources(checkTime, refFlags, rFid);
        tFlags = 0x00001;
        refreshes = 0;







        while ((tFlags & 0x00001) &&
               (refreshes < 10)) {
            tFlags = dhashSearchFids(frl, 0, &gen, &dirTime);
            if (!(tFlags & 0x00002)) {
                sFlags = tFlags;
            }
            if (parFid) {
                if ((tFlags & 0x00001)) {
                    if (maybeRemote) {




                        checkTime = ((pal_time_t)(kail_xtime->tv_sec));
                    }
                    dhashRefresh(parFid, checkTime, &hitDirs, &dirTime);
                    refreshes++;
                    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_DHASH_REF_LOOP, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(refreshes), (long)tFlags),0) : 0);


                }
            } else {

                tFlags &= ~(0x00001);
            }
        }

        if (refreshes > 1) {
            char msg[128];
            if (refreshes == 10) {


                kail_sprintf((msg), ("dfid val %d insert flags 0x%x"), (*((int *)(&(&(parFid)->fid)->fid_ino))), (tFlags));

                pal_logErr(0x340b4011, msg);
            } else {
                kail_sprintf((msg), ("dfid val %d insert flags 0x%x"), (*((int *)(&(&(parFid)->fid)->fid_ino))), (tFlags));

                pal_logErr(0x340b4012, msg);
            }
        }

        if (!frl->count && parFid && !(sFlags & 0x00004)) {





            addDirFidToNegativeCache(parFid, NULL, gen);
        }
    }

    return sFlags;
}
static int
findFileResByBaseName(kenv_envHandle_t accEnv, fresList_t *frl)
{
    int count, retFlags, tFlags, refFlags;
    char *bName;
    pal_time_t checkTime, dirTime;
    uint gen;
    ;
    bName = kenv_envGetBaseName(accEnv);

    if (kpcf_negCacheCheck(frl->parFidp) || (bName == NULL)) {
        return 0;
    }

    gen = 0;
    checkTime = (pal_time_t)((frl->parFidp)->ctime);
    retFlags = dhashSearchName(bName, frl, checkTime, &gen, &dirTime);

    if (!frl->count) {
        if ((retFlags & 0x00004) && dirTime) {
            checkTime = dirTime;
        }

        refFlags = 0;
        if (((frl->parFidp)->fid.fid_flags & (0x1))) {




            refFlags = (0x4 | 0x8);
            if (!(retFlags & 0x00004)) {





                checkTime = ((pal_time_t)(kail_xtime->tv_sec));
            }
        }
        ;
        count = refreshResources(checkTime, refFlags, frl->parFidp);
        tFlags = dhashSearchName(bName, frl, 0, &gen, &dirTime);
        if (!(tFlags & 0x00002)) {
            retFlags = tFlags;
        }

        if (!frl->count) {
            if (frl->parFidp && !(retFlags & 0x00004))
                addDirFidToNegativeCache(frl->parFidp, NULL, gen);
        }
    }

    return retFlags;
}
static int
checkResByFid(kenv_envHandle_t accEnv, int action ,int eflags)
{
    int kpcFlags = 0;
    pal_rawFid_t *rfp;
    pal_fattr_t *fap;
    fresList_t frl;


    fap = kenv_envGetFattr(accEnv);
    rfp = kenv_envGetRawFid(accEnv);
    ;
    do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (fap); (&frl)->rFidp = (rfp); (&frl)->parFidp = (NULL) ; } while ( 0);

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_CHECK_FID_ONLY, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(*((int *)(&(&(rfp)->fid)->fid_ino))), (long)fap->ftype, (long)fap->mode, (long)fap->attrFlags),0) : 0);





    if (kpcf_findFidByFidOnly(&frl)) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.directHits));
        kpcFlags |= (0x1 | 0x100);
        kpcFlags = kpcf_addResourcesToKPCInfo(&frl, accEnv,
                                              kpcFlags, action, eflags);
    }
    fresListClean(&frl);

    return kpcFlags;
}
static int
checkResSpecial(kenv_envHandle_t accEnv, int action ,int eflags)
{
    int kpcFlags;
    fileRes_t *resp = NULL;
    pal_fattr_t *fap;
    fresList_t frl;


    kpcFlags = 0;
    do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (kenv_envGetFattr(accEnv)); (&frl)->rFidp = (NULL); (&frl)->parFidp = (NULL) ; } while ( 0);
    if (eflags & 0x4) {
        if ((exceptionFind((&frl), 0x2 | (0)) & 0x8)) {
            kpcFlags = 0x4;
        }
    } else if (eflags & 0x2) {
        if (resp = kpcGetUnixRes()) {
            fresListAdd(&frl, resp);
        }
    }

    if (frl.count) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.directHits));
        kpcFlags |= (0x1 | 0x100);
        kpcFlags = kpcf_addResourcesToKPCInfo(&frl, accEnv,
                                              kpcFlags, action, eflags);
    }
    fresListClean(&frl);

    return kpcFlags;
}
static int
checkResName(kenv_envHandle_t accEnv, int action, pal_rawFid_t *dir_rfp)
{
    int kpcFlags, c, dhFlags;
    fresList_t frl;
    char *tn;


    ;
    kpcFlags = 0;
    tn = kenv_envGetTrappedName(accEnv, &c);
    do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (tn); (&frl)->fap = (NULL); (&frl)->rFidp = (NULL); (&frl)->parFidp = (dir_rfp) ; } while ( 0);
    dhFlags = findFileResByBaseName(accEnv, &frl);
    if (frl.count) {
        kpcFlags = (0x40 | 0x1);
        if (dhFlags & 0x00020) {
            kpcFlags |= 0x100;
        }
        kpcFlags = kpcf_addResourcesToKPCInfo(&frl, accEnv,
                                              kpcFlags, action, 0);
    }
    fresListClean(&frl);

    return kpcFlags;
}
static int
checkResPath(kenv_envHandle_t accEnv, pal_rawFid_t *dir_rfp)
{
    int i, pfcHit, kpcFlags, numFids, numCurFids, startFid=0;
    uint32_t changeGen;
    pal_rawFid_t *curFid, *parentFid;
    fileRes_t *resp;
    fresList_t frl;





    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event0((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_CHECKPATH, (((0)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16))),0) : 0);
    kpcFlags = 0;
    changeGen = kpcf_changeGen;

    if (dir_rfp && (pfcHit = kpcf_pfcCheck(dir_rfp, &resp))) {
        if (resp == NULL) {

            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_CKPATH_FAST_RTN, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(0)),0) : 0);

        } else {

            kail_atomic_add((int)(1),(void *)(&kpcFileStats.inheritHits));
            kpcFlags = 0x2;
            kpcfSetupKpcInfo(accEnv, resp, kpcFlags, NULL);
            if (!(resp->rflags.hasAcl || resp->rflags.isWC)) {



                startFid = 1;
            }
            releFileResource(resp);
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_CKPATH_FAST_RTN, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(1)),0) : 0);

        }
        if (startFid == 0) {

            goto cpOut;
        }
    }

    do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (NULL); (&frl)->rFidp = (NULL); (&frl)->parFidp = (NULL) ; } while ( 0);
    curFid = kenv_envBuildPathFids(accEnv, &numFids);
    if (startFid) {
        curFid++;
    }
    numCurFids = numFids - 1;
    for (i = startFid; i < numFids; i++, curFid++) {
        if (i < numCurFids) {
            parentFid = curFid + 1;
            if (kpcf_negCacheCheck(parentFid)) {
                continue;
            }
        } else {

            if (((numFids == 1) && kpcRootDirResource) || kpcFileInheritRoot) {






                parentFid = NULL;
            } else {
                break;
            }
        }
        ;
        do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (NULL); (&frl)->rFidp = (curFid); (&frl)->parFidp = (parentFid) ; } while ( 0);
        (void)findFidResources(&frl);
        if (frl.count) {
            if (frl.frlFlags & (0x1 | 0x2)) {
                break;
            } else {
                if (frl.frlFlags & (0x10 | 0x40)) {
                    kail_atomic_add((int)(1),(void *)(&kpcFileStats.inheritHits));
                    kpcFlags = 0x2;
                    kpcFlags = kpcf_addResourcesToKPCInfo(&frl, accEnv,
                                                          kpcFlags, 0, 0);
                    if ((frl.count == 1) && (numFids > 1)) {
                        kpcf_pfcAdd(dir_rfp, (&((&frl)->node))->resp,
                                    changeGen);
                    }
                }
                fresListClean(&frl);
                do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (NULL); (&frl)->rFidp = (curFid); (&frl)->parFidp = (parentFid) ; } while ( 0);
            }
        }
    }

    if (frl.count == 0) {
        if (dir_rfp) {


            if ( (numFids > 2) || !kpcRootDirResource) {
                (void)kpcf_pfcAdd(dir_rfp, NULL, changeGen);
            }
        }
    } else {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.inheritHits));
        kpcFlags = 0x2;




        kpcFlags = kpcf_addResourcesToKPCInfo(&frl, accEnv, kpcFlags, 0, 0);


        if ((frl.count == 1) && (numFids > 1)) {
            kpcf_pfcAdd(dir_rfp, (&((&frl)->node))->resp, changeGen);
        }
    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_CKPATH_RTN, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(frl.count), (long)numFids),0) : 0);

    fresListClean(&frl);

  cpOut:
    return kpcFlags;
}
static int
checkResLeaf(
    kenv_envHandle_t accEnv,
    int action,
    int eflags,
    pal_rawFid_t *rfp,
    pal_rawFid_t *dir_rfp,
    pal_fattr_t *fap)
{
    int kpcFlags=0, ncHit=0, l, dhFlags=0;
    fresList_t frl;
    char *tn;



    do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (fap); (&frl)->rFidp = (rfp); (&frl)->parFidp = (dir_rfp) ; } while ( 0);
    if (dir_rfp) {
        if (ncHit = kpcf_negCacheCheck(dir_rfp)) {




            if (fap && (fap->links <= 1) && ((fap->ftype) == PAL_FTYPE_FILE)) {
                goto quickout;
            } else if (!fap || ((fap->ftype) == PAL_FTYPE_DIR)) {
                goto quickout;
            }
        }
    }

    tn = kenv_envGetTrappedName(accEnv, &l);

    frl.nameHint = tn;

    if (!ncHit) {
        dhFlags = findFidResources(&frl);
    }

    if (frl.count) {
        if ((frl.count == 1) && (dhFlags & 0x20000)) {


            fresListClean(&frl);
        } else {
            kpcFlags |= 0x20;






            if (dhFlags & (0x00020|0x00080)) {
                kpcFlags |= 0x100;
            }

            if (fap && (fap->links > 1) && ((fap->ftype) == PAL_FTYPE_FILE)) {

                kpcFlags |= 0x10;
            }
        }
    } else if (fap) {




        if ((((fap->ftype) == PAL_FTYPE_BLKDEV) || ((fap->ftype) == PAL_FTYPE_CHARDEV) || ((fap->ftype) == PAL_FTYPE_MPC)) &&
            !(action & (0x10000 | 0x100000))) {
            if ((exceptionFind((&frl), 0x2 | (0)) & 0x8)) {
                kpcFlags |= (0x4 | 0x100);
            }
        }

        if ((fap->links > 1) && ((fap->ftype) == PAL_FTYPE_FILE)) {
            if ((exceptionFind((&frl), 0x1) & 0x8)) {

                kpcFlags |= (0x10 | 0x100);
            }
        }
    }

    if (frl.count) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.directHits));
        kpcFlags |= 0x1;

        kpcFlags = kpcf_addResourcesToKPCInfo(&frl, accEnv,
                                              kpcFlags, action, eflags);
    }
    fresListClean(&frl);
 quickout:
    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_EXIT_CHECK_LEAF, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(kpcFlags), (long)frl.count, (long)ncHit),0) : 0);


    return kpcFlags;
}
kazn_kpcFileCheckResource(kenv_envHandle_t accEnv, int action, int eflags)
{

    int retFlags, hitRes, kpcFlags, checkPath, doTrace, len;
    pal_rawFid_t *rfp, *dir_rfp;
    pal_fattr_t *fap;
    char *trName;

    kail_atomic_add((int)(1),(void *)(&kpcFileStats.resChecks));
    rfp = kenv_envGetFidsAndFattrs(accEnv, &dir_rfp, &fap);

    doTrace = 0;
    if ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active)) {
        doTrace = 1;
        if ((trName = kenv_envGetTrappedName(accEnv, &len)) == NULL) {
            trName = "UK";
        }
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_CFR, (((1)<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((2)<<16)), (long)(trName), (long)eflags, (long)rfp, (long)((fap)? fap->ftype: 9999)),0) : 0);




    }

    checkPath = 1;
    hitRes = 0;
    kpcFlags = 0;


    if (rfp) {
        if (fap && (fap->attrFlags & 0x2)) {
            kpcFlags = checkResByFid(accEnv, action, eflags);
        } else if (fap &&
            ((fap->ftype) == PAL_FTYPE_DIR) && kpcf_pfcCheckNoAcl(rfp)) {

            checkPath = 0;
        } else {
            kpcFlags = checkResLeaf(accEnv, action, eflags, rfp, dir_rfp, fap);
        }
    } else {
        if ((action & 0x8000) && dir_rfp &&
            kenv_envGetTrappedName(accEnv, &len)) {
            kpcFlags = checkResName(accEnv, action, dir_rfp);
        } else {
            kpcFlags = checkResSpecial(accEnv, action, eflags);
        }
    }

    if (kpcFlags & 0x1) {
        hitRes = 1;
        if ((kpcFlags & (0x80 | 0x100)) == (0x80 | 0x100)) {

            checkPath = 0;
        }
    }

    if (checkPath && !(eflags & 0x10)) {
        if (retFlags = checkResPath(accEnv, dir_rfp)) {
            kpcFlags |= retFlags;
            hitRes = 1;
        }
    }

    if (hitRes) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.resCheckHits));
        if (doTrace) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_CFR_HIT, (((1)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(trName), (long)eflags, (long)kpcFlags, (long)kpcFileStats.resCheckHits),0) : 0);




        }
    } else {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event0((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_CFR_MISS, (((0)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16))),0) : 0);
    }

    return hitRes;
}
char *
kazn_kpcFileFindPgmResource(kenv_envHandle_t accEnv, kpc_resFlags_t *resFlags)
{
    pal_rawFid_t *rfp, *drfp;
    pal_fattr_t *fap;
    fresList_t frl;
    fresNode_t *rn;
    char *pgmRes = NULL, *pgmSRN;




    if ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active)) {
        pgmSRN = kenv_envGetProgram(accEnv);
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_FIND_PGM_KPON, (((1)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(pgmSRN)),0) : 0);

    }

    if (!(pgmRes = kenv_envGetPgmResource(accEnv))) {
        if (rfp = kenv_envGetPgmFidAndDirFid(accEnv, &drfp, &fap)) {
            do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (fap); (&frl)->rFidp = (rfp); (&frl)->parFidp = (drfp) ; } while ( 0);
            if (fap->links > 1) {
                pgmSRN = kenv_envGetProgram(accEnv);
                frl.bName = kutil_pathExtractBaseName(pgmSRN);
                if (frl.bName) {
                    frl.bNameLen = strlen(frl.bName);
                }
            }

            ;
            (void)findFidResources(&frl);
            if (frl.count) {
                if (frl.count == 1) {
                    rn = &((&frl)->node);
                    pgmRes = kenv_envSetPgmResource(accEnv, rn->resp->resName,
                                                    rn->resp->resNameLen);
                    *resFlags = rn->resp->rflags;
                } else {




                    pgmSRN = kenv_envGetProgram(accEnv);
                    for (rn = &((&frl)->node); rn; rn = rn->next) {
                        if (!strcmp(pgmSRN, rn->resp->resName)) {
                            pgmRes = kenv_envSetPgmResource(accEnv,
                                                        rn->resp->resName,
                                                        rn->resp->resNameLen);
                            break;
                        }
                    }
                    if (!pgmRes) {
                        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(frl.count)),0) : 0);


                    }
                }
            }
            fresListClean(&frl);
        }
    }

    if (pgmRes) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_FIND_PGM_KPON_FOUND, (((1)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(pgmRes), (long)(*((int *)resFlags))),0) : 0);


    } else {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event0((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_FIND_PGM_KPON_NONE, (((0)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16))),0) : 0);
    }

    return pgmRes;
}
char *
kazn_kpcFileFindTerminal(
    kenv_envHandle_t accEnv,
    int *extDataLen,
    byte_t **extData)
{
    pal_dev_t *dev;
    pal_fattr_t fa;
    char *localTerm = NULL;
    fresList_t frl;
    fresNode_t *rn;

    dev = kenv_envGetTermDev(accEnv);
    if (dev) {
        fa.dev = *dev;
        do { (&frl)->count = (&frl)->frlFlags = 0; (&frl)->node.next = NULL; (&frl)->bName = NULL; (&frl)->nameHint = (NULL); (&frl)->fap = (&fa); (&frl)->rFidp = (NULL); (&frl)->parFidp = (NULL) ; } while ( 0);
        if ((exceptionFind((&frl), 0x2 | (0x4)) & 0x8)) {
            rn = &((&frl)->node);
            (kail_mutex_lock(&(rn->resp)->rLock));
            localTerm = kenv_envSetLocalTermName(accEnv, rn->resp->resName);
            if (localTerm) {
                *extDataLen = 0;
                if (rn->resp->extDataLen) {
                    *extData = kenv_envSetTermExtData(accEnv,
                                                      rn->resp->extDataLen,
                                                      rn->resp->extData);
                    if (*extData) {
                        *extDataLen = rn->resp->extDataLen;
                    }
                }

                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_HIT_LOCALTERM, (((1)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(localTerm), (long)*extDataLen),0) : 0);


            }
            (kail_mutex_unlock(&(rn->resp)->rLock));
        }
        fresListClean(&frl);
    }
    return localTerm;
}
int
kazn_kpcFileAddResource(kpc_resourceInfo_t *rip)
{
    fileRes_t *newFresp, *fresp;
    pal_rawFid_t rfid;
    int nh, rnLen, doProcUpdate=0, rc=0, didAdd=0, didUpdate=0, refCode;
    kenv_procFlags_t pflags;







    if (kpcShuttingDown) {
        return ENOSYS;
    }

    kail_atomic_add((int)(1),(void *)(&kpcf_adminGen));

    rnLen = strlen(rip->resourceName);

    if (!(newFresp = getFileResource())) {
        rc = ENOMEM;
        goto out;
    }

    newFresp->rflags = rip->flags;
    newFresp->epoch = _kpcFilePendingEpoch;
    newFresp->branchId = rip->branchId;
    rc = kutil_setStringWithLocal(rip->resourceName, &rnLen,
                                  newFresp->_lclSpace,
                                  sizeof(newFresp->_lclSpace),
                                  &newFresp->resName);
    if (rc) {
        goto out;
    }
    newFresp->resNameLen = rnLen;

    if (rip->extDataLen && rip->extData) {
        ;
        newFresp->extData = pal_alloc(rip->extDataLen);
        if (newFresp->extData) {
            memcpy(newFresp->extData,rip->extData,rip->extDataLen);
            newFresp->extDataLen = rip->extDataLen;
        } else {
            rc = ENOMEM;
            goto out;
        }
    }

    (kail_mutex_lock(&fileDbLock));
    rc = kpcf_findResByResName(rip->resourceName, &fresp, &nh);
    if (rc) {
        (kail_mutex_unlock(&fileDbLock));
        goto out;
    }

    if (!fresp) {
        fresp = newFresp;
        kpcf_nameHashInsert(fresp, nh);
        didAdd = 1;
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.resAdds));

        memset(&dh_createMissFid,0,sizeof(dh_createMissFid));
        *dh_nameMiss = '\0';
    } else {
        didUpdate = 1;
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.resUpdates));

        (kail_mutex_lock(&(fresp)->rLock));



        if ((fresp->rflags.isLoginPgm != rip->flags.isLoginPgm) ||
            (fresp->rflags.isPrivPgm != rip->flags.isPrivPgm) ||
            (fresp->rflags.isImpersonator != rip->flags.isImpersonator) ||
            (fresp->rflags.isImSurPgm != rip->flags.isImSurPgm)) {
            doProcUpdate = 1;
        }

        fresp->rflags = rip->flags;
        fresp->epoch = _kpcFilePendingEpoch;

        fresp->branchId = rip->branchId;





        if (fresp->extDataLen && fresp->extData) {
            pal_free(fresp->extData, fresp->extDataLen);
            fresp->extData = NULL; fresp->extDataLen = 0;
        }
        if (newFresp->extDataLen && newFresp->extData) {
            fresp->extData = newFresp->extData;
            fresp->extDataLen = newFresp->extDataLen;
            newFresp->extData = NULL; newFresp->extDataLen = 0;
        }
        (kail_mutex_unlock(&(fresp)->rLock));
    }

    if (rc == 0) {





        refCode = refreshFileRes(fresp, 0x1|0x2, 0);
        if (refCode && refCode != EACCES) {
            char *msg = pal_alloc(4096);
            if (msg) {
                kail_sprintf((msg), ("<%s> errno %d"), (fresp->resName), (refCode));

                pal_logErr(0x340b4008, msg);
                pal_free(msg, 4096);
            }
        }

        if (strcmp(fresp->resName, "/unix") == 0) {
            kpcSetUnixRes(fresp->rflags);
        }

        if (((fresp)->intFlags & 0x1)) {
            if ((rip->flags.isLoginPgm || rip->flags.isPrivPgm ||
                 rip->flags.isImpersonator || rip->flags.isImSurPgm)) {
                rfid = fresp->rfid;
                doProcUpdate = 1;
            }
        } else if (doProcUpdate) {

            doProcUpdate = 0;
        }
    }
    (kail_mutex_unlock(&fileDbLock));

  out:
    if (didAdd == 0 || rc) {
        if (newFresp) {
            freeFileResource(newFresp);
        }
    }

    if (rc == 0) {

        if (rip->flags.isRootDir) {
            kpcRootDirResource = 1;
        }

        if (doProcUpdate) {
            pflags = 0;
            if (rip->flags.isLoginPgm)
                pflags |= 0x4;
            if (rip->flags.isImpersonator)
                pflags |= 0x8;
            if (rip->flags.isPrivPgm)
                pflags |= 0x2;
            if (rip->flags.isImSurPgm)
                pflags |= 0x00100000;



            kenv_procAddProcFlagsByName(rip->resourceName, &rfid, pflags,
                                        1);
        }

        if (didAdd) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KAZN_KPCF_ADD, (((1)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(rip->resourceName), (long)(*((int *)&rip->flags)), (long)rip->extDataLen, (long)(kpcFileStats.resAdds - kpcFileStats.resDeletes)),0) : 0);





        } else {
            ;
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KAZN_KPCF_UPDATE, (((1)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(rip->resourceName), (long)(*((int *)&rip->flags)), (long)rip->extDataLen, (long)(kpcFileStats.resAdds - kpcFileStats.resDeletes)),0) : 0);





        }
    }





    kail_atomic_add((int)(1),(void *)(&kpcf_adminGen));
    kail_atomic_add((int)(1),(void *)(&kpcf_changeGen));
    return rc;
}
int
kazn_kpcFileDelResource(kpc_resourceInfo_t *rip)
{
    fileRes_t *frp;
    int rc, h, rootres=0;






    if (!rip) {
        return EINVAL;
    }

    (kail_mutex_lock(&fileDbLock));
    rc = kpcf_findResByResName(rip->resourceName, &frp, &h);
    if (frp && (rc == 0)) {
        if (frp->rflags.isRootDir) {
            rootres = 1;
        }
        if (((frp)->intFlags & 0x1)) {
            if ((frp->rflags.isLoginPgm != rip->flags.isLoginPgm) ||
                (frp->rflags.isPrivPgm != rip->flags.isPrivPgm) ||
                (frp->rflags.isImpersonator != rip->flags.isImpersonator) ||
                (frp->rflags.isImSurPgm != rip->flags.isImSurPgm)) {
                kenv_procAddProcFlagsByName(rip->resourceName, &frp->rfid, 0,
                                            1);
            }
        }
        if (! removeFileResource(frp)) {
           ;

           frp = NULL;
        }
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.resDeletes));
    }
    (kail_mutex_unlock(&fileDbLock));
    kail_atomic_add((int)(1),(void *)(&kpcf_adminGen));

    if (frp && (rc == 0)) {

        if (rootres) {
            kpcRootDirResource = 0;
        }
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KAZN_KPCF_DEL, (((1)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(rip->resourceName)),0) : 0);

    }

    return rc;
}
static void
kpcfAddImmunePrograms(void)
{
    char **nptr;
    int rc, h, len, didAdd;
    fileRes_t *frp;


    ;

    for (nptr = pal_immunePrograms; nptr && *nptr; nptr++) {
        didAdd = 0;
        rc = kpcf_findResByResName(*nptr, &frp, &h);
        if (frp && (rc == 0)) {
            (void)refreshFileRes(frp, 0x1, 0);
            kail_atomic_add((int)(1),(void *)(&kpcFileStats.resUpdates));
        } else if (rc == 0) {
            if (frp = getFileResource()) {
                len = 0;
                rc = kutil_setStringWithLocal(*nptr, &len, frp->_lclSpace,
                                              sizeof(frp->_lclSpace),
                                              &frp->resName);
                if (rc == 0) {
                    frp->resNameLen = len;
                    didAdd = 1;
                    kpcf_nameHashInsert(frp, h);
                    kail_atomic_add((int)(1),(void *)(&kpcFileStats.resAdds));
                    (void)refreshFileRes(frp, 0x1, 0);
                } else {
                    freeFileResource(frp);
                    frp = NULL;
                }
            }
        }

        if (frp && (rc == 0)) {
            frp->epoch = _kpcFilePendingEpoch;
            frp->rflags.isPrivPgm = 1;
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[1], ((didAdd)? KT_TRACE_KPCF_ADD_IMMUNE: KT_TRACE_KPCF_UPDATE_IMMUNE), (((1)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(frp->resName)),0) : 0);




            if (((frp)->intFlags & 0x1)) {

                (void)kenv_procAddProcFlagsByName(frp->resName,
                    &frp->rfid, (0x2 | 0x1), 0);
            }
        }
    }




}
static void
kpcfAddDefaultTermDevices(void)
{
    char **nptr;
    int rc, h, len, didAdd;
    fileRes_t *frp;
    static char *kpc_defaultLocalTermList[] = {
        "/dev/console",
        "/dev/tty0",
        "/dev/tty1",
        NULL
    };


    ;
    for (nptr = kpc_defaultLocalTermList; nptr && *nptr; nptr++) {
        didAdd = 0;
        rc = kpcf_findResByResName(*nptr, &frp, &h);
        if (frp && (rc == 0)) {
            (void)refreshFileRes(frp, 0x1, 0);
            kail_atomic_add((int)(1),(void *)(&kpcFileStats.resUpdates));
        } else if (rc == 0) {
            if (frp = getFileResource()) {
                len = 0;
                rc = kutil_setStringWithLocal(*nptr, &len, frp->_lclSpace,
                                              sizeof(frp->_lclSpace),
                                              &frp->resName);
                if (rc == 0) {
                    frp->resNameLen = len;
                    didAdd = 1;
                    kpcf_nameHashInsert(frp, h);
                    kail_atomic_add((int)(1),(void *)(&kpcFileStats.resAdds));
                    (void)refreshFileRes(frp, 0x1, 0);
                } else {
                    freeFileResource(frp);
                    frp = NULL;
                }
            }
        }

        if (frp && (rc == 0)) {
            frp->epoch = _kpcFilePendingEpoch;
            frp->rflags.isTerminal = 1;
        }
    }
}
void
kazn_kpcFileEpochNotify(int64_t e, int commit)
{
    int doRefresh = 0;
    int64_t ke;
    fileRes_t *fresp;
    kutil_q_t *qp, *next;





    (kail_mutex_lock(&fileDbLock));
    ke = _kpcFileEpoch;
    if (commit) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KPCF_EPOCH_NOT_COMMIT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)((e >> 32) & 0x0ffffffff)), (long)(int)(e & 0x0ffffffff), (long)(int)((ke >> 32) & 0x0ffffffff), (long)(int)(ke & 0x0ffffffff)),0) : 0);





        kpcfAddImmunePrograms();
        kpcfAddDefaultTermDevices();
        _kpcFileEpoch = (uint32_t)e;
        doRefresh = 1;
    } else {
        _kpcFilePendingEpoch = (uint32_t)e;
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KPCF_EPOCH_NOT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)((e >> 32) & 0x0ffffffff)), (long)(int)(e & 0x0ffffffff), (long)(int)((ke >> 32) & 0x0ffffffff), (long)(int)(ke & 0x0ffffffff)),0) : 0);




    }

    if (doRefresh) {
        for (qp = (((kutil_q_t *)&kpcf_refreshQ)->prev); ((qp) != &kpcf_refreshQ); qp = next) {
            next = ((qp)->prev);
            fresp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, refreshQ)));
            if ((fresp->epoch < _kpcFileEpoch) && !((fresp)->intFlags & 0x200)) {

                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_EPOCH_DEL, (((1)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(fresp->resName), (long)(int)_kpcFileEpoch, (long)(int)fresp->epoch),0) : 0);



                removeFileResource(fresp);
                kail_atomic_add((int)(1),(void *)(&kpcFileStats.epochRemoves));
            }
        }
    }
    (kail_mutex_unlock(&fileDbLock));

    if (!commit) {





        pal_delay(1000);
    }


    kail_atomic_add((int)(1),(void *)(&kpcf_changeGen));
    kail_atomic_add((int)(1),(void *)(&kpcf_adminGen));
}
int
kazn_kpcfRunAsync(void)
{
    int rc = EEXIST;


    if (!kpc_ftRunning) {
        kpcFileThread(NULL);
        rc = 0;
    }
    return rc;
}
void
kazn_kpcfStopAsync(void)
{
    (kail_mutex_lock(&kpcf_ftLock));
    kpc_ftShutdown = 1;
    (kail_wake_up(&kpcf_ftCV));

    while (kpc_ftRunning) {
        (kail_cond_wait(&kpcf_ftCV,&kpcf_ftLock));
    }
    kpc_ftShutdown = 0;
    (kail_mutex_unlock(&kpcf_ftLock));
}
void
kazn_kpcfTriggerAsyncRefresh(int flags)
{
    pal_time_t now;
    (kail_mutex_lock(&kpcf_ftLock));
    ;

    if (flags & 0x1) {
        if (!kpcf_startScan) {
            kpc_ftTrigger = 0x1|0x8;
        }




        now = ((pal_time_t)(kail_xtime->tv_sec));
        kpcf_startScan = now + 2;
    } else {
        kpc_ftTrigger = 0x1;
    }

    kpc_ftNoWindow = 1;

    if (kpc_ftTrigger) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KPCF_TRIG_REF, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(flags), (long)kpc_ftTrigger, (long)kpc_ftNoWindow, (long)kpc_ftSleeping),0) : 0);


    } else {

        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) ? (kt_Event1((kt_chanID_t)&kt_defChannels[0], KT_TRACE_KPCF_SCAN_TIME, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)kpcf_startScan)),0) : 0);

    }

    (kail_mutex_unlock(&kpcf_ftLock));
    if (kpc_ftSleeping) {
        ;

        (kail_wake_up(&kpcf_ftCV));
    } else {
        ;


    }
}
void
kazn_kpcFileInit(void)
{
    int i, j;
    pal_time_t now;




    kpcf_subrInit();

    (kail_cond_init(&kpcf_ftCV));
    (kail_mutex_init(&kpcf_ftLock));

    ((&exceptionQ)->next = (&exceptionQ)->prev = (&exceptionQ));
    ((&excNoFidQ)->next = (&excNoFidQ)->prev = (&excNoFidQ));

    kpcf_asyncLUInit();


    pal_delay(1100);
    now = ((pal_time_t)(kail_xtime->tv_sec));
    for (i = 0; i < 907; i++) {
        for (j = 0; j < 8; j++) {
            ((&dirFidHashQ[i].dfQ[j])->next = (&dirFidHashQ[i].dfQ[j])->prev = (&dirFidHashQ[i].dfQ[j]));
        }
        (kail_mutex_init(&dirFidHashQ[i].hlock));
        dirFidHashQ[i].genNo = 1;
        dirFidHashQ[i].leastRefreshTime = now;
    }

    kpcInitUnixRes();


    if(pal_kthreadCreate(kpcFileThread, NULL, "KPCF")) {
        kt_logString(0,"failed to spawn background KPC file thread");
    }


    (kail_mutex_lock(&fileDbLock));
    kpcfAddImmunePrograms();
    kpcfAddDefaultTermDevices();
    (kail_mutex_unlock(&fileDbLock));
}
void
kazn_kpcFileShutdown(void)
{




    (kail_mutex_lock(&kpcf_ftLock));
    kpc_ftShutdown = 1;
    (kail_mutex_unlock(&kpcf_ftLock));
    (kail_wake_up(&kpcf_ftCV));

    (kail_mutex_lock(&fileDbLock));
    kpcShuttingDown = 1;
    freeAllResources();
    (kail_mutex_unlock(&fileDbLock));

    kpcf_subrShutdown();
    kpcf_asyncLUFini();


    (kail_mutex_lock(&kpcf_ftLock));
    while (kpc_ftRunning) {
        (kail_cond_wait(&kpcf_ftCV,&kpcf_ftLock));
    }
    (kail_mutex_unlock(&kpcf_ftLock));
}
