
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)44	1.40  src/oss/kazn/kazn/kazn_kpcnw.c, oss.kazn.src, oss600, 050722a  7/15/05  16:16:27";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));

extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));

extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );




struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;
        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#ifdef LINUX_RHEL4
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
struct sockaddr {
        unsigned short sa_family;
        char sa_data[14];
} ;
struct in_addr {
        uint s_addr;
};

struct sockaddr_in {
  unsigned short sin_family;
  unsigned short int sin_port;
  struct in_addr sin_addr;


  unsigned char __pad[16 - sizeof(short int) -
                        sizeof(unsigned short int) - sizeof(struct in_addr)];
};
struct in6_addr
{
        union
        {
                unsigned char u6_addr8[16];
                unsigned short u6_addr16[8];
                unsigned int u6_addr32[4];
        } in6_u;



};
struct sockaddr_in6 {
        unsigned short int sin6_family;
        unsigned short sin6_port;
        unsigned int sin6_flowinfo;
        struct in6_addr sin6_addr;
        unsigned int sin6_scope_id;
};


typedef struct sockaddr pal_sockaddr_t;
#include <asm/string.h>
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void * kenv_pathReqHandle_t;







typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef void (*kpc_res_rele_func_t)(void *);
typedef struct kpcInfo {
    struct kpcInfo *next;
    struct kpcInfo *prev;
    char *resName;
    kpc_resFlags_t resFlags;
    uint32_t kpcFlags;
    uint32_t branchId;
    byte_t *extData;
    uint16_t resNameLen;
    uint16_t extDataLen;
    union {
        struct __f {
            pal_rawFid_t *poFid;
            pal_ftypes_t poFtype;
            int32_t kpcFileAddGen;
            pal_rawFid_t __poFid;
        } f;
        struct __nw {
            int64_t policyVersion;
            pal_ptr32_t pUserRes;
            void *pRes;
            kpc_res_rele_func_t relef;
        } nw;
    } resData;

    char __resName[48];
} kenv_kpcInfo_t;
typedef struct filetgt {
    char *trappedNameRef;
    char *baseName;
    pal_pathBuf_t *fullSrnRef;
    pal_rawFid_t *dir_rfidp;
    pal_rawFid_t *pathFids;
    pal_vnodeH_t dir_vnh;
    pal_vnodeH_t vnh;
    struct filetgt *auxFile;
    int tnLen;
    int pathFidsCount;
    int pathFidsAlloced;
    pal_rawFid_t rfid;
    pal_fattr_t fattrs;
    pal_pid_t killPid;


    void *tgt_nd;
    void *aux_tgt_nd;


    pal_rawFid_t _fids[5];
} kenv_fileTgt_t;






typedef struct pgmInfo {
    kenv_procFlags_t procFlags;
    char *pgmSRN;
    char *pgmKPON;
    pal_rawFid_t pgmFid;
    pal_rawFid_t pgmDFid;
    pal_fattr_t pgmFattrs;
    struct pgmInfo *saveArea;
    int16_t __srnLen;
    int16_t __kponLen;
    char __srn[32];
    char __kpon[32];
} pgmInfo_t;
typedef void * kenv_envHandle_t;

typedef struct kenv_env {
    int magic;
    uint32_t flags;
    pal_pid_t pid;
    int envError;



    union {



        struct {
            kenv_fileTgt_t f;
            pal_idSet_t idSet;
            pal_dev_t termDev;
            char *localTermName;
            pal_nwAddr_t nwTermAddr;
            byte_t *termExtData;
            int termExtDataLen;
        } fs;



        struct {
            pal_nwAddr_t addrRemote;
            pal_nwAddr_t addrLocal;
        } nw;
    } tgt;




    pal_idList_t idList;




    pgmInfo_t accPgm;




    int kpcInfoCount;
    kenv_kpcInfo_t *kpcInfoHead;
    kenv_kpcInfo_t *curKPCInfo;
    kenv_kpcInfo_t _kpcInfo;



    void *auxDatap1;
} kenv_env_t;
extern pal_authID_t kenv_envGetAuthID(kenv_envHandle_t);
extern pal_idList_t *kenv_envGetIdListRef(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetPathFids(kenv_envHandle_t, int *);
extern void kenv_envSetPathFids(kenv_envHandle_t, int, pal_rawFid_t *);
extern void kenv_envSetRfid(kenv_envHandle_t, pal_rawFid_t *, pal_fattr_t *);
extern void kenv_envSetFattr(kenv_envHandle_t, pal_fattr_t *);
extern pal_fattr_t *kenv_envGetFattr(kenv_envHandle_t);
extern void kenv_envSetKPCInfo(kenv_envHandle_t , kenv_kpcInfo_t *);
extern kenv_kpcInfo_t * kenv_envGetKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfo(kenv_envHandle_t);
extern void kenv_envSetNextKPCInfo(kenv_envHandle_t);
extern void kenv_envSetFirstKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfoResName(kenv_envHandle_t,
                                        kenv_kpcInfo_t *, char *, int);
extern char * kenv_envGetProgram(kenv_envHandle_t);
extern pal_rawFid_t *
        kenv_envGetPgmFidAndDirFid(kenv_envHandle_t,
                                   pal_rawFid_t **, pal_fattr_t **);
extern char *kenv_envSetPgmResource(kenv_envHandle_t, char *, int);
extern char *kenv_envGetPgmResource(kenv_envHandle_t);
extern void kenv_envSetAuxFileActive(kenv_envHandle_t, int);
extern char *kenv_envGetTrappedName(kenv_envHandle_t, int *);
extern char *kenv_envGetBaseName(kenv_envHandle_t);
extern void kenv_envSetImpProcAccId(kenv_envHandle_t, pal_authID_t);
extern void kenv_envProgramExecUpdate(kenv_envHandle_t);
extern void kenv_envSaveProgramState(kenv_envHandle_t);
extern void kenv_envRestoreProgramState(kenv_envHandle_t);
extern void kenv_envTrackOpenFd(kenv_envHandle_t, int, int);
extern int kenv_envGetFdInfo(kenv_envHandle_t, int);
extern void kenv_envGetTerminals(kenv_envHandle_t,
                                 pal_dev_t **, pal_nwAddr_t **);
extern pal_dev_t *kenv_envGetTermDev(kenv_envHandle_t);
extern char *kenv_envSetLocalTermName(kenv_envHandle_t, char *);
extern byte_t *kenv_envSetTermExtData(kenv_envHandle_t, int, byte_t *);
extern byte_t *kenv_envGetTermExtData(kenv_envHandle_t, int *);
extern pal_nwAddr_t *kenv_envGetNWTerm(kenv_envHandle_t);
extern void kenv_envResetTargetData(kenv_envHandle_t, int);
extern char *kenv_envFdToBname(kenv_envHandle_t);
extern pal_pathBuf_t *kenv_envGetFullSrnRef(kenv_envHandle_t);
extern void kenv_envSetFullSrnRef(kenv_envHandle_t, pal_pathBuf_t *);
extern pal_rawFid_t *kenv_envBuildPathFids(kenv_envHandle_t, int *);
extern pal_rawFid_t *kenv_envGetDirRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetFidsAndFattrs(kenv_envHandle_t,
                                              pal_rawFid_t **, pal_fattr_t **);

extern int kenv_envSetKPCCurrent(kenv_envHandle_t, char *);




extern void kenv_envSetTrappedNameRef(kenv_env_t *, char *, int);
extern void kenv_envInit(kenv_env_t *);
extern void kenv_envClean(kenv_env_t *);
extern int kenv_envProcessTrappedPath(kenv_env_t *, int);
extern int kenv_envProcessAuxPath(kenv_env_t *, char *, int, int);
extern void kenv_envUpdateACLInfo(kenv_env_t *);
extern void kenv_envInitialize(void);
extern void kenv_envShutdown(void);
extern kenv_env_t *kenv_envAllocEnv(void);
extern void kenv_envFreeEnv(kenv_env_t *);
typedef enum kpc_notifyOp {
    kpc_opAdd, kpc_opDelete
} kpc_notifyOp_t;

typedef enum kpc_objType {
    kpc_objFile,
    kpc_objNetwork,
    kpc_objIdset,
    kpc_objMyProgram

} kpc_objType_t;


typedef struct _addrType {
    int addrClassic:1;
    int addrV6:1;
    int noProto:1;
    int noServ:1;
    int noHostIP:1;
    int noHostName:1;
    int hostInline:1;
    int nwIn:1;
    int nwOut:1;
    int pad:23;
} kpc_nwAddrType_t;





typedef struct idInfo {
    int64_t idValue __attribute__ ((aligned (8)));
    int isGroupId:1;
} __attribute__ ((aligned (8))) kpc_idInfo_t;







typedef oss_nwAddr_t kpc_nwAddr_t;


typedef struct _portrange {
    uint16_t portLow;
    uint16_t portHigh;
} kpc_portrange_t;
typedef struct _nwdesc {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));



    pal_ptr32_t pHost;

    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        kpc_portrange_t *setp;
    } portRange;
    char *wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc_t;




typedef struct _resInfo {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        kpc_nwDesc_t *nwDesc;


    } resDesc;





    char *resourceName;


    byte_t *extData;


} kpc_resourceInfo_t;
typedef struct kpcRecord {
    kpc_resFlags_t flags;
    int32_t extDataLen;
    int32_t howFound;
    uint32_t branchId;
    int32_t reserved[4];
    char kpon[1024];
    byte_t extData[6144];
} kpc_record_t;
typedef struct _nwdesc32 {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));
    pal_ptr32_t pHost;
    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        pal_ptr32_t set;
    } portRange;
    pal_ptr32_t wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc32_t;





typedef struct _resInfo32 {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        pal_ptr32_t pnwDesc;


    } resDesc;





    pal_ptr32_t resourceName;


    pal_ptr32_t extData;


} kpc_resourceInfo32_t;



typedef struct kpcattr {
    int64_t kpcEpoch __attribute__ ((aligned (8)));

    int64_t lastNotify __attribute__ ((aligned (8)));
    int64_t policyVersion __attribute__ ((aligned (8)));
    int64_t policyEpoch __attribute__ ((aligned (8)));




    int32_t resourceCount;
} __attribute__ ((aligned (8))) kpc_attr_t;
typedef struct kpc_info {
    kpc_attr_t attrs;
    uint32_t resourceChecks;
    uint32_t doEvals;
    uint32_t resourceAdds;
    uint32_t resourceDeletes;
    uint32_t setVersionCalls;
    uint32_t startEpochCalls;
    uint32_t commitEpochCalls;
} kpc_info_t;

extern kpc_info_t kpcInfo;
typedef struct kpc_kptr
{
    uint32_t high;
    uint32_t low;
} kpc_kptr_t;

typedef struct kpc_fdumpRec {
    uint32_t resFlags;
    uint32_t intResFlags;
    uint32_t pointerSize;
    uint32_t branchId;
    kpc_kptr_t resPtr;
    kpc_kptr_t rfidPtr;
    kpc_kptr_t dfidPtr;
    char resName[156];
} kpc_fdumpRec_t;



typedef struct kpc_fdumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_fdumpRec_t frecs[3072];
} kpc_fdumpBlock_t;



typedef struct kpc_ndumpRec
{
    kpc_nwAddrType_t addrType;
    uint32_t pointerSize;
    uint32_t branchId;
    int64_t policyVersion __attribute__ ((aligned (8)));
    kpc_kptr_t protPtr;
    kpc_kptr_t servPtr;
    kpc_kptr_t hostPtr;
    char resName[156];
} __attribute__ ((aligned (8))) kpc_ndumpRec_t;



typedef struct kpc_ndumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_ndumpRec_t nrecs[128];
} kpc_ndumpBlock_t;




extern kpc_info_t kpcInfo;
extern void kazn_kpcNetSetActive(int);
extern int kazn_kpcNetGetActive(void);

extern void kazn_kpcInit(void);
extern int kazn_kpcCheckResource(kenv_envHandle_t, int, int, int);
extern int kazn_kpcFileCheckResource(kenv_envHandle_t, int, int);
extern int kazn_kpcNetCheckResource(kenv_envHandle_t, int, int);
extern char *kazn_kpcFileFindPgmResource(kenv_envHandle_t, kpc_resFlags_t *);
extern void kazn_kpcFileDirNotify(char *);
extern char *kazn_kpcFileFindTerminal(kenv_envHandle_t, int *, byte_t **);
extern void kazn_kpcFileInit(void);
extern void kazn_kpcFileShutdown(void);
extern void kazn_kpcFileEpochNotify(int64_t, int);
extern void kazn_kpcNetInit(void);
extern void kazn_kpcNetShutdown(void);
extern void kazn_kpcFileRefreshNotify(kenv_envHandle_t);
extern void kazn_kpcFileCreateNotify(kenv_envHandle_t);
extern int kazn_kpcfRunAsync(void);
extern void kpcf_asyncLUThread(void);
extern int kpcf_asyncStopLookup(void);




void kazn_kpcfTriggerAsyncRefresh(int);

extern void kazn_kpcfStopAsync(void);
extern int64_t kazn_kpcStartNewPolicyEpoch(void);
extern int kazn_kpcCommitPolicyEpoch(int64_t);
extern void kazn_kpcfFlushNegCache(void);


extern void kazn_kpcSetPolicyVersion(int64_t);
extern void kazn_kpcGetAttr(kpc_attr_t *);
extern int kazn_kpcAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetDelResource(kpc_resourceInfo_t *);
extern void kazn_kpcNetSetResource(int, kenv_envHandle_t, char *);
typedef struct kpc_nwBaseNode
{
    kutil_q_t q;
    kpc_resFlags_t resFlags;
    uint32_t size;
    uint32_t refcount;
    uint32_t branchId;
    kutil_q_t resultsQ;
    int64_t epoch __attribute__ ((aligned (8)));
    char *pcKpon;
} __attribute__ ((aligned (8))) kpc_nwBaseNode_t;


typedef struct kpc_nwServ {
    kutil_q_t q;
    kpc_resFlags_t resFlags;
    uint32_t size;
    uint32_t refcount;
    uint32_t branchId;
    kutil_q_t resultsQ;
    int64_t epoch __attribute__ ((aligned (8)));
    char *pcKpon;
    uint16_t totalPorts;
    uint16_t numPortRanges;
    uint32_t maxHighPort;
    kutil_q_t HostSpecQ;
    kutil_q_t HostWCQ;
    kpc_portrange_t portRange[1];
} __attribute__ ((aligned (8))) kpc_nwServNode_t;




typedef struct kpc_nwHost {
    kutil_q_t q;
    kpc_resFlags_t resFlags;
    uint32_t size;
    uint32_t refcount;
    uint32_t branchId;
    kutil_q_t resultsQ;
    int64_t epoch __attribute__ ((aligned (8)));
    char *pcKpon;
    kutil_q_t ProtoQ;
    int64_t policyVersion __attribute__ ((aligned (8)));
    pal_ptr32_t pWCNode;
    union {
        struct kpc_nwHostIP {
            oss_nwIP_t addr;
            oss_nwIP_t mask;
            int32_t bits;
        } ip;
        char wcSpecInt[44];
    } h;
    char *wcSpecp;
} __attribute__ ((aligned (8))) kpc_nwHostNode_t;

typedef struct kpc_nwProtoNode {
    kutil_q_t q;
    kpc_resFlags_t resFlags;
    uint32_t size;
    uint32_t refcount;
    uint32_t branchId;
    kutil_q_t resultsQ;
    int64_t epoch __attribute__ ((aligned (8)));
    char *pcKpon;
    kutil_q_t ServiceQ;
    int16_t protocol;
    int16_t flags;
    int16_t servElems;
    int16_t maxPort;
    kpc_nwServNode_t *searchList;
} __attribute__ ((aligned (8))) kpc_nwProtoNode_t;




typedef struct kpc_nwInPolicy {
    kutil_q_t ProtoQ;
    pal_mutex_t lock;
    pal_cond_t cond;
    uint16_t flags;
    uint16_t nodes;
    uint16_t ambiguous;
    uint16_t readers;
    uint32_t gen;
} kpc_nwInPolicy_t;

typedef struct kpc_nwOutPolicy {
    kutil_q_t HostIPQ;
    kutil_q_t HostNameQ;
    pal_mutex_t lock;
    pal_cond_t cond;
    uint16_t flags;
    int16_t readers;
    int16_t IPNodes, hostNodes;
    uint32_t gen;
} kpc_nwOutPolicy_t;
void kazn_kpcNetInit(void);
void kazn_kpcNetShutdown(void);

int kazn_kpcNetAddResource(kpc_resourceInfo_t *rip);
int kazn_kpcNetDelResource(kpc_resourceInfo_t *rip);

void kazn_kpcNetSetResource(int action, kenv_envHandle_t envH, char *pcKPON);

void kpc_nwServNodeRele(void *nodep);
void kpc_nwHostNodeRele(void *nodep);
void kpc_nwProtoNodeRele(void *nodep);


int kazn_kpcNetCheckResource(kenv_envHandle_t accEnv, int action, int flags);




int kazn_kpcNetMapError(int error, int *perr);
typedef struct rcnw_base_elem {
    kutil_q_t hitQ;
    kutil_q_t lruQ;
    pal_time_t expTime;
    uint32_t hits;
    pal_authID_t id;
    pal_rawFid_t *pgm_rfid;
    kpc_nwBaseNode_t *nodep;
} rcnw_base_elem_t;

typedef rcnw_base_elem_t rcnw_exact_t;

typedef struct rcnw_ambig_elem {
    kutil_q_t hashQ;
    kutil_q_t lruQ;
    pal_time_t expTime;
    uint32_t hits;
    pal_authID_t id;
    pal_rawFid_t *pgm_rfid;
    kpc_nwBaseNode_t *nodep;
    oss_nwAddr_t nwAddr;
} rcnw_ambig_t;

typedef struct rcnw_stats {

    uint32_t adds;
    uint32_t recycles;
    uint32_t reclaim;
    uint32_t used_recycle;
    uint32_t pad1;

    uint32_t checks;
    uint32_t hits;
    uint32_t longhits;
    uint32_t pad2;

    pal_time_t firstRecycle;
    pal_time_t lastGrow;
    uint32_t lastHits, lastChecks;
} rcnw_stats_t;


int kazn_rcnwInit(void);
void kazn_rcnwShutdown(void);

void kazn_rcnwSetActive(int OnOff);
int kazn_rcnwGetActive(void);

int kazn_rcnwAddGrant(kenv_envHandle_t envH, int action, int flags);
void kazn_rcnwFlushAll(void);
int kazn_rcnwCheck(kenv_envHandle_t envH, int action, int flags);
void kazn_rcnwReclaim(kpc_nwBaseNode_t *KNPCnodep);
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
enum kt_msgs {
    KT_TRACE_DUMMY = 1024,
    KT_TRACE_STR,
    KT_TRACE_INT,
    KT_TRACE_LKUPNAME,
    KT_TRACE_PROCESS_PATH,
    KT_TRACE_NOFID,
    KT_TRACE_TRACK_OPEN,
    KT_TRACE_KAZN_PATH_ACCESS,
    KT_TRACE_KAZN_PATH_ACCESS_RTN,
    KT_TRACE_KPC_NOTIFY,
    KT_TRACE_KPC_NOTIFY_RTN,
    KT_TRACE_KPC_GETATTR,
    KT_TRACE_KPC_GETATTR_RTN,
    KT_TRACE_KPC_SETVERSION,
    KT_TRACE_KPC_SETVERSION_RTN,
    KT_TRACE_KPC_SETEPOCH,
    KT_TRACE_KPC_SETEPOCH_RTN,
    KT_TRACE_KOSS_SYSCALL,
    KT_TRACE_KOSS_SYSCALL_RTN,
    KT_TRACE_KOSS_REGISTER,
    KT_TRACE_KOSS_REGISTER_RTN,
    KT_TRACE_KOSS_SET_PRIVID,
    KT_TRACE_KOSS_SET_PRIVPID,
    KT_TRACE_KOSS_ALLOC_FAIL,
    KT_TRACE_KOSS_INT_ERR,
    KT_TRACE_KAUD_SETLEVEL,
    KT_TRACE_KAUD_SETLEVEL_RTN,
    KT_TRACE_KAUD_AUD_SERVICE,
    KT_TRACE_KAUD_AUD_SERVICE_RTN,
    KT_TRACE_CSC_SETGROUPS,
    KT_TRACE_KOSS_PRIVCHECK,
    KT_TRACE_KOSS_PRIVCHECK_IDS,
    KT_TRACE_KOSS_PRIVCHECK_RTN,
    KT_TRACE_CSC_SUID,
    KT_TRACE_CSC_SUID2,
    KT_TRACE_CSC_SGID,
    KT_TRACE_CSC_SUID_BYPASS,
    KT_TRACE_CSC_SGID_BYPASS,
    KT_TRACE_KOSS_SET_ACTIVE,
    KT_TRACE_KOSS_SET_INACTIVE,
    KT_TRACE_KOSS_SET_STATE,
    KT_TRACE_NCT_OCREAT_CK_LINK_TGT,
    KT_TRACE_CSC_LOGIN_DIRECT_BP,
    KT_TRACE_KUTIL_GET_LOGIN_DATA,
    KT_TRACE_KUTIL_GET_LOGIN_DATA_EXIT,
    KT_TRACE_KAUD_LOG_USER_EVENT,
    KT_TRACE_KAUD_LOG_USER_EVENT_EXIT,
    KT_TRACE_KAUD_TRACE_EVENT,
    KT_TRACE_KAUD_TRACE_EVENT_EXIT,
    KT_TRACE_KAUD_LOGOUT_NOTERM,
    KT_TRACE_KAUD_LOGOUT_LOCTERM,
    KT_TRACE_KAUD_LOGOUT_REMTERM,
    KT_TRACE_KAUD_LOGOUT_EXIT,
    KT_TRACE_KAUD_TRACE_PID_EXEMPT,
    KT_TRACE_KAUD_TRACE_UID_EXEMPT,
    KT_TRACE_KOSS_INIT_PROC_RGY,
    KT_TRACE_KOSS_ASYNC_LU_START,
    KT_TRACE_KOSS_ASYNC_LU_STOP,
    KT_TRACE_KOSS_ASYNC_LU_TIMEOUT,
    KT_TRACE_KOSS_ASYNC_LU_STATE,
    KT_TRACE_KPCF_TRIG_REF,
    KT_TRACE_KPCF_SCAN_TIME,
    KT_TRACE_SHMEM_REINIT,
    KT_TRACE_SHMEM_REINITERR,
    KT_TRACE_SHMEM_INIT,
    KT_TRACE_SHMEM_FINI_ENT,
    KT_TRACE_SHMEM_FINI_WAITUSED,
    KT_TRACE_SHMEM_FINI_FAILUSED,
    KT_TRACE_SHMEM_FINI_FAILWAITERS,
    KT_TRACE_SHMEM_SRVT_START,
    KT_TRACE_SHMEM_SRVT_INVNODE,
    KT_TRACE_SHMEM_SRVT_ERRCOPY,
    KT_TRACE_SHMEM_SRVT_STOP,
    KT_TRACE_SHMEM_SRVT_WAIT,
    KT_TRACE_SHMEM_SRVT_WAITERR,
    KT_TRACE_SHMEM_STOP,
    KT_TRACE_GETMEM_NONE,
    KT_TRACE_SHBANG_TOOBIG,
    KT_TRACE_SHBANG_CHECK_READ,
    KT_TRACE_SHMEM_HELPER_START,
    KT_TRACE_SHMEM_HELPER_RESTART,
    KT_TRACE_SHMEM_HELPER_RETURN,
    KT_TRACE_SHMEM_CHECK_FAIL,
    KT_TRACE_SHMEM_NODE_RECLAIM,
    KT_TRACE_FDPATH_FAILURE,
    KT_TRACE_SHMEM_OLDPOOL_DEC
};
enum kt_kazn_msgs {
    KT_TRACE_KAZN_DUMMY = 2048,
    KT_TRACE_KAZN_ACC_ALLOWED_FI,
    KT_TRACE_KAZN_ACC_ALLOWED_ID,
    KT_TRACE_KAZN_ACC_ALLOWED_NW,
    KT_TRACE_KAZN_CFR,
    KT_TRACE_KAZN_CFR_HIT,
    KT_TRACE_KAZN_CFR_MISS,
    KT_TRACE_KAZN_KPCF_ADD,
    KT_TRACE_KAZN_KPCF_UPDATE,
    KT_TRACE_KAZN_KPCF_DEL,
    KT_TRACE_KPCF_DINS,
    KT_TRACE_KPCF_REFRES,
    KT_TRACE_KPCF_REFRES_RTN,
    KT_TRACE_KPCF_REF_FR,
    KT_TRACE_KPCF_NCADD,
    KT_TRACE_KPCF_NCHIT,
    KT_TRACE_KPCF_NCFLUSH,
    KT_TRACE_KPCF_DIR_NOTIFY,
    KT_TRACE_KPCF_EPOCH_DEL,
    KT_TRACE_KPCF_HIT_WC,
    KT_TRACE_KAZN_LOGIN_SUSKIP,
    KT_TRACE_KAZN_SECPGM_SUSKIP,
    KT_TRACE_KAZN_PRIVPGM_PERMIT,
    KT_TRACE_KPCF_HIT_LOCALTERM,
    KT_TRACE_KAZN_ACC_ALLOWED_EFLAGS,
    KT_TRACE_KAZN_RES_NOAZN,
    KT_TRACE_KPCF_KPCI_ADD_PO,
    KT_TRACE_KAZN_CHECKACCESS,
    KT_TRACE_KAZN_CHECKACCESS_GRANT,
    KT_TRACE_KAZN_CHECKACCESS_DENY,
    KT_TRACE_KAZN_CHECKACCESS_DENY_MORE,
    KT_TRACE_KPCF_REFRESH_NOTIFY,
    KT_TRACE_KPCF_CHECKPATH,
    KT_TRACE_KPCF_CKPATH_RTN,
    KT_TRACE_KPCF_CKPATH_FAST_RTN,
    KT_TRACE_KPCF_REF_DHASH,
    KT_TRACE_KPCF_REF_DHASH_RTN,
    KT_TRACE_RCF_ADD_GRANT,
    KT_TRACE_RCF_ADD_GRANT_RES,
    KT_TRACE_RCF_CHECK,
    KT_TRACE_RCF_CHECK_GRANT,
    KT_TRACE_RCF_CHECK_NOGRANT,
    KT_TRACE_RCF_FLUSH,
    KT_TRACE_RCF_COND_INFO,
    KT_TRACE_KAZN_DAEMON_EBUSY,
    KT_TRACE_KPCF_BKG_SLEEP,
    KT_TRACE_KPCF_BKG_RUN,
    KT_TRACE_KPCF_EPOCH_NOT,
    KT_TRACE_KPCF_EPOCH_NOT_COMMIT,
    KT_TRACE_KAZN_RES_NOTIFY,
    KT_TRACE_KPC_GET_NEWEPOCH,
    KT_TRACE_KPC_COMMIT_EPOCH,
    KT_TRACE_CSC_OPEN,
    KT_TRACE_CSC_KILL_ERR,
    KT_TRACE_KPCF_GENFID_ERR,
    KT_TRACE_KPCF_NOFID_REFRESH,
    KT_TRACE_KPCF_ADD_IMMUNE,
    KT_TRACE_KPCF_UPDATE_IMMUNE,
    KT_TRACE_KAZN_ERR_GRANT,
    KT_TRACE_KAZN_FIND_PGM_KPON,
    KT_TRACE_KAZN_FIND_PGM_KPON_FOUND,
    KT_TRACE_KAZN_FIND_PGM_KPON_NONE,
    KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG,
    KT_TRACE_KAZN_KPC_QFILE,
    KT_TRACE_KAZN_KPC_QFILE_RTN,
    KT_TRACE_KAZN_KPC_QPGM,
    KT_TRACE_KAZN_KPC_QPGM_RTN,
    KT_TRACE_KAZN_KPC_DHASHFID_EXIT,
    KT_TRACE_KAZN_KPC_DHASHNAME_EXIT,
    KT_TRACE_KAZN_KPC_CREATE_NOTIFY,
    KT_TRACE_RCID_ADD_GRANT,
    KT_TRACE_RCID_ADD_GRANT_RES,
    KT_TRACE_RCID_CHECK,
    KT_TRACE_RCID_CHECK_GRANT,
    KT_TRACE_RCID_CHECK_NOGRANT,
    KT_TRACE_RCID_FLUSH,
    KT_TRACE_KAZN_AZNCALL_REMAP_TO,
    KT_TRACE_KPCF_EXCEPTION_ADD,
    KT_TRACE_KAZN_AZND_TOUT,
    KT_TRACE_KAZN_EXPAND_PATH,
    KT_TRACE_KAZN_EXPAND_PATH_ERR,
    KT_TRACE_KAZN_EXPAND_PATH_SKIP,
    KT_TRACE_KAZN_UFILE_HIT,
    KT_TRACE_KAZN_UFILE_ADD,
    KT_TRACE_KAZN_UFILE_MISS,
    KT_TRACE_KAZN_UFILE_FLUSH,
    KT_TRACE_KPCF_REF_DH_BYFID,
    KT_TRACE_KPCF_REF_DH_BYFID_END,
    KT_TRACE_EXEC_SETUSER,
    KT_TRACE_EXEC_SETGROUP,
    KT_TRACE_KAZN_CHECK_FID_ONLY,
    KT_TRACE_KAZN_EXEMPT_PID_PERMIT,
    KT_TRACE_KAZN_PFC_HIT,
    KT_TRACE_KAZN_PFC_ADD,
    KT_TRACE_KAZN_PFC_MISS,
    KT_TRACE_KAZN_PFC_FLUSH,
    KT_TRACE_KAZN_PFC_FLUSHBYRES,
    KT_TRACE_KAZN_PFC_PROTRES_RELE,
    KT_TRACE_KAZN_ACC_ALLOWED_PERMIT,
    KT_TRACE_KAZN_ACC_ALLOWED_DENY,

    KT_TRACE_KAZN_AUTOFS_NOREF,

    KT_TRACE_KAZN_NW_ADDR_BADFAM,
    KT_TRACE_KAZN_RES_TRY_AGAIN,
    KT_TRACE_KAZN_KPC_QNW,
    KT_TRACE_KAZN_KPC_QNW_RTN,
    KT_TRACE_KAZN_IMSURPGM_SUSKIP,
    KT_TRACE_KAZN_USER_AUDIT_LOGOUT,
    KT_TRACE_KAZN_ALWAYS_SET_KPON,
    KT_TRACE_KAZN_FILTER_RES,
    KT_TRACE_KAZN_KPCFT_DELAY,
    KT_TRACE_KAZN_IPV6_ADDR,
    KT_TRACE_KAZN_DHANAL_FRL_CLR,
    KT_TRACE_KAZN_SET_ALIAS,
    KT_TRACE_KAZN_HAS_ALIAS,
    KT_TRACE_KAZN_RES_WAIT,
    KT_TRACE_KAZN_RES_REFD,
    KT_TRACE_KAZN_RES_BROADCAST,
    KT_TRACE_KAZN_DHASH_REF_LOOP,
    KT_TRACE_KAZN_USE_COPY,
    KT_TRACE_KAZN_NO_COPY,
    KT_TRACE_KAZN_DENY_SHMCTL_OP,
    KT_TRACE_KAZN_DHASH_SEARCH_STALE
};







enum kt_kmsg_msgs {
    KT_TRACE_KMSG_DUMMY = 3072,
    KT_TRACE_KMSG_INIT,
    KT_TRACE_KMSG_FINISH,
    KT_TRACE_KMSG_OPEN,
    KT_TRACE_KMSG_CLOSE,
    KT_TRACE_KMSG_IOCTL,
    KT_TRACE_KMSG_READ_ENTRY,
    KT_TRACE_KMSG_READ_EXIT,
    KT_TRACE_KMSG_READ_WAIT,
    KT_TRACE_KMSG_READ_WORK,
    KT_TRACE_KMSG_WRITE_ENTRY,
    KT_TRACE_KMSG_WRITE_EXIT,
    KT_TRACE_KMSG_WRITE_ID,
    KT_TRACE_KMSG_WRITE_LEN,
    KT_TRACE_KMSG_SEND_REQ,
    KT_TRACE_KMSG_GET_RESP,
    KT_TRACE_KMSG_RECV_RESP,
    KT_TRACE_KMSG_GET_HAND,
    KT_TRACE_KMSG_FREE_HAND,
    KT_TRACE_KMSG_WAIT_MSG,

    KT_TRACE_KMSG_BADTRANID,
    KT_TRACE_KMSG_BADSIZE,
    KT_TRACE_KMSG_TOOBIG,
    KT_TRACE_KMSG_CHANCLOSED,
    KT_TRACE_KMSG_ERR_GET_HAND,
    KT_TRACE_KMSG_GET_RESP_ERR,
    KT_TRACE_KMSG_CHAN_DOWN,
    KT_TRACE_KMSG_CHAN_RETRY,
    KT_TRACE_KMSG_WAIT_TO,
    KT_TRACE_KMSG_HARD_TO,
    KT_TRACE_KMSG_TO_RETRY,
    KT_TRACE_KMSG_DOWN_TO_TOUT
};







enum kt_kenv_msgs {
    KT_TRACE_KENV_DUMMY = 4096,
    KT_TRACE_KENV_NEW_PROC_INFO,
    KT_TRACE_KENV_PR_ADD_FD,
    KT_TRACE_KENV_PR_CLOSE_FD,
    KT_TRACE_KENV_PR_RET_FDINFO,
    KT_TRACE_KENV_PR_GROW_FDTABLE,
    KT_TRACE_KENV_PR_ADD_FLAGS,
    KT_TRACE_KENV_PR_DEL_FLAGS,
    KT_TRACE_KENV_PR_SET_IMP_ID,
    KT_TRACE_KENV_E_NW_TERM,
    KT_TRACE_KENV_E_DEV_TERM,
    KT_TRACE_KENV_E_NO_TERM,
    KT_TRACE_KENV_PR_ADD_FLAGS_BNAME,
    KT_TRACE_KENV_PTP_E2BIG,
    KT_TRACE_KENV_PTP_E2BIG_RETRY,
    KT_TRACE_KENV_PR_GET_TRUE_ACCID,
    KT_TRACE_KENV_PR_SET_ACC_ID,
    KT_TRACE_KENV_PR_ADD_NO_FORK,
    KT_TRACE_KENV_PR_ADD_REMT_TERM,
    KT_TRACE_KENV_PR_GET_REMT_TERM,
    KT_TRACE_KENV_BUMP_STREAM_COUNT,
    KT_TRACE_KENV_DELAY_PROC_DEL,
    KT_TRACE_KENV_PROC_INFO_NOTPAR,
    KT_TRACE_KENV_E_NW_TERM_IPV6,
    KT_TRACE_KENV_IPV6_ADDR,
    KT_TRACE_KENV_PR_NOSET_REMT,
    KT_TRACE_KENV_SHMEM_TOOBIG,
    KT_TRACE_KENV_SHMEM_WAIT,
    KT_TRACE_KENV_SHMEM_STOPPED,
    KT_TRACE_KENV_SHMEM_NOFREE,
    KT_TRACE_KENV_SHMEM_INVNODE,
    KT_TRACE_KENV_SHMEM_RQWAIT,
    KT_TRACE_KENV_SHMEM_RQDONE,
    KT_TRACE_KENV_SHMEM_PUTERR,
    KT_TRACE_KENV_SHMEM_PUT,
    KT_TRACE_KENV_GETMEM_REL,
    KT_TRACE_KENV_GETMEM_NEVER,
    KT_TRACE_KENV_GETMEM_OK,
    KT_TRACE_KENV_GETMEM_OFF,
    KT_TRACE_KENV_GETMEM_ERR,
    KT_TRACE_KENV_PUTMEM,
    KT_TRACE_KENV_SHMAT_RESET,
    KT_TRACE_KENV_SHMREQ_SCAN_DELAY,
    KT_TRACE_KENV_SHMREQ_SCAN_NOW,
    KT_TRACE_KENV_SHMREQ_REC_NOPID,
    KT_TRACE_KENV_SHMREQ_REC_EXP,
    KT_TRACE_KENV_SHMREQ_SCAN_RET,
    KT_TRACE_KENV_SHMEM_RESET_EXEC,
    KT_TRACE_KENV_PROC_FORK_CHILD,
    KT_TRACE_KENV_PROC_FORK_PAR,
    KT_TRACE_KENV_PROC_ALREADY,
    KT_TRACE_KENV_PROC_CONDADD,
    KT_TRACE_KENV_PROC_EXISTS,
    KT_TRACE_KENV_PR_ADD_NO_PAR,
    KT_TRACE_KENV_PROC_ADD,
    KT_TRACE_KENV_PROC_ADD_PPID,
    KT_TRACE_KENV_PROC_TERM,
    KT_TRACE_KENV_PROC_USE_DEAD
};







enum kt_dbg_msgs {
    KT_TRACE_DBG_DUMMY = 8192,
    KT_TRACE_DBG_NCT_Q_AREQ,
    KT_TRACE_DBG_NCT_START_AREQ,
    KT_TRACE_DBG_NCT_END_AREQ,
    KT_TRACE_DBG_PAL_NO_FID,
    KT_TRACE_DBG_PAL_LKUP_ERR,
    KT_TRACE_DBG_PAL_DCOMP_ERR,
    KT_TRACE_DBG_PAL_LU_FID_DIR,
    KT_TRACE_DBG_TLI_SVC_PRIM_PEND,
    KT_TRACE_DBG_TLI_SVC_PRIM_NOPEND,
    KT_TRACE_DBG_NCT_PATH_OP_RESULT,
    KT_TRACE_DBG_NCT_FD_OP_RESULT,
    KT_TRACE_DBG_NCT_KILL_COMMON,
    KT_TRACE_DBG_NCT_KILL_TRAP,
    KT_TRACE_DBG_NCT_KILL_FILTER_PGRP,
    KT_TRACE_DBG_NCT_KILL_FILTER_USER,

    KT_TRACE_DBG_PAL_FILE_COUNT,
    KT_TRACE_DBG_PAL_FILE_LOOKUP22,
    KT_TRACE_DBG_PAL_FILE_LOOKUP24,

    KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP,
    KT_TRACE_DBG_RFID_FL_VFSP,
    KT_TRACE_DBG_AUTO_FS_MOUNTED,
    KT_TRACE_DBG_DEFER_UMOUNT,
    KT_TRACE_DBG_CHECK_VFS_MOUNTED,
    KT_TRACE_DBG_MOUNTED_YES,
    KT_TRACE_DBG_MOUNTED_NO,
    KT_TRACE_DBG_VFS_DATA_SET,
    KT_TRACE_DBG_FURTHER_LKUP_REQ,
    KT_TRACE_DBG_NEXT_LOOKUP,
    KT_TRACE_DBG_GEN_RES_FIDS,
    KT_TRACE_DBG_CHECK_FID_PATH,

    KT_TRACE_DBG_RESET_VFS_DATA,
    KT_TRACE_DBG_FAILED_VFS_SEARCH,
    KT_TRACE_DBG_ASYNC_LU_START,
    KT_TRACE_DBG_DEFER_UNAVAIL,
    KT_TRACE_DBG_REFRESH_FSID_EQ,
    KT_TRACE_DBG_REFRESH_FSID_NOFID,
    KT_TRACE_DBG_REFRESH_EPOCH,

    KT_TRACE_DBG_KPCF_ADD_RES,
    KT_TRACE_DBG_KPCF_AZN_FLAGS,
    KT_TRACE_DBG_NCT_FORK_TRAP,
    KT_TRACE_DBG_EXIT_CHECK_LEAF,

    KT_TRACE_DBG_SHMEM_SRVT_WAIT,
    KT_TRACE_DBG_SHMEM_SRVT_PROC,
    KT_TRACE_DBG_SHMEM_SRVT_RECLAIM,
    KT_TRACE_DBG_SHBANG_EXEC,
    KT_TRACE_DBG_SHMEM_HELPER_CHECK,
    KT_TRACE_DBG_FDPATH_BUILT,
    KT_TRACE_DBG_BYPASS_ENTRY1,
    KT_TRACE_DBG_BYPASS_ENTRY2,
    KT_TRACE_DBG_BYPASS_EXIT
};
enum kt_ffdc_msgs {
    KT_TRACE_FFDC_DUMMY = 5120,
    KT_TRACE_FFDC_STR,
    KT_TRACE_FFDC_AZNCALL_FILE,
    KT_TRACE_FFDC_AZNCALL_IDSET,
    KT_TRACE_FFDC_AZNCALL_NWOUT,
    KT_TRACE_FFDC_AZNCALL_NWIN,
    KT_TRACE_FFDC_AZNCALL_RACC_ADDR,
    KT_TRACE_FFDC_AZNCALL_CONT,
    KT_TRACE_FFDC_AZNCALL_RES_PERMIT,
    KT_TRACE_FFDC_AZNCALL_RES_DENY,
    KT_TRACE_FFDC_ERR_GRANT,
    KT_TRACE_FFDC_AZNCALL_SLOW,
    KT_TRACE_FFDC_CSC_LOGIN,
    KT_TRACE_FFDC_CKLOGIN,
    KT_TRACE_FFDC_CKLOGIN_EXIT,
    KT_TRACE_FFDC_CKLOGIN_DOAZN,
    KT_TRACE_FFDC_EXEC_PGM,
    KT_TRACE_FFDC_EXEC_PGM_LINK,
    KT_TRACE_FFDC_EXEC_SUPGM,
    KT_TRACE_FFDC_EXEC_SGPGM,
    KT_TRACE_FFDC_EXEC_SUGPGM,
    KT_TRACE_FFDC_EXEC_DENIED,
    KT_TRACE_FFDC_EXEC_ALLOWED,
    KT_TRACE_FFDC_LOGOUT_LOC,
    KT_TRACE_FFDC_LOGOUT_REM,
    KT_TRACE_FFDC_PROC_ADD,
    KT_TRACE_FFDC_PROC_ADD_PPID,
    KT_TRACE_FFDC_PROC_TERM,
    KT_TRACE_FFDC_NPC_FREE,
    KT_TRACE_FFDC_HOST_RULE_BAD,
    KT_TRACE_FFDC_CSC_V6TERM,
    KT_TRACE_FFDC_IPV6_ADDR
};




enum kt_knpc_msgs {
    KT_TRACE_KNPC_DUMMY = 6144,
    KT_TRACE_KNPC_STR,
    KT_TRACE_KNPC_SEARCH_SERVICE,
    KT_TRACE_KNPC_SEARCH_HOSTIP,
    KT_TRACE_KNPC_SEARCH_HOSTNAME,
    KT_TRACE_KNPC_SEARCH_PROTOCOL,
    KT_TRACE_KNPC_NET_UPD_ENTRY,
    KT_TRACE_KNPC_NET_UPD_ENTRY2,
    KT_TRACE_KNPC_KPCRES_ATTACH,
    KT_TRACE_KNPC_NET_ALREADY,
    KT_TRACE_KNPC_NETIN_ADD_NODE,
    KT_TRACE_KNPC_NETIN_DEL_ERR,
    KT_TRACE_KNPC_NETIN_DEL,
    KT_TRACE_KNPC_NETOUT_ADD_NODE,
    KT_TRACE_KNPC_NETOUT_DEL_ERR,
    KT_TRACE_KNPC_NETOUT_DEL,
    KT_TRACE_KNPC_NETIN_MATCH,
    KT_TRACE_KNPC_NETOUT_MATCH,
    KT_TRACE_KNPC_DUMP_HEADER,
    KT_TRACE_KNPC_DUMP_ELEM,
    KT_TRACE_KNPC_CUR_INIT,
    KT_TRACE_KNPC_CUR_FINI,
    KT_TRACE_KNPC_CHECK_RES,

    KT_TRACE_KNPCD_SERV_NODE_ALLOC,
    KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_SERV_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_HOSTIP_NODE_FREE,
    KT_TRACE_KNPCD_HOST_NODE_FREE,
    KT_TRACE_KNPCD_PROT_NODE_ALLOC,
    KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_PROT_NODE_FREE,
    KT_TRACE_KNPCD_MATCH_SERVICE,
    KT_TRACE_KNPCD_MATCH_HOSTIP,
    KT_TRACE_KNPCD_MATCH_PROTOCOL,
    KT_TRACE_KNPCD_KPON_FREE,
    KT_TRACE_KNPCD_WAIT_LOCK,
    KT_TRACE_KNPCD_SEARCH_SERV_ENTRY,
    KT_TRACE_KNPCD_SEARCH_NODE_CMP,
    KT_TRACE_KNPCD_FREE_NODE_REF,
    KT_TRACE_KNPCD_MATCH_HOSTNAME,
    KT_TRACE_KNPC_NETIN_SETRES,
    KT_TRACE_KNPC_NETOUT_SETRES,
    KT_TRACE_KNPC_ENV_SETRES,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC,
    KT_TRACE_KNPCD_HOSTIPV6_ADDR,
    KT_TRACE_KNPCD_HOSTIPV6_MASK,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIPV6_HIT_V4,
    KT_TRACE_KNPCD_HOSTIPV6_CMP,
    KT_TRACE_KNPC_SEARCH_HOSTIPV6,
    KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM,
    KT_TRACE_KNPCD_MATCH_HOSTIPV6,
    KT_TRACE_KNPC_BRANCH_CHANGE
};



enum kt_knrc_msgs {
    KT_TRACE_KNRC_DUMMY = 7168,
    KT_TRACE_KNRC_STR,
    KT_TRACE_KNRC_INIT_ERR,
    KT_TRACE_KNRC_INIT_CACHE,
    KT_TRACE_KNRC_FINI_FREE,
    KT_TRACE_KNRC_CHECK_GROW,
    KT_TRACE_KNRC_RECYCLE_ELEM,
    KT_TRACE_KNRC_NEW_POOL_ALLOC,
    KT_TRACE_KNRC_FLUSH,
    KT_TRACE_KNRC_ADD_EXACT,
    KT_TRACE_KNRC_ADD_GRANT_EXACT,
    KT_TRACE_KNRC_ADD_AMBIG,
    KT_TRACE_KNRC_AMBIG_HASH,
    KT_TRACE_KNRC_ADD_GRANT_AMBIG,
    KT_TRACE_KNRC_HAS_VIA,
    KT_TRACE_KNRC_ADD_STATS,
    KT_TRACE_KNRC_CHECK_EXACT,
    KT_TRACE_KNRC_RECLAIM_EXACT,
    KT_TRACE_KNRC_FID_NOMATCH,
    KT_TRACE_KNRC_HIT_EXACT,
    KT_TRACE_KNRC_NOMATCH_EXACT,
    KT_TRACE_KNRC_CHECK_STATS,
    KT_TRACE_KNRC_CHECK_AMBIG,
    KT_TRACE_KNRC_CHECK_HASHQ,
    KT_TRACE_KNRC_RECLAIM_AMBIG,
    KT_TRACE_KNRC_HIT_AMBIG,
    KT_TRACE_KNRC_NOMATCH_AMBIG,
    KT_TRACE_KNRC_RECLAIM,
    KT_TRACE_KNRC_RECLAIM_ELEM
};
uint32_t kpc_NWCacheOn=0;
kpc_nwInPolicy_t kpc_nwInPol;
kpc_nwOutPolicy_t kpc_nwOutPol;
void
kazn_kpcNetSetActive(int OnOff)
{
    if (OnOff) {
        kpc_NWCacheOn = 1;
    } else {
        kpc_NWCacheOn = 0;
    }
}
int
kazn_kpcNetGetActive(void)
{
    if (kpc_NWCacheOn) {
        return(1);
    } else {
        return(0);
    }
}





kpc_nwServNode_t *kpc_nwServNodeAlloc(kpc_resourceInfo_t *,int);
void kpc_nwServNodeFree(kpc_nwServNode_t *nodep, int check);
kpc_nwHostNode_t *kpc_nwHostNodeAlloc(kpc_resourceInfo_t *,int);
void kpc_nwHostNodeFree(kpc_nwHostNode_t *hostNodep, int check);
kpc_nwProtoNode_t *kpc_nwProtoNodeAlloc(kpc_resourceInfo_t *,int);
void kpc_nwProtoNodeFree(kpc_nwProtoNode_t *protoNodep, int check);
void
kpc_nwIntFreeKpon(char *pcStart, int32_t size, char *pcKpon)
{

    if ( pcKpon && ((pcKpon < pcStart) || (pcKpon > (pcStart+size))) ) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_KPON_FREE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((0)<<16)), (long)(pcKpon), (long)(strlen(pcKpon)+1), (long)pcStart),0) : 0);


        pal_free( pcKpon, (strlen(pcKpon)+1) );
    }
}
kpc_nwServNode_t *
kpc_nwServNodeAlloc(kpc_resourceInfo_t *pkpcRes, int allocFlags)
{
    uint32_t range, numRanges;
    size_t size;
    kpc_nwServNode_t *nodep=(kpc_nwServNode_t *)NULL;
    kpc_nwDesc_t *rulep= pkpcRes->resDesc.nwDesc;
    char *pcPtr;

    size = sizeof(kpc_nwServNode_t);
    size += ((rulep->numPortRanges-1) * sizeof(kpc_portrange_t));
    if (allocFlags & 0x2) {
        size += (strlen(pkpcRes->resourceName) + 1);
    }
    nodep = (kpc_nwServNode_t *)pal_alloc(size);
    if (!nodep) {

        return(nodep);
    }


    memset(nodep,0,size);
    nodep->size = size;

    nodep->branchId = pkpcRes->branchId;
    numRanges = rulep->numPortRanges;

    if (allocFlags & 0x2) {

        pcPtr = (char *)nodep;
        pcPtr += sizeof(kpc_nwServNode_t);
        pcPtr += ((numRanges-1) * sizeof(kpc_portrange_t));
        nodep->pcKpon = pcPtr;
        strcpy(nodep->pcKpon, pkpcRes->resourceName);

        nodep->resFlags = pkpcRes->flags;

        nodep->epoch = kpcInfo.attrs.policyEpoch;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_KPCRES_ATTACH, (((1)<<28) + ((2)<<24) + ((1)<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16)), (long)(nodep->pcKpon), (long)*((int *)&nodep->resFlags), (long)"service", (long)nodep),0) : 0);



    }

    if (numRanges == 1) {
        nodep->portRange[0] = rulep->portRange.one;
        nodep->maxHighPort = rulep->portRange.one.portHigh;
    } else {
        for (range = 0; range < numRanges; range++) {
            nodep->portRange[range] = rulep->portRange.setp[range];

            if (rulep->portRange.setp[range].portHigh > nodep->maxHighPort) {
                nodep->maxHighPort = rulep->portRange.setp[range].portHigh;
            }
        }
    }
    nodep->totalPorts = rulep->totalPorts;
    nodep->numPortRanges = numRanges;
    ((&(nodep->q))->next = (&(nodep->q))->prev = (&(nodep->q)));
    ((&(nodep->resultsQ))->next = (&(nodep->resultsQ))->prev = (&(nodep->resultsQ)));
    ((&(nodep->HostSpecQ))->next = (&(nodep->HostSpecQ))->prev = (&(nodep->HostSpecQ)));
    ((&(nodep->HostWCQ))->next = (&(nodep->HostWCQ))->prev = (&(nodep->HostWCQ)));
    nodep->refcount = 1;
    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_SERV_NODE_ALLOC, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(nodep), (long)size, (long)numRanges, (long)nodep->totalPorts ,(long)nodep->maxHighPort),0) : 0);



    return(nodep);
}
void
kpc_nwServNodeFree(kpc_nwServNode_t *nodep, int check)
{
    kutil_q_t *iter, *next, *qptr;
    kpc_nwHostNode_t *pHostNode;


    kail_atomic_add((int)(-1),(void *)((int *)&(nodep->refcount)));
    if (nodep->refcount) {
        if (nodep->refcount > 1) {




            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_FREE_NODE_REF, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)("serv"), (long)nodep, (long)nodep->refcount),0) : 0);


        }
        return;
    }


    if (!((((kutil_q_t *)&(nodep->HostSpecQ))->next) == (kutil_q_t *)&(nodep->HostSpecQ))) {
        if (check) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((1)<<24) + ((0)<<20) + ((0)<<16)), (long)(nodep), (long)"IP Queue"),0) : 0);


        }
        qptr = &(nodep->HostSpecQ);
        for (iter=(((kutil_q_t *)qptr)->next); iter != qptr; iter=next) {
            next = ((iter)->next);
            pHostNode = (kpc_nwHostNode_t *)iter;
            (((&(pHostNode->q))->next)->prev = ((&(pHostNode->q))->prev), ((&(pHostNode->q))->prev)->next = ((&(pHostNode->q))->next));
            kpc_nwHostNodeFree(pHostNode,check);
        }
    }

    if (!((((kutil_q_t *)&(nodep->HostWCQ))->next) == (kutil_q_t *)&(nodep->HostWCQ))) {
        if (check) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((1)<<24) + ((0)<<20) + ((0)<<16)), (long)(nodep), (long)"Host Queue"),0) : 0);


        }
        qptr = &(nodep->HostWCQ);
        for (iter=(((kutil_q_t *)qptr)->next); iter != qptr; iter=next) {
            next = ((iter)->next);
            pHostNode = (kpc_nwHostNode_t *)iter;
            (((&(pHostNode->q))->next)->prev = ((&(pHostNode->q))->prev), ((&(pHostNode->q))->prev)->next = ((&(pHostNode->q))->next));
            kpc_nwHostNodeFree(pHostNode,check);
        }
    }


    kazn_rcnwReclaim((kpc_nwBaseNode_t *)nodep);

    kpc_nwIntFreeKpon((char *)nodep, nodep->size, nodep->pcKpon);

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_SERV_NODE_FREE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(nodep), (long)nodep->size, (long)nodep->numPortRanges, (long)nodep->totalPorts ,(long)nodep->maxHighPort),0) : 0);




    pal_free(nodep,nodep->size);
}
void
kpc_nwServNodeRele(void *_nodep)
{
    kpc_nwServNode_t *nodep = (kpc_nwServNode_t *)_nodep;

    if (!nodep) return;
    (!(nodep->refcount)? (*((char *)0) = 0) : 0);
    kpc_nwServNodeFree(nodep, 1);
}
kpc_nwHostNode_t *
kpc_nwHostNodeAlloc(kpc_resourceInfo_t *pkpcRes, int allocFlags)
{
    kpc_nwHostNode_t *nodep=(kpc_nwHostNode_t *)NULL;
    kpc_nwDesc_t *rulep= pkpcRes->resDesc.nwDesc;
    uint32_t internal=0;
    char *pcPtr;
    size_t size;

    size = sizeof(kpc_nwHostNode_t);
    if (rulep->addrType.noHostIP) {
        if ((strlen(rulep->wcHostData) +1) > 44) {
            size += (strlen(rulep->wcHostData) + 1);
        } else {
            internal = 1;
        }
    } else if (!(rulep->addrType.addrClassic || rulep->addrType.addrV6)) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_HOST_RULE_BAD, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(rulep), (long)*((int *)&rulep->addrType)),0) : 0);


        return(nodep);
    }
    if (allocFlags & (0x8|0x4)) {
        size += (strlen(pkpcRes->resourceName) + 1);
    }

    nodep = (kpc_nwHostNode_t *)pal_alloc(size);
    if (!nodep) {

        return(nodep);
    }
    pcPtr = (char *)nodep;
    pcPtr += sizeof(kpc_nwHostNode_t);
    memset(nodep,0,size);
    nodep->size = size;

    nodep->branchId = pkpcRes->branchId;
    ((&(nodep->q))->next = (&(nodep->q))->prev = (&(nodep->q)));
    ((&(nodep->ProtoQ))->next = (&(nodep->ProtoQ))->prev = (&(nodep->ProtoQ)));
    ((&(nodep->resultsQ))->next = (&(nodep->resultsQ))->prev = (&(nodep->resultsQ)));

    if (rulep->addrType.noHostIP) {
        if (internal) {
            nodep->wcSpecp = nodep->h.wcSpecInt;
        } else {
            nodep->wcSpecp = pcPtr;
            pcPtr += (strlen(rulep->wcHostData) + 1);
        }
        strcpy(nodep->wcSpecp,rulep->wcHostData);
    } else {
        nodep->wcSpecp = (char *)NULL;
        nodep->h.ip.bits = rulep->significantBits;
        memcpy(&(nodep->h.ip.addr),&(rulep->ipaddr),sizeof(oss_nwIP_t));
        memcpy(&(nodep->h.ip.mask),&(rulep->mask),sizeof(oss_nwIP_t));
    }
    nodep->refcount = 1;

    if (allocFlags & (0x8|0x4)) {
        nodep->pcKpon = pcPtr;
        strcpy(nodep->pcKpon, pkpcRes->resourceName);

        nodep->resFlags = pkpcRes->flags;
        nodep->epoch = kpcInfo.attrs.policyEpoch;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_KPCRES_ATTACH, (((1)<<28) + ((2)<<24) + ((1)<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16)), (long)(nodep->pcKpon), (long)*((int *)&nodep->resFlags), (long)"host", (long)nodep),0) : 0);



    }

    if (rulep->addrType.noHostIP) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOST_NODE_ALLOC, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((1)<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16) + ((((sizeof(char *) == 4) ? 2 : 4))<<12) + ((0)<<8)), (long)(nodep), (long)size, (long)nodep->wcSpecp, (long)&(nodep->h.wcSpecInt) ,(long)nodep->wcSpecp),0) : 0);




    } else if (rulep->addrType.addrClassic) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(nodep), (long)size, (long)ntohl(nodep->h.ip.addr.addr.addrClassic.addr), (long)ntohl(nodep->h.ip.mask.addr.addrClassic.addr) ,(long)nodep->h.ip.bits),0) : 0);




    } else if (rulep->addrType.addrV6) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(nodep), (long)size, (long)nodep->h.ip.bits),0) : 0);



        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(nodep->h.ip.addr.addr.a32[0])), (long)ntohl(nodep->h.ip.addr.addr.a32[1]), (long)ntohl(nodep->h.ip.addr.addr.a32[2]), (long)ntohl(nodep->h.ip.addr.addr.a32[3])),0) : 0);




        if (nodep->h.ip.bits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(nodep->h.ip.mask.addr.a32[0])), (long)ntohl(nodep->h.ip.mask.addr.a32[1]), (long)ntohl(nodep->h.ip.mask.addr.a32[2]), (long)ntohl(nodep->h.ip.mask.addr.a32[3])),0) : 0);




        }
    }

    return(nodep);
}
void
kpc_nwHostNodeFree(kpc_nwHostNode_t *nodep, int check)
{
    kutil_q_t *iter, *next, *qptr;
    kpc_nwProtoNode_t *protoNodep;


    kail_atomic_add((int)(-1),(void *)((int *)&(nodep->refcount)));
    if (nodep->refcount) {
        if (nodep->refcount > 1) {




            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_FREE_NODE_REF, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)("serv"), (long)nodep, (long)nodep->refcount),0) : 0);


        }
        return;
    }


    if (!((((kutil_q_t *)&(nodep->ProtoQ))->next) == (kutil_q_t *)&(nodep->ProtoQ))) {
        if (check) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event1((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(nodep)),0) : 0);


        }
        qptr = &(nodep->ProtoQ);
        for (iter=(((kutil_q_t *)qptr)->next); iter != qptr; iter = next) {
            next = ((iter)->next);
            protoNodep = (kpc_nwProtoNode_t *)iter;
            (((&(protoNodep->q))->next)->prev = ((&(protoNodep->q))->prev), ((&(protoNodep->q))->prev)->next = ((&(protoNodep->q))->next));
            kpc_nwProtoNodeFree(protoNodep,check);
        }
    }


    kazn_rcnwReclaim((kpc_nwBaseNode_t *)nodep);

    kpc_nwIntFreeKpon((char *)nodep, nodep->size, nodep->pcKpon);

    if (nodep->wcSpecp) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOST_NODE_FREE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((1)<<20) + ((0)<<16)), (long)(nodep), (long)nodep->size, (long)nodep->wcSpecp),0) : 0);


    } else {
        if (nodep->h.ip.addr.ipV6) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(nodep), (long)nodep->size, (long)nodep->h.ip.bits),0) : 0);



            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(nodep->h.ip.addr.addr.a32[0])), (long)ntohl(nodep->h.ip.addr.addr.a32[1]), (long)ntohl(nodep->h.ip.addr.addr.a32[2]), (long)ntohl(nodep->h.ip.addr.addr.a32[3])),0) : 0);




            if (nodep->h.ip.bits != 128) {
                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(nodep->h.ip.mask.addr.a32[0])), (long)ntohl(nodep->h.ip.mask.addr.a32[1]), (long)ntohl(nodep->h.ip.mask.addr.a32[2]), (long)ntohl(nodep->h.ip.mask.addr.a32[3])),0) : 0);





            }
        } else {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIP_NODE_FREE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(nodep), (long)nodep->size, (long)ntohl(nodep->h.ip.addr.addr.addrClassic.addr), (long)ntohl(nodep->h.ip.mask.addr.addrClassic.addr) ,(long)nodep->h.ip.bits),0) : 0);







        }
    }

    pal_free(nodep,nodep->size);
}
void
kpc_nwHostNodeRele(void *_nodep)
{
    kpc_nwHostNode_t *nodep = (kpc_nwHostNode_t *)_nodep;

    if (!nodep) return;
    (!(nodep->refcount)? (*((char *)0) = 0) : 0);
    kpc_nwHostNodeFree(nodep, 1);
}
kpc_nwProtoNode_t *
kpc_nwProtoNodeAlloc(kpc_resourceInfo_t *pkpcRes, int allocFlags)
{
    size_t size;
    kpc_nwProtoNode_t *nodep=(kpc_nwProtoNode_t *)NULL;
    kpc_nwDesc_t *rulep= pkpcRes->resDesc.nwDesc;
    char *pcPtr;

    size = sizeof(kpc_nwProtoNode_t);
    if (allocFlags & 0x1) {
        size += (strlen(pkpcRes->resourceName) + 1);
    }

    nodep = (kpc_nwProtoNode_t *)pal_alloc(size);
    if (!nodep) {

        return(nodep);
    }
    memset(nodep,0,size);
    nodep->size = size;

    nodep->branchId = pkpcRes->branchId;
    pcPtr = (char *)nodep;
    pcPtr += (sizeof(kpc_nwProtoNode_t));

    nodep->protocol = rulep->protocol;
    ((&(nodep->q))->next = (&(nodep->q))->prev = (&(nodep->q)));
    ((&(nodep->ServiceQ))->next = (&(nodep->ServiceQ))->prev = (&(nodep->ServiceQ)));
    ((&(nodep->resultsQ))->next = (&(nodep->resultsQ))->prev = (&(nodep->resultsQ)));
    nodep->refcount = 1;
    if (allocFlags & 0x1) {
        nodep->pcKpon = pcPtr;
        strcpy(nodep->pcKpon, pkpcRes->resourceName);

        nodep->resFlags = pkpcRes->flags;
        nodep->epoch = kpcInfo.attrs.policyEpoch;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_KPCRES_ATTACH, (((1)<<28) + ((2)<<24) + ((1)<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16)), (long)(nodep->pcKpon), (long)*((int *)&nodep->resFlags), (long)"protocol", (long)nodep),0) : 0);



    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_PROT_NODE_ALLOC, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(nodep), (long)size, (long)nodep->protocol),0) : 0);


    return(nodep);
}
void
kpc_nwProtoNodeFree(kpc_nwProtoNode_t *nodep, int check)
{
    kutil_q_t *iter, *next, *qptr;
    kpc_nwServNode_t *servNodep;


    kail_atomic_add((int)(-1),(void *)((int *)&(nodep->refcount)));
    if (nodep->refcount) {
        if (nodep->refcount > 1) {




            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_FREE_NODE_REF, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)("serv"), (long)nodep, (long)nodep->refcount),0) : 0);


        }
        return;
    }
    if (!((((kutil_q_t *)&(nodep->ServiceQ))->next) == (kutil_q_t *)&(nodep->ServiceQ))) {
        if (check) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(nodep), (long)nodep->size, (long)nodep->protocol),0) : 0);



        }

        qptr = &(nodep->ServiceQ);
        for (iter=(((kutil_q_t *)qptr)->next); iter != qptr; iter = next) {
            next = ((iter)->next);
            servNodep = (kpc_nwServNode_t *)iter;
            (((&(servNodep->q))->next)->prev = ((&(servNodep->q))->prev), ((&(servNodep->q))->prev)->next = ((&(servNodep->q))->next));
            kpc_nwServNodeFree(servNodep,check);
        }
    }

    if (nodep->searchList) {
        pal_free(nodep->searchList,
                 (nodep->servElems * sizeof(servNodep)));
    }


    kazn_rcnwReclaim((kpc_nwBaseNode_t *)nodep);

    kpc_nwIntFreeKpon((char *)nodep, nodep->size, nodep->pcKpon);

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 7) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_PROT_NODE_FREE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(nodep), (long)nodep->size, (long)nodep->protocol),0) : 0);


    pal_free(nodep,nodep->size);
}
void
kpc_nwProtoNodeRele(void *_nodep)
{
    kpc_nwProtoNode_t *nodep = (kpc_nwProtoNode_t *)_nodep;

    if (!nodep) return;
    (!(nodep->refcount)? (*((char *)0) = 0) : 0);
    kpc_nwProtoNodeFree(nodep, 1);
}
int
kpc_nwIntServNodeImplicit(kpc_nwServNode_t *pNode)
{
    if (pNode && !pNode->pcKpon && ((((kutil_q_t *)&(pNode->HostSpecQ))->next) == (kutil_q_t *)&(pNode->HostSpecQ)) &&
        ((((kutil_q_t *)&(pNode->HostWCQ))->next) == (kutil_q_t *)&(pNode->HostWCQ)) ) {
        return(1);
    } else {
        return(0);
    }
}
int
kpc_nwIntHostNodeImplicit(kpc_nwHostNode_t *pNode)
{
    if (pNode && !pNode->pcKpon && ((((kutil_q_t *)&(pNode->ProtoQ))->next) == (kutil_q_t *)&(pNode->ProtoQ))) {
        return(1);
    } else {
        return(0);
    }
}
int
kpc_nwIntProtoNodeImplicit(kpc_nwProtoNode_t *pNode)
{
    if (pNode && !pNode->pcKpon && ((((kutil_q_t *)&(pNode->ServiceQ))->next) == (kutil_q_t *)&(pNode->ServiceQ)) ) {
        return(1);
    } else {
        return(0);
    }
}




char *
kpc_nwIntNewKPON(char *pcKpon)
{
    char *pcNew;

    pcNew = (char *)pal_alloc(strlen(pcKpon) + 1);
    if (pcNew) {
        memcpy(pcNew,pcKpon,(strlen(pcKpon)+1));
    }

    return(pcNew);
}
int
kpc_nwPortRangeCompare(kpc_portrange_t *range1, kpc_portrange_t *range2)
{
    int cmpval=0;

    if (range1->portLow < range2->portLow) {
        cmpval=-1;
    } else if (range1->portLow > range2->portLow) {
        cmpval=1;
    } else {

        if (range1->portHigh < range2->portHigh) {
            cmpval=-1;
        } else if (range1->portHigh > range2->portHigh) {
            cmpval=1;
        }
    }
    return(cmpval);
}
kpc_nwServNode_t *
kpc_nwSearchServiceQ(kutil_q_t *q, kpc_nwDesc_t *rulep, int *flagp)
{
    kpc_nwServNode_t *node = (kpc_nwServNode_t *)NULL;
    kutil_q_t *iter,*next;
    int range, cmpval=0,ncnt=0,rcnt=0;
    uint32_t ruleRanges=rulep->numPortRanges;

    if (rulep->addrType.noServ) {
        (*flagp) |= 0x0010;
        goto errout;
    }
    if (!q) { goto errout; }
    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 5) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_SEARCH_SERV_ENTRY, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(q), (long)rulep, (long)ruleRanges, (long)((ruleRanges == 1) ? rulep->portRange.one.portLow : rulep->portRange.setp[0].portLow) ,(long)((ruleRanges == 1) ? rulep->portRange.one.portHigh : rulep->portRange.setp[0].portHigh)),0) : 0);







    for (iter=(((kutil_q_t *)q)->next),ncnt=0,rcnt=0; iter != q; iter=next,ncnt++) {
        next = ((iter)->next);
        node = (kpc_nwServNode_t *)iter;

        for (range=0,cmpval=0;
             (range < ruleRanges) && (range < node->numPortRanges);
             range++,rcnt++) {
            if (ruleRanges == 1) {
                cmpval =kpc_nwPortRangeCompare(&(rulep->portRange.one),
                                               &(node->portRange[range]));
            } else {
                cmpval =kpc_nwPortRangeCompare(&(rulep->portRange.setp[range]),
                                               &(node->portRange[range]));
            }
            if (cmpval != 0) break;

        }
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 8) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_SEARCH_NODE_CMP, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(node), (long)node->numPortRanges, (long)node->portRange[0].portLow, (long)node->portRange[0].portHigh ,(long)cmpval),0) : 0);





        if (cmpval == 0) {
            if (ruleRanges < node->numPortRanges) cmpval=-1;
            else if (ruleRanges == node->numPortRanges) {

                (*flagp) |= 0x0001; break;
            } else if (ruleRanges > node->numPortRanges) cmpval=1;
        }
        if (cmpval < 0) {
            break;
        }
    }
    if ((iter == q) && node) {


        node = (kpc_nwServNode_t *)NULL;
    }
 errout:

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_SEARCH_SERVICE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(node), (long)*flagp, (long)ncnt, (long)rcnt),0) : 0);


    return(node);
}

static oss_nwIP_t kpc_ipV6_nomask;
int
kpc_nwCmpIPv6Addr(oss_nwIP_t *addr1, oss_nwIP_t *addr2,
                  oss_nwIP_t *mask1, oss_nwIP_t *mask2)
{
    int rc=0, word;
    oss_nwIP_t *usemask;

    if (mask1 && mask2) {
        for (word=0; word<4 && rc==0; word++) {
            if ((addr1->addr.a32[word] & mask1->addr.a32[word]) <
                (addr2->addr.a32[word] & mask2->addr.a32[word])) {
                rc = -1;
            } else if ((addr1->addr.a32[word] & mask1->addr.a32[word]) >
                       (addr2->addr.a32[word] & mask2->addr.a32[word])) {
                rc = 1;
            }
        }
    } else if (mask1 || mask2) {
        usemask = ( (mask1) ? mask1 : mask2);
        for (word=0; word<4 && rc==0; word++) {
            if ((addr1->addr.a32[word] & usemask->addr.a32[word]) <
                (addr2->addr.a32[word] & usemask->addr.a32[word])) {
                rc = -1;
            } else if ((addr1->addr.a32[word] & usemask->addr.a32[word]) >
                       (addr2->addr.a32[word] & usemask->addr.a32[word])) {
                rc = 1;
            }
        }
    } else {
        for (word=0; word<4 && rc==0; word++) {
            if (addr1->addr.a32[word] < addr2->addr.a32[word]) {
                rc = -1;
            } else if (addr1->addr.a32[word] > addr2->addr.a32[word]) {
                rc = 1;
            }
        }
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 9) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_CMP, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16) + ((2)<<12) + ((0)<<8)), (long)(addr1), (long)addr2, (long)mask1, (long)mask2 ,(long)rc),0) : 0);



    return(rc);
}
kpc_nwHostNode_t *
kpc_nwSearchHostIPv6Q(kutil_q_t *q, kpc_nwDesc_t *rulep, int *flagp)
{
    kpc_nwHostNode_t *node = (kpc_nwHostNode_t *)NULL;
    kutil_q_t *iter,*next;
    int ncnt=0, match=1, word=0, done=0, rc;






    for (iter=(((kutil_q_t *)q)->prev); iter != q; iter=next, ncnt++) {
        next = ((iter)->prev);
        node = (kpc_nwHostNode_t *)iter;
        if (node->h.ip.addr.ipV6 == 0) {

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 5) ? (kt_Event1((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_HIT_V4, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(node)),0) : 0);

            break;
        }
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 9) ? (kt_Event2((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_HIT_V4, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(node), (long)(ncnt+1)),0) : 0);

        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 9) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(node->h.ip.addr.addr.a32[0])), (long)ntohl(node->h.ip.addr.addr.a32[1]), (long)ntohl(node->h.ip.addr.addr.a32[2]), (long)ntohl(node->h.ip.addr.addr.a32[3])),0) : 0);




        if (node->h.ip.bits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 9) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(node->h.ip.mask.addr.a32[0])), (long)ntohl(node->h.ip.mask.addr.a32[1]), (long)ntohl(node->h.ip.mask.addr.a32[2]), (long)ntohl(node->h.ip.mask.addr.a32[3])),0) : 0);




        }

        rc = kpc_nwCmpIPv6Addr(&(node->h.ip.addr), &(rulep->ipaddr),
                               &(node->h.ip.mask), &(rulep->mask));

        if (rc == 0) {
            rc = kpc_nwCmpIPv6Addr(&(node->h.ip.addr), &(rulep->ipaddr),
                                   NULL, NULL);
            if ((rc == 0) && (node->h.ip.bits == rulep->significantBits)) {


                (*flagp) |= 0x0002; break;
            } else if (node->h.ip.bits < rulep->significantBits) {


                break;
            } else if (rc < 0) {


                break;
            }
        } else if (rc < 0) {

            break;
        }

    }
    if ((iter == q) && node) {


        node = (kpc_nwHostNode_t *)NULL;
    }
 errout:

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_SEARCH_HOSTIPV6, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(node), (long)*flagp, (long)ncnt),0) : 0);

    if (node) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(node->h.ip.addr.addr.a32[0])), (long)ntohl(node->h.ip.addr.addr.a32[1]), (long)ntohl(node->h.ip.addr.addr.a32[2]), (long)ntohl(node->h.ip.addr.addr.a32[3])),0) : 0);




        if (node->h.ip.bits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(node->h.ip.mask.addr.a32[0])), (long)ntohl(node->h.ip.mask.addr.a32[1]), (long)ntohl(node->h.ip.mask.addr.a32[2]), (long)ntohl(node->h.ip.mask.addr.a32[3])),0) : 0);




        }
    }
    return(node);
}
kpc_nwHostNode_t *
kpc_nwSearchHostIPQ(kutil_q_t *q, kpc_nwDesc_t *rulep, int *flagp)
{
    kpc_nwHostNode_t *node = (kpc_nwHostNode_t *)NULL;
    kutil_q_t *iter,*next;
    uint32_t ruleIPAddr=0;
    int ncnt=0;

    if (rulep->addrType.noHostIP) {
        (*flagp) |= 0x0040;
        goto errout;
    }
    if (!q) { goto errout; }


    if (!(rulep->addrType.addrClassic || rulep->addrType.addrV6)) {
        (*flagp) |= 0x0008;
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_HOST_RULE_BAD, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(rulep), (long)*((int *)&rulep->addrType)),0) : 0);


        goto errout;
    }

    if (rulep->addrType.addrV6) {

        return(kpc_nwSearchHostIPv6Q(q, rulep, flagp));
    }

    ruleIPAddr = rulep->ipaddr.addr.addrClassic.addr;



    for (iter=(((kutil_q_t *)q)->next); iter != q; iter=next, ncnt++) {
        next = ((iter)->next);
        node = (kpc_nwHostNode_t *)iter;

        if ((node->h.ip.addr.addr.addrClassic.addr &
             node->h.ip.mask.addr.addrClassic.addr) ==
            (ruleIPAddr & rulep->mask.addr.addrClassic.addr)) {


            if ((ruleIPAddr == node->h.ip.addr.addr.addrClassic.addr) &&
                (node->h.ip.bits == rulep->significantBits)) {

                (*flagp) |= 0x0002; break;
            } else if (node->h.ip.bits < rulep->significantBits) {


                break;
            } else if (ruleIPAddr > node->h.ip.addr.addr.addrClassic.addr) {

                break;
            }
        } else if ((node->h.ip.addr.addr.addrClassic.addr &
                    node->h.ip.mask.addr.addrClassic.addr) <
                   (ruleIPAddr & rulep->mask.addr.addrClassic.addr)) {

            break;
        }

    }
    if ((iter == q) && node) {


        node = (kpc_nwHostNode_t *)NULL;
    }
 errout:

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_SEARCH_HOSTIP, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(node), (long)*flagp, (long)ncnt, (long)ruleIPAddr ,(long)rulep->mask.addr.addrClassic.addr),0) : 0);



    return(node);
}
kpc_nwHostNode_t *
kpc_nwSearchHostNameQ(kutil_q_t *q, kpc_nwDesc_t *rulep, int *flagp)
{

    kpc_nwHostNode_t *node = (kpc_nwHostNode_t *)NULL;
    kutil_q_t *iter,*next;
    int cmpval=0, ncnt=0;

    if (rulep->addrType.noHostName) {
        (*flagp) |= 0x0080;
        goto errout;
    }
    if (!q) { goto errout; }


    if (rulep->wcHostData == NULL) {
        (*flagp) |= 0x0008;
        goto errout;
    }


    for (iter=(((kutil_q_t *)q)->next); iter != q; iter=next, ncnt++) {
        next = ((iter)->next);
        node = (kpc_nwHostNode_t *)iter;

        cmpval = strcmp(node->wcSpecp, rulep->wcHostData);
        if (cmpval == 0) {

            (*flagp) |= 0x0002; break;
        } else if (cmpval < 0) {


            break;
        }

    }

    if ((iter == q) && node) {


        node = (kpc_nwHostNode_t *)NULL;
    }
 errout:

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_SEARCH_HOSTNAME, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((1)<<16)), (long)(node), (long)*flagp, (long)ncnt, (long)rulep->wcHostData),0) : 0);


    return(node);
}
kpc_nwProtoNode_t *
kpc_nwSearchProtoQ(kutil_q_t *q, kpc_nwDesc_t *rulep, int *flagp)
{
    kpc_nwProtoNode_t *node = (kpc_nwProtoNode_t *)NULL;
    kutil_q_t *iter,*next;
    int cmpval=0, ncnt=0;

    if (rulep->addrType.noProto) {
        (*flagp) |= 0x0020;
        goto errout;
    }
    if (!q) { goto errout; }

    if (rulep->protocol != 6) {
        (*flagp) |= 0x0008;
        goto errout;
    }


    for (iter=(((kutil_q_t *)q)->next); iter != q; iter=next, ncnt++) {
        next = ((iter)->next);
        node = (kpc_nwProtoNode_t *)iter;

        if (rulep->protocol == node->protocol) {

            (*flagp) |= 0x0004; break;
        } else if (rulep->protocol < node->protocol) {


            break;
        }

    }

    if ((iter == q) && node) {


        node = (kpc_nwProtoNode_t *)NULL;
    }
 errout:

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_SEARCH_PROTOCOL, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(node), (long)*flagp, (long)ncnt, (long)rulep->protocol),0) : 0);


    return(node);
}
kpc_nwServNode_t *
kpc_nwMatchServ(kutil_q_t *q, int service)
{
    kpc_nwServNode_t *node=NULL, *match=NULL;
    kutil_q_t *iter,*next;
    int range, found = 0, ncnt=0, rcnt=0;

    if (!q) { return(node); }
    for (iter=(((kutil_q_t *)q)->next); iter != q; iter=next, ncnt++) {
        next = ((iter)->next);
        node = (kpc_nwServNode_t *)iter;


        if (node->epoch != kpcInfo.attrs.policyEpoch) {

            kpc_nwIntFreeKpon((char *)node, node->size, node->pcKpon);

            node->pcKpon = (char *)NULL;
            if (kpc_nwIntServNodeImplicit(node)) {
                (((&(node->q))->next)->prev = ((&(node->q))->prev), ((&(node->q))->prev)->next = ((&(node->q))->next));
                kpc_nwServNodeFree(node,1);
                continue;
            }
        }


        for (range=0; (range < node->numPortRanges); range++, rcnt++) {
            if ((node->portRange[range].portLow <= service) &&
                (service <= node->portRange[range].portHigh)) {
                found = 1; break;
            }
        }
        if (found) {
            if (!match) {
                match = node;
            } else {

                if (node->totalPorts < match->totalPorts) {
                    match = node;

                }
            }
            found = 0;
        }
    }


    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_MATCH_SERVICE, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((2)<<16)), (long)(service), (long)match, (long)ncnt, (long)rcnt),0) : 0);


    return(match);
}
kpc_nwHostNode_t *
kpc_nwMatchHostIPv6(kutil_q_t *q,oss_nwIP_t * ipaddr,
                    kpc_nwOutPolicy_t *pOutPol)
{
    kpc_nwHostNode_t *node=NULL, *match=NULL;
    kutil_q_t *iter,*next;
    int ncnt=0, rc;

    if (!q) { return(node); }
    for (iter=(((kutil_q_t *)q)->prev); iter != q && !match; iter=next, ncnt++) {
        next = ((iter)->prev);
        node = (kpc_nwHostNode_t *)iter;


        if (node->epoch != kpcInfo.attrs.policyEpoch) {

            kpc_nwIntFreeKpon((char *)node, node->size, node->pcKpon);

            node->pcKpon = (char *)NULL;
            if (kpc_nwIntHostNodeImplicit(node)) {
                (((&(node->q))->next)->prev = ((&(node->q))->prev), ((&(node->q))->prev)->next = ((&(node->q))->next));
                kpc_nwHostNodeFree(node,1);
                if (pOutPol) {
                    pOutPol->IPNodes -= 1;
                }
                continue;
            }
        }


        if (node->h.ip.addr.ipV6 == 0) {

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 9) ? (kt_Event1((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_HIT_V4, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(node)),0) : 0);

            break;
        }
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 9) ? (kt_Event2((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(node), (long)(ncnt+1)),0) : 0);


        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 9) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(node->h.ip.addr.addr.a32[0])), (long)ntohl(node->h.ip.addr.addr.a32[1]), (long)ntohl(node->h.ip.addr.addr.a32[2]), (long)ntohl(node->h.ip.addr.addr.a32[3])),0) : 0);




        if (node->h.ip.bits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 9) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(node->h.ip.mask.addr.a32[0])), (long)ntohl(node->h.ip.mask.addr.a32[1]), (long)ntohl(node->h.ip.mask.addr.a32[2]), (long)ntohl(node->h.ip.mask.addr.a32[3])),0) : 0);




        }

        rc = kpc_nwCmpIPv6Addr(&(node->h.ip.addr), ipaddr,
                               &(node->h.ip.mask), NULL);
        if (rc == 0) {
            match = node;

            break;
        }
    }


    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_MATCH_HOSTIPV6, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(ipaddr), (long)match, (long)ncnt),0) : 0);

    if (match) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(match->h.ip.addr.addr.a32[0])), (long)ntohl(match->h.ip.addr.addr.a32[1]), (long)ntohl(match->h.ip.addr.addr.a32[2]), (long)ntohl(match->h.ip.addr.addr.a32[3])),0) : 0);




        if (match->h.ip.bits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(match->h.ip.mask.addr.a32[0])), (long)ntohl(match->h.ip.mask.addr.a32[1]), (long)ntohl(match->h.ip.mask.addr.a32[2]), (long)ntohl(match->h.ip.mask.addr.a32[3])),0) : 0);




        }
    }
    return(match);
}
kpc_nwHostNode_t *
kpc_nwMatchHostIP(kutil_q_t *q, oss_nwIP_t * ipaddr,
                  int checkV4V6, kpc_nwOutPolicy_t *pOutPol)
{
    kpc_nwHostNode_t *node=NULL, *match=NULL;
    kutil_q_t *iter,*next;
    int ncnt=0;

    if (!q) { return(node); }

    if (ipaddr->ipV6) {

        return(kpc_nwMatchHostIPv6(q,ipaddr,pOutPol));
    }

    for (iter=(((kutil_q_t *)q)->next); iter != q; iter=next, ncnt++) {
        next = ((iter)->next);
        node = (kpc_nwHostNode_t *)iter;


        if (node->epoch != kpcInfo.attrs.policyEpoch) {

            kpc_nwIntFreeKpon((char *)node, node->size, node->pcKpon);

            node->pcKpon = (char *)NULL;
            if (kpc_nwIntHostNodeImplicit(node)) {
                (((&(node->q))->next)->prev = ((&(node->q))->prev), ((&(node->q))->prev)->next = ((&(node->q))->next));
                kpc_nwHostNodeFree(node,1);
                if (pOutPol) {
                    pOutPol->IPNodes -= 1;
                }
                continue;
            }
        }


        if ((ipaddr->addr.addrClassic.addr &
             node->h.ip.mask.addr.addrClassic.addr) ==
            (node->h.ip.addr.addr.addrClassic.addr &
             node->h.ip.mask.addr.addrClassic.addr)) {
            match = node;

            break;
        }
    }


    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_MATCH_HOSTIP, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(ipaddr->addr.addrClassic.addr), (long)match, (long)ncnt),0) : 0);


    return(match);
}
kpc_nwHostNode_t *
kpc_nwMatchHostName(kutil_q_t *q, char *pcHost, kpc_nwOutPolicy_t *pOutPol)
{
    kpc_nwHostNode_t *node=NULL, *match=NULL;
    kutil_q_t *iter,*next;
    int ncnt=0;

    if (!q) { return(node); }
    for (iter=(((kutil_q_t *)q)->next); iter != q; iter=next, ncnt++) {
        next = ((iter)->next);
        node = (kpc_nwHostNode_t *)iter;


        if (node->epoch != kpcInfo.attrs.policyEpoch) {

            kpc_nwIntFreeKpon((char *)node, node->size, node->pcKpon);

            node->pcKpon = (char *)NULL;
            if (kpc_nwIntHostNodeImplicit(node)) {
                (((&(node->q))->next)->prev = ((&(node->q))->prev), ((&(node->q))->prev)->next = ((&(node->q))->next));
                kpc_nwHostNodeFree(node,1);
                if (pOutPol) {
                    pOutPol->hostNodes -= 1;
                }
                continue;
            }
        }

        if (!strcmp(pcHost, node->wcSpecp)) {
            match = node;

            break;
        }
    }


    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_MATCH_HOSTNAME, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(pcHost), (long)match, (long)ncnt),0) : 0);

    return(match);
}
kpc_nwProtoNode_t *
kpc_nwMatchProto(kutil_q_t *q, uint16_t proto, kpc_nwInPolicy_t *pInPol)
{
    kpc_nwProtoNode_t *node=NULL, *match=NULL;
    kutil_q_t *iter,*next;
    int ncnt=0;

    if (!q) { return(node); }
    for (iter=(((kutil_q_t *)q)->next); iter != q; iter=next, ncnt++) {
        next = ((iter)->next);
        node = (kpc_nwProtoNode_t *)iter;


        if (node->epoch != kpcInfo.attrs.policyEpoch) {

            kpc_nwIntFreeKpon((char *)node, node->size, node->pcKpon);

            node->pcKpon = (char *)NULL;
            if (kpc_nwIntProtoNodeImplicit(node)) {
                (((&(node->q))->next)->prev = ((&(node->q))->prev), ((&(node->q))->prev)->next = ((&(node->q))->next));
                kpc_nwProtoNodeFree(node,1);
                if (pInPol) {
                    pInPol->nodes -= 1;
                }
                continue;
            }
        }


        if (proto == node->protocol) {
            match = node;

            break;
        }
    }


    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_MATCH_PROTOCOL, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(proto), (long)match, (long)ncnt),0) : 0);

    return(match);
}
void
kpc_nwSetAllocFlags(kpc_nwDesc_t *pnwRes, int policyType, int *pAllocFlags)
{
    *pAllocFlags = 0;

    if (policyType == 0x1) {
        if (pnwRes->addrType.noHostIP && pnwRes->addrType.noHostName) {

            if (pnwRes->addrType.noServ) {

                if (!pnwRes->addrType.noProto) {
                    (*pAllocFlags) = 0x1;
                } else {
                    (*pAllocFlags) = 0x1000;
                }
            } else {

                (*pAllocFlags) = 0x2;
            }
        } else {

            if (pnwRes->addrType.noHostIP) {
                (*pAllocFlags) = 0x8;
            } else {
                (*pAllocFlags) = 0x4;
            }
        }
    } else if (policyType == 0x2) {
        if (pnwRes->addrType.noServ) {

            if (pnwRes->addrType.noProto) {

                if (pnwRes->addrType.noHostIP && pnwRes->addrType.noHostName) {
                    (*pAllocFlags) = 0x1000;
                } else {
                    if (pnwRes->addrType.noHostIP) {
                        (*pAllocFlags) = 0x8;
                    } else {
                        (*pAllocFlags) = 0x4;
                    }
                }
            } else {

                (*pAllocFlags) = 0x1;
            }
        } else {

                (*pAllocFlags) = 0x2;
        }
    }
    else {
        (*pAllocFlags) = 0x2000;
    }
}




void
kpc_nwInitKPCInfo(kenv_kpcInfo_t *kip)
{
    memset(kip,0,sizeof(kenv_kpcInfo_t));
    kip->resName = NULL;
    kip->next = NULL;
    kip->extDataLen = 0;
    kip->kpcFlags = 0x02000000;
}
void
kpc_nwConvAddrNH(oss_nwAddr_t *nwAddrp)
{
    uint32_t temp32;
    uint16_t temp16;

    if (!nwAddrp) return;


    temp16 = ntohs(nwAddrp->service.port);
    nwAddrp->service.port = temp16;
    if (!(nwAddrp->ip.ipV6)) {
        temp32 = ntohl(nwAddrp->ip.addr.addrClassic.addr);
        nwAddrp->ip.addr.addrClassic.addr = temp32;
    } else {
        temp32 = ntohl(nwAddrp->ip.addr.a32[0]);
        nwAddrp->ip.addr.a32[0] = temp32;
        temp32 = ntohl(nwAddrp->ip.addr.a32[1]);
        nwAddrp->ip.addr.a32[1] = temp32;
        temp32 = ntohl(nwAddrp->ip.addr.a32[2]);
        nwAddrp->ip.addr.a32[2] = temp32;
        temp32 = ntohl(nwAddrp->ip.addr.a32[3]);
        nwAddrp->ip.addr.a32[3] = temp32;
    }
}
void
kpc_nwConvAddrHN(oss_nwAddr_t *nwAddrp)
{
    uint32_t temp32;
    uint16_t temp16;

    if (!nwAddrp) return;


    temp16 = htons(nwAddrp->service.port);
    nwAddrp->service.port = temp16;
    if (!(nwAddrp->ip.ipV6)) {
        temp32 = htonl(nwAddrp->ip.addr.addrClassic.addr);
        nwAddrp->ip.addr.addrClassic.addr = temp32;
    } else {
        temp32 = htonl(nwAddrp->ip.addr.a32[0]);
        nwAddrp->ip.addr.a32[0] = temp32;
        temp32 = htonl(nwAddrp->ip.addr.a32[1]);
        nwAddrp->ip.addr.a32[1] = temp32;
        temp32 = htonl(nwAddrp->ip.addr.a32[2]);
        nwAddrp->ip.addr.a32[2] = temp32;
        temp32 = htonl(nwAddrp->ip.addr.a32[3]);
        nwAddrp->ip.addr.a32[3] = temp32;
    }
}
void
kpc_nwEnvResReset(kpc_nwHostNode_t *pHost, char *pcSearch,
                  kenv_envHandle_t envH, kenv_kpcInfo_t *kip)
{
    kenv_kpcInfo_t *kipCur;


    kipCur = kenv_envGetKPCInfo(envH);
    if (kipCur) {
        if (strcmp(kipCur->resName, pcSearch)) {

            kenv_envResetKPCInfo(envH);
            kipCur = NULL;
        }
    }



    if (!kipCur) {

        kip->resData.nw.policyVersion = pHost->policyVersion;
        kip->resData.nw.pUserRes = pHost->pWCNode;

        kip->resName = pcSearch;
        kip->resNameLen = strlen(pcSearch);
        kip->kpcFlags |= 0x1000;
        kenv_envSetKPCInfo(envH, kip);
    }


    (((kenv_env_t *)(envH))->flags |= 0x00080000);

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 5) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_ENV_SETRES, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(pcSearch), (long)envH, (long)((kenv_env_t *)envH)->flags),0) : 0);


}
int
kpc_nwInPolicyAdd(kpc_nwInPolicy_t *kpc_nwInPol,kpc_resourceInfo_t *kpcresp)
{
    kpc_nwProtoNode_t *protNode=NULL, *newProtp=(kpc_nwProtoNode_t *)NULL;
    kpc_nwServNode_t *servNode=NULL, *newServp=(kpc_nwServNode_t *)NULL;
    kpc_nwHostNode_t *hostNode=NULL, *newHostp=(kpc_nwHostNode_t *)NULL;
    kpc_nwDesc_t *rulep;
    int addFlags=0, rc=0, allocFlags;
    char *pcTrace=(char *)NULL;


    if (!kpcresp) {
        return(-13);
    }
    rulep = kpcresp->resDesc.nwDesc;
    kpc_nwSetAllocFlags(rulep, 0x1, &allocFlags);
    if (allocFlags & 0xff000) {
        return(-14);
    }
    if (rulep->addrType.noProto) {
        return(-13);
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_UPD_ENTRY, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(kpcresp->op), (long)*((int *)&rulep->addrType), (long)rulep->protocol, (long)rulep->numPortRanges ,(long)rulep->totalPorts),0) : 0);



    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_UPD_ENTRY2, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((1)<<12) + ((0)<<8)), (long)(((rulep->numPortRanges > 1) ? rulep->portRange.setp[0].portLow : rulep->portRange.one.portLow)), (long)((rulep->numPortRanges > 1) ? rulep->portRange.setp[0].portHigh : rulep->portRange.one.portHigh), (long)rulep->ipaddr.addr.addrClassic.addr, (long)rulep->significantBits ,(long)(rulep->wcHostData ? rulep->wcHostData:"NULL")),0) : 0);
    if (rulep->addrType.addrV6) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(rulep->ipaddr.addr.a32[0])), (long)ntohl(rulep->ipaddr.addr.a32[1]), (long)ntohl(rulep->ipaddr.addr.a32[2]), (long)ntohl(rulep->ipaddr.addr.a32[3])),0) : 0);




        if (rulep->significantBits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(rulep->mask.addr.a32[0])), (long)ntohl(rulep->mask.addr.a32[1]), (long)ntohl(rulep->mask.addr.a32[2]), (long)ntohl(rulep->mask.addr.a32[3])),0) : 0);




        }
    }


    (kail_mutex_lock(&(kpc_nwInPol->lock)));
    if (kpc_nwInPol->flags & 0x10) {
        goto out;
    }
    (kpc_nwInPol->flags) |= 0x1;
    while (kpc_nwInPol->readers > 0) {
        (kail_cond_wait(&(kpc_nwInPol->cond),&(kpc_nwInPol->lock)));
    }


    protNode = kpc_nwSearchProtoQ(&(kpc_nwInPol->ProtoQ),rulep,&addFlags);
    if (addFlags & 0x0004) {
        newProtp = protNode;

        newProtp->epoch = kpcInfo.attrs.policyEpoch;
        if (!(allocFlags & 0x1)) {

            servNode = kpc_nwSearchServiceQ(&(protNode->ServiceQ),rulep,
                                            &addFlags);
        } else {

            protNode->branchId = kpcresp->branchId;
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_BRANCH_CHANGE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(protNode), (long)(protNode->pcKpon ? protNode->pcKpon : "NULL"), (long)protNode->branchId),0) : 0);




            if (!protNode->pcKpon) {
                protNode->pcKpon = kpc_nwIntNewKPON(kpcresp->resourceName);
                if (!protNode->pcKpon) {
                    rc = -10; goto out;
                }
            }
        }
    } else {

        newProtp = kpc_nwProtoNodeAlloc(kpcresp, allocFlags);
    }
    if (!newProtp) { rc = -10; goto out; }

    if ((addFlags & 0x0001) && servNode) {


        newServp = servNode;

        newServp->epoch = kpcInfo.attrs.policyEpoch;
        if (!(allocFlags & 0x2)) {

            if (rulep->addrType.noHostIP) {
                hostNode = kpc_nwSearchHostNameQ(&(newServp->HostWCQ),rulep,
                                                 &addFlags);
            } else {
                hostNode = kpc_nwSearchHostIPQ(&(newServp->HostSpecQ),rulep,
                                               &addFlags);
            }
        } else {

            servNode->branchId = kpcresp->branchId;
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_BRANCH_CHANGE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(servNode), (long)(servNode->pcKpon ? servNode->pcKpon : "NULL"), (long)servNode->branchId),0) : 0);




            if (!servNode->pcKpon) {
                servNode->pcKpon = kpc_nwIntNewKPON(kpcresp->resourceName);
                if (!servNode->pcKpon) {
                    rc = -10; goto out;
                }
            }
        }
    } else if (!(rulep->addrType.noServ)) {


        newServp = kpc_nwServNodeAlloc(kpcresp, allocFlags);
    }

    if (!newServp && !(rulep->addrType.noServ)) {
        rc = -10; goto out;
    }
    if (addFlags & 0x0002) {

        hostNode->branchId = kpcresp->branchId;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_BRANCH_CHANGE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(hostNode), (long)(hostNode->pcKpon ? hostNode->pcKpon : "NULL"), (long)hostNode->branchId),0) : 0);



        hostNode->epoch = kpcInfo.attrs.policyEpoch;

        pcTrace = "host";
                                       goto out;
    }

    if (!(rulep->addrType.noHostIP && rulep->addrType.noHostName) &&
        newServp) {

        newHostp = kpc_nwHostNodeAlloc(kpcresp, allocFlags);
        if (!newHostp) {

            rc = -10; goto out;
        }


        if (newHostp->wcSpecp) {
            if ((hostNode ? &(hostNode->q) : NULL)) { if (0x1 == 0x1) { ((&(newHostp->q))->next = ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL)), (&(newHostp->q))->prev = (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev), (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev)->next = (&(newHostp->q)), ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev = (&(newHostp->q))); } else if (0x1 == 0x2) { ((&(newHostp->q))->next = (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next), (&(newHostp->q))->prev = ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL)), (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next)->prev = (&(newHostp->q)), ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next = (&(newHostp->q))); } } else { if (0x1 == 0x1) { ((&(newHostp->q))->next = (&(newServp->HostWCQ)), (&(newHostp->q))->prev = (((kutil_q_t *)&(newServp->HostWCQ))->prev), (((kutil_q_t *)&(newServp->HostWCQ))->prev)->next = (&(newHostp->q)), (&(newServp->HostWCQ))->prev = (&(newHostp->q))); } else if (0x1 == 0x2) { ((&(newHostp->q))->next = (((kutil_q_t *)&(newServp->HostWCQ))->next), (&(newHostp->q))->prev = (&(newServp->HostWCQ)), (((kutil_q_t *)&(newServp->HostWCQ))->next)->prev = (&(newHostp->q)), (&(newServp->HostWCQ))->next = (&(newHostp->q))); } };

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETIN_ADD_NODE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16)), (long)("host name"), (long)newHostp, (long)(newHostp->pcKpon ? newHostp->pcKpon : "NULL"), (long)newHostp->branchId),0) : 0);




        } else {
            int qAddFlag;

            if (newHostp->h.ip.addr.ipV6) {
                qAddFlag = 0x2;

            } else {
                qAddFlag = 0x1;
            }
            if ((hostNode ? &(hostNode->q) : NULL)) { if (qAddFlag == 0x1) { ((&(newHostp->q))->next = ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL)), (&(newHostp->q))->prev = (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev), (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev)->next = (&(newHostp->q)), ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev = (&(newHostp->q))); } else if (qAddFlag == 0x2) { ((&(newHostp->q))->next = (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next), (&(newHostp->q))->prev = ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL)), (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next)->prev = (&(newHostp->q)), ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next = (&(newHostp->q))); } } else { if (qAddFlag == 0x1) { ((&(newHostp->q))->next = (&(newServp->HostSpecQ)), (&(newHostp->q))->prev = (((kutil_q_t *)&(newServp->HostSpecQ))->prev), (((kutil_q_t *)&(newServp->HostSpecQ))->prev)->next = (&(newHostp->q)), (&(newServp->HostSpecQ))->prev = (&(newHostp->q))); } else if (qAddFlag == 0x2) { ((&(newHostp->q))->next = (((kutil_q_t *)&(newServp->HostSpecQ))->next), (&(newHostp->q))->prev = (&(newServp->HostSpecQ)), (((kutil_q_t *)&(newServp->HostSpecQ))->next)->prev = (&(newHostp->q)), (&(newServp->HostSpecQ))->next = (&(newHostp->q))); } };

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETIN_ADD_NODE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16)), (long)("host IP"), (long)newHostp, (long)(newHostp->pcKpon ? newHostp->pcKpon : "NULL"), (long)newHostp->branchId),0) : 0);




        }
    }



    if (newServp && (newServp != servNode)) {
        if ((servNode ? &(servNode->q) : NULL)) { if (0x1 == 0x1) { ((&(newServp->q))->next = ((kutil_qHead_t *)(servNode ? &(servNode->q) : NULL)), (&(newServp->q))->prev = (((kutil_q_t *)(kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->prev), (((kutil_q_t *)(kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->prev)->next = (&(newServp->q)), ((kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->prev = (&(newServp->q))); } else if (0x1 == 0x2) { ((&(newServp->q))->next = (((kutil_q_t *)(kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->next), (&(newServp->q))->prev = ((kutil_qHead_t *)(servNode ? &(servNode->q) : NULL)), (((kutil_q_t *)(kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->next)->prev = (&(newServp->q)), ((kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->next = (&(newServp->q))); } } else { if (0x1 == 0x1) { ((&(newServp->q))->next = (&(newProtp->ServiceQ)), (&(newServp->q))->prev = (((kutil_q_t *)&(newProtp->ServiceQ))->prev), (((kutil_q_t *)&(newProtp->ServiceQ))->prev)->next = (&(newServp->q)), (&(newProtp->ServiceQ))->prev = (&(newServp->q))); } else if (0x1 == 0x2) { ((&(newServp->q))->next = (((kutil_q_t *)&(newProtp->ServiceQ))->next), (&(newServp->q))->prev = (&(newProtp->ServiceQ)), (((kutil_q_t *)&(newProtp->ServiceQ))->next)->prev = (&(newServp->q)), (&(newProtp->ServiceQ))->next = (&(newServp->q))); } };

        (newProtp->flags) |= 0x2;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETIN_ADD_NODE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16)), (long)("service"), (long)newServp, (long)(newServp->pcKpon ? newServp->pcKpon : "NULL"), (long)newServp->branchId),0) : 0);




    }



    if (newProtp && (newProtp != protNode)) {
        if ((protNode ? &(protNode->q) : NULL)) { if (0x1 == 0x1) { ((&(newProtp->q))->next = ((kutil_qHead_t *)(protNode ? &(protNode->q) : NULL)), (&(newProtp->q))->prev = (((kutil_q_t *)(kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->prev), (((kutil_q_t *)(kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->prev)->next = (&(newProtp->q)), ((kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->prev = (&(newProtp->q))); } else if (0x1 == 0x2) { ((&(newProtp->q))->next = (((kutil_q_t *)(kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->next), (&(newProtp->q))->prev = ((kutil_qHead_t *)(protNode ? &(protNode->q) : NULL)), (((kutil_q_t *)(kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->next)->prev = (&(newProtp->q)), ((kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->next = (&(newProtp->q))); } } else { if (0x1 == 0x1) { ((&(newProtp->q))->next = (&(kpc_nwInPol->ProtoQ)), (&(newProtp->q))->prev = (((kutil_q_t *)&(kpc_nwInPol->ProtoQ))->prev), (((kutil_q_t *)&(kpc_nwInPol->ProtoQ))->prev)->next = (&(newProtp->q)), (&(kpc_nwInPol->ProtoQ))->prev = (&(newProtp->q))); } else if (0x1 == 0x2) { ((&(newProtp->q))->next = (((kutil_q_t *)&(kpc_nwInPol->ProtoQ))->next), (&(newProtp->q))->prev = (&(kpc_nwInPol->ProtoQ)), (((kutil_q_t *)&(kpc_nwInPol->ProtoQ))->next)->prev = (&(newProtp->q)), (&(kpc_nwInPol->ProtoQ))->next = (&(newProtp->q))); } };

        kpc_nwInPol->nodes += 1;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETIN_ADD_NODE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16)), (long)("protocol"), (long)newProtp, (long)(newProtp->pcKpon ? newProtp->pcKpon : "NULL"), (long)newProtp->branchId),0) : 0);




    }
 out:
    if (rc != 0) {
        if (rc == -12) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_ALREADY, (((1)<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(kpcresp->resourceName), (long)pcTrace, (long)addFlags),0) : 0);


        }

        if (!(addFlags & 0x0001) && newServp) {
            kpc_nwServNodeFree(newServp,1);
        }
        if (!(addFlags & 0x0004) && newProtp) {
            kpc_nwProtoNodeFree(newProtp,1);
        }
    }


    (kpc_nwInPol->flags) &= ~0x1;
    (kail_mutex_unlock(&(kpc_nwInPol->lock)));

    (kail_wake_up(&(kpc_nwInPol->cond)));

    return(rc);
}
int
kpc_nwInPolicyDel(kpc_nwInPolicy_t *kpc_nwInPol,kpc_resourceInfo_t *kpcresp)
{
    kpc_nwProtoNode_t *protNode=(kpc_nwProtoNode_t *)NULL;
    kpc_nwServNode_t *servNode=(kpc_nwServNode_t *)NULL;
    kpc_nwHostNode_t *hostNode=(kpc_nwHostNode_t *)NULL;
    void *pNode=NULL;
    kpc_nwDesc_t *rulep;
    int searchFlags=0, rc=0, delState=0;
    char *pcTrace="NULL";


    if (!kpcresp) {
        return(-13);
    }
    rulep = kpcresp->resDesc.nwDesc;

    if (rulep->addrType.noProto) {
        return(-13);
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_UPD_ENTRY, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(kpcresp->op), (long)*((int *)&rulep->addrType), (long)rulep->protocol, (long)rulep->numPortRanges ,(long)rulep->totalPorts),0) : 0);




    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_UPD_ENTRY2, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((1)<<12) + ((0)<<8)), (long)(((rulep->numPortRanges > 1) ? rulep->portRange.setp[0].portLow : rulep->portRange.one.portLow)), (long)((rulep->numPortRanges > 1) ? rulep->portRange.setp[0].portHigh : rulep->portRange.one.portHigh), (long)rulep->ipaddr.addr.addrClassic.addr, (long)rulep->significantBits ,(long)(rulep->wcHostData ? rulep->wcHostData:"NULL")),0) : 0);
    if (rulep->addrType.addrV6) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(rulep->ipaddr.addr.a32[0])), (long)ntohl(rulep->ipaddr.addr.a32[1]), (long)ntohl(rulep->ipaddr.addr.a32[2]), (long)ntohl(rulep->ipaddr.addr.a32[3])),0) : 0);




        if (rulep->significantBits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(rulep->mask.addr.a32[0])), (long)ntohl(rulep->mask.addr.a32[1]), (long)ntohl(rulep->mask.addr.a32[2]), (long)ntohl(rulep->mask.addr.a32[3])),0) : 0);




        }
    }


    (kail_mutex_lock(&(kpc_nwInPol->lock)));
    if (kpc_nwInPol->flags & 0x10) {
        goto errout;
    }
    (kpc_nwInPol->flags) |= 0x1;
    while (kpc_nwInPol->readers > 0) {
        (kail_cond_wait(&(kpc_nwInPol->cond),&(kpc_nwInPol->lock)));
    }


    protNode = kpc_nwSearchProtoQ(&(kpc_nwInPol->ProtoQ),rulep,&searchFlags);
    if (!(searchFlags & 0x0004)) {

        pcTrace = "protocol";
        delState |= 0x8000;
        rc = -15; goto errout;
    }


    delState |= 0x0008;
    if (!(rulep->addrType.noServ)) {

        servNode = kpc_nwSearchServiceQ(&(protNode->ServiceQ),rulep,
                                        &searchFlags);
        if (!(searchFlags & 0x0001)) {

            delState |= 0x4000;
            pcTrace = "service";
            rc = -15; goto errout;
        }
        delState |= 0x0004;
    } else if (!rulep->addrType.noHostIP || !rulep->addrType.noHostName) {

        delState |= 0x4000;
        pcTrace = "service";
        rc = -13; goto errout;
    }


    if (!(rulep->addrType.noHostIP && rulep->addrType.noHostName) &&
        servNode) {

        if (rulep->addrType.noHostIP) {
            hostNode =
                kpc_nwSearchHostNameQ(&(servNode->HostWCQ),rulep,&searchFlags);
        } else {
            hostNode =
                kpc_nwSearchHostIPQ(&(servNode->HostSpecQ),rulep,&searchFlags);
        }
        if (!hostNode) {

            if (rulep->addrType.noHostIP) {
                pcTrace = "host name";
                delState |= 0x2000;
            } else {
                pcTrace = "host IP";
                delState |= 0x1000;
            }
            rc = -15; goto errout;
        }
        delState |= 0x0002;
    }


    if (hostNode) {
        if (!hostNode->pcKpon) {
            rc = -14;
        }
        (((&(hostNode->q))->next)->prev = ((&(hostNode->q))->prev), ((&(hostNode->q))->prev)->next = ((&(hostNode->q))->next));
        kpc_nwHostNodeFree(hostNode,1);
        delState |= 0x0020;
    }


    if (!hostNode && servNode) {
        kpc_nwIntFreeKpon((char *)servNode, servNode->size, servNode->pcKpon);
        servNode->pcKpon = (char *)NULL;
        delState |= 0x0040;
    }

    if (kpc_nwIntServNodeImplicit(servNode)) {
        (((&(servNode->q))->next)->prev = ((&(servNode->q))->prev), ((&(servNode->q))->prev)->next = ((&(servNode->q))->next));
        kpc_nwServNodeFree(servNode,1);
        delState |= 0x0040;
    }


    if (!hostNode && !servNode) {
        kpc_nwIntFreeKpon((char *)protNode, protNode->size, protNode->pcKpon);
        protNode->pcKpon = (char *)NULL;
        delState |= 0x0080;
    }

    if (kpc_nwIntProtoNodeImplicit(protNode)) {
        (((&(protNode->q))->next)->prev = ((&(protNode->q))->prev), ((&(protNode->q))->prev)->next = ((&(protNode->q))->next));
        kpc_nwProtoNodeFree(protNode,1);
        kpc_nwInPol->nodes -= 1;
        delState |= 0x0080;
    }

    if (!(delState & (0x0020|0x0040|
                      0x0080|0x0010))) {
        delState |= 0x4000;
        rc = -15;
    }

 errout:

    (kpc_nwInPol->flags) &= ~0x1;
    (kail_mutex_unlock(&(kpc_nwInPol->lock)));

    (kail_wake_up(&(kpc_nwInPol->cond)));

    if (rc != 0) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETIN_DEL_ERR, (((1)<<28) + ((1)<<24) + ((2)<<20) + ((2)<<16)), (long)(kpcresp->resourceName), (long)pcTrace, (long)delState, (long)rc),0) : 0);



    } else {

        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETIN_DEL, (((1)<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16) + ((((sizeof(char *) == 4) ? 2 : 4))<<12) + ((0)<<8)), (long)(kpcresp->resourceName), (long)delState, (long)protNode, (long)servNode ,(long)hostNode),0) : 0);



    }

    return(rc);
}
int
kpc_nwInPolicyMatch(kpc_nwInPolicy_t *kpc_nwInPol, kenv_envHandle_t envH)
{
    kpc_nwProtoNode_t *protoMatch=NULL;
    kpc_nwServNode_t *servMatch=NULL;
    kpc_nwHostNode_t *hostMatch=NULL;
    char *pcKpon=NULL, *pcTrace;
    int rc=0, matchState=0;
    kenv_kpcInfo_t ki;
    oss_nwAddr_t *addrp,nwAddr;


    (!(envH)? (*((char *)0) = 0) : 0);
    do { kenv_env_t *ep = (kenv_env_t *)envH; addrp = (ep->flags & 0x00004000)? &ep->tgt.nw.addrRemote: NULL; } while ( 0);
    (!(addrp)? (*((char *)0) = 0) : 0);
    memcpy(&nwAddr,addrp,sizeof(oss_nwAddr_t));
    do { kenv_env_t *ep = (kenv_env_t *)envH; addrp = (ep->flags & 0x00008000)? &ep->tgt.nw.addrLocal: NULL; } while ( 0);
    (!(addrp)? (*((char *)0) = 0) : 0);
    nwAddr.service = addrp->service;

    kpc_nwConvAddrHN(&nwAddr);


    kpc_nwInitKPCInfo(&ki);


    (kail_mutex_lock(&(kpc_nwInPol->lock)));
    if (kpc_nwInPol->flags & 0x10) {
        goto out;
    }
    while (kpc_nwInPol->flags & 0x1) {
        (kail_cond_wait(&(kpc_nwInPol->cond),&(kpc_nwInPol->lock)));
    }
    (kpc_nwInPol->readers) += 1;
    (kail_mutex_unlock(&(kpc_nwInPol->lock)));


    protoMatch = kpc_nwMatchProto(&(kpc_nwInPol->ProtoQ),
                                  nwAddr.service.protocol, kpc_nwInPol);
    if (protoMatch) {

        matchState |= 0x0008;
        pcTrace = "protocol";
        servMatch=kpc_nwMatchServ(&(protoMatch->ServiceQ),nwAddr.service.port);
        if (servMatch) {

            matchState |= 0x0004;
            pcTrace = "service";



            hostMatch=kpc_nwMatchHostIP(&(servMatch->HostSpecQ),&(nwAddr.ip),
                                        1, NULL);
            if (!hostMatch) {

                if (!((((kutil_q_t *)&(servMatch->HostWCQ))->next) == (kutil_q_t *)&(servMatch->HostWCQ))) {
                    kutil_q_t *qptr;

                    matchState |= 0x0002;
                    pcTrace = "host name";




                    hostMatch =
                        (kpc_nwHostNode_t *)(((kutil_q_t *)&(servMatch->HostWCQ))->next);

                    ki.resData.nw.policyVersion = hostMatch->policyVersion;
                    ki.resData.nw.pUserRes = hostMatch->pWCNode;
                    ki.resData.nw.pRes = hostMatch;
                    ki.resData.nw.relef = kpc_nwHostNodeRele;
                    kail_atomic_add((int)(1),(void *)((int *)&(hostMatch->refcount)));
                    ki.resName = hostMatch->pcKpon;
                    ki.resNameLen = strlen(hostMatch->pcKpon);
                    ki.kpcFlags |= 0x1000;



                    ki.branchId = 0;
                    rc++;
                    kenv_envSetKPCInfo(envH, &ki);

                    (((kenv_env_t *)(envH))->flags |= 0x00040000);
                } else {
                    if (servMatch->pcKpon) {

                        ki.resData.nw.pRes = servMatch;
                        ki.resData.nw.relef = kpc_nwServNodeRele;
                        kail_atomic_add((int)(1),(void *)((int *)&(servMatch->refcount)));
                        pcKpon = servMatch->pcKpon;
                        rc++;
                    } else if (protoMatch->pcKpon) {

                        pcKpon = protoMatch->pcKpon;
                        ki.resData.nw.pRes = protoMatch;
                        ki.resData.nw.relef = kpc_nwProtoNodeRele;
                        kail_atomic_add((int)(1),(void *)((int *)&(protoMatch->refcount)));
                        rc++;
                    }
                }
            } else {
                matchState |= 0x0001;
                pcTrace = "host IP";

                ki.resData.nw.pRes = hostMatch;
                ki.resData.nw.relef = kpc_nwHostNodeRele;
                kail_atomic_add((int)(1),(void *)((int *)&(hostMatch->refcount)));
                rc++;
                pcKpon = hostMatch->pcKpon;
            }
        } else if (protoMatch->pcKpon) {

            pcKpon = protoMatch->pcKpon;
            ki.resData.nw.pRes = protoMatch;
            ki.resData.nw.relef = kpc_nwProtoNodeRele;
            kail_atomic_add((int)(1),(void *)((int *)&(protoMatch->refcount)));
            rc++;
        }
    }


    if (pcKpon) {

        ki.resName = pcKpon;
        ki.resNameLen = strlen(pcKpon);
        ki.kpcFlags |= 0x100;

        ki.branchId = ((kpc_nwBaseNode_t *)ki.resData.nw.pRes)->branchId;
        kenv_envSetKPCInfo(envH, &ki);
    }

    (kail_mutex_lock(&(kpc_nwInPol->lock)));
    (kpc_nwInPol->readers) -= 1;
 out:
    (kail_mutex_unlock(&(kpc_nwInPol->lock)));
    (kail_wake_up(&(kpc_nwInPol->cond)));

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETIN_MATCH, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((1)<<12) + ((0)<<8)), (long)(rc), (long)*((int *)&(nwAddr.ip.addr.addrClassic.addr)), (long)nwAddr.service.port, (long)matchState ,(long)(rc ? ki.resName : "NULL")),0) : 0);




    return rc;
}
int
kpc_nwInPolicySetRes(kpc_nwInPolicy_t *kpc_nwInPol, kenv_envHandle_t envH,
                     char *pcKpon)
{
    kpc_nwProtoNode_t *protoMatch=NULL;
    kpc_nwServNode_t *servMatch=NULL;
    kpc_nwHostNode_t *hostMatch=NULL;
    char *pcTrace, *pcHost;
    int rc=0, matchState=0;
    kenv_kpcInfo_t ki;
    oss_nwAddr_t *addrp,nwAddr;


    (!(envH)? (*((char *)0) = 0) : 0);
    do { kenv_env_t *ep = (kenv_env_t *)envH; addrp = (ep->flags & 0x00004000)? &ep->tgt.nw.addrRemote: NULL; } while ( 0);
    (!(addrp)? (*((char *)0) = 0) : 0);
    memcpy(&nwAddr,addrp,sizeof(oss_nwAddr_t));
    do { kenv_env_t *ep = (kenv_env_t *)envH; addrp = (ep->flags & 0x00008000)? &ep->tgt.nw.addrLocal: NULL; } while ( 0);
    (!(addrp)? (*((char *)0) = 0) : 0);
    nwAddr.service = addrp->service;

    kpc_nwConvAddrHN(&nwAddr);


    kpc_nwInitKPCInfo(&ki);


    (kail_mutex_lock(&(kpc_nwInPol->lock)));
    if (kpc_nwInPol->flags & 0x10) {
        goto out;
    }
    while (kpc_nwInPol->flags & 0x1) {
        (kail_cond_wait(&(kpc_nwInPol->cond),&(kpc_nwInPol->lock)));
    }
    (kpc_nwInPol->readers) += 1;
    (kail_mutex_unlock(&(kpc_nwInPol->lock)));


    protoMatch = kpc_nwMatchProto(&(kpc_nwInPol->ProtoQ),
                                  addrp->service.protocol, kpc_nwInPol);
    if (protoMatch) {

        matchState |= 0x0008;
        pcTrace = "protocol";
        servMatch=kpc_nwMatchServ(&(protoMatch->ServiceQ),addrp->service.port);
        if (servMatch) {


            matchState |= 0x0004;
            pcTrace = "service";

            pcHost = strrchr(pcKpon,'/');
            if (pcHost) {
                pcHost++;
                hostMatch = kpc_nwMatchHostName(&(servMatch->HostWCQ), pcHost,
                                                NULL);
                if (hostMatch) {
                    matchState |= 0x0002;
                    pcTrace = "host name";
                    ki.resData.nw.relef = kpc_nwHostNodeRele;
                    ki.resData.nw.pRes = hostMatch;

                    kpc_nwEnvResReset(hostMatch, hostMatch->pcKpon, envH, &ki);

                    kail_atomic_add((int)(1),(void *)((int *)&(hostMatch->refcount)));
                }
            }
            if (!hostMatch) {
                matchState |= 0x2000;
                rc = -1;
            }
        } else {

            matchState |= 0x4000;
            rc = -1;
        }
    } else {

        matchState |= 0x8000;
        rc = -1;
    }

    (kail_mutex_lock(&(kpc_nwInPol->lock)));
    (kpc_nwInPol->readers) -= 1;
 out:
    (kail_mutex_unlock(&(kpc_nwInPol->lock)));
    (kail_wake_up(&(kpc_nwInPol->cond)));

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= ((rc) ? 1 : 5)) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETIN_SETRES, (((1)<<28) + ((2)<<24) + ((1)<<20) + ((0)<<16)), (long)(pcKpon), (long)matchState, (long)(!rc ? ki.resName : "NULL")),0) : 0);



    return rc;
}







void
kpc_nwInPolicyInit(kpc_nwInPolicy_t *kpc_nwPol)
{
    memset(kpc_nwPol,0,sizeof(*kpc_nwPol));
    (kail_mutex_init(&kpc_nwPol->lock));
    (kail_cond_init(&(kpc_nwPol->cond)));
    ((&(kpc_nwPol->ProtoQ))->next = (&(kpc_nwPol->ProtoQ))->prev = (&(kpc_nwPol->ProtoQ)));
    kpc_nwPol->flags = 0x4;
}






void
kpc_nwInPolicyFini(kpc_nwInPolicy_t *kpc_nwPol)
{
    kpc_nwProtoNode_t *nodep;
    kutil_q_t *iter, *next, *qptr;
    size_t size;

    if (! (kpc_nwPol->flags & 0x4) ) {
        return;
    }

    (kail_mutex_lock(&(kpc_nwPol->lock)));
    (kpc_nwPol->flags) |= (0x1|0x10);
    while (kpc_nwPol->readers > 0) {
        (kail_cond_wait(&(kpc_nwPol->cond),&(kpc_nwPol->lock)));
    }
    qptr = &(kpc_nwPol->ProtoQ);
    for (iter=(((kutil_q_t *)qptr)->next); iter != qptr; iter = next) {
        next = ((iter)->next);
        nodep = (kpc_nwProtoNode_t *)iter;
        (((&(nodep->q))->next)->prev = ((&(nodep->q))->prev), ((&(nodep->q))->prev)->next = ((&(nodep->q))->next));
        kpc_nwProtoNodeFree(nodep,0);
        (kpc_nwPol->nodes)--;
    }
    (kail_mutex_unlock(&(kpc_nwPol->lock)));
    (!(kpc_nwPol->nodes == 0)? (*((char *)0) = 0) : 0);
}
int
kpc_nwOutPolicyAdd(kpc_nwOutPolicy_t *kpc_nwOutPol,kpc_resourceInfo_t *kpcresp)
{
    kpc_nwProtoNode_t *protNode=NULL, *newProtp=(kpc_nwProtoNode_t *)NULL;
    kpc_nwServNode_t *servNode=NULL, *newServp=(kpc_nwServNode_t *)NULL;
    kpc_nwHostNode_t *hostNode=NULL, *newHostp=(kpc_nwHostNode_t *)NULL;
    kpc_nwDesc_t *rulep;
    int addFlags=0, rc=0, allocFlags;
    char *pcTrace=(char *)NULL;


    if (!kpcresp) {
        return(-13);
    }
    rulep = kpcresp->resDesc.nwDesc;
    kpc_nwSetAllocFlags(rulep, 0x2, &allocFlags);
    if (allocFlags & 0xff000) {
        return(-14);
    }
    if (rulep->addrType.noHostIP && rulep->addrType.noHostName) {
        return(-13);
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_UPD_ENTRY, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(kpcresp->op), (long)*((int *)&rulep->addrType), (long)rulep->protocol, (long)rulep->numPortRanges ,(long)rulep->totalPorts),0) : 0);




    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_UPD_ENTRY2, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((1)<<12) + ((0)<<8)), (long)(((rulep->numPortRanges > 1) ? rulep->portRange.setp[0].portLow : rulep->portRange.one.portLow)), (long)((rulep->numPortRanges > 1) ? rulep->portRange.setp[0].portHigh : rulep->portRange.one.portHigh), (long)rulep->ipaddr.addr.addrClassic.addr, (long)rulep->significantBits ,(long)(rulep->wcHostData ? rulep->wcHostData:"NULL")),0) : 0);
    if (rulep->addrType.addrV6) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(rulep->ipaddr.addr.a32[0])), (long)ntohl(rulep->ipaddr.addr.a32[1]), (long)ntohl(rulep->ipaddr.addr.a32[2]), (long)ntohl(rulep->ipaddr.addr.a32[3])),0) : 0);




        if (rulep->significantBits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(rulep->mask.addr.a32[0])), (long)ntohl(rulep->mask.addr.a32[1]), (long)ntohl(rulep->mask.addr.a32[2]), (long)ntohl(rulep->mask.addr.a32[3])),0) : 0);




        }
    }


    (kail_mutex_lock(&(kpc_nwOutPol->lock)));
    if (kpc_nwOutPol->flags & 0x10) {
        goto out;
    }
    (kpc_nwOutPol->flags) |= 0x1;
    while (kpc_nwOutPol->readers > 0) {
        (kail_cond_wait(&(kpc_nwOutPol->cond),&(kpc_nwOutPol->lock)));
    }



    if (rulep->addrType.noHostIP) {
        hostNode = kpc_nwSearchHostNameQ(&(kpc_nwOutPol->HostNameQ),rulep,
                                         &addFlags);
    } else {
        hostNode=kpc_nwSearchHostIPQ(&(kpc_nwOutPol->HostIPQ),rulep,&addFlags);
    }
    if (addFlags & 0x0002) {
        newHostp = hostNode;

        newHostp->epoch = kpcInfo.attrs.policyEpoch;
        if (!(allocFlags & (0x8|0x4))) {

            protNode =
                kpc_nwSearchProtoQ(&(newHostp->ProtoQ),rulep,&addFlags);
        } else if (!newHostp->pcKpon) {

            hostNode->branchId = kpcresp->branchId;
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_BRANCH_CHANGE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(hostNode), (long)(hostNode->pcKpon ? hostNode->pcKpon : "NULL"), (long)hostNode->branchId),0) : 0);




            hostNode->pcKpon = kpc_nwIntNewKPON(kpcresp->resourceName);
            if (!hostNode->pcKpon) {
                rc = -10; goto out;
            }
        }
    } else {

        newHostp = kpc_nwHostNodeAlloc(kpcresp, allocFlags);
    }
    if (!newHostp) { rc = -10; goto out; }

    if ((addFlags & 0x0004) && protNode) {

        newProtp = protNode;

        newProtp->epoch = kpcInfo.attrs.policyEpoch;
        if (!(allocFlags & 0x1)) {

            servNode = kpc_nwSearchServiceQ(&(protNode->ServiceQ),rulep,
                                            &addFlags);
        } else if (!newProtp->pcKpon) {

            protNode->branchId = kpcresp->branchId;
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_BRANCH_CHANGE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(protNode), (long)(protNode->pcKpon ? protNode->pcKpon : "NULL"), (long)protNode->branchId),0) : 0);




            protNode->pcKpon = kpc_nwIntNewKPON(kpcresp->resourceName);
            if (!protNode->pcKpon) {
                rc = -10; goto out;
            }
        }
    } else if (!(rulep->addrType.noProto)) {

        newProtp = kpc_nwProtoNodeAlloc(kpcresp, allocFlags);
        if (!newProtp) { rc = -10; goto out; }
    }

    if (addFlags & 0x0001) {

        servNode->branchId = kpcresp->branchId;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_BRANCH_CHANGE, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(servNode), (long)(servNode->pcKpon ? servNode->pcKpon : "NULL"), (long)servNode->branchId),0) : 0);




        servNode->epoch = kpcInfo.attrs.policyEpoch;
        pcTrace = "service";
                                       goto out;
    } else if (!(rulep->addrType.noServ)) {

        newServp = kpc_nwServNodeAlloc(kpcresp, allocFlags);
        if (!newServp) {
            rc = -10; goto out;
        }
    }



    if (newServp && (newServp != servNode)) {
        if ((servNode ? &(servNode->q) : NULL)) { if (0x1 == 0x1) { ((&(newServp->q))->next = ((kutil_qHead_t *)(servNode ? &(servNode->q) : NULL)), (&(newServp->q))->prev = (((kutil_q_t *)(kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->prev), (((kutil_q_t *)(kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->prev)->next = (&(newServp->q)), ((kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->prev = (&(newServp->q))); } else if (0x1 == 0x2) { ((&(newServp->q))->next = (((kutil_q_t *)(kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->next), (&(newServp->q))->prev = ((kutil_qHead_t *)(servNode ? &(servNode->q) : NULL)), (((kutil_q_t *)(kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->next)->prev = (&(newServp->q)), ((kutil_qHead_t *)(servNode ? &(servNode->q) : NULL))->next = (&(newServp->q))); } } else { if (0x1 == 0x1) { ((&(newServp->q))->next = (&(newProtp->ServiceQ)), (&(newServp->q))->prev = (((kutil_q_t *)&(newProtp->ServiceQ))->prev), (((kutil_q_t *)&(newProtp->ServiceQ))->prev)->next = (&(newServp->q)), (&(newProtp->ServiceQ))->prev = (&(newServp->q))); } else if (0x1 == 0x2) { ((&(newServp->q))->next = (((kutil_q_t *)&(newProtp->ServiceQ))->next), (&(newServp->q))->prev = (&(newProtp->ServiceQ)), (((kutil_q_t *)&(newProtp->ServiceQ))->next)->prev = (&(newServp->q)), (&(newProtp->ServiceQ))->next = (&(newServp->q))); } };

        (newProtp->flags) |= 0x2;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETOUT_ADD_NODE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16)), (long)("service"), (long)newServp, (long)(newServp->pcKpon ? newServp->pcKpon : "NULL"), (long)newServp->branchId),0) : 0);




    }



    if (newProtp && (newProtp != protNode)) {
        if ((protNode ? &(protNode->q) : NULL)) { if (0x1 == 0x1) { ((&(newProtp->q))->next = ((kutil_qHead_t *)(protNode ? &(protNode->q) : NULL)), (&(newProtp->q))->prev = (((kutil_q_t *)(kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->prev), (((kutil_q_t *)(kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->prev)->next = (&(newProtp->q)), ((kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->prev = (&(newProtp->q))); } else if (0x1 == 0x2) { ((&(newProtp->q))->next = (((kutil_q_t *)(kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->next), (&(newProtp->q))->prev = ((kutil_qHead_t *)(protNode ? &(protNode->q) : NULL)), (((kutil_q_t *)(kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->next)->prev = (&(newProtp->q)), ((kutil_qHead_t *)(protNode ? &(protNode->q) : NULL))->next = (&(newProtp->q))); } } else { if (0x1 == 0x1) { ((&(newProtp->q))->next = (&(newHostp->ProtoQ)), (&(newProtp->q))->prev = (((kutil_q_t *)&(newHostp->ProtoQ))->prev), (((kutil_q_t *)&(newHostp->ProtoQ))->prev)->next = (&(newProtp->q)), (&(newHostp->ProtoQ))->prev = (&(newProtp->q))); } else if (0x1 == 0x2) { ((&(newProtp->q))->next = (((kutil_q_t *)&(newHostp->ProtoQ))->next), (&(newProtp->q))->prev = (&(newHostp->ProtoQ)), (((kutil_q_t *)&(newHostp->ProtoQ))->next)->prev = (&(newProtp->q)), (&(newHostp->ProtoQ))->next = (&(newProtp->q))); } };

        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETOUT_ADD_NODE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16)), (long)("protocol"), (long)newProtp, (long)(newProtp->pcKpon ? newProtp->pcKpon : "NULL"), (long)newProtp->branchId),0) : 0);




    }


    if (newHostp && (newHostp != hostNode)) {
        if (newHostp->wcSpecp) {
            if ((hostNode ? &(hostNode->q) : NULL)) { if (0x1 == 0x1) { ((&(newHostp->q))->next = ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL)), (&(newHostp->q))->prev = (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev), (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev)->next = (&(newHostp->q)), ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev = (&(newHostp->q))); } else if (0x1 == 0x2) { ((&(newHostp->q))->next = (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next), (&(newHostp->q))->prev = ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL)), (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next)->prev = (&(newHostp->q)), ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next = (&(newHostp->q))); } } else { if (0x1 == 0x1) { ((&(newHostp->q))->next = (&(kpc_nwOutPol->HostNameQ)), (&(newHostp->q))->prev = (((kutil_q_t *)&(kpc_nwOutPol->HostNameQ))->prev), (((kutil_q_t *)&(kpc_nwOutPol->HostNameQ))->prev)->next = (&(newHostp->q)), (&(kpc_nwOutPol->HostNameQ))->prev = (&(newHostp->q))); } else if (0x1 == 0x2) { ((&(newHostp->q))->next = (((kutil_q_t *)&(kpc_nwOutPol->HostNameQ))->next), (&(newHostp->q))->prev = (&(kpc_nwOutPol->HostNameQ)), (((kutil_q_t *)&(kpc_nwOutPol->HostNameQ))->next)->prev = (&(newHostp->q)), (&(kpc_nwOutPol->HostNameQ))->next = (&(newHostp->q))); } };

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETOUT_ADD_NODE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16)), (long)("host name"), (long)newHostp, (long)(newHostp->pcKpon ? newHostp->pcKpon : "NULL"), (long)newHostp->branchId),0) : 0);




            kpc_nwOutPol->hostNodes += 1;
        } else {
            int qAddFlag;

            if (newHostp->h.ip.addr.ipV6) {
                qAddFlag = 0x2;

                if (newHostp->h.ip.addr.ipV6V4Mapped ||
                    newHostp->h.ip.addr.ipV6V4Compat) {
                    (kpc_nwOutPol->flags) |= 0x20;
                }
            } else {
                qAddFlag = 0x1;
            }
            if ((hostNode ? &(hostNode->q) : NULL)) { if (qAddFlag == 0x1) { ((&(newHostp->q))->next = ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL)), (&(newHostp->q))->prev = (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev), (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev)->next = (&(newHostp->q)), ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->prev = (&(newHostp->q))); } else if (qAddFlag == 0x2) { ((&(newHostp->q))->next = (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next), (&(newHostp->q))->prev = ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL)), (((kutil_q_t *)(kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next)->prev = (&(newHostp->q)), ((kutil_qHead_t *)(hostNode ? &(hostNode->q) : NULL))->next = (&(newHostp->q))); } } else { if (qAddFlag == 0x1) { ((&(newHostp->q))->next = (&(kpc_nwOutPol->HostIPQ)), (&(newHostp->q))->prev = (((kutil_q_t *)&(kpc_nwOutPol->HostIPQ))->prev), (((kutil_q_t *)&(kpc_nwOutPol->HostIPQ))->prev)->next = (&(newHostp->q)), (&(kpc_nwOutPol->HostIPQ))->prev = (&(newHostp->q))); } else if (qAddFlag == 0x2) { ((&(newHostp->q))->next = (((kutil_q_t *)&(kpc_nwOutPol->HostIPQ))->next), (&(newHostp->q))->prev = (&(kpc_nwOutPol->HostIPQ)), (((kutil_q_t *)&(kpc_nwOutPol->HostIPQ))->next)->prev = (&(newHostp->q)), (&(kpc_nwOutPol->HostIPQ))->next = (&(newHostp->q))); } };

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETOUT_ADD_NODE, (((1)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((1)<<20) + ((2)<<16)), (long)("host IP"), (long)newHostp, (long)(newHostp->pcKpon ? newHostp->pcKpon : "NULL"), (long)newHostp->branchId),0) : 0);




            kpc_nwOutPol->IPNodes += 1;
        }
    }

 out:
    if (rc != 0) {
        if (rc == -12) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_ALREADY, (((1)<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(kpcresp->resourceName), (long)pcTrace, (long)addFlags),0) : 0);


        }

        if (!(addFlags & 0x0001) && newServp) {
            kpc_nwServNodeFree(newServp,1);
        }
        if (!(addFlags & 0x0004) && newProtp) {
            kpc_nwProtoNodeFree(newProtp,1);
        }
    }


    (kpc_nwOutPol->flags) &= ~0x1;
    (kail_mutex_unlock(&(kpc_nwOutPol->lock)));

    (kail_wake_up(&(kpc_nwOutPol->cond)));

    return(rc);
}
int
kpc_nwOutPolicyDel(kpc_nwOutPolicy_t *kpc_nwOutPol,kpc_resourceInfo_t *kpcresp)
{
    kpc_nwProtoNode_t *protNode=(kpc_nwProtoNode_t *)NULL;
    kpc_nwServNode_t *servNode=(kpc_nwServNode_t *)NULL;
    kpc_nwHostNode_t *hostNode=(kpc_nwHostNode_t *)NULL;
    void *pNode=NULL;
    kpc_nwDesc_t *rulep;
    int searchFlags=0, rc=0, delState=0;
    char *pcTrace=(char *)NULL;


    if (!kpcresp) {
        return(-13);
    }
    rulep = kpcresp->resDesc.nwDesc;

    if (rulep->addrType.noHostIP && rulep->addrType.noHostName) {
        return(-13);
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_UPD_ENTRY, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(kpcresp->op), (long)*((int *)&rulep->addrType), (long)rulep->protocol, (long)rulep->numPortRanges ,(long)rulep->totalPorts),0) : 0);




    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NET_UPD_ENTRY2, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((1)<<12) + ((0)<<8)), (long)(((rulep->numPortRanges > 1) ? rulep->portRange.setp[0].portLow : rulep->portRange.one.portLow)), (long)((rulep->numPortRanges > 1) ? rulep->portRange.setp[0].portHigh : rulep->portRange.one.portHigh), (long)rulep->ipaddr.addr.addrClassic.addr, (long)rulep->significantBits ,(long)(rulep->wcHostData ? rulep->wcHostData:"NULL")),0) : 0);
    if (rulep->addrType.addrV6) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(rulep->ipaddr.addr.a32[0])), (long)ntohl(rulep->ipaddr.addr.a32[1]), (long)ntohl(rulep->ipaddr.addr.a32[2]), (long)ntohl(rulep->ipaddr.addr.a32[3])),0) : 0);




        if (rulep->significantBits != 128) {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPCD_HOSTIPV6_MASK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(rulep->mask.addr.a32[0])), (long)ntohl(rulep->mask.addr.a32[1]), (long)ntohl(rulep->mask.addr.a32[2]), (long)ntohl(rulep->mask.addr.a32[3])),0) : 0);




        }
    }


    (kail_mutex_lock(&(kpc_nwOutPol->lock)));
    if (kpc_nwOutPol->flags & 0x10) {
        goto errout;
    }
    (kpc_nwOutPol->flags) |= 0x1;
    while (kpc_nwOutPol->readers > 0) {
        (kail_cond_wait(&(kpc_nwOutPol->cond),&(kpc_nwOutPol->lock)));
    }


    if (rulep->addrType.noHostIP) {
        hostNode = kpc_nwSearchHostNameQ(&(kpc_nwOutPol->HostNameQ),
                                         rulep, &searchFlags);
    } else {
        hostNode = kpc_nwSearchHostIPQ(&(kpc_nwOutPol->HostIPQ),
                                       rulep, &searchFlags);
    }
    if (!hostNode) {

        if (rulep->addrType.noHostIP) {
            pcTrace = "host name";
            delState |= 0x2000;
        } else {
            pcTrace = "host IP";
            delState |= 0x1000;
        }
        rc = -15; goto errout;
    }
    delState |= 0x0002;


    if (!(rulep->addrType.noProto)) {
        protNode = kpc_nwSearchProtoQ(&(hostNode->ProtoQ),rulep,&searchFlags);
        if (!(searchFlags & 0x0004)) {

            pcTrace = "protocol";
            delState |= 0x8000;
            rc = -15; goto errout;
        }
        delState |= 0x0008;
    } else if (!(rulep->addrType.noServ)) {

        delState |= 0x8000;
        pcTrace = "protocol";
        rc = -13; goto errout;
    }

    if (!(rulep->addrType.noServ) && protNode) {

        servNode = kpc_nwSearchServiceQ(&(protNode->ServiceQ),rulep,
                                        &searchFlags);
        if (!(searchFlags & 0x0001)) {
            delState |= 0x4000;
            pcTrace = "service";
            rc = -15; goto errout;
        }
        delState |= 0x0004;
    }


    if (servNode) {
        if (!servNode->pcKpon) {
            rc = -14;
        }
        (((&(servNode->q))->next)->prev = ((&(servNode->q))->prev), ((&(servNode->q))->prev)->next = ((&(servNode->q))->next));
        kpc_nwServNodeFree(servNode,1);
        delState |= 0x0040;
    }


    if (!servNode && protNode) {

        kpc_nwIntFreeKpon((char *)protNode, protNode->size, protNode->pcKpon);
        protNode->pcKpon = (char *)NULL;
        delState |= 0x0080;
    }
    if (kpc_nwIntProtoNodeImplicit(protNode)) {
        (((&(protNode->q))->next)->prev = ((&(protNode->q))->prev), ((&(protNode->q))->prev)->next = ((&(protNode->q))->next));
        kpc_nwProtoNodeFree(protNode,1);
        delState |= 0x0080;
    }





    if (!servNode && !protNode && hostNode) {
        kpc_nwIntFreeKpon((char *)hostNode, hostNode->size, hostNode->pcKpon);

        hostNode->pcKpon = (char *)NULL;
        delState |= 0x0020;
    }
    if (kpc_nwIntHostNodeImplicit(hostNode)) {
        (((&(hostNode->q))->next)->prev = ((&(hostNode->q))->prev), ((&(hostNode->q))->prev)->next = ((&(hostNode->q))->next));
        kpc_nwHostNodeFree(hostNode,1);

        if (rulep->addrType.noHostIP) {
            kpc_nwOutPol->hostNodes -= 1;
        } else {
            kpc_nwOutPol->IPNodes -= 1;
        }
        delState |= 0x0020;
    }

    if (!(delState & (0x0020|0x0040|
                      0x0080|0x0010))) {
        delState |= 0x4000;
        rc = -15;
    }

 errout:
    (kpc_nwOutPol->flags) &= ~0x1;
    (kail_mutex_unlock(&(kpc_nwOutPol->lock)));

    (kail_wake_up(&(kpc_nwOutPol->cond)));

    if (rc != 0) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETOUT_DEL_ERR, (((1)<<28) + ((1)<<24) + ((2)<<20) + ((2)<<16)), (long)(kpcresp->resourceName), (long)pcTrace, (long)delState, (long)rc),0) : 0);



    } else {

        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETOUT_DEL, (((1)<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16) + ((((sizeof(char *) == 4) ? 2 : 4))<<12) + ((0)<<8)), (long)(kpcresp->resourceName), (long)delState, (long)protNode, (long)servNode ,(long)hostNode),0) : 0);



    }

    return(rc);
}
char *
kpc_nwOutPolicyMatchHost(kpc_nwHostNode_t *pHost,
                         oss_nwAddr_t *addrp,
                         int *pMatchState,
                         char **ppcTrace,
                         kenv_kpcInfo_t *kip)
{
    kpc_nwProtoNode_t *protoMatch=NULL;
    kpc_nwServNode_t *servMatch=NULL;
    char *pcKpon=(char *)NULL;

    protoMatch=kpc_nwMatchProto(&(pHost->ProtoQ),addrp->service.protocol,NULL);
    if (protoMatch) {
        *pMatchState |= 0x0008;
        *ppcTrace = "protocol";

        servMatch=kpc_nwMatchServ(&(protoMatch->ServiceQ),addrp->service.port);
        if (servMatch) {
            (*pMatchState) |= 0x0004;
            *ppcTrace = "service";
            pcKpon = servMatch->pcKpon;
            kip->resData.nw.pRes = servMatch;
            kip->resData.nw.relef = kpc_nwServNodeRele;
            kail_atomic_add((int)(1),(void *)((int *)&(servMatch->refcount)));
        } else if (protoMatch->pcKpon) {

            pcKpon = protoMatch->pcKpon;
            kip->resData.nw.pRes = protoMatch;
            kip->resData.nw.relef = kpc_nwProtoNodeRele;
            kail_atomic_add((int)(1),(void *)((int *)&(protoMatch->refcount)));
        }
    }

    if (!pcKpon && pHost->pcKpon) {

        pcKpon = pHost->pcKpon;
        kip->resData.nw.pRes = pHost;
        kip->resData.nw.relef = kpc_nwHostNodeRele;
        kail_atomic_add((int)(1),(void *)((int *)&(pHost->refcount)));
    }

    return(pcKpon);
}
int
kpc_nwOutPolicyMatch(kpc_nwOutPolicy_t *kpc_nwOutPol,
                     kenv_envHandle_t envH)
{
    kutil_q_t *iter, *next, *qptr;
    kpc_nwProtoNode_t *protoMatch=NULL;
    kpc_nwServNode_t *servMatch=NULL;
    kpc_nwHostNode_t *hostMatch=NULL;
    char *pcKpon=NULL, *pcTrace, *pcHost;
    int count, rc=0, matchState=0;
    kenv_kpcInfo_t ki;
    oss_nwAddr_t *addrp,nwAddr;

    (!(envH)? (*((char *)0) = 0) : 0);
    do { kenv_env_t *ep = (kenv_env_t *)envH; addrp = (ep->flags & 0x00004000)? &ep->tgt.nw.addrRemote: NULL; } while ( 0);
    ;
    memcpy(&nwAddr,addrp,sizeof(oss_nwAddr_t));

    kpc_nwConvAddrHN(&nwAddr);

    (kail_mutex_lock(&(kpc_nwOutPol->lock)));
    if (kpc_nwOutPol->flags & 0x10) {
        goto out;
    }
    while (kpc_nwOutPol->flags & 0x1) {
        (kail_cond_wait(&(kpc_nwOutPol->cond),&(kpc_nwOutPol->lock)));
    }
    (kpc_nwOutPol->readers) += 1;
    (kail_mutex_unlock(&(kpc_nwOutPol->lock)));


    hostMatch = kpc_nwMatchHostIP(&(kpc_nwOutPol->HostIPQ), &(nwAddr.ip),
                                  (kpc_nwOutPol->flags & 0x20),
                                  kpc_nwOutPol);
    if (hostMatch) {
        matchState |= 0x0001;
        pcTrace = "host IP";

        kpc_nwInitKPCInfo(&ki);
        pcKpon = kpc_nwOutPolicyMatchHost(hostMatch, &nwAddr, &matchState,
                                          &pcTrace, &ki);

        if (pcKpon) {

            ki.kpcFlags |= 0x100;
            ki.resName = pcKpon;
            ki.resNameLen = strlen(pcKpon);

            ki.branchId = ((kpc_nwBaseNode_t *)ki.resData.nw.pRes)->branchId;
            kenv_envSetKPCInfo(envH, &ki);
            rc++;
        }
    } else if (!((((kutil_q_t *)&(kpc_nwOutPol->HostNameQ))->next) == (kutil_q_t *)&(kpc_nwOutPol->HostNameQ))) {



        matchState |= 0x0002;
        pcTrace = "host name";


        qptr = &(kpc_nwOutPol->HostNameQ);
        for (iter=(((kutil_q_t *)qptr)->next), count=0; iter!=qptr && (rc == 0);
             iter=next, count++) {
            next = ((iter)->next);
            hostMatch = (kpc_nwHostNode_t *)iter;
            kpc_nwInitKPCInfo(&ki);
            pcKpon = kpc_nwOutPolicyMatchHost(hostMatch, &nwAddr, &matchState,
                                              &pcTrace, &ki);
            if (pcKpon) {

                ki.resData.nw.policyVersion = hostMatch->policyVersion;
                ki.resData.nw.pUserRes = hostMatch->pWCNode;
                ki.resName = pcKpon;
                ki.resNameLen = strlen(pcKpon);
                ki.kpcFlags |= 0x1000;



                ki.branchId = 0;
                kenv_envSetKPCInfo(envH, &ki);
                rc++;



                break;
            }
        }
        if (rc) {

            (((kenv_env_t *)(envH))->flags |= 0x00040000);
        }
    }

    (kail_mutex_lock(&(kpc_nwOutPol->lock)));
    (kpc_nwOutPol->readers) -= 1;
 out:
    (kail_mutex_unlock(&(kpc_nwOutPol->lock)));
    (kail_wake_up(&(kpc_nwOutPol->cond)));

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= ((rc) ? 1 : 5)) ? (kt_Event5((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETOUT_MATCH, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((1)<<12) + ((0)<<8)), (long)(rc), (long)*((int *)&(nwAddr.ip.addr.addrClassic.addr)), (long)nwAddr.service.port, (long)matchState ,(long)(rc ? ki.resName : "NULL")),0) : 0);






    return rc;
}
int
kpc_nwOutPolicySetRes(kpc_nwOutPolicy_t *kpc_nwOutPol, kenv_envHandle_t envH,
                     char *pcKpon)
{
    kpc_nwProtoNode_t *protoMatch=NULL;
    kpc_nwServNode_t *servMatch=NULL;
    kpc_nwHostNode_t *hostMatch=NULL;
    char *pcSearch=NULL, *pcIter=NULL, *pcTrace;
    int count, rc=0, matchState=0;
    kenv_kpcInfo_t ki;
    oss_nwAddr_t *addrp,nwAddr;

    (!(envH)? (*((char *)0) = 0) : 0);
    do { kenv_env_t *ep = (kenv_env_t *)envH; addrp = (ep->flags & 0x00004000)? &ep->tgt.nw.addrRemote: NULL; } while ( 0);
    ;
    memcpy(&nwAddr,addrp,sizeof(oss_nwAddr_t));

    kpc_nwConvAddrHN(&nwAddr);

    (kail_mutex_lock(&(kpc_nwOutPol->lock)));
    if (kpc_nwOutPol->flags & 0x10) {
        goto out;
    }
    while (kpc_nwOutPol->flags & 0x1) {
        (kail_cond_wait(&(kpc_nwOutPol->cond),&(kpc_nwOutPol->lock)));
    }
    (kpc_nwOutPol->readers) += 1;
    (kail_mutex_unlock(&(kpc_nwOutPol->lock)));



    pcIter = strchr(pcKpon, '/');
    if (pcIter) {
        *pcIter = 0;
    }

    hostMatch = kpc_nwMatchHostName(&(kpc_nwOutPol->HostNameQ), pcKpon,
                                    kpc_nwOutPol);
    if (pcIter) {

        *pcIter = '/';
    }

    if (hostMatch) {
        kpc_nwInitKPCInfo(&ki);
        pcSearch = kpc_nwOutPolicyMatchHost(hostMatch, &nwAddr,
                                            &matchState, &pcTrace, &ki);
        if (pcSearch) {
            kpc_nwEnvResReset(hostMatch, pcSearch, envH, &ki);
        } else {
            rc = -1;
        }
    } else {
        matchState |= 0x2000;
        rc = -1;
    }

    (kail_mutex_lock(&(kpc_nwOutPol->lock)));
    (kpc_nwOutPol->readers) -= 1;
 out:
    (kail_mutex_unlock(&(kpc_nwOutPol->lock)));
    (kail_wake_up(&(kpc_nwOutPol->cond)));

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= ((!rc) ? 1 : 5)) ? (kt_Event4((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_NETOUT_SETRES, (((2)<<28) + ((1)<<24) + ((2)<<20) + ((1)<<16)), (long)(rc), (long)pcKpon, (long)matchState, (long)(pcSearch ? pcSearch : "NULL")),0) : 0);




    return rc;
}







void
kpc_nwOutPolicyInit(kpc_nwOutPolicy_t *kpc_nwPol)
{
    memset(kpc_nwPol,0,sizeof(*kpc_nwPol));
    (kail_mutex_init(&kpc_nwPol->lock));
    (kail_cond_init(&(kpc_nwPol->cond)));
    ((&(kpc_nwPol->HostIPQ))->next = (&(kpc_nwPol->HostIPQ))->prev = (&(kpc_nwPol->HostIPQ)));
    ((&(kpc_nwPol->HostNameQ))->next = (&(kpc_nwPol->HostNameQ))->prev = (&(kpc_nwPol->HostNameQ)));
    kpc_nwPol->flags = 0x4;
}






void
kpc_nwOutPolicyFini(kpc_nwOutPolicy_t *kpc_nwPol)
{
    kpc_nwHostNode_t *nodep;
    kutil_q_t *iter,*next,*qptr;
    size_t size;

    if (! (kpc_nwPol->flags & 0x4) ) {
        return;
    }

    (kail_mutex_lock(&(kpc_nwPol->lock)));
    (kpc_nwPol->flags) |= (0x1|0x10);
    while (kpc_nwPol->readers > 0) {
        (kail_cond_wait(&(kpc_nwPol->cond),&(kpc_nwPol->lock)));
    }
    qptr = &(kpc_nwPol->HostIPQ);
    for (iter=(((kutil_q_t *)qptr)->next);iter!=qptr; iter=next) {
        next = ((iter)->next);
        nodep = (kpc_nwHostNode_t *)iter;
        (((&(nodep->q))->next)->prev = ((&(nodep->q))->prev), ((&(nodep->q))->prev)->next = ((&(nodep->q))->next));
        kpc_nwHostNodeFree(nodep,0);
        (kpc_nwPol->IPNodes)--;
    }
    qptr = &(kpc_nwPol->HostNameQ);
    for (iter=(((kutil_q_t *)qptr)->next); iter!=qptr; iter=next) {
        next = ((iter)->next);
        nodep = (kpc_nwHostNode_t *)iter;
        (((&(nodep->q))->next)->prev = ((&(nodep->q))->prev), ((&(nodep->q))->prev)->next = ((&(nodep->q))->next));
        kpc_nwHostNodeFree(nodep,0);
        (kpc_nwPol->hostNodes)--;
    }
    (kail_mutex_unlock(&(kpc_nwPol->lock)));
    (!(kpc_nwPol->hostNodes == 0)? (*((char *)0) = 0) : 0);
    (!(kpc_nwPol->IPNodes == 0)? (*((char *)0) = 0) : 0);
}




int
kazn_kpcNetMapError(int error, int *perr)
{
    int rc=0;

    *perr = 0;
    if (error >= 0) {
        return(error);
    }
    rc = -1;
    switch(error) {
    case -10: *perr = ENOMEM; break;
    case -11: *perr = EINVAL; break;
    case -12: *perr = EEXIST; break;
    case -13: *perr = ENXIO; break;
    case -14: *perr = ESRCH; break;
    case -15: *perr = ENOENT; break;
    default:
        *perr = EIO;
    }

    return(rc);
}
int
kazn_kpcNetCheckResource(kenv_envHandle_t accEnv, int action, int flags)
{
    int rc=0,err=0;

    if (action == 0x20) {
        if (kpc_NWCacheOn) {
            rc = kpc_nwInPolicyMatch(&kpc_nwInPol, accEnv);
        } else {
            rc = 1;
        }
    } else if (action == 0x10) {
        if (kpc_NWCacheOn) {
            rc = kpc_nwOutPolicyMatch(&kpc_nwOutPol, accEnv);
        } else {
            rc = 1;
        }
    } else {
        rc = ENOSYS;
    }
    rc = kazn_kpcNetMapError(rc, &err);

    if (err) {
        char acErr[128];
        kail_sprintf((acErr), ("ERR %d on NW%s, rc %d."), (err), ((action == 0x20) ? "in" : "out"), (rc));

        pal_logErr(0x340b4003,acErr);
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[5])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[5], KT_TRACE_KNPC_CHECK_RES, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(accEnv), (long)action, (long)rc),0) : 0);

    return(rc);
}
void
kazn_kpcNetSetResource(int action, kenv_envHandle_t pEnv, char *pcKpon)
{
    if (action & 0x10) {
        kpc_nwOutPolicySetRes(&kpc_nwOutPol, pEnv, pcKpon);
    } else if (action & 0x20) {
        kpc_nwInPolicySetRes(&kpc_nwInPol, pEnv, pcKpon);
    }
}
int
kazn_kpcNetAddResource(kpc_resourceInfo_t *rip)
{
    int rc = 0;

    if (rip->resDesc.nwDesc->addrType.nwIn) {
        rc = kpc_nwInPolicyAdd(&kpc_nwInPol, rip);
    } else {
        rc = kpc_nwOutPolicyAdd(&kpc_nwOutPol, rip);
    }
    return rc;
}
int
kazn_kpcNetDelResource(kpc_resourceInfo_t *rip)
{
    int rc = 0;

    if (rip->resDesc.nwDesc->addrType.nwIn) {
        rc = kpc_nwInPolicyDel(&kpc_nwInPol, rip);
    } else {
        rc = kpc_nwOutPolicyDel(&kpc_nwOutPol, rip);
    }
    return rc;
}


void
kazn_kpcNetInit(void)
{
    kpc_NWCacheOn = 1;
    kpc_nwInPolicyInit(&kpc_nwInPol);
    kpc_nwOutPolicyInit(&kpc_nwOutPol);
    kpc_ipV6_nomask.ipV6 = 1;
    kpc_ipV6_nomask.addr.a32[0] = kpc_ipV6_nomask.addr.a32[1] =
        kpc_ipV6_nomask.addr.a32[2] = kpc_ipV6_nomask.addr.a32[3] = 0xffffffff;
    return;
}


void
kazn_kpcNetShutdown(void)
{
    kpc_nwInPolicyFini(&kpc_nwInPol);
    kpc_nwOutPolicyFini(&kpc_nwOutPol);
    return;
}
